-- Content of tables:
-- attribute_categories
-- attribute_groups
-- cache_attrib
-- cache_report_reasons
-- cache_report_status
-- cache_size
-- cache_status
-- cache_type
-- cache_logtype
-- coordinates_type
-- countries
-- countries_list_default
-- countries_options
-- data_licenses
-- languages
-- languages_list_default
-- log_types
-- log_types_text
-- logentries_types
-- news_topics
-- nodes
-- object_types
-- profile_options
-- replication_overwritetypes
-- search_ignore
-- statpics
-- sys_menu
-- sys_trans
-- sys_trans_ref
-- sys_trans_text
-- watches_waitingtypes

-- Table attribute_categories
SET NAMES 'utf8';
TRUNCATE TABLE `attribute_categories`;
INSERT INTO `attribute_categories` (`id`, `name`, `trans_id`, `color`) VALUES ('1', 'Properties', '1342', '#FFDD51');
INSERT INTO `attribute_categories` (`id`, `name`, `trans_id`, `color`) VALUES ('2', 'Restrictions / Preconditions', '1343', '#69F765');
INSERT INTO `attribute_categories` (`id`, `name`, `trans_id`, `color`) VALUES ('3', 'Recommendations / Prohibitions', '1344', '#00F0FF');

-- Table attribute_groups
SET NAMES 'utf8';
TRUNCATE TABLE `attribute_groups`;
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('1', '1', 'Dangers', '1331');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('2', '1', 'Infrastructure', '1332');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('3', '1', 'Route', '1658');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('4', '1', 'Waypoints', '1333');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('5', '2', 'Common', '1334');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('6', '2', 'Time', '1335');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('7', '2', 'Seasonal', '1336');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('8', '2', 'System', '1337');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('9', '2', 'Tools needed', '1338');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('10', '2', 'Preparation needed', '1339');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('11', '3', 'Persons', '1340');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('12', '3', 'Transportation', '1341');
INSERT INTO `attribute_groups` (`id`, `category_id`, `name`, `trans_id`) VALUES ('13', '3', 'Infrastructure', '1332');

-- Table cache_attrib
SET NAMES 'utf8';
TRUNCATE TABLE `cache_attrib`;
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('1', 'Only at night', 'night', '1541', '6', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/night.png', 'resource2/ocstyle/images/attributes/night-no.png', 'resource2/ocstyle/images/attributes/night-disabled.png', 'This geocache can be found at night only - it is a so-called night cache. There may be reflectors which have to be flashlighted and will point to the hiding place, or other special night-caching mechanisms.', '1545', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('6', 'Only loggable at Opencaching', 'oconly', '1345', '8', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/oconly.png', 'resource2/ocstyle/images/attributes/oconly-no.png', 'resource2/ocstyle/images/attributes/oconly-disabled.png', 'This geocache is listed at Opencaching only. This attribute will enable users of other geocaching platforms to find interesting OC caches quickly.', '1546', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('7', 'Hyperlink to another caching portal only', 'wwwlink', '1542', '8', '0', '0', '1', '2', 'resource2/ocstyle/images/attributes/wwwlink.png', 'resource2/ocstyle/images/attributes/wwwlink-no.png', 'resource2/ocstyle/images/attributes/wwwlink-disabled.png', '<br /><i>Obsolete: This attribute cannot be assigned to new caches, because it does not fit our current terms of use.</i><br />\r\nThis cache ist listed at Opencaching and at other geocaching sites. This applies to caches which have been linked by their owners to the corresponding listings at other sites. Please note that descriptions and status of multiple-listed caches have to be equally maintained at all sites including Opencaching, according to our terms of use.', '1705', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('8', 'Letterbox (needs stamp)', 'letter', '1543', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/letter.png', 'resource2/ocstyle/images/attributes/letter-no.png', 'resource2/ocstyle/images/attributes/letter-disabled.png', 'There is a stamp in the cache for stamping your personal logbook, and the cache’s logbook will be stamped with your personal stamp. Take care not to mix up stamps and to leave the cache’s stamp in the cache! Frequently letterboxes can be found without GPS, maybe with a compass and paces from a location - add the \"without GPS\" attribute for those.', '1548', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('9', 'Dangerous area', 'danger', '1544', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/danger.png', 'resource2/ocstyle/images/attributes/danger-no.png', 'resource2/ocstyle/images/attributes/danger-disabled.png', 'The cache is located within a dangerous area. Use this attribute to mark non-obvious dangers, like high-traffic roads, steep ground or falling rocks. Security measures should be taken or the cache be omitted, especially when geocaching with children, large groups or at unfavourable weather conditions.', '1549', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('10', 'Active railway nearby', 'train', '1550', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/train.png', 'resource2/ocstyle/images/attributes/train-no.png', 'resource2/ocstyle/images/attributes/train-disabled.png', 'There are active railroads nearby. Please be careful, keep a safe distance and cross the rails only at level crossings etc.!', '1599', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('11', 'Cliff / Rocks', 'cliff', '1551', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/cliff.png', 'resource2/ocstyle/images/attributes/cliff-no.png', 'resource2/ocstyle/images/attributes/cliff-disabled.png', 'There are cliffs or dangerous rocks nearby. Beware of falling rocks at the lower side, and be careful at the upper side of cliffs - especially with children and while mountain biking. It can be very dangerous to take a steep slope towards a cliff, because you may not notice in time where the former ends and the latter starts.', '1600', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('12', 'Hunting', 'hunting', '1552', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/hunting.png', 'resource2/ocstyle/images/attributes/hunting-no.png', 'resource2/ocstyle/images/attributes/hunting-disabled.png', 'The geocache is placed within a hunting ground. At twilight and in the dark, a flashlight or headlight should always be used for security reasons. Be considerate when meeting hunters.', '1601', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('13', 'Thorns', 'thorn', '1553', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/thorn.png', 'resource2/ocstyle/images/attributes/thorn-no.png', 'resource2/ocstyle/images/attributes/thorn-disabled.png', 'There are thorns near the cache. Wear appropriate clothes.', '1602', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('14', 'Ticks', 'ticks', '1554', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/ticks.png', 'resource2/ocstyle/images/attributes/ticks-no.png', 'resource2/ocstyle/images/attributes/ticks-disabled.png', 'There are seasonably many ticks in this area. It is recommended to wear long trousers and to check yourself for ticks after geocaching. There are risk maps for tick-borne encephalitis in the internet, e.g. for Germany at sites like www.meningitis.de (look for FSME there).', '1603', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('15', 'Abandoned mines', 'mine', '1555', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/mine.png', 'resource2/ocstyle/images/attributes/mine-no.png', 'resource2/ocstyle/images/attributes/mine-disabled.png', 'This cache leads into a (former) mining area. There may be dangers by collapsing adits, or you may need to enter adits. Be careful and use appropriate equipment, especially in the dark. Old mines may be covered by historic preservation.', '1625', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('16', 'Poisonous plants', 'plants', '1556', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/plants.png', 'resource2/ocstyle/images/attributes/plants-no.png', 'resource2/ocstyle/images/attributes/plants-disabled.png', 'There are poisonous plants near the cache. Take care and prevent children and dogs from touching or eating them.', '1626', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('17', 'Dangerous animals', 'animals', '1557', '1', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/animals.png', 'resource2/ocstyle/images/attributes/animals-no.png', 'resource2/ocstyle/images/attributes/animals-disabled.png', 'The area is inhabited by possibly dangerous animals, e.g. rabies areas, venomous snakes, scorpions or bears.', '1627', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('18', 'Parking area nearby', 'parking', '1558', '2', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/parking.png', 'resource2/ocstyle/images/attributes/parking-no.png', 'resource2/ocstyle/images/attributes/parking-disabled.png', 'A nearby parking area is situated as starting point for doing this cache. If no free parking is available, add the \"access or parking fee\" attribute.', '1628', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('19', 'Public transportation', 'public', '1559', '2', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/public.png', 'resource2/ocstyle/images/attributes/public-no.png', 'resource2/ocstyle/images/attributes/public-disabled.png', 'This cache is located outside of urban areas and has a public transport station nearby. Don’t set this attribute for geocaches in urban areas that are commonly equipped with public transportation.', '1629', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('20', 'Drinking water nearby', 'water', '1560', '2', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/water.png', 'resource2/ocstyle/images/attributes/water-no.png', 'resource2/ocstyle/images/attributes/water-disabled.png', 'There is drinking water along the trail or near the cache. This attribute is useful especially for planning event caches, longer hikes or caches at probably dirty locations like caves.', '1630', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('21', 'Public restrooms nearby', 'restrooms', '1561', '2', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/restrooms.png', 'resource2/ocstyle/images/attributes/restrooms-no.png', 'resource2/ocstyle/images/attributes/restrooms-disabled.png', 'There are public restrooms along the way or near the cache. This attribute is useful especially for planning event caches or extensive multicaches.', '1631', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('22', 'Public phone nearby', 'phone', '1562', '2', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/phone.png', 'resource2/ocstyle/images/attributes/phone-no.png', 'resource2/ocstyle/images/attributes/phone-disabled.png', 'There is a public phone along the way or near the cache. Especially for event caches you should enquire for nearby phones and set this attribute if applicable.', '1632', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('23', 'First aid available', 'firstaid', '1563', '2', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/firstaid.png', 'resource2/ocstyle/images/attributes/firstaid-no.png', 'resource2/ocstyle/images/attributes/firstaid-disabled.png', 'There is a first aid station, call box, mountain rescue or similar arrangement near the cache. This attribute is useful especially in demanding areas, like climbing caches, cave caches, high mountains or at the water. Check if you can add emergency phone numbers (like a mountain rescue) to your cache listing.', '1633', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('24', 'Near the parking area', 'car', '1564', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/car.png', 'resource2/ocstyle/images/attributes/car-no.png', 'resource2/ocstyle/images/attributes/car-disabled.png', 'The geocache is located close to a parking area, only a few steps away - it’s a \"cache and dash\".', '1634', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('25', 'Long walk', 'hiking', '1565', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/hiking.png', 'resource2/ocstyle/images/attributes/hiking-no.png', 'resource2/ocstyle/images/attributes/hiking-disabled.png', 'This cache requires a long walk - more than 5 km round trip. In the mountains and other steep areas, the distance for a \"long walk\" may be shorter. Walking shoes and appropriate equipment are recommended.', '1635', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('26', 'Swamp or marsh', 'wading', '1566', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/wading.png', 'resource2/ocstyle/images/attributes/wading-no.png', 'resource2/ocstyle/images/attributes/wading-disabled.png', 'This cache requires passing swampy or marshy ground. Wear appropriate clothes. After rainfall, the terrain may be very demanding or not passable at all.', '1636', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('27', 'Hilly area', 'steep', '1567', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/steep.png', 'resource2/ocstyle/images/attributes/steep-no.png', 'resource2/ocstyle/images/attributes/steep-disabled.png', 'One or more ascents lie between you and the cache.', '1637', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('28', 'Some climbing (no gear needed)', 'climbing', '1568', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/climbing.png', 'resource2/ocstyle/images/attributes/climbing-no.png', 'resource2/ocstyle/images/attributes/climbing-disabled.png', 'This cache requires some climbing and you may have to use your hands, but you won’t need climbing gear. Be very careful during rainy weather or before thunderstorms!', '1638', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('29', 'Swimming required', 'swimming', '1569', '3', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/swimming.png', 'resource2/ocstyle/images/attributes/swimming-no.png', 'resource2/ocstyle/images/attributes/swimming-disabled.png', 'This cache requires crossing a river or a lake. The water is steep ', '1639', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('30', 'Point of interest', 'interestsign', '1570', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/interestsign.png', 'resource2/ocstyle/images/attributes/interestsign-no.png', 'resource2/ocstyle/images/attributes/interestsign-disabled.png', 'There is a point of interest at the cache, like a nice scenic overlook or a larger castle ruin. This place is worth visiting it even without a geocache nearby.', '1640', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('31', 'Moving target', 'moving', '1571', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/moving.png', 'resource2/ocstyle/images/attributes/moving-no.png', 'resource2/ocstyle/images/attributes/moving-disabled.png', 'This geocache is moving around. For example, the owner might regularly move the cache from one place to another, or the finders will do this task and post new coordinates in their log entries. The owner must update coordinates in the cache description after each move.', '1641', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('32', 'Webcam ', 'webcam', '1572', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/webcam.png', 'resource2/ocstyle/images/attributes/webcam-no.png', 'resource2/ocstyle/images/attributes/webcam-disabled.png', 'There is a webcam at the target location. You must record a webcam picture of your visit and include it in your \"found\" log entry. There may be additional requirements like a geocaching banner on the photo. The webcam’s address is included in the cache description, and it must be publicly accessible, i.e. no user account or similar is required.', '1642', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('33', 'Wihin enclosed rooms (caves, buildings etc.)', 'indoor', '1573', '4', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/indoor.png', 'resource2/ocstyle/images/attributes/indoor-no.png', 'resource2/ocstyle/images/attributes/indoor-disabled.png', 'This geocache is not hidden in the open air, but within a building, a cave or similar.', '1643', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('34', 'In the water', 'submerged', '1604', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/submerged.png', 'resource2/ocstyle/images/attributes/submerged-no.png', 'resource2/ocstyle/images/attributes/submerged-disabled.png', 'This cache or one of the stages is placed underwater. You will have to enter the water, swim or dive.', '1644', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('35', 'Without GPS (letterboxes, cistes, compass juggling ...)', 'nogps', '1575', '4', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/nogps.png', 'resource2/ocstyle/images/attributes/nogps-no.png', 'resource2/ocstyle/images/attributes/nogps-disabled.png', 'This cache can be found without a GPS device. No additional coordinates are used besides of the starting coordinates.', '1645', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('36', 'Access or parking fee', 'fee', '1576', '5', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/fee.png', 'resource2/ocstyle/images/attributes/fee-no.png', 'resource2/ocstyle/images/attributes/fee-disabled.png', 'You must pay an access or parking fee to access this cache, e.g. if the cache is located within a theme park. If there are alternative free parking areas nearby, please include them in the cache description. Please note our current terms of use regarding \"commercial geocaches\".', '1646', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('37', 'Overnight stay necessary', 'overnight', '1577', '5', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/overnight.png', 'resource2/ocstyle/images/attributes/overnight-no.png', 'resource2/ocstyle/images/attributes/overnight-disabled.png', 'This cache cannot be done within a single day or a single night. You will have to visit the location for more than one time, or you must stay overnight. Preparation time is not included in this calculation, but only the time on site.', '1647', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('38', 'Available 24 hours', 'available', '1578', '6', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/available.png', 'resource2/ocstyle/images/attributes/available-no.png', 'resource2/ocstyle/images/attributes/available-disabled.png', 'This cache can be done both at daylight and at night.', '1605', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('39', 'Only available at specified times', 'time', '1579', '6', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/time.png', 'resource2/ocstyle/images/attributes/time-no.png', 'resource2/ocstyle/images/attributes/time-disabled.png', 'This cache can only be done at certain times of day - see the cache description for more details. For example, the cache may be placed in an area with restricted opening hours.', '1606', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('40', 'by day only', 'day', '1580', '6', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/day.png', 'resource2/ocstyle/images/attributes/day-no.png', 'resource2/ocstyle/images/attributes/day-disabled.png', 'This cache shoud be attempted during daylight only. For example, the area may be dangerous and contain cliffs or abysses. Or using flashlights may be unfeasable because it would look suspicious within a residential area.', '1607', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('41', 'Tide', 'tide', '1581', '6', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/tide.png', 'resource2/ocstyle/images/attributes/tide-no.png', 'resource2/ocstyle/images/attributes/tide-disabled.png', 'This cache can be done only at low-tide or only at high-tide.', '1608', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('42', 'All seasons', 'date', '1582', '7', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/date.png', 'resource2/ocstyle/images/attributes/date-no.png', 'resource2/ocstyle/images/attributes/date-disabled.png', 'This cache can be found the whole year round, while difficulty may depend on seasons. Specify difficulty for good conditions.', '1609', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('43', 'Breeding season / protected nature', 'naturschutz', '1583', '7', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/naturschutz.png', 'resource2/ocstyle/images/attributes/naturschutz-no.png', 'resource2/ocstyle/images/attributes/naturschutz-disabled.png', 'Don’t seek this cache during animal breeding season! Please indicate in the cache description which time of year must be avoided. Also, pay attention to the local terms and signs regarding nature protection.', '1610', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('44', 'Snow-proof hiding place', 'snow', '1584', '7', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/snow.png', 'resource2/ocstyle/images/attributes/snow-no.png', 'resource2/ocstyle/images/attributes/snow-disabled.png', 'This cache can be found even after heavy snowing. All stages and the geocache are hidden in a snow-safe way: they will not be covered by fallen snow an not by snow-piles created by snow-clearing vehicles.', '1611', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('46', 'Special equipment', 'tools', '1585', '9', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/tools.png', 'resource2/ocstyle/images/attributes/tools-no.png', 'resource2/ocstyle/images/attributes/tools-disabled.png', 'You will need special equipment which is not specified by other attributes, e.g. a laser pointer, walkie-talkies or a car jack.', '1612', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('47', 'Compass', 'compass', '1586', '9', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/compass.png', 'resource2/ocstyle/images/attributes/compass-no.png', 'resource2/ocstyle/images/attributes/compass-disabled.png', 'A compass is required.', '1613', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('48', 'Flashlight', 'flashlight', '1587', '9', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/flashlight.png', 'resource2/ocstyle/images/attributes/flashlight-no.png', 'resource2/ocstyle/images/attributes/flashlight-disabled.png', 'A flashlight is required for finding this cache. Don’t forget spare batteries!', '1614', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('49', 'Climbing gear', 'rappeling', '1588', '9', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/rappeling.png', 'resource2/ocstyle/images/attributes/rappeling-no.png', 'resource2/ocstyle/images/attributes/rappeling-disabled.png', 'For this cache, you will need climbing equipment and the knowledge how to use it properly. If you are a beginner, don’t do it alone but use the support of a experienced climber or mountaineer.', '1615', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('50', 'Cave equipment', 'cave', '1589', '9', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/cave.png', 'resource2/ocstyle/images/attributes/cave-no.png', 'resource2/ocstyle/images/attributes/cave-disabled.png', 'This geocache is hidden in a cave, and you should use appropriate equipment to access it. Beware: Even small caves may confront you with unforeseen problems and dangers, like thunder storms (water!) or a sprained ankle. Have advice first from cave-experienced people! Also take care of protected nature; e.g. bat places must not be disturbed.', '1616', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('51', 'Diving equipment', 'scuba', '1590', '9', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/scuba.png', 'resource2/ocstyle/images/attributes/scuba-no.png', 'resource2/ocstyle/images/attributes/scuba-disabled.png', 'You will need diving equipment to find this geocache. The water depth of the cache location is specified in the description. Please note that secure diving requires special training. Without diving experience, you may search this cache in company of a diving teacher.', '1617', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('52', 'Watercraft', 'boat', '1591', '9', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/boat.png', 'resource2/ocstyle/images/attributes/boat-no.png', 'resource2/ocstyle/images/attributes/boat-disabled.png', 'This cache usually can be found only using a watercraft. Swimming is impossible because of the distance or currents. See the cache description for more details.', '1618', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('53', 'Aircraft', 'aircraft', '1592', '9', '0', '0', '0', '0', 'resource2/ocstyle/images/attributes/aircraft.png', 'resource2/ocstyle/images/attributes/aircraft-no.png', 'resource2/ocstyle/images/attributes/aircraft-disabled.png', '', '0', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('54', 'Investigation', 'wiki', '1593', '10', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/wiki.png', 'resource2/ocstyle/images/attributes/wiki-no.png', 'resource2/ocstyle/images/attributes/wiki-disabled.png', 'You must investigate additional information before you can seek this cache. This commonly applies to puzzle/mystery caches.', '1619', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('55', 'Puzzle / Mystery', 'riddle', '1594', '10', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/riddle.png', 'resource2/ocstyle/images/attributes/riddle-no.png', 'resource2/ocstyle/images/attributes/riddle-disabled.png', 'Puzzles or mysteries have to be solved before or while seeking this cache.', '1620', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('56', 'Arithmetical problem', 'arith_prob', '1595', '10', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/arith_prob.png', 'resource2/ocstyle/images/attributes/arith_prob-no.png', 'resource2/ocstyle/images/attributes/arith_prob-disabled.png', 'Before or while seeking this cache, arithmetical problems must be solved which go beyond very basic calculations.', '1621', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('57', 'Other cache type', 'othercache', '1596', '10', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/othercache.png', 'resource2/ocstyle/images/attributes/othercache-no.png', 'resource2/ocstyle/images/attributes/othercache-disabled.png', 'This is none of the standard, pre-defined types of cache. Use this attribute for special, unusual caches.', '1622', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('58', 'Ask owner for start conditions', 'ask', '1597', '10', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/ask.png', 'resource2/ocstyle/images/attributes/ask-no.png', 'resource2/ocstyle/images/attributes/ask-disabled.png', 'Before doing this cache, you must ask the owner for the starting conditions. E.g. the cache may be linked to certain events at varying dates.', '1623', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('59', 'Suited for children', 'kids', '1598', '11', '1', '0', '1', '0', 'resource2/ocstyle/images/attributes/kids.png', 'resource2/ocstyle/images/attributes/kids-no.png', 'resource2/ocstyle/images/attributes/kids-disabled.png', 'This geocache is created for children. All challenges can be solved by child in the age of 10 to 12 years and the terrain has no risks (like highways, abysms). There is a large geocache container with trading items inside and the challenges are interesting.', '1624', '0');
INSERT INTO `cache_attrib` (`id`, `name`, `icon`, `trans_id`, `group_id`, `selectable`, `category`, `search_default`, `default`, `icon_large`, `icon_no`, `icon_undef`, `html_desc`, `html_desc_trans_id`, `hidden`) VALUES ('60', 'Only available during specified seasons', 'calendar', '1799', '7', '1', '0', '0', '0', 'resource2/ocstyle/images/attributes/calendar.png', 'resource2/ocstyle/images/attributes/calendar-no.png', 'resource2/ocstyle/images/attributes/calendar-disabled.png', 'This cache can be done at certain seasons only - see the cache description for more details. For example, the cache may be placed in a corn labyrinth, which only exists from bloom to harvest season.', '1800', '0');

-- Table cache_report_reasons
SET NAMES 'utf8';
TRUNCATE TABLE `cache_report_reasons`;
INSERT INTO `cache_report_reasons` (`id`, `name`, `trans_id`) VALUES ('1', 'Cache on private property', '776');
INSERT INTO `cache_report_reasons` (`id`, `name`, `trans_id`) VALUES ('2', 'Copyright violation', '777');
INSERT INTO `cache_report_reasons` (`id`, `name`, `trans_id`) VALUES ('3', 'Cache is gone', '778');
INSERT INTO `cache_report_reasons` (`id`, `name`, `trans_id`) VALUES ('4', 'Other reason', '779');

-- Table cache_report_status
SET NAMES 'utf8';
TRUNCATE TABLE `cache_report_status`;
INSERT INTO `cache_report_status` (`id`, `name`, `trans_id`) VALUES ('1', 'New', '773');
INSERT INTO `cache_report_status` (`id`, `name`, `trans_id`) VALUES ('2', 'In progress', '774');
INSERT INTO `cache_report_status` (`id`, `name`, `trans_id`) VALUES ('3', 'Done', '775');

-- Table cache_size
SET NAMES 'utf8';
TRUNCATE TABLE `cache_size`;
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('1', 'other size', '524', '7', 'andere Größe', 'other size');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('2', 'micro', '525', '2', 'mikro', 'micro');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('3', 'small', '526', '3', 'klein', 'small');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('4', 'normal', '527', '4', 'normal', 'normal');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('5', 'large', '528', '5', 'groß', 'large');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('6', 'very large', '529', '6', 'extrem groß', 'very large');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('7', 'no container', '530', '8', 'kein Behälter', 'no container');
INSERT INTO `cache_size` (`id`, `name`, `trans_id`, `ordinal`, `de`, `en`) VALUES ('8', 'nano', '1803', '1', 'nano', 'nano');

-- Table cache_status
SET NAMES 'utf8';
TRUNCATE TABLE `cache_status`;
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('1', 'Ready for search', '531', 'Kann gesucht werden', 'Ready for search', '1', '1', '1');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('2', 'Temporary not available', '532', 'Momentan nicht verfügbar', 'Temporary not available', '1', '1', '1');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('3', 'Archived', '496', 'Archiviert', 'Archived', '1', '1', '1');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('4', 'Hidden by approvers to check', '533', 'Von den Approvern entfernt, um geürpft zu werden', 'Hidden by approvers to check', '0', '1', '0');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('5', 'Not yet available', '534', 'Noch nicht veröffentlicht', 'Not yet available', '0', '1', '0');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('6', 'Locked, visible', '821', '', '', '1', '1', '0');
INSERT INTO `cache_status` (`id`, `name`, `trans_id`, `de`, `en`, `allow_user_view`, `allow_owner_edit_status`, `allow_user_log`) VALUES ('7', 'Locked, invisible', '822', '', '', '0', '0', '0');

-- Table cache_type
SET NAMES 'utf8';
TRUNCATE TABLE `cache_type`;
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('1', 'unknown cachetyp', '535', '10', 'Other', 'unbekannter Cachetyp', 'unknown cachetyp', 'cache/unknown.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('2', 'Traditional Cache', '536', '1', 'Trad.', 'normaler Cache', 'Traditional Cache', 'cache/traditional.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('3', 'Multicache', '514', '2', 'Multi', 'Multicache', 'Multicache', 'cache/multi.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('4', 'virtual Cache', '537', '6', 'Virt.', 'virtueller Cache', 'virtual Cache', 'cache/virtual.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('5', 'Webcam Cache', '538', '7', 'ICam.', 'Webcam-Cache', 'Webcam Cache', 'cache/webcam.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('6', 'Event Cache', '539', '3', 'Event', 'Event-Cache', 'Event Cache', 'cache/event.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('7', 'Quizcache', '518', '8', 'Quiz', 'Rätselcache', 'Quizcache', 'cache/mystery.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('8', 'Math/Physics-Cache', '540', '9', 'Math', 'Mathe-/Physikcache', 'Math/Physics-Cache', 'cache/mathe.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('9', 'Moving Cache', '541', '4', 'Moving', 'beweglicher Cache', 'Moving Cache', 'cache/moving.gif');
INSERT INTO `cache_type` (`id`, `name`, `trans_id`, `ordinal`, `short`, `de`, `en`, `icon_large`) VALUES ('10', 'Drive-In', '542', '5', 'Driv.', 'Drive-In', 'Drive-In', 'cache/drivein.gif');

-- Table cache_logtype
SET NAMES 'utf8';
TRUNCATE TABLE `cache_logtype`;
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('1', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('1', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('1', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('2', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('2', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('2', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('3', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('3', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('3', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('4', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('4', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('4', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('5', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('5', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('5', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('6', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('6', '7');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('6', '8');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('7', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('7', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('7', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('8', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('8', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('8', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('9', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('9', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('9', '3');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('10', '1');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('10', '2');
INSERT INTO `cache_logtype` (`cache_type_id`, `log_type_id`) VALUES ('10', '3');

-- Table coordinates_type
SET NAMES 'utf8';
TRUNCATE TABLE `coordinates_type`;
INSERT INTO `coordinates_type` (`id`, `name`, `trans_id`, `image`) VALUES ('1', 'Parking', '1788', 'resource2/ocstyle/images/misc/wp_parking.png');
INSERT INTO `coordinates_type` (`id`, `name`, `trans_id`, `image`) VALUES ('2', 'Reference point', '1789', 'resource2/ocstyle/images/misc/wp_reference.png');

-- Table countries
SET NAMES 'utf8';
TRUNCATE TABLE `countries`;
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AD', 'Andorra', '447', 'Andorra', 'Andorra', '0', 'andorra', '0', 'andorra');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AE', 'United Arab Emirates', '446', 'Vereinigte Arabische Emirate', 'United Arab Emirates', '0', 'arabische emirate, vereinigte', '0', 'arab emirates, united');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AF', 'Afghanistan', '445', 'Afghanistan', 'Afghanistan', '0', 'afghanistan', '0', 'afghanistan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AG', 'Antigua And Barbuda', '444', 'Antigua und Barbuda', 'Antigua And Barbuda', '0', 'antigua und barbuda', '0', 'antigua and barbuda');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AI', 'Anguilla', '443', 'Anguilla', 'Anguilla', '0', 'anguilla', '0', 'anguilla');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AL', 'Albania', '442', 'Albanien', 'Albania', '0', 'albanien', '0', 'albania');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AM', 'Armenia', '441', 'Armenien', 'Armenia', '0', 'armenien', '0', 'armenia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AN', 'Netherlands Antilles', '440', 'Niederländische Antillen', 'Netherlands Antilles', '0', 'antillen, niederlaendische', '0', 'netherlands antilles');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AO', 'Angola', '439', 'Angola', 'Angola', '0', 'angola', '0', 'angola');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AR', 'Argentina', '438', 'Argentinien', 'Argentina', '0', 'argentinien', '0', 'argentina');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AS', 'American Samoa', '437', 'Amerikanisch-Samoa', 'American Samoa', '0', 'samoa-amerikanisch', '1', 'american samoa');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AT', 'Austria', '436', 'Österreich', 'Austria', '1', 'oesterreich', '0', 'austria');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AU', 'Australia', '435', 'Australien', 'Australia', '0', 'australien', '1', 'australia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AW', 'Aruba', '434', 'Aruba', 'Aruba', '0', 'aruba', '0', 'aruba');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('AZ', 'Azerbaijan', '433', 'Aserbaidschan', 'Azerbaijan', '0', 'aserbaidschan', '0', 'azerbaijan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BA', 'Bosnia And Herzegowina', '432', 'Bosnien-Herzegowina', 'Bosnia And Herzegowina', '0', 'bosnien-herzegowina', '0', 'bosnia and herzegowina');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BB', 'Barbados', '431', 'Barbados', 'Barbados', '0', 'barbados', '0', 'barbados');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BD', 'Bangladesh', '430', 'Bangladesch', 'Bangladesh', '0', 'bangladesch', '0', 'bangladesh');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BE', 'Belgium', '429', 'Belgien', 'Belgium', '1', 'belgien', '0', 'belgium');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BF', 'Burkina Faso', '428', 'Burkina Faso', 'Burkina Faso', '0', 'burkina faso', '0', 'burkina faso');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BG', 'Bulgaria', '427', 'Bulgarien', 'Bulgaria', '0', 'bulgarien', '0', 'bulgaria');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BH', 'Bahrain', '426', 'Bahrain', 'Bahrain', '0', 'bahrain', '0', 'bahrain');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BI', 'Burundi', '425', 'Burundi', 'Burundi', '0', 'burundi', '0', 'burundi');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BJ', 'Benin', '424', 'Benin', 'Benin', '0', 'benin', '0', 'benin');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BM', 'Bermuda', '423', 'Bermuda', 'Bermuda', '0', 'bermuda', '0', 'bermuda');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BN', 'Brunei Darussalam', '422', 'Brunei', 'Brunei Darussalam', '0', 'brunei', '0', 'brunei darussalam');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BO', 'Bolivia', '421', 'Bolivien', 'Bolivia', '0', 'bolivien', '0', 'bolivia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BR', 'Brazil', '420', 'Brasilien', 'Brazil', '0', 'brasilien', '0', 'brazil');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BS', 'Bahamas', '419', 'Bahamas', 'Bahamas', '0', 'bahamas', '0', 'bahamas');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BT', 'Bhutan', '418', 'Bhutan', 'Bhutan', '0', 'bhutan', '0', 'bhutan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BV', 'Bouvet Island', '417', 'die Bouvetinseln', 'Bouvet Island', '0', 'bouvetinseln, die', '0', 'bouvet island');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BW', 'Botswana', '416', 'Botsuana', 'Botswana', '0', 'botsuana', '0', 'botswana');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BY', 'Belarus', '415', 'Belarus (Weißrußland)', 'Belarus', '0', 'belarus (weissrussland)', '0', 'belarus');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('BZ', 'Belize', '414', 'Belize', 'Belize', '0', 'belize', '0', 'belize');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CA', 'Canada', '413', 'Kanada', 'Canada', '0', 'kanada', '1', 'canada');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CC', 'Cocos (Keeling) Islands', '412', 'Kokosinseln', 'Cocos (Keeling) Islands', '0', 'kokosinseln', '0', 'cocos (keeling) islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CF', 'Central African Republic', '411', 'Zentralafrikanische Republik', 'Central African Republic', '0', 'zentralafrikanische republik', '0', 'central african republic');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CG', 'Congo', '410', 'Kongo', 'Congo', '0', 'kongo', '0', 'congo');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CH', 'Switzerland', '409', 'Schweiz', 'Switzerland', '1', 'schweiz', '0', 'switzerland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CI', 'Cote d\'Ivoire', '408', 'Elfenbeinküste', 'Cote d\'Ivoire', '0', 'elfenbeinkueste', '0', 'Zimbabwe');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CK', 'Cook Islands', '407', 'Cookinseln', 'Cook Islands', '0', 'cookinseln', '0', 'cook islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CL', 'Chile', '406', 'Chile', 'Chile', '0', 'chile', '0', 'chile');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CM', 'Cameroon', '405', 'Kamerun', 'Cameroon', '0', 'kamerun', '0', 'cameroon');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CN', 'China', '404', 'Volksrepublik China', 'China', '0', 'china, volksrepublik', '0', 'china');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CO', 'Colombia', '403', 'Kolumbien', 'Colombia', '0', 'kolumbien', '0', 'colombia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CR', 'Costa Rica', '402', 'Costa Rica', 'Costa Rica', '0', 'costa rica', '0', 'costa rica');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CU', 'Cuba', '400', 'Kuba', 'Cuba', '0', 'kuba', '0', 'cuba');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CV', 'Cape Verde', '399', 'Kapverden', 'Cape Verde', '0', 'kapverden', '0', 'cape verde');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CX', 'Christmas Island', '398', 'Weihnachtsinseln', 'Christmas Island', '0', 'weihnachtsinseln', '0', 'christmas island');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CY', 'Cyprus', '397', 'Zypern', 'Cyprus', '0', 'zypern', '0', 'cyprus');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('CZ', 'Czech Republic', '396', 'Tschechische Republik', 'Czech Republic', '1', 'tschechische republik', '0', 'czech republic');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('DE', 'Germany', '395', 'Deutschland', 'Germany', '1', 'deutschland', '0', 'germany');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('DJ', 'Djibouti', '394', 'Dschibuti', 'Djibouti', '0', 'dschibuti', '0', 'djibouti');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('DK', 'Denmark', '393', 'Dänemark', 'Denmark', '1', 'daenemark', '0', 'denmark');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('DO', 'Dominican Republic', '392', 'Dominikanische Republik', 'Dominican Republic', '0', 'dominikanische republik', '0', 'dominican republic');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('DZ', 'Algeria', '391', 'Algerien', 'Algeria', '0', 'algerien', '0', 'algeria');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('EC', 'Ecuador', '390', 'Ecuador', 'Ecuador', '0', 'ecuador', '0', 'ecuador');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('EE', 'Estonia', '389', 'Estland', 'Estonia', '0', 'estland', '0', 'estonia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('EG', 'Egypt', '388', 'Ägypten', 'Egypt', '0', 'aegypten', '0', 'egypt');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('EH', 'Western Sahara', '387', 'Westsahara', 'Western Sahara', '0', 'westsahara', '0', 'western sahara');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ER', 'Eritrea', '386', 'Eritrea', 'Eritrea', '0', 'eritrea', '0', 'eritrea');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ES', 'Spain', '385', 'Spanien', 'Spain', '1', 'spanien', '0', 'spain');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ET', 'Ethiopia', '384', 'Äthiopien', 'Ethiopia', '0', 'aethiopien', '0', 'ethiopia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FI', 'Finland', '383', 'Finnland', 'Finland', '0', 'finnland', '0', 'finland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FJ', 'Fiji', '382', 'Fidschi', 'Fiji', '0', 'fidschi', '0', 'fiji');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FK', 'Falkland Islands (Malvinas)', '381', 'Falklandinseln', 'Falkland Islands (Malvinas)', '0', 'falklandinseln', '0', 'falkland islands (malvinas)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FM', 'Micronesia, Federated States Of', '380', 'Mikronesien', 'Micronesia, Federated States Of', '0', 'mikronesien', '0', 'micronesia, federated states of');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FO', 'Faroe Islands', '379', 'Färöer (zu Dänemark)', 'Faroe Islands', '0', 'faeroeer (zu daenemark)', '0', 'faroe islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('FR', 'France', '378', 'Frankreich', 'France', '1', 'frankreich', '0', 'france');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GA', 'Gabon', '377', 'Gabun', 'Gabon', '0', 'gabun', '0', 'gabon');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GB', 'United Kingdom (UK)', '376', 'Großbritannien', 'United Kingdom (UK)', '0', 'grossbritannien', '1', 'united kingdom (uk)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GD', 'Grenada', '375', 'Granada', 'Grenada', '0', 'granada', '0', 'grenada');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GE', 'Georgia', '374', 'Georgien', 'Georgia', '0', 'georgien', '0', 'georgia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GF', 'French Guiana', '373', 'Guayana', 'French Guiana', '0', 'guayana', '0', 'french guiana');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GH', 'Ghana', '372', 'Ghana', 'Ghana', '0', 'ghana', '0', 'ghana');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GI', 'Gibraltar', '371', 'Gibraltar', 'Gibraltar', '0', 'gibraltar', '0', 'gibraltar');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GL', 'Greenland', '370', 'Grönland', 'Greenland', '0', 'groenland', '0', 'greenland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GM', 'Gambia', '369', 'Gambia', 'Gambia', '0', 'gambia', '0', 'gambia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GN', 'Guinea', '368', 'Guinea', 'Guinea', '0', 'guinea', '0', 'guinea');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GP', 'Guadeloupe', '367', 'Guadelope', 'Guadeloupe', '0', 'guadelope', '0', 'guadeloupe');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GR', 'Greece', '366', 'Griechenland', 'Greece', '0', 'griechenland', '0', 'greece');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GS', 'South Georgia And The South Sandwich Islands', '365', 'Südgeorgien und die Südlichen Sandwichinseln', 'South Georgia And The South Sandwich Islands', '0', 'suedgeorgien und die suedlichen sandwichinseln', '0', 'south georgia and the south sandwich islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GT', 'Guatemala', '364', 'Guatemala', 'Guatemala', '0', 'guatemala', '0', 'guatemala');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GU', 'Guam', '363', 'Guam', 'Guam', '0', 'guam', '0', 'guam');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GW', 'Guinea-Bissau', '362', 'Guinea-Bissau', 'Guinea-Bissau', '0', 'guinea-bissau', '0', 'guinea-bissau');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('GY', 'Guyana', '361', 'Guyana', 'Guyana', '0', 'guyana', '0', 'guyana');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HK', 'Hong Kong', '360', 'Honkong', 'Hong Kong', '0', 'honkong', '0', 'hong kong');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HM', 'Heard And Mc Donald Islands', '359', 'Heard und McDonaldinseln', 'Heard And Mc Donald Islands', '0', 'heard und mcdonaldinseln', '0', 'heard and mc donald islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HN', 'Honduras', '358', 'Honduras', 'Honduras', '0', 'honduras', '0', 'honduras');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HR', 'Croatia (local name: Hrvatska)', '357', 'Kroatien', 'Croatia (local name: Hrvatska)', '0', 'kroatien', '0', 'croatia (local name: hrvatska)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HT', 'Haiti', '356', 'Haiti', 'Haiti', '0', 'haiti', '0', 'haiti');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('HU', 'Hungary', '355', 'Ungarn', 'Hungary', '0', 'ungarn', '0', 'hungary');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ID', 'Indonesia', '354', 'Indonesien', 'Indonesia', '0', 'indonesien', '0', 'indonesia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IE', 'Ireland', '353', 'Irland', 'Ireland', '0', 'irland', '0', 'ireland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IL', 'Israel', '352', 'Israel', 'Israel', '0', 'israel', '0', 'israel');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IN', 'India', '351', 'Indien', 'India', '0', 'indien', '0', 'india');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IO', 'British Indian Ocean Territory', '350', 'Britisches Territorium im Indischen Ozean', 'British Indian Ocean Territory', '0', 'britisches territorium im indischen ozean', '0', 'british indian ocean territory');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IQ', 'Iraq', '349', 'Irak', 'Iraq', '0', 'irak', '0', 'iraq');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IR', 'Iran (Islamic Republic Of)', '348', 'Iran', 'Iran (Islamic Republic Of)', '0', 'iran', '0', 'iran (islamic republic of)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IS', 'Iceland', '347', 'Island', 'Iceland', '0', 'island', '0', 'iceland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('IT', 'Italy', '346', 'Italien', 'Italy', '1', 'italien', '0', 'italy');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('JM', 'Jamaica', '345', 'Jamaika', 'Jamaica', '0', 'jamaika', '0', 'jamaica');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('JO', 'Jordan', '344', 'Jordanien', 'Jordan', '0', 'jordanien', '0', 'jordan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('JP', 'Japan', '343', 'Japan', 'Japan', '0', 'japan', '0', 'japan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KE', 'Kenya', '342', 'Kenia', 'Kenya', '0', 'kenia', '0', 'kenya');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KG', 'Kyrgyzstan', '341', 'Kirgistan', 'Kyrgyzstan', '0', 'kirgistan', '0', 'kyrgyzstan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KH', 'Cambodia', '340', 'Kambodscha', 'Cambodia', '0', 'kambodscha', '0', 'cambodia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KI', 'Kiribati', '339', 'Kiribati', 'Kiribati', '0', 'kiribati', '0', 'kiribati');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KM', 'Comoros', '338', 'Komoren', 'Comoros', '0', 'komoren', '0', 'comoros');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KN', 'Saint Kitts And Nevis', '337', 'St. Kitts und Nevis', 'Saint Kitts And Nevis', '0', 'st. kitts und nevis', '0', 'saint kitts and nevis');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KP', 'Korea, Democratic People\'s Republic Of', '336', 'Demokratische Volksrepublik Korea', 'Korea, Democratic People\'s Republic Of', '0', 'korea, demokratische volksrepublik', '0', 'Zimbabwe');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KR', 'Korea, Republic Of', '335', 'Republik Korea', 'Korea, Republic Of', '0', 'korea, republik', '0', 'korea, republic of');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KW', 'Kuwait', '334', 'Kuwait', 'Kuwait', '0', 'kuwait', '0', 'kuwait');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KY', 'Cayman Islands', '333', 'Kaimaninseln', 'Cayman Islands', '0', 'kaimaninseln', '0', 'cayman islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('KZ', 'Kazakhstan', '332', 'Kasachstan', 'Kazakhstan', '0', 'kasachstan', '0', 'kazakhstan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LA', 'Lao People\'s Democratic Republic', '331', 'Laos', 'Lao People\'s Democratic Republic', '0', 'laos', '0', 'Zimbabwe');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LB', 'Lebanon', '330', 'Libanon', 'Lebanon', '0', 'libanon', '0', 'lebanon');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LC', 'Saint Lucia', '329', 'St. Lucia', 'Saint Lucia', '0', 'st. lucia', '0', 'saint lucia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LI', 'Liechtenstein', '328', 'Liechtenstein', 'Liechtenstein', '1', 'liechtenstein', '0', 'liechtenstein');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LK', 'Sri Lanka', '327', 'Sri Lanka', 'Sri Lanka', '0', 'sri lanka', '0', 'sri lanka');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LR', 'Liberia', '326', 'Liberia', 'Liberia', '0', 'liberia', '0', 'liberia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LS', 'Lesotho', '325', 'Lesotho', 'Lesotho', '0', 'lesotho', '0', 'lesotho');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LT', 'Lithuania', '324', 'Litauen', 'Lithuania', '0', 'litauen', '0', 'lithuania');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LU', 'Luxembourg', '323', 'Luxemburg', 'Luxembourg', '1', 'luxemburg', '0', 'luxembourg');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LV', 'Latvia', '322', 'Lettland', 'Latvia', '0', 'lettland', '0', 'latvia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('LY', 'Libyan Arab Jamahiriya', '321', 'Libyen', 'Libyan Arab Jamahiriya', '0', 'libyen', '0', 'libyan arab jamahiriya');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MA', 'Morocco', '320', 'Marokko', 'Morocco', '0', 'marokko', '0', 'morocco');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MC', 'Monaco', '319', 'Monaco', 'Monaco', '0', 'monaco', '0', 'monaco');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MD', 'Moldova, Republic Of', '318', 'Moldau', 'Moldova, Republic Of', '0', 'moldau', '0', 'moldova, republic of');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ME', 'Montenegro', '856', 'Montenegro', 'Montenegro', '0', 'montenegro', '0', 'montenegro');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MG', 'Madagascar', '317', 'Madagaskar', 'Madagascar', '0', 'madagaskar', '0', 'madagascar');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MH', 'Marshall Islands', '316', 'Marshallinseln', 'Marshall Islands', '0', 'marshallinseln', '0', 'marshall islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MK', 'Macedonia, The Former Yugoslav Republic Of', '315', 'Mazedonien', 'Macedonia, The Former Yugoslav Republic Of', '0', 'mazedonien', '0', 'macedonia, the former yugoslav republic of');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ML', 'Mali', '314', 'Mali', 'Mali', '0', 'mali', '0', 'mali');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MM', 'Myanmar', '313', 'Myanmar', 'Myanmar', '0', 'myanmar', '0', 'myanmar');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MN', 'Mongolia', '312', 'Mongolei', 'Mongolia', '0', 'mongolei', '0', 'mongolia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MO', 'Macau', '311', 'Macau', 'Macau', '0', 'macau', '0', 'macau');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MP', 'Northern Mariana Islands', '310', 'Marianen', 'Northern Mariana Islands', '0', 'marianen', '0', 'northern mariana islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MQ', 'Martinique', '309', 'Martinique', 'Martinique', '0', 'martinique', '0', 'martinique');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MR', 'Mauritania', '308', 'Mauretanien', 'Mauritania', '0', 'mauretanien', '0', 'mauritania');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MS', 'Montserrat', '307', 'Montserrat', 'Montserrat', '0', 'montserrat', '0', 'montserrat');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MT', 'Malta', '306', 'Malta', 'Malta', '0', 'malta', '0', 'malta');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MU', 'Mauritius', '305', 'Mauritius', 'Mauritius', '0', 'mauritius', '0', 'mauritius');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MV', 'Maldives', '304', 'Malediven', 'Maldives', '0', 'malediven', '0', 'maldives');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MW', 'Malawi', '303', 'Malwai', 'Malawi', '0', 'malwai', '0', 'malawi');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MX', 'Mexico', '302', 'Mexiko', 'Mexico', '0', 'mexiko', '0', 'mexico');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MY', 'Malaysia', '301', 'Malaysia', 'Malaysia', '0', 'malaysia', '0', 'malaysia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('MZ', 'Mozambique', '300', 'Mosambik', 'Mozambique', '0', 'mosambik', '0', 'mozambique');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NA', 'Namibia', '299', 'Namibia', 'Namibia', '0', 'namibia', '0', 'namibia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NC', 'New Caledonia', '298', 'Neukaledonien', 'New Caledonia', '0', 'neukaledonien', '0', 'new caledonia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NE', 'Niger', '297', 'Niger', 'Niger', '0', 'niger', '0', 'niger');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NF', 'Norfolk Island', '296', 'Norfolkinseln', 'Norfolk Island', '0', 'norfolkinseln', '0', 'norfolk island');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NG', 'Nigeria', '295', 'Nigeria', 'Nigeria', '0', 'nigeria', '0', 'nigeria');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NI', 'Nicaragua', '294', 'Nicaragua', 'Nicaragua', '0', 'nicaragua', '0', 'nicaragua');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NL', 'Netherlands', '293', 'Niederlande', 'Netherlands', '1', 'niederlande', '0', 'netherlands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NO', 'Norway', '292', 'Norwegen', 'Norway', '0', 'norwegen', '0', 'norway');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NP', 'Nepal', '291', 'Nepal', 'Nepal', '0', 'nepal', '0', 'nepal');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NR', 'Nauru', '290', 'Nauru', 'Nauru', '0', 'nauru', '0', 'nauru');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NU', 'Niue', '289', 'Niue', 'Niue', '0', 'niue', '0', 'niue');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('NZ', 'New Zealand', '288', 'Neuseeland', 'New Zealand', '0', 'neuseeland', '0', 'new zealand');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('OM', 'Oman', '287', 'Oman', 'Oman', '0', 'oman', '0', 'oman');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PA', 'Panama', '286', 'Panama', 'Panama', '0', 'panama', '0', 'panama');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PE', 'Peru', '285', 'Peru', 'Peru', '0', 'peru', '0', 'peru');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PF', 'French Polynesia', '284', 'Französisch-Polynesien', 'French Polynesia', '0', 'franzoesisch-polynesien', '0', 'french polynesia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PG', 'Papua New Guinea', '283', 'Papua-Neuguinea', 'Papua New Guinea', '0', 'papua-neuguinea', '0', 'papua new guinea');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PH', 'Philippines', '282', 'Philippinen', 'Philippines', '0', 'philippinen', '0', 'philippines');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PK', 'Pakistan', '281', 'Pakistan', 'Pakistan', '0', 'pakistan', '0', 'pakistan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PL', 'Poland', '280', 'Polen', 'Poland', '1', 'polen', '0', 'poland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PM', 'St. Pierre And Miquelon', '279', 'St. Pierre und Miquelon', 'St. Pierre And Miquelon', '0', 'st. pierre und miquelon', '0', 'st. pierre and miquelon');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PN', 'Pitcairn', '278', 'die Pitcairninseln', 'Pitcairn', '0', 'pitcairninseln, die', '0', 'pitcairn');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PR', 'Puerto Rico', '277', 'Puerto Rico', 'Puerto Rico', '0', 'puerto rico', '0', 'puerto rico');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PT', 'Portugal', '276', 'Portugal', 'Portugal', '0', 'portugal', '0', 'portugal');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PW', 'Palau', '275', 'Palau', 'Palau', '0', 'palau', '0', 'palau');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('PY', 'Paraguay', '274', 'Paraguay', 'Paraguay', '0', 'paraguay', '0', 'paraguay');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('QA', 'Qatar', '273', 'Katar', 'Qatar', '0', 'katar', '0', 'qatar');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('RE', 'Reunion', '272', 'Réunion', 'Reunion', '0', 'reunion', '0', 'reunion');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('RO', 'Romania', '271', 'Rumänien', 'Romania', '0', 'rumaenien', '0', 'romania');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('RS', 'Serbia', '857', 'Serbien', 'Serbia', '0', 'serbia', '0', 'serbia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('RU', 'Russian Federation', '270', 'Russische Föderation', 'Russian Federation', '0', 'russische foederation', '0', 'russian federation');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('RW', 'Rwanda', '269', 'Ruanda', 'Rwanda', '0', 'ruanda', '0', 'rwanda');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SA', 'Saudi Arabia', '268', 'Saudi-Arabien', 'Saudi Arabia', '0', 'saudi-arabien', '0', 'saudi arabia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SB', 'Solomon Islands', '267', 'Salomonen', 'Solomon Islands', '0', 'salomonen', '0', 'solomon islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SC', 'Seychelles', '266', 'Seychellen', 'Seychelles', '0', 'seychellen', '0', 'seychelles');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SD', 'Sudan', '265', 'Sudan', 'Sudan', '0', 'sudan', '0', 'sudan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SE', 'Sweden', '264', 'Schweden', 'Sweden', '0', 'schweden', '0', 'sweden');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SG', 'Singapore', '263', 'Singapur', 'Singapore', '0', 'singapur', '0', 'singapore');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SH', 'St. Helena', '262', 'St. Helena', 'St. Helena', '0', 'st. helena', '0', 'st. helena');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SI', 'Slovenia', '261', 'Slowenien', 'Slovenia', '0', 'slowenien', '0', 'slovenia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SJ', 'Svalbard And Jan Mayen Islands', '260', 'Svalbard und Jan Mayen', 'Svalbard And Jan Mayen Islands', '0', 'svalbard und jan mayen', '0', 'svalbard and jan mayen islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SK', 'Slovakia (Slovak Republic)', '259', 'Slowakai', 'Slovakia (Slovak Republic)', '0', 'slowakai', '0', 'slovakia (slovak republic)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SL', 'Sierra Leone', '258', 'Sierra Leone', 'Sierra Leone', '0', 'sierra leone', '0', 'sierra leone');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SM', 'San Marino', '257', 'San Marino', 'San Marino', '0', 'san marino', '0', 'san marino');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SN', 'Senegal', '256', 'Senegal', 'Senegal', '0', 'senegal', '0', 'senegal');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SO', 'Somalia', '252', 'Somalia', 'Somalia', '0', 'somalia', '0', 'somalia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SR', 'Suriname', '251', 'Suriname', 'Suriname', '0', 'suriname', '0', 'suriname');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ST', 'Sao Tome And Principe', '250', 'Sao Tomé und Principe', 'Sao Tome And Principe', '0', 'sao tomé und principe', '0', 'sao tome and principe');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SV', 'El Salvador', '249', 'El Salvador', 'El Salvador', '0', 'el salvador', '0', 'el salvador');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SY', 'Syrian Arab Republic', '243', 'Syrien', 'Syrian Arab Republic', '0', 'syrien', '0', 'syrian arab republic');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('SZ', 'Swaziland', '242', 'Swasiland', 'Swaziland', '0', 'swasiland', '0', 'swaziland');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TC', 'Turks And Caicos Islands', '240', 'Turks- und Caicosinseln', 'Turks And Caicos Islands', '0', 'turks- und caicosinseln', '0', 'turks and caicos islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TD', 'Chad', '239', 'Tschad', 'Chad', '0', 'tschad', '0', 'chad');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TF', 'French Southern Territories', '238', 'Französische Süd- und Antarktisgebiete', 'French Southern Territories', '0', 'franzoesische sued- und antarktisgebiete', '0', 'french southern territories');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TG', 'Togo', '237', 'Togo', 'Togo', '0', 'togo', '0', 'togo');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TH', 'Thailand', '236', 'Thailand', 'Thailand', '0', 'thailand', '0', 'thailand');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TJ', 'Tajikistan', '235', 'Tadschikistan', 'Tajikistan', '0', 'tadschikistan', '0', 'tajikistan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TK', 'Tokelau', '234', 'Tokelau', 'Tokelau', '0', 'tokelau', '0', 'tokelau');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TM', 'Turkmenistan', '233', 'Turkmenistan', 'Turkmenistan', '0', 'turkmenistan', '0', 'turkmenistan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TN', 'Tunisia', '231', 'Tunesien', 'Tunisia', '0', 'tunesien', '0', 'tunisia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TO', 'Tonga', '223', 'Tonga', 'Tonga', '0', 'tonga', '0', 'tonga');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TR', 'Turkey', '215', 'Türkei', 'Turkey', '0', 'tuerkei', '0', 'turkey');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TT', 'Trinidad And Tobago', '214', 'Trinidad und Tobago', 'Trinidad And Tobago', '0', 'trinidad und tobago', '0', 'trinidad and tobago');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TV', 'Tuvalu', '213', 'Tuvalu', 'Tuvalu', '0', 'tuvalu', '0', 'tuvalu');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TW', 'Taiwan, Province Of China', '212', 'Taiwan', 'Taiwan, Province Of China', '0', 'taiwan', '0', 'taiwan, province of china');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('TZ', 'Tanzania, United Republic Of', '211', 'Tansania', 'Tanzania, United Republic Of', '0', 'tansania', '0', 'tanzania, united republic of');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('UA', 'Ukraine', '210', 'Ukraine', 'Ukraine', '0', 'ukraine', '0', 'ukraine');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('UG', 'Uganda', '209', 'Uganda', 'Uganda', '0', 'uganda', '0', 'uganda');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('UM', 'United States Minor Outlying Islands', '204', 'Amerikanisch-Ozeanien', 'United States Minor Outlying Islands', '0', 'amerikanisch-ozeanien', '0', 'united states minor outlying islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('US', 'United States', '203', 'Vereinigte Staaten von Amerika', 'United States', '0', 'vereinigte staaten von amerika', '1', 'united states');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('UY', 'Uruguay', '201', 'Uruguay', 'Uruguay', '0', 'uruguay', '0', 'uruguay');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('UZ', 'Uzbekistan', '194', 'Usbekistan', 'Uzbekistan', '0', 'usbekistan', '0', 'uzbekistan');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VA', 'Vatican City State (Holy See)', '193', 'der Heilige Stuhl (Vatikan)', 'Vatican City State (Holy See)', '0', 'vatikan, der heilige stuhl', '0', 'vatican city state (holy see)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VC', 'Saint Vincent And The Grenadines', '192', 'St. Vincent und die Grenadinen', 'Saint Vincent And The Grenadines', '0', 'st. vincent und die grenadinen', '0', 'saint vincent and the grenadines');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VE', 'Venezuela', '185', 'Venezuela', 'Venezuela', '0', 'venezuela', '0', 'venezuela');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VG', 'Virgin Islands (British)', '184', 'die Britischen Jungferninseln', 'Virgin Islands (British)', '0', 'jungferninseln, die britischen', '0', 'virgin islands (british)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VI', 'Virgin Islands (U.S.)', '183', 'die Amerikanischen Jungferninseln', 'Virgin Islands (U.S.)', '0', 'jungferninseln, die amerikanischen', '0', 'virgin islands (u.s.)');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VN', 'Viet Nam', '182', 'Vietnam', 'Viet Nam', '0', 'vietnam', '0', 'viet nam');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('VU', 'Vanuatu', '181', 'Vanuatu', 'Vanuatu', '0', 'vanuatu', '0', 'vanuatu');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('WF', 'Wallis And Futuna Islands', '179', 'Wallis und Futuna', 'Wallis And Futuna Islands', '0', 'wallis und futuna', '0', 'wallis and futuna islands');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('WS', 'Samoa', '173', 'Samoa', 'Samoa', '0', 'samoa', '0', 'samoa');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('YE', 'Yemen', '172', 'Jemen', 'Yemen', '0', 'jemen', '0', 'yemen');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('YT', 'Mayotte', '165', 'Mayotte', 'Mayotte', '0', 'mayotte', '0', 'mayotte');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ZA', 'South Africa', '164', 'Südafrika', 'South Africa', '0', 'suedafrika', '0', 'south africa');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ZM', 'Zambia', '163', 'Sambia', 'Zambia', '0', 'sambia', '0', 'zambia');
INSERT INTO `countries` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `sort_de`, `list_default_en`, `sort_en`) VALUES ('ZW', 'Zimbabwe', '162', 'Simbabwe', 'Zimbabwe', '0', 'simbabwe', '0', 'zimbabwe');

-- Table countries_list_default
SET NAMES 'utf8';
TRUNCATE TABLE `countries_list_default`;
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'AT');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'BE');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'CH');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'CZ');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'DE');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'DK');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'ES');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'FR');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'IT');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'LI');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'LU');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'NL');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('DE', 'PL');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('EN', 'AS');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('EN', 'AU');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('EN', 'CA');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('EN', 'GB');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('EN', 'US');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('IT', 'AT');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('IT', 'CH');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('IT', 'FR');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('IT', 'IT');
INSERT INTO `countries_list_default` (`lang`, `show`) VALUES ('IT', 'SI');

-- Table countries_options
SET NAMES 'utf8';
TRUNCATE TABLE `countries_options`;
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('AT', '1', '47.0177163539792', '13.1396484375', '7', '1');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('BE', '1', '50.5483444906748', '4.537353515625', '8', '14');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('BG', '1', '42.0982224111897', '25.86181640625', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('CH', '1', '46.6381224623797', '8.1353759765625', '8', '1');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('CY', '1', '35.0120020431607', '33.2968139648438', '9', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('CZ', '1', '49.4324125802485', '15.238037109375', '7', '3');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('DE', '1', '51.1380014880626', '10.5908203125', '6', '1');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('DK', '1', '56.0536350191344', '10.118408203125', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('EE', '1', '55.4539413294331', '25.1806640625', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('ES', '1', '40.3632883409158', '-2.98828125', '6', '1');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('FI', '1', '62.5731057844998', '14.9853515625', '5', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('FR', '1', '46.9652594003493', '2.87841796875', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('GB', '1', '53.93021986394', '-5.2294921875', '6', '7');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('GR', '1', '39.0618491342915', '22.74169921875', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('HR', '1', '44.3631331138077', '16.76513671875', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('HU', '1', '47.0252060015854', '19.324951171875', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('IE', '1', '53.93021986394', '-5.2294921875', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('IS', '1', '65.2750935499542', '-18.83056640625', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('IT', '1', '42.1796881966596', '12.12890625', '6', '1');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('JP', '1', '36.3151251474805', '136.73583984375', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('LI', '1', '47.1346220607737', '9.55467224121094', '11', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('LT', '1', '55.4539413294331', '25.1806640625', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('LU', '1', '49.7617517582823', '6.053466796875', '9', '14');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('LV', '1', '55.4539413294331', '25.1806640625', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('MD', '1', '47.3834738721015', '28.6083984375', '8', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('ME', '1', '44.3631331138077', '16.76513671875', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('MT', '1', '35.9324286833512', '14.3879699707031', '11', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('NL', '1', '51.4471603469801', '5.44921875', '7', '14');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('NO', '1', '62.5731057844998', '14.9853515625', '5', '8');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('PL', '1', '52.1199986576382', '18.74267578125', '6', '2');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('PT', '1', '40.3632883409158', '-2.98828125', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('RO', '1', '45.8747122489048', '24.93896484375', '7', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('RU', '1', '59.1759282492714', '92.109375', '3', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('SE', '1', '62.5731057844998', '14.9853515625', '5', '6');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('SI', '1', '46.0160387383342', '14.798583984375', '8', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('SK', '1', '48.6220164284684', '18.907470703125', '8', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('TR', '1', '38.0307856938229', '33.90380859375', '6', '0');
INSERT INTO `countries_options` (`country`, `display`, `gmLat`, `gmLon`, `gmZoom`, `nodeId`) VALUES ('US', '1', '30.1451271833761', '-94.658203125', '4', '10');

-- Table data_licenses
SET NAMES 'utf8';
TRUNCATE TABLE `data_licenses`;
INSERT INTO `data_licenses` (`id`, `license`) VALUES ('0', 'passively accepted new license');
INSERT INTO `data_licenses` (`id`, `license`) VALUES ('1', 'declined new license');
INSERT INTO `data_licenses` (`id`, `license`) VALUES ('2', 'actively accepted new license');

-- Table languages
SET NAMES 'utf8';
TRUNCATE TABLE `languages`;
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('BG', 'Bulgarian', '146', 'Bulgarisch', 'Bulgarian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('CS', 'Czech', '145', 'Tschechisch', 'Czech', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('DA', 'Danish', '104', 'Dänisch', 'Danish', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('DE', 'German', '160', 'Deutsch', 'German', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('EL', 'Greek', '103', 'Griechisch', 'Greek', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('EN', 'English', '159', 'Englisch', 'English', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('EO', 'Esperanto', '102', 'Esperanto', 'Esperanto', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('ES', 'Spanish', '157', 'Spanisch', 'Spanish', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('ET', 'Estonian', '101', 'Estnisch', 'Estonian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('EU', 'Basque', '100', 'Baskisch', 'Basque', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('FI', 'Finnish', '93', 'Finnisch', 'Finnish', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('FR', 'French', '158', 'Französisch', 'French', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('HR', 'Croatian', '92', 'Kroatisch', 'Croatian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('HU', 'Hungarian', '91', 'Ungarisch', 'Hungarian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('IS', 'Icelandic', '79', 'Isländisch', 'Icelandic', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('IT', 'Italian', '78', 'Italienisch', 'Italian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('JA', 'Japanese', '156', 'Japanisch', 'Japanese', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('LT', 'Lithuanian', '77', 'Litauisch', 'Lithuanian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('LV', 'Latvian', '76', 'Lettisch', 'Latvian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('NL', 'Dutch', '155', 'Niederländisch', 'Dutch', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('NO', 'Norwegian', '75', 'Norwegisch', 'Norwegian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('PL', 'Polish', '74', 'Polnisch', 'Polish', '1', '1');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('PT', 'Portuguese', '64', 'Portugiesisch', 'Portuguese', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('RO', 'Romanian', '59', 'Rumänisch', 'Romanian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('RU', 'Russian', '49', 'Russisch', 'Russian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('SK', 'Slovak', '48', 'Slowakisch', 'Slovak', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('SL', 'Slovenian', '43', 'Slowenisch', 'Slovenian', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('SV', 'Swedish', '42', 'Schwedisch', 'Swedish', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('TR', 'Turkish', '36', 'Türkisch', 'Turkish', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('UZ', 'Uzbek', '28', 'Usbekisch', 'Uzbek', '0', '0');
INSERT INTO `languages` (`short`, `name`, `trans_id`, `de`, `en`, `list_default_de`, `list_default_en`) VALUES ('VI', 'Vietnamese', '21', 'Vietnamesisch', 'Vietnamese', '0', '0');

-- Table languages_list_default
SET NAMES 'utf8';
TRUNCATE TABLE `languages_list_default`;
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'DA');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'DE');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'EN');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'ES');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'FR');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'NL');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('DE', 'PL');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'DA');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'DE');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'EN');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'ES');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'FR');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'NL');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('EN', 'PL');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('ES', 'EN');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('ES', 'ES');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('IT', 'DE');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('IT', 'EN');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('IT', 'FR');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('IT', 'IT');
INSERT INTO `languages_list_default` (`lang`, `show`) VALUES ('IT', 'SK');

-- Table log_types
SET NAMES 'utf8';
TRUNCATE TABLE `log_types`;
INSERT INTO `log_types` (`id`, `name`, `trans_id`, `permission`, `cache_status`, `de`, `en`, `icon_small`, `allow_rating`, `require_password`) VALUES ('1', 'Found', '56', 'C', '0', 'gefunden', 'Found', 'log/16x16-found.png', '1', '1');
INSERT INTO `log_types` (`id`, `name`, `trans_id`, `permission`, `cache_status`, `de`, `en`, `icon_small`, `allow_rating`, `require_password`) VALUES ('2', 'Not found', '497', 'C', '0', 'nicht gefunden', 'Not found', 'log/16x16-dnf.png', '0', '0');
INSERT INTO `log_types` (`id`, `name`, `trans_id`, `permission`, `cache_status`, `de`, `en`, `icon_small`, `allow_rating`, `require_password`) VALUES ('3', 'Note', '20', 'A', '0', 'Bemerkung', 'Note', 'log/16x16-note.png', '0', '0');
INSERT INTO `log_types` (`id`, `name`, `trans_id`, `permission`, `cache_status`, `de`, `en`, `icon_small`, `allow_rating`, `require_password`) VALUES ('7', 'Attended', '498', 'C', '0', 'teilgenommen', 'Attended', 'log/16x16-go.png', '1', '1');
INSERT INTO `log_types` (`id`, `name`, `trans_id`, `permission`, `cache_status`, `de`, `en`, `icon_small`, `allow_rating`, `require_password`) VALUES ('8', 'Will attend', '499', 'C', '0', 'will dabei sein', 'Will attend', 'log/16x16-trash.png', '0', '0');

-- Table log_types_text
SET NAMES 'utf8';
TRUNCATE TABLE `log_types_text`;
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('1', '1', 'DE', 'gefunden', 'hat den Cache gefunden');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('2', '2', 'DE', 'nicht gefunden', 'hat den Cache nicht gefunden');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('3', '3', 'DE', 'Bemerkung', 'hat eine Bemerkung geschrieben');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('4', '4', 'DE', 'gesperrt', 'hat den Cache gesperrt');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('5', '5', 'DE', 'fregegeben', 'hat den Cache wieder freigegeben');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('6', '6', 'DE', 'entfernt', 'hat den Cache entfernt');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('13', '7', 'EN', 'attended', 'attended the event');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('14', '8', 'EN', 'will attend', 'will attend the event');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('15', '7', 'DE', 'Teilgenommen', 'hat am Event teilgenommen');
INSERT INTO `log_types_text` (`id`, `log_types_id`, `lang`, `text_combo`, `text_listing`) VALUES ('16', '8', 'DE', 'will dabei sein', 'beabsichtigt, am Event teilzunehmen');

-- Table logentries_types
SET NAMES 'utf8';
TRUNCATE TABLE `logentries_types`;
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('1', 'watchlist', 'owner_notify');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('2', 'watchlist', 'sendmail');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('3', 'remindemail', 'sendmail');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('4', 'approving', 'deletecache');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('5', 'cache', 'changeowner');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('6', 'user', 'disable');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('7', 'user', 'delete');
INSERT INTO `logentries_types` (`id`, `module`, `eventname`) VALUES ('8', 'notification', 'sendmail');

-- Table news_topics
SET NAMES 'utf8';
TRUNCATE TABLE `news_topics`;
INSERT INTO `news_topics` (`id`, `name`, `trans_id`) VALUES ('1', 'Geocaching', '0');
INSERT INTO `news_topics` (`id`, `name`, `trans_id`) VALUES ('2', 'www.opencaching.de', '0');
INSERT INTO `news_topics` (`id`, `name`, `trans_id`) VALUES ('3', 'Opencaching-Netzwerk', '0');

-- Table nodes
SET NAMES 'utf8';
TRUNCATE TABLE `nodes`;
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('1', 'Opencaching Germany', 'www.opencaching.de', 'OC');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('2', 'Opencaching Poland', 'www.opencaching.pl', 'OP');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('3', 'Opencaching Czech', 'www.opencaching.cz', 'OZ');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('4', 'Local Development', '', 'AA');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('6', 'Opencaching Sweden', 'www.opencaching.se', 'OS');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('7', 'Opencaching Great Britan', 'www.opencaching.org.uk', 'OK');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('8', 'Opencaching Norway', 'www.opencaching.no', 'ON');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('9', 'Opencaching Latvian', 'www.opencaching.lv', 'OV');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('10', 'Opencaching United States', 'www.opencaching.us', 'OU');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('11', 'Opencaching Japan', 'www.opencaching.jp', 'OJ');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('12', 'Opencaching Russia', 'www.opencaching.su', 'OR');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('13', 'Opencaching Garmin', 'www.opencaching.com', 'OX');
INSERT INTO `nodes` (`id`, `name`, `url`, `waypoint_prefix`) VALUES ('14', 'Opencaching Benelux', 'www.opencaching.nl', 'OB');

-- Table object_types
SET NAMES 'utf8';
TRUNCATE TABLE `object_types`;
INSERT INTO `object_types` (`id`, `name`) VALUES ('1', 'cache log');
INSERT INTO `object_types` (`id`, `name`) VALUES ('2', 'cache');
INSERT INTO `object_types` (`id`, `name`) VALUES ('3', 'cache description');
INSERT INTO `object_types` (`id`, `name`) VALUES ('4', 'user');
INSERT INTO `object_types` (`id`, `name`) VALUES ('5', 'Traveler');
INSERT INTO `object_types` (`id`, `name`) VALUES ('6', 'Picture');
INSERT INTO `object_types` (`id`, `name`) VALUES ('7', 'Removed Object');

-- Table profile_options
SET NAMES 'utf8';
TRUNCATE TABLE `profile_options`;
INSERT INTO `profile_options` (`id`, `name`, `trans_id`, `internal_use`, `default_value`, `check_regex`, `option_order`, `option_input`) VALUES ('1', 'MiniMap-Zoom', '748', '1', '11', '^[1-9][0-9]{0,1}$', '0', 'text');
INSERT INTO `profile_options` (`id`, `name`, `trans_id`, `internal_use`, `default_value`, `check_regex`, `option_order`, `option_input`) VALUES ('2', 'Hometown', '747', '0', '', '^.*$', '10', 'text');
INSERT INTO `profile_options` (`id`, `name`, `trans_id`, `internal_use`, `default_value`, `check_regex`, `option_order`, `option_input`) VALUES ('3', 'Free text', '746', '0', '', NULL, '100', 'textarea');
INSERT INTO `profile_options` (`id`, `name`, `trans_id`, `internal_use`, `default_value`, `check_regex`, `option_order`, `option_input`) VALUES ('4', 'Age', '745', '0', '', '^[[0-9]+$', '80', 'text');
INSERT INTO `profile_options` (`id`, `name`, `trans_id`, `internal_use`, `default_value`, `check_regex`, `option_order`, `option_input`) VALUES ('5', 'Show statistics', '744', '1', '1', '^[[0-1]{1,1}$', '50', 'checkbox');

-- Table replication_overwritetypes
SET NAMES 'utf8';
TRUNCATE TABLE `replication_overwritetypes`;
INSERT INTO `replication_overwritetypes` (`id`, `table`, `field`, `uuid_fieldname`, `backupfirst`) VALUES ('1', 'user', 'password', 'uuid', '0');
INSERT INTO `replication_overwritetypes` (`id`, `table`, `field`, `uuid_fieldname`, `backupfirst`) VALUES ('2', 'user', 'email', 'uuid', '0');
INSERT INTO `replication_overwritetypes` (`id`, `table`, `field`, `uuid_fieldname`, `backupfirst`) VALUES ('3', 'user', 'is_active_flag', 'uuid', '0');
INSERT INTO `replication_overwritetypes` (`id`, `table`, `field`, `uuid_fieldname`, `backupfirst`) VALUES ('4', 'user', 'permanent_login_flag', 'uuid', '0');
INSERT INTO `replication_overwritetypes` (`id`, `table`, `field`, `uuid_fieldname`, `backupfirst`) VALUES ('5', 'user', 'admin', 'uuid', '0');

-- Table search_ignore
SET NAMES 'utf8';
TRUNCATE TABLE `search_ignore`;
INSERT INTO `search_ignore` (`word`) VALUES ('aber');
INSERT INTO `search_ignore` (`word`) VALUES ('als');
INSERT INTO `search_ignore` (`word`) VALUES ('also');
INSERT INTO `search_ignore` (`word`) VALUES ('and');
INSERT INTO `search_ignore` (`word`) VALUES ('are');
INSERT INTO `search_ignore` (`word`) VALUES ('auch');
INSERT INTO `search_ignore` (`word`) VALUES ('auf');
INSERT INTO `search_ignore` (`word`) VALUES ('aus');
INSERT INTO `search_ignore` (`word`) VALUES ('bei');
INSERT INTO `search_ignore` (`word`) VALUES ('beim');
INSERT INTO `search_ignore` (`word`) VALUES ('bin');
INSERT INTO `search_ignore` (`word`) VALUES ('bis');
INSERT INTO `search_ignore` (`word`) VALUES ('dann');
INSERT INTO `search_ignore` (`word`) VALUES ('das');
INSERT INTO `search_ignore` (`word`) VALUES ('dem');
INSERT INTO `search_ignore` (`word`) VALUES ('den');
INSERT INTO `search_ignore` (`word`) VALUES ('denn');
INSERT INTO `search_ignore` (`word`) VALUES ('der');
INSERT INTO `search_ignore` (`word`) VALUES ('des');
INSERT INTO `search_ignore` (`word`) VALUES ('die');
INSERT INTO `search_ignore` (`word`) VALUES ('diese');
INSERT INTO `search_ignore` (`word`) VALUES ('diesem');
INSERT INTO `search_ignore` (`word`) VALUES ('diesen');
INSERT INTO `search_ignore` (`word`) VALUES ('dieser');
INSERT INTO `search_ignore` (`word`) VALUES ('dieses');
INSERT INTO `search_ignore` (`word`) VALUES ('doch');
INSERT INTO `search_ignore` (`word`) VALUES ('dort');
INSERT INTO `search_ignore` (`word`) VALUES ('durch');
INSERT INTO `search_ignore` (`word`) VALUES ('ein');
INSERT INTO `search_ignore` (`word`) VALUES ('eine');
INSERT INTO `search_ignore` (`word`) VALUES ('einem');
INSERT INTO `search_ignore` (`word`) VALUES ('einen');
INSERT INTO `search_ignore` (`word`) VALUES ('einer');
INSERT INTO `search_ignore` (`word`) VALUES ('euch');
INSERT INTO `search_ignore` (`word`) VALUES ('for');
INSERT INTO `search_ignore` (`word`) VALUES ('fuer');
INSERT INTO `search_ignore` (`word`) VALUES ('für');
INSERT INTO `search_ignore` (`word`) VALUES ('geht');
INSERT INTO `search_ignore` (`word`) VALUES ('gibt');
INSERT INTO `search_ignore` (`word`) VALUES ('habe');
INSERT INTO `search_ignore` (`word`) VALUES ('haben');
INSERT INTO `search_ignore` (`word`) VALUES ('hat');
INSERT INTO `search_ignore` (`word`) VALUES ('hatte');
INSERT INTO `search_ignore` (`word`) VALUES ('hatten');
INSERT INTO `search_ignore` (`word`) VALUES ('hier');
INSERT INTO `search_ignore` (`word`) VALUES ('ich');
INSERT INTO `search_ignore` (`word`) VALUES ('ihr');
INSERT INTO `search_ignore` (`word`) VALUES ('ist');
INSERT INTO `search_ignore` (`word`) VALUES ('kann');
INSERT INTO `search_ignore` (`word`) VALUES ('koennen');
INSERT INTO `search_ignore` (`word`) VALUES ('können');
INSERT INTO `search_ignore` (`word`) VALUES ('konnten');
INSERT INTO `search_ignore` (`word`) VALUES ('mal');
INSERT INTO `search_ignore` (`word`) VALUES ('man');
INSERT INTO `search_ignore` (`word`) VALUES ('mein');
INSERT INTO `search_ignore` (`word`) VALUES ('mich');
INSERT INTO `search_ignore` (`word`) VALUES ('mir');
INSERT INTO `search_ignore` (`word`) VALUES ('mit');
INSERT INTO `search_ignore` (`word`) VALUES ('muss');
INSERT INTO `search_ignore` (`word`) VALUES ('muß');
INSERT INTO `search_ignore` (`word`) VALUES ('nach');
INSERT INTO `search_ignore` (`word`) VALUES ('nicht');
INSERT INTO `search_ignore` (`word`) VALUES ('noch');
INSERT INTO `search_ignore` (`word`) VALUES ('not');
INSERT INTO `search_ignore` (`word`) VALUES ('nun');
INSERT INTO `search_ignore` (`word`) VALUES ('nur');
INSERT INTO `search_ignore` (`word`) VALUES ('oder');
INSERT INTO `search_ignore` (`word`) VALUES ('sein');
INSERT INTO `search_ignore` (`word`) VALUES ('sich');
INSERT INTO `search_ignore` (`word`) VALUES ('sie');
INSERT INTO `search_ignore` (`word`) VALUES ('sind');
INSERT INTO `search_ignore` (`word`) VALUES ('that');
INSERT INTO `search_ignore` (`word`) VALUES ('the');
INSERT INTO `search_ignore` (`word`) VALUES ('there');
INSERT INTO `search_ignore` (`word`) VALUES ('this');
INSERT INTO `search_ignore` (`word`) VALUES ('über');
INSERT INTO `search_ignore` (`word`) VALUES ('und');
INSERT INTO `search_ignore` (`word`) VALUES ('uns');
INSERT INTO `search_ignore` (`word`) VALUES ('vom');
INSERT INTO `search_ignore` (`word`) VALUES ('von');
INSERT INTO `search_ignore` (`word`) VALUES ('vor');
INSERT INTO `search_ignore` (`word`) VALUES ('war');
INSERT INTO `search_ignore` (`word`) VALUES ('waren');
INSERT INTO `search_ignore` (`word`) VALUES ('was');
INSERT INTO `search_ignore` (`word`) VALUES ('wenn');
INSERT INTO `search_ignore` (`word`) VALUES ('werden');
INSERT INTO `search_ignore` (`word`) VALUES ('wie');
INSERT INTO `search_ignore` (`word`) VALUES ('will');
INSERT INTO `search_ignore` (`word`) VALUES ('wir');
INSERT INTO `search_ignore` (`word`) VALUES ('wird');
INSERT INTO `search_ignore` (`word`) VALUES ('with');
INSERT INTO `search_ignore` (`word`) VALUES ('wurde');
INSERT INTO `search_ignore` (`word`) VALUES ('yes');
INSERT INTO `search_ignore` (`word`) VALUES ('you');
INSERT INTO `search_ignore` (`word`) VALUES ('zum');
INSERT INTO `search_ignore` (`word`) VALUES ('zur');

-- Table statpics
SET NAMES 'utf8';
TRUNCATE TABLE `statpics`;
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('1', 'images/ocstats1.gif', 'images/ocstats1_prev.jpg', 'Standardlogo', '1745', '60');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('2', 'images/ocstats2.gif', 'images/ocstats2_prev.jpg', 'Alternative logo', '1752', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('3', 'images/ocstats3.gif', 'images/ocstats3_prev.jpg', 'Alternative by nybbler', '1747', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('4', 'images/ocstats4.gif', 'images/ocstats4_prev.jpg', 'Slimline', '1753', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('5', 'images/ocstats5.gif', 'images/ocstats5_prev.jpg', 'Red logo, slimline', '1754', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('6', 'images/ocstats4.gif', 'images/ocstats4a_prev.jpg', 'Slimline, without statistics', '1755', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('7', 'images/ocstats5.gif', 'images/ocstats5a_prev.jpg', 'Slimline red, without statistics', '1756', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('8', 'images/ocstats6.gif', 'images/ocstats6_prev.jpg', 'Round corners', '1757', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('9', 'images/ocstats7.gif', 'images/ocstats7_prev.jpg', 'OC.de new', '1821', '60');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('10', 'images/ocstats8.gif', 'images/ocstats8_prev.jpg', 'OC.de new, slimline', '1822', '50');
INSERT INTO `statpics` (`id`, `tplpath`, `previewpath`, `description`, `trans_id`, `maxtextwidth`) VALUES ('11', 'images/ocstats8.gif', 'images/ocstats8a_prev.jpg', 'OC.de new, without statistics', '1823', '50');

-- Table sys_menu
SET NAMES 'utf8';
TRUNCATE TABLE `sys_menu`;
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('1', 'MNU_START', '', '0', 'Start', '80', '0', 'index.php', '1', '0', '1', '#D5D9FF', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('2', 'MNU_START_ABOUTGC', 'About Geocaching', '123', 'About Geocaching', '123', '0', 'articles.php?page=geocaching', '1', '1', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('3', 'MNU_START_REGISTER', 'Register', '18', 'Register', '18', '0', 'register.php', '1', '1', '2', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('4', 'MNU_START_NEWS', 'News', '70', 'News', '70', '0', 'news.php', '1', '1', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('5', 'MNU_START_NEWCACHES', 'New caches', '122', 'New caches', '122', '0', 'newcaches.php', '1', '1', '4', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('6', 'MNU_START_NEWCACHES_WITHOUTOWN', 'Without Germany', '121', 'Without Germany', '121', '0', 'newcachesrest.php', '1', '5', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('7', 'MNU_START_NEWLOGS', 'New logs', '120', 'New logs', '120', '0', 'newlogs.php', '1', '1', '5', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('8', 'MNU_START_IMPRINT', 'Imprint', '15', 'Imprint', '15', '0', 'articles.php?page=impressum', '1', '1', '10', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('9', 'MNU_MYPROFILE', 'My profile', '119', 'My profile', '119', '0', 'myhome.php', '1', '0', '2', '#E8DDE4', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('10', 'MNU_CACHES', 'Caches', '118', 'Caches', '118', '0', 'search.php', '1', '0', '3', '#FFFFC5', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('12', 'MNU_ADMIN', 'Admin', '116', 'Admin', '116', '1', 'translate.php', '1', '0', '7', '#E8DDE4', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('20', 'MNU_CACHES_SEARCH', 'Search', '125', 'Search', '125', '0', 'search.php', '1', '10', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('21', 'MNU_CACHES_HIDE', 'Create a cache', '115', 'Create a cache', '115', '0', 'newcache.php', '1', '10', '2', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('22', 'MNU_CACHES_HIDE_DESCRIPTION', 'Description', '114', 'Description', '114', '0', 'articles.php?page=cacheinfo', '1', '21', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('23', 'MNU_CACHES_HIDE_HTMLTAGS', 'HTML Tags', '113', 'HTML Tags', '113', '0', 'articles.php?page=htmltags', '1', '21', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('24', 'MNU_ADMIN_MENU_NEWITEM', 'New Item', '124', 'New Item', '124', '0', 'newitem.php', '0', '13', '1', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('25', 'MNU_CACHES_TOPS', 'Special caches', '52', 'Special caches', '52', '0', 'tops.php', '1', '10', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('26', 'MNU_CACHES_HIDE_PREVIEW', 'HTML preview', '58', 'HTML preview', '58', '0', 'htmlprev.php', '1', '21', '2', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('27', 'MNU_START_CONTACT', 'Contact', '16', 'Contact', '16', '0', 'articles.php?page=contact', '0', '1', '11', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('28', 'MNU_START_PRIVACY', 'Privacy statement', '14', 'Privacy statement', '14', '0', 'articles.php?page=dsb', '0', '1', '12', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('29', 'MNU_START_REGISTER_ACTIVATION', 'Activation', '127', 'Activation', '127', '0', 'activation.php', '0', '3', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('30', 'MNU_CACHES_USERPROFILE', 'Userprofile', '128', 'Userprofile', '128', '0', 'viewprofile.php', '0', '10', '4', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('31', 'MNU_START_NEWS_POST', 'Post some news', '180', 'Post some news', '180', '0', 'newstopic.php', '0', '4', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('32', 'MNU_LOGIN', 'Login', '207', 'Login', '207', '0', 'login.php', '0', '0', '8', '#D5D9FF', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('33', 'MNU_CACHES_USERTOPS', 'Show recommendations', '248', 'Show recommendations', '248', '0', 'usertops.php', '0', '10', '5', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('34', 'MNU_ERROR', 'Error message', '133', 'Error message', '133', '0', '', '0', '0', '9', '#D5D9FF', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('35', 'MNU_ADMIN_TRANSLATE', 'Translation', '126', 'Translation', '126', '1', 'translate.php', '1', '12', '1', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('36', 'MNU_MYPROFILE_OVERVIEW', 'My profile', '119', 'Overview', '483', '0', 'myhome.php', '1', '9', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('37', 'MNU_MYPROFILE_DATA', 'Profile', '484', 'Profile', '484', '0', 'myprofile.php', '1', '9', '2', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('38', 'MNU_MYPROFILE_QUERIES', 'Stored queries', '485', 'Stored queries', '485', '0', 'query.php', '1', '9', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('39', 'MNU_MYPROFILE_WATCHES', 'Watched caches', '486', 'Watched caches', '486', '0', 'mywatches.php', '1', '9', '4', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('40', 'MNU_MYPROFILE_IGNORES', 'Ignored caches', '487', 'Ignored caches', '487', '0', 'myignores.php', '1', '9', '5', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('41', 'MNU_MYPROFILE_RECOMMENDATIONS', 'Recommendations', '55', 'Recommendations', '55', '0', 'mytop5.php', '1', '9', '6', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('42', 'MNU_MYPROFILE_WATCHES_EDIT', 'Settings', '488', 'Settings', '488', '0', 'mywatches.php?action=edit', '1', '39', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('43', 'MNU_MYPROFILE_DATA_EDIT', 'Edit profile', '489', 'Edit profile', '489', '0', 'myprofile.php?action=change', '1', '37', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('44', 'MNU_MYPROFILE_DATA_EMAIL', 'E-Mail Address', '493', 'E-Mail Address', '493', '0', 'newemail.php', '1', '37', '2', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('45', 'MNU_MYPROFILE_DATA_PASSWORD', 'Change password', '491', 'Change password', '491', '0', 'newpw.php', '1', '37', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('46', 'MNU_MYPROFILE_DATA_STATPIC', 'Change statpic', '492', 'Change statpic', '492', '0', 'change_statpic.php', '1', '37', '4', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('47', 'MNU_CACHES_VIEWLOGS', 'Show logentries', '555', 'Show logentries', '555', '0', 'viewlogs.php', '0', '10', '6', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('48', 'MNU_LOGIN_NEWPW', 'Change password', '491', 'Change password', '491', '0', 'newpw.php', '0', '32', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('49', 'MNU_LOGIN_REMINDEMAIL', 'Remind E-Mail', '659', 'Remind E-Mail', '659', '0', 'remindemail.php', '0', '32', '3', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('50', 'MNU_CACHES_SEARCH_RECOMMENDATIONS', 'Recommendations', '55', 'Recommendations', '55', '0', 'recommendations.php', '0', '20', '1', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('51', 'MNU_SITEMAP', 'Sitemap', '17', 'Sitemap', '17', '0', 'sitemap.php', '0', '0', '11', '#D5D9FF', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('52', 'MNU_ADMIN_DBMAINTAIN', 'Database maintainance', '672', 'DB Maintainance', '673', '1', 'dbmaintain.php', '1', '12', '2', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('53', 'MNU_USER', 'User', '4', 'User', '4', '0', '', '0', '0', '5', '#FFFFC5', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('54', 'MNU_USER_MAILTO', 'Send E-Mail', '148', 'Send E-Mail', '148', '0', 'mailto.php', '0', '53', '1', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('55', 'MNU_CACHES_SEARCH_VIEWCACHE', 'Show Geocache', '698', 'Show Geocache', '698', '0', 'viewcache.php', '0', '20', '1', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('56', 'MNU_CACHES_PICTURE', 'Edit picture', '741', 'Edit picture', '741', '0', 'picture.php', '0', '10', '7', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('58', 'MNU_ADMIN_REPORTS', 'Reported caches', '750', 'Reported caches', '750', '1', 'adminreports.php', '1', '12', '3', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('59', 'MNU_CACHES_REPORT', 'Report cache', '772', 'Report cache', '772', '0', 'reportcache.php', '0', '10', '8', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('60', 'MNU_MYPROFILE_DETAILS', 'My details', '799', 'My details', '799', '0', 'mydetails.php', '1', '37', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('61', 'MNU_MYPROFILE_DETAILS_EDIT', 'Edit details', '800', 'Edit details', '800', '0', 'mydetails.php?action=change', '1', '37', '1', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('62', 'MNU_CACHES_USERDETAILS', 'User details', '801', 'User details', '801', '0', 'viewuserdetails.php', '0', '10', '4', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('63', 'MNU_MYPROFILE_ADOPT', 'Adoptions', '827', 'Adoptions', '827', '0', 'adoptcache.php', '1', '9', '7', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('64', 'MNU_CACHES_ADOPT', 'Adoptions', '827', 'Adoptions', '827', '0', 'adoptcache.php', '0', '10', '9', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('65', 'MNU_ADMIN_USER', 'Manage User', '859', 'Manage User', '859', '0', 'adminuser.php', '1', '12', '4', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('66', 'MNU_ADMIN_NEWS', 'News approve', '873', 'News approve', '873', '1', 'newsapprove.php', '1', '12', '5', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('67', 'MNU_START_DONATE', 'Donations', '900', 'Donations', '900', '0', 'articles.php?page=donations', '1', '1', '6', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('68', 'MNU_START_TOS', 'Terms of use', '906', 'Terms of use', '906', '0', 'articles.php?page=impressum#tos', '1', '1', '9', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('69', 'MNU_START_TEAM', 'Our Team', '907', 'Our Team', '907', '0', 'articles.php?page=team', '1', '1', '7', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('70', 'MNU_MAP', 'Map', '1269', 'Map', '1269', '0', 'map2.php', '1', '0', '4', '#FFFFC5', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('85', 'MNU_CACHES_LOG', 'Create a logentry', '1687', 'Create a logentry', '1687', '0', 'log2.php', '0', '10', '10', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('86', 'MNU_START_CHANGELOG', 'Changelog', '1797', 'Changelog', '1797', '0', 'articles.php?page=changelog', '0', '0', '10', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('87', 'MNU_START_OPERATOR', 'Operator Association', '1798', 'Operator Association', '1798', '0', 'articles.php?page=verein', '1', '1', '8', '', '1', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('88', 'MNU_VERIFY_EMAIL', 'Verify e-mail address', '1824', 'Verify e-mail address', '1824', '0', 'verifyemail.php', '0', '0', '0', '', '0', NULL);
INSERT INTO `sys_menu` (`id`, `id_string`, `title`, `title_trans_id`, `menustring`, `menustring_trans_id`, `access`, `href`, `visible`, `parent`, `position`, `color`, `sitemap`, `only_if_parent`) VALUES ('89', 'MNU_ADMIN_ADMINS', 'Admins', '1831', 'Admins', '1831', '1', 'admins.php', '1', '12', '6', '', '0', NULL);

-- Table sys_trans
SET NAMES 'utf8';
TRUNCATE TABLE `sys_trans`;
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1', 'Reorder ID\'s', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('2', 'The database could not be reconnected.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('3', 'Testing - do not login, please', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('4', 'User', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('5', '(empty)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('6', 'Logged in as', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('7', 'Logout', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('8', 'Waypoint-Search', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('9', 'Page timing', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('10', 'sec', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('11', 'Page cached', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('12', 'DB connected', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('13', 'Created at', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('14', 'Privacy statement', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('15', 'Imprint', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('16', 'Contact', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('17', 'Sitemap', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('18', 'Register', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('19', 'New user registered', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('20', 'Note', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('21', 'Vietnamese', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('22', 'Username', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('23', 'E-Mail', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('24', 'First name', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('25', 'Last name', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('26', 'Country', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('27', 'Register new user', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('28', 'Uzbek', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('29', 'The username is not valid.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('30', 'Print last logs', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('31', 'The last name is not valid.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('32', 'The first name is not valid.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('33', 'Not specified', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('34', 'Show all', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('35', 'The E-Mail is not valid.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('36', 'Turkish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('37', 'Your password', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('38', 'The password contains invalid chars.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('39', 'The passwords did not match.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('40', 'Please repeat', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('41', '* are required', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('42', 'Swedish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('43', 'Slovenian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('44', 'length at least 6 chars', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('45', 'at least 4 different chars', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('46', 'not part of the username', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('47', 'not in the wordlist with often used passwords', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('48', 'Slovak', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('49', 'Russian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('50', 'You have to accept the privacy statement and terms of use to register at opencaching.de', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('51', 'Reset', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('52', 'Special caches', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('54', 'Index', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('55', 'Recommendations', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('56', 'Found', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('57', 'by', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('58', 'HTML preview', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('59', 'Romanian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('60', 'Step 1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('61', 'Enter the text in following field:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('62', 'Next', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('63', 'Step 2', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('64', 'Portuguese', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('65', 'Back', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('66', 'Preview', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('67', 'Step 3', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('68', 'The Browser will show your HTML code like the following:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('69', 'You can save the following HTML code and enter it in the cache description.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('70', 'News', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('71', 'Latest caches', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('72', 'Latest caches without germany', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('73', 'Latest logs entries', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('74', 'Polish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('75', 'Norwegian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('76', 'Latvian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('77', 'Lithuanian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('78', 'Italian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('79', 'Icelandic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('80', 'Start', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('81', 'What do i find on this website?', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('82', 'You can find everything you need to go Geocaching ...', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('83', 'The file was not uploaded correctly.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('84', 'The file was too big. The maximum file size is 150 KB.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('85', 'No picture file given.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('86', 'same type', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('87', 'Opencaching.de', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('90', 'Total of %1 active Caches and %2 founds by %3 users', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('91', 'Hungarian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('92', 'Croatian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('93', 'Finnish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('94', 'Yes', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('95', 'No', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('96', 'Hello', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('99', 'This E-Mail was generated by the opencaching.de website, because an account with this E-Mail address was created. If you don\'t want to receive E-Mails in future, please contact us via E-Mail %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('100', 'Basque', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('101', 'Estonian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('102', 'Esperanto', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('103', 'Greek', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('104', 'Danish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('105', 'An unkown error occured.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('106', 'Template does not exist.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('107', 'Sorry, you are not allowed to view this page.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('108', 'Sorry, the requested cache does not exist.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('109', 'Sorry, the requested operation cannot be performed.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('110', 'Sorry, the requested operation cannot be performed because you are not logged in with an user account.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('111', 'Sorry, the requested user does not exist.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('112', 'Mail template does not exist.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('113', 'HTML Tags', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('114', 'Description', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('115', 'Create a cache', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('116', 'Admin', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('117', 'Informations', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('118', 'Caches', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('119', 'My profile', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('120', 'New logs', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('121', 'Without Germany', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('122', 'New caches', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('123', 'About Geocaching', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('124', 'New Item', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('125', 'Search', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('126', 'Translation', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('127', 'Activation', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('128', 'Userprofile', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('129', 'An error occured while processing the page', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('130', 'An error occured while processing the page. If you\'ve called this page from an hyperlink on our site and this error persists some time, please contact us via E-Mail.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('131', 'The following error occured', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('132', 'Site', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('133', 'Error message', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('134', '%2 found %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('135', '%2 didn\'t find %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('136', '%2 wrote a note for %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('137', '%2 visited %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('138', '%2 want\'s to visit %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('139', 'Registration confirmation', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('140', 'welcome at www.opencaching.de!', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('141', 'The following data has been stored for your E-Mail address %1:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('142', 'Slave', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('143', 'The activation can be performed on the following URL:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('144', 'If you don\'t login in the next 14 days, your account may be deleted.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('145', 'Czech', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('146', 'Bulgarian', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('147', 'Userprofile of %1', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('148', 'Send E-Mail', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('149', 'Others', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('150', 'I\'m taking an PMR radio on channel 2 with me', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('151', 'Registered&nbsp;since', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('152', 'Hidden caches', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('153', 'Caches found', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('154', '%1 of %2 possibles', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('155', 'Dutch', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('156', 'Japanese', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('157', 'Spanish', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('158', 'French', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('159', 'English', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('160', 'German', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('161', 'Attention: If you are using this option, don\'t forget to log out before other persons can use your computer. Otherwise, they can use and modify your personal data.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('162', 'Zimbabwe', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('163', 'Zambia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('164', 'South Africa', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('165', 'Mayotte', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('166', 'The activation code was sent with an E-Mail to you.<br> Please follow the instructions in the E-Mail.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('167', 'To create an account on opencaching.de, you have to enter a vaild E-Mail address and an username. An E-Mail will be sent to the address you supplied with an activation code. Only one account can be created per E-Mail address. First name, last name and country are optional.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('168', 'There already exists an account with that E-Mail address. It\'s not possible the register a scond account with the same E-Mail address.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('170', 'Your choosen password was too simple. For your own security, we recommend a stronger password:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('171', 'The activation code or E-Mail was incorrect.<br /> The activation of your account was not successfull<br /> Please use the E-Mail where the registration mail was sent to.<br /> <br /> Please check if you have mistyped - if you cannot solve the problem yourself, contact us via <a href=\"mailto:%1\">%1</a>', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('172', 'Yemen', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('173', 'Samoa', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('174', 'Go', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('175', 'Developer system - only testing', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('177', 'With this wizard, you can make some part of your description <b>bold</b> or <i>italic</i>. No HTML knowledge required.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('178', 'Here you can see the HTML code generated from your text. If you want to make a word <b>bold</b>, insert before the word \&lt;b\&gt; and after the word \&lt;/b\&gt;', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('179', 'Wallis And Futuna Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('180', 'Post some news', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('181', 'Vanuatu', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('182', 'Viet Nam', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('183', 'Virgin Islands (U.S.)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('184', 'Virgin Islands (British)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('185', 'Venezuela', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('186', 'Select target language:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('187', 'Show new translations', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('188', 'Clear smarty cache', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('189', 'Not defined', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('190', 'Show translations no longer referenced', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('191', 'Show all translations', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('192', 'Saint Vincent And The Grenadines', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('193', 'Vatican City State (Holy See)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('194', 'Uzbekistan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('195', 'Use existing translations:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('196', 'All translations:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('197', 'New translations:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('198', 'Translations no longer referenced:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('199', 'Languages', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('201', 'Uruguay', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('202', 'Activation code:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('203', 'United States', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('204', 'United States Minor Outlying Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('206', 'Total', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('207', 'Login', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('208', 'Password', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('209', 'Uganda', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('210', 'Ukraine', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('211', 'Tanzania, United Republic Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('212', 'Taiwan, Province Of China', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('213', 'Tuvalu', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('214', 'Trinidad And Tobago', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('215', 'Turkey', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('216', 'Not registered?', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('217', 'Forgotten your password?', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('218', 'Forgotten your E-Mail-Address?', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('219', 'Here you can find more troubleshooting:', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('220', 'Print no logs', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('221', 'Create a new password', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('222', 'Remind me', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('223', 'Tonga', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('224', 'Please fill in username and password!', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('225', 'Logout was successful.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('226', 'The login was not successfull.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('227', 'The entered username/e-mail or the specified password did not match.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('228', 'Your tried to login more than %1 times in the last hour. The next login will not be allowed before one hour since the first try has passed.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('229', 'Your account is not acivated.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('230', '\&gt;<a href=\"activation.php\">Here</a>\&lt; you can activate your account.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('231', 'Tunisia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('232', 'To complete the registration, you have to enter your E-Mail and activation code.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('233', 'Turkmenistan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('234', 'Tokelau', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('235', 'Tajikistan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('236', 'Thailand', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('237', 'Togo', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('238', 'French Southern Territories', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('239', 'Chad', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('240', 'Turks And Caicos Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('241', 'Name', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('242', 'Swaziland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('243', 'Syrian Arab Republic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('244', 'Recommendations of <a href=\"viewprofile.php?userid=%1\">%2</a>', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('245', '<a href=\"viewcache.php?cacheid=%1\">%2</a> by %3', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('246', '%1 has not recommended any geocache.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('248', 'Show recommendations', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('249', 'El Salvador', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('250', 'Sao Tome And Principe', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('251', 'Suriname', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('252', 'Somalia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('253', 'Unkown format of the given waypoint. The following formats are known OCxxxx, NCxxxx and GCxxxx, whereas xxxx can be any number or char.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('254', 'There exists more than one cache with the waypoint \&quot;%1\&quot;.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('255', 'The waypoint \&quot;%1\&quot; was not found.', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('256', 'Senegal', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('257', 'San Marino', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('258', 'Sierra Leone', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('259', 'Slovakia (Slovak Republic)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('260', 'Svalbard And Jan Mayen Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('261', 'Slovenia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('262', 'St. Helena', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('263', 'Singapore', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('264', 'Sweden', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('265', 'Sudan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('266', 'Seychelles', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('267', 'Solomon Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('268', 'Saudi Arabia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('269', 'Rwanda', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('270', 'Russian Federation', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('271', 'Romania', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('272', 'Reunion', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('273', 'Qatar', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('274', 'Paraguay', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('275', 'Palau', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('276', 'Portugal', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('277', 'Puerto Rico', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('278', 'Pitcairn', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('279', 'St. Pierre And Miquelon', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('280', 'Poland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('281', 'Pakistan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('282', 'Philippines', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('283', 'Papua New Guinea', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('284', 'French Polynesia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('285', 'Peru', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('286', 'Panama', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('287', 'Oman', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('288', 'New Zealand', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('289', 'Niue', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('290', 'Nauru', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('291', 'Nepal', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('292', 'Norway', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('293', 'Netherlands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('294', 'Nicaragua', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('295', 'Nigeria', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('296', 'Norfolk Island', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('297', 'Niger', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('298', 'New Caledonia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('299', 'Namibia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('300', 'Mozambique', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('301', 'Malaysia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('302', 'Mexico', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('303', 'Malawi', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('304', 'Maldives', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('305', 'Mauritius', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('306', 'Malta', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('307', 'Montserrat', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('308', 'Mauritania', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('309', 'Martinique', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('310', 'Northern Mariana Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('311', 'Macau', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('312', 'Mongolia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('313', 'Myanmar', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('314', 'Mali', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('315', 'Macedonia, The Former Yugoslav Republic Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('316', 'Marshall Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('317', 'Madagascar', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('318', 'Moldova, Republic Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('319', 'Monaco', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('320', 'Morocco', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('321', 'Libyan Arab Jamahiriya', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('322', 'Latvia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('323', 'Luxembourg', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('324', 'Lithuania', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('325', 'Lesotho', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('326', 'Liberia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('327', 'Sri Lanka', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('328', 'Liechtenstein', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('329', 'Saint Lucia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('330', 'Lebanon', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('331', 'Lao People\'s Democratic Republic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('332', 'Kazakhstan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('333', 'Cayman Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('334', 'Kuwait', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('335', 'Korea, Republic Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('336', 'Korea, Democratic People\'s Republic Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('337', 'Saint Kitts And Nevis', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('338', 'Comoros', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('339', 'Kiribati', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('340', 'Cambodia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('341', 'Kyrgyzstan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('342', 'Kenya', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('343', 'Japan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('344', 'Jordan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('345', 'Jamaica', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('346', 'Italy', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('347', 'Iceland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('348', 'Iran (Islamic Republic Of)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('349', 'Iraq', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('350', 'British Indian Ocean Territory', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('351', 'India', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('352', 'Israel', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('353', 'Ireland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('354', 'Indonesia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('355', 'Hungary', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('356', 'Haiti', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('357', 'Croatia (local name: Hrvatska)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('358', 'Honduras', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('359', 'Heard And Mc Donald Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('360', 'Hong Kong', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('361', 'Guyana', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('362', 'Guinea-Bissau', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('363', 'Guam', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('364', 'Guatemala', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('365', 'South Georgia And The South Sandwich Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('366', 'Greece', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('367', 'Guadeloupe', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('368', 'Guinea', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('369', 'Gambia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('370', 'Greenland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('371', 'Gibraltar', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('372', 'Ghana', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('373', 'French Guiana', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('374', 'Georgia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('375', 'Grenada', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('376', 'United Kingdom (UK)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('377', 'Gabon', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('378', 'France', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('379', 'Faroe Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('380', 'Micronesia, Federated States Of', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('381', 'Falkland Islands (Malvinas)', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('382', 'Fiji', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('383', 'Finland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('384', 'Ethiopia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('385', 'Spain', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('386', 'Eritrea', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('387', 'Western Sahara', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('388', 'Egypt', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('389', 'Estonia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('390', 'Ecuador', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('391', 'Algeria', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('392', 'Dominican Republic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('393', 'Denmark', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('394', 'Djibouti', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('395', 'Germany', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('396', 'Czech Republic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('397', 'Cyprus', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('398', 'Christmas Island', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('399', 'Cape Verde', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('400', 'Cuba', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('401', 'Attendees', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('402', 'Costa Rica', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('403', 'Colombia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('404', 'China', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('405', 'Cameroon', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('406', 'Chile', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('407', 'Cook Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('408', 'Cote d\'Ivoire', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('409', 'Switzerland', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('410', 'Congo', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('411', 'Central African Republic', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('412', 'Cocos (Keeling) Islands', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('413', 'Canada', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('414', 'Belize', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('415', 'Belarus', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('416', 'Botswana', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('417', 'Bouvet Island', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('418', 'Bhutan', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('419', 'Bahamas', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('420', 'Brazil', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('421', 'Bolivia', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('422', 'Brunei Darussalam', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('423', 'Bermuda', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('424', 'Benin', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('425', 'Burundi', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('426', 'Bahrain', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('427', 'Bulgaria', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('428', 'Burkina Faso', '2010-08-28 11:48:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('429', 'Belgium', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('430', 'Bangladesh', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('431', 'Barbados', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('432', 'Bosnia And Herzegowina', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('433', 'Azerbaijan', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('434', 'Aruba', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('435', 'Australia', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('436', 'Austria', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('437', 'American Samoa', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('438', 'Argentina', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('439', 'Angola', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('440', 'Netherlands Antilles', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('441', 'Armenia', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('442', 'Albania', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('443', 'Anguilla', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('444', 'Antigua And Barbuda', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('445', 'Afghanistan', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('446', 'United Arab Emirates', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('447', 'Andorra', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('448', 'Switching to db-root failed.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('449', '(before an export)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('450', 'We are updating Opencaching.de and to protect against faults it processing, we set to entire page offline.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('452', 'Newsentry saved', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('453', 'Thank you very much for your newsentry. We\'ll try to validate your entry as soon as possible.<br /> <br /> Back to <a href=\"index.php\">Start</a>', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('454', 'Submit a newsentry', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('455', 'Submit', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('456', 'The code did not match.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('457', 'And now fill in the code to protect against spammers:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('458', 'What does this picture show?', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('459', 'E-Mail-Adress is not valid.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('460', 'Your E-Mail for further questions:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('461', 'Please only use HTML tags to format the text - eg. bold, color or hyperlinks. We do not want tables, divs etc.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('462', 'The newsentry is written with HTML tags', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('463', 'Newsentry:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('464', 'Topic:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('465', 'Are there any news about Geocaching?<br /> Here you can create a newsentry, that will be shown on the start page.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('466', 'The activation of your account was successfull. You can now login on the login page.<br /><br /> <a href=\"login.php\">Go to the login page</a>', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('467', 'Hint', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('468', 'Activate account', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('469', 'Best regards,<br/>the Opencaching.de-Team', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('470', 'Please be patient, we will do our best to get the site back online as soon as possible.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('471', 'The account could not be created, the reason is not known. If you cannot solve this problem yourself, pleas contact us via <a href=\"mailto:%1\">E-Mail</a>', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('472', 'We respect your privacy. Your personal data will be stored in our database, but not shared to third parties. Please note our exact <a href=\"articles.php?page=dsb\">privacy statement</a>. If you have further questions, please <a href=\"mailto:%1\">contact us</a> <b>before</b> you create your account.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('473', 'We have to approve your newsentry before we can display it. We try to do this within 24h to 48h. The newsentry cannot be modified after you have submitted it. If you want to take changes in the newsentry, please resubmit the correct newsentry. It is allowed to submit news about everything around Geocaching - but it is not allowed to submit advertisement for products or geocaches. The decission to approve or not approve a newsentry lies exclusively in the discretion of the operator of the web page - there is not a requirement on publication. In the case of doubts, please submit your newsentry and wait if it will be shown - or ask via E-Mail before submitting <a href=\"mailto:%1\">%1</a>.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('474', 'If this problem persists over a longer time, please contact us at <a href=\"mailto:%1\">%1</a>.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('475', 'Opencaching is out of service', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('476', 'Created at:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('477', 'Total runtime:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('478', 'Business layer runtime:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('479', 'Framework runtime:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('480', 'User runtime:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('481', 'SQL Debugger', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('482', '%1 commands', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('483', 'Overview', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('484', 'Profile', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('485', 'Stored queries', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('486', 'Watched caches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('487', 'Ignored caches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('488', 'Settings', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('489', 'Edit profile', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('490', 'The notification radius must be not more than 150 km. To deaktivate notifications, set the radius to 0.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('491', 'Change password', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('492', 'Change statpic', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('493', 'E-Mail Address', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('494', 'Available', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('495', 'Temporary disabled', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('496', 'Archived', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('497', 'Not found', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('498', 'Attended', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('499', 'Will attend', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('500', 'Hello %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('501', 'Logs', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('502', 'Geocaches found: %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('503', 'Your latest log entries:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('504', 'No entries found', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('505', 'Geocaches hidden: %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('506', 'Your latest Geocaches hidden:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('507', 'No Geocaches hidden', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('508', 'Not published Geocaches will be available', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('509', 'All Geocaches are published', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('510', 'E-Mails sent', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('511', 'E-Mails sent: %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('512', 'Unknown Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('513', 'Traditional Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('514', 'Multicache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('515', 'Virtual Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('516', 'Webcam Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('517', 'Event Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('518', 'Quizcache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('519', 'Math/Physics Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('520', 'Moving Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('521', 'Drive-In Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('522', 'Motocycle Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('524', 'other size', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('525', 'micro', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('526', 'small', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('527', 'normal', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('528', 'large', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('529', 'very large', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('530', 'no container', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('531', 'Ready for search', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('532', 'Temporary not available', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('533', 'Hidden by approvers to check', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('534', 'Not yet available', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('535', 'unknown cachetyp', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('536', 'Traditional Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('537', 'virtual Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('538', 'Webcam Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('539', 'Event Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('540', 'Math/Physics-Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('541', 'Moving Cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('542', 'Drive-In', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('544', 'I want to be notified about new Geocaches within an radius of %1 km.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('545', 'BBCode for webforums:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('546', 'Opencaching.de-statstic of %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('547', 'Choose logo', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('548', 'HTML-Code:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('549', 'Text displayed:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('550', 'Text contains invalid charecters!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('551', 'Available logos:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('552', 'Cancel', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('553', 'Save', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('554', 'The following settings are stored for your logo:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('555', 'Show logentries', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('556', 'Statistic picture:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('557', 'Registered&nbsp;since:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('558', 'Don\'t use an HTML editor by default.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('559', 'Don\'t log me out after 15 minutes inaktivity.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('560', 'I\'m taking an PMR walkie talkie on channel 2 with me.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('561', 'Others:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('562', 'Notification about new Geocaches is not activated.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('563', 'Notify about new Geocaches in a radius of %1 km.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('564', 'Notifications:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('565', 'Home coordinates:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('566', 'Country:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('567', 'Last name:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('568', 'First name:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('569', 'Recommended', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('570', '%1 found the Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('571', '%1 didn\'t find the Geoacache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('572', '%1 wrote a note', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('573', '%1 has visited the event', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('574', '%1 wants to visit the event', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('575', '%1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('576', 'Edit', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('577', 'Delete', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('578', 'Upload picture', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('579', 'Pictures for this logentry:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('580', 'Back to the Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('581', 'E-Mail-Address:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('582', 'Logentries for %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('583', 'Picture selection', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('584', 'Picture selection for %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('585', 'There are no pictures for the Geocache.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('586', 'As preview picture', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('587', 'My profile data', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('588', 'The following informations are stored in your userprofile:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('589', 'Gray entries will be hidden to other users.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('590', 'Username:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('591', 'The country is not valid.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('592', 'The entered radius is not valid.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('593', 'An unknown error occured.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('594', 'Before you can login the first time you have to activate your account with to followin code:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('595', 'New password', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('596', 'Request', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('597', 'Change', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('598', 'Request code', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('599', 'New password code', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('600', 'you requested at %1 a security code to change your password.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('601', 'The following code was generated: %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('602', 'This code is 3 days valid.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('603', 'You can enter your new password at %1newpw.php', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('604', 'To change your password, you have to request a security code which will be sent to you via E-Mail.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('605', 'This E-Mail-Address is not registered with a valid username.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('606', 'An E-Mail was sent to you with the security code.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('607', 'An unknown error occured. The security code could not be sent to you.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('608', 'Please enter your E-Mail-Address, the security code you received and your new password. The security code is only 3 days valid. You have to request a new one after that time.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('609', 'The user account is not activated.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('610', 'Security code:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('611', 'The security code is expired. Request a new one.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('612', 'The security code does not match.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('613', 'Please repeat:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('614', 'The password has been changed.', '2013-02-14 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('615', 'New email code', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('616', 'you requested at %1 a security code to change your E-Mail-Address.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('617', 'You can verify your new E-Mail-Address at %1newemail.php', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('618', 'Change E-Mail address', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('619', 'To change your E-Mail address, you have to request a security code. It will be sent to your new E-Mail-Address.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('620', 'New E-Mail address:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('621', 'This E-Mail is already assigned to your account.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('622', 'Please enter the security code you received. The security code is only 3 days valid. You have to request a new one after that time.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('623', 'Request security code first.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('624', 'There was no new E-Mail-Address entered, please request a security code first.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('625', 'The E-Mail-Address was changed.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('626', 'Download', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('627', 'No stored queries found', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('628', 'With the download you accept the <a href=\"articles.php?page=impressum#tos\">term of use</a> from opencaching.de', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('629', 'Store query', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('630', 'Store options as new search', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('631', 'Name of the search', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('632', 'You have to enter a name for this search.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('633', 'There already exists a search with this name.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('634', 'Store', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('635', 'Overwrite old search options', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('636', '-- Select search to overwrite --', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('637', '-- no stored search found --', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('638', 'My recommendations', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('639', 'Your recommendation for \"<a href=\"viewcache.php?wp=%1\">%2</a>\" has been removed!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('640', 'Remove recommendation', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('641', 'You haven\'t recommended a Geocache.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('642', 'Ignored Geocaches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('643', 'remove', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('644', 'No ignored Geocaches found.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('645', 'Watched Geocaches - Settings', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('646', 'Delivery:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('647', 'Immediate', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('648', 'Daily', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('649', 'Weekly', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('650', 'Send at:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('651', '#timetitle', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('652', 'Sent day:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('653', 'Sent time and day is only used with daily or weekly delivery.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('654', 'Error while trying to save!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('655', 'Settings stored successfull.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('656', 'Watched Geocaches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('657', 'Last found', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('658', 'No Geocaches watched.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('659', 'Remind E-Mail', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('660', 'Remind my account E-Mail', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('661', 'Enter your username and we will send an E-Mail to your E-Mail-Address.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('662', 'Enter an username.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('663', 'Username does not exist.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('664', 'The remind E-Mail was sent.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('665', 'Reminder to your E-Mail-Address', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('666', 'Your E-Mail-Address to login:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('667', 'you requested an reminder E-Mail at %1 .', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('668', 'Cache-Recommendations', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('669', 'User that recommended %1 by %2 also recommended the following geocaches:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('670', 'Quota', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('671', 'No recommendations found.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('672', 'Database maintainance', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('673', 'DB Maintainance', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('674', '%1 corrected: %2 entries', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('675', 'Execute', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('676', 'Send', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('677', 'E-Mail from', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('678', 'Sorry, the requested user account is deactivated.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('679', 'Sorry, there is no E-Mail address for the user requested.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('680', 'An unkown error occured and the E-Mail was not sent.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('681', '\'%1\' contacted you via %2 The user profile: %2viewprofile.php?userid=%3 To reply this E-Mail use the E-Mail link on the users profile.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('682', 'Subject:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('683', 'All informations will be handled confidential and not published to third parties!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('684', '\'%1\' with the E-Mail address %2 contacted you via %3 The user profile: %3viewprofile.php?userid=%4 Use the reply button of your E-Mail agent to answer this E-Mail.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('685', 'E-Mail to %1 was sent', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('686', 'Content:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('687', 'Send E-Mail to %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('688', 'You have to enter a subject!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('689', 'You have to enter a content!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('690', 'Send my E-Mail address with this message', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('691', 'This enables the receiver to answer your E-Mail directly with his E-Mail agent.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('692', 'To protect you and us from abuse:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('693', 'Only E-Mail that regards Geocaching are allowed. Spaming is not allowed!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('694', 'All relevant informations will be logged (date/time, sender/receiver and IP address)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('696', 'Sorry, the Geocache is not published.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('697', 'Show all logentries', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('698', 'Show Geocache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('699', 'You are already logged in.<br /> Please <a href=\"login.php?action=logout\">logout</a> to login again.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('700', 'When downloading this file, you accept our <a href=\"articles.php?page=impressum#tos\">terms of use</a>.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('701', 'Difficulty: %1 of 5.0', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('702', 'Terrain: %1 of 5.0', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('703', 'List of participants', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('704', 'Log this cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('705', 'Don\'t watch', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('706', 'Watch', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('707', 'Don\'t ignore', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('708', 'Ignore', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('709', 'Print', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('710', 'Convert coordinates', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('711', 'Size', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('712', 'Time required', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('713', 'Distance', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('715', 'Hidden at', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('716', 'Listed since', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('717', 'Last update', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('718', 'Waypoint', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('719', 'Also listed at', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('720', 'Notes', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('721', 'Watched', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('722', 'Ignored', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('723', 'Page visits', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('724', 'Cache attributes', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('725', 'Additional hint', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('726', 'Decrypt', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('727', 'Pictures', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('728', 'Utilities', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('729', 'Show cache recommendations from users that recommended this geocache: <a href=\"recommendations.php?cacheid=%1\">alle</a>', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('730', 'Search geocaches nearby:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('731', 'all', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('732', 'searchable', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('733', 'Download as file:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('734', 'GPS Exchange Format .gpx', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('735', 'Waypointfile .loc', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('736', 'Google Earth .kml', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('737', 'TomTom POI .ov2', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('738', 'TOP50-Overlay .ovl', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('739', 'Textfile .txt', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('740', 'C O P Y', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('741', 'Edit picture', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('742', 'Sorry, the requested picture does not exist.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('743', 'Sorry, the requested cachelog does not exist.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('744', 'Show statistics', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('745', 'Age', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('746', 'Free text', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('747', 'Hometown', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('748', 'MiniMap-Zoom', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('749', 'Report this cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('750', 'Reported caches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('751', 'File:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('752', 'Please give the picture a name!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('753', 'Add picture for Geocaches %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('754', 'Add picture for Logentry %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('755', 'Edit picture for Geocaches %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('756', 'Edit picture for Logentry %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('757', 'Name:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('758', 'Give the picture a name!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('759', 'After click to upload, it can take a while, until the next page is been shown.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('760', 'This picture is a spoiler - dont show a thumbnail.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('761', 'Upload', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('762', 'Only the following picture formats are allowed: BMP, GIF, PNG and JPEG. We recommend JPEG for photos.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('763', 'The file size of the pictures must not exeed 150 KB. We recommend 480x360 pixel of picture size.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('764', 'Report for %1 submitted', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('765', 'Reason:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('766', 'Comment:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('767', 'Report %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('768', 'You have to select a reason for your report!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('769', 'Comment: (required)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('770', 'It is required to enter a comment for reporting a cache!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('771', 'An unknown error occured. Reporting failed.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('772', 'Report cache', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('773', 'New', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('774', 'In progress', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('775', 'Done', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('776', 'Cache on private property', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('777', 'Copyright violation', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('778', 'Cache is gone', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('779', 'Other reason', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('780', 'The report is already assigned to another admin!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('781', 'The report is already assigned to you!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('782', 'You can not work on this report! Another admin is already pursuing it.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('783', 'To work on a report you have to assign it to you!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('784', 'No reported caches', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('785', 'Details for report of ', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('786', ' by ', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('787', 'not assigned', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('788', 'Assign to me', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('789', 'Contact owner', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('792', 'Mark as finished', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('793', 'Action', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('794', 'Prior to reporting a cache to your Opencaching team you should try to contact the owner, to solve possible problems immediate user to user. This does not apply for caches violating the Opencaching terms of use in a way, that requires immediate action of an Opencaching administrator.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('795', 'Do not display this picture (only used in HTML description)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('796', 'No information on user details found.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('797', 'Coordinates', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('798', 'Geokrets', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('799', 'My details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('800', 'Edit details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('801', 'User details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('802', 'My profile details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('803', 'The following detailed information is stored in your userprofile:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('804', 'Unchecked entries are not visible for other users.<br /> Entries without checkbox are only needed for internal purposes and will never show up in your public profile.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('805', 'Error while saving.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('806', 'Illegal characters found in', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('807', 'Field values too long in', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('808', 'Original values were restored.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('809', 'visible', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('810', 'invisible', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('811', 'internal', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('812', '(*) New reports', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('814', 'User statistics', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('815', 'show', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('816', 'The user has not found any caches yet.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('817', 'The geocache was locked by an administrator because it did not follow the Opencaching terms of use. If you wish to unlock it, contact us using the \"report cache\"-link. Please choose \"other\" as reason and explain shortly what you have changed to make the listing compliant to our terms of use. Thank you!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('818', 'doc/sql/static-data/data.sql has been changed with last CVS checkout.<br /> Before you change translastions, update database with data.sql!<br /> \&nbsp;', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('819', 'Sorry, the Geocache is locked and can not be viewed.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('821', 'Locked, visible', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('822', 'Locked, invisible', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('823', 'Last modified:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('826', '=== Please select ===', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('827', 'Adoptions', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('828', 'Date', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('829', 'Yes, i\'ve read and understand the <a href=\"articles.php?page=impressum#tos\">terms of use</a> of Opencaching.de', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('830', 'To complete the adoption, you have to submit this form.<br /> With submitting this form you are the responsible owner of this Geocache.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('831', '%1 offered you this Geocache for adoption at %2', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('832', 'Thank you for adopting %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('833', 'Commit the adoption of %1', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('834', 'There are no caches that can be adopted by you at the moment.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('835', 'Adopt now', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('836', 'Geocaches the owner offers you for adoption', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('837', 'Yes, i\'ve read and understand the above and agree with it.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('838', 'If you find a user that wants to adopt your Geocache, fill in the username here and submit. The user will then see this Geocache under My Profile \&gt; Adoptions. To complete, the user has to accept our terms of use and commit the adoption. You can offer this Geocache to more than one user. The first user committing the adoption will get the new owner of this Geocache. With the adoption, you will give the committing user an unlimited right to use, modifiy, publish and sublicense content of this Geocache.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('839', 'Offer %1 for adoption', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('840', 'You have no users invited to adopt your cache.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('841', 'Reject adoption', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('842', 'List of users you offered %1 for adoption', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('843', 'Username unknown', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('844', 'You cannot adopt your own cache!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('845', 'Sorry, you have to read and accept the above to proceed!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('846', 'Sorry, you have to read and accept the terms of use to proceed!', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('847', 'This rules ensures that your password cannot be guessed by an automated script.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('848', 'a-z A-Z 0-9 and .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~#', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('849', 'Not all special characters are allowed. You may only use', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('850', 'Do not use dictionary words like \'master\'', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('851', 'Do not use common geocaching words', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('852', 'Do not use parts of your username, name or email', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('853', 'Between 6 and 60 chars of length', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('854', 'Verify that your password matches the following criteria:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('855', 'Your password did not pass our security check.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('856', 'Montenegro', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('857', 'Serbia', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('858', '* If the user explicitly logged out after page visit or last login <br /> is older than 90 days, the last login cannot be determined.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('859', 'Manage User', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('860', 'Sure?', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('861', 'Disable (and lock all geocaches owned)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('862', 'Unknown', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('863', 'Last known login:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('864', 'Active geocaches:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('865', 'Total hidden:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('866', 'Logentries:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('867', 'User active:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('868', 'Date created:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('869', 'View useraccount details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('870', 'Useraccount details', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('871', 'E-Mail:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('872', 'Waypoint download', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('873', 'News approve', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('874', 'Do not show', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('875', 'Terrain', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('876', 'Difficulty', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('877', 'Send this waypoint to GPS device:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('882', 'Current top ratings', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('884', '%1 Recommendations in the last 30 days', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('885', 'You can find more recommendations \&gt;<a href=\"tops.php\">here</a>\&lt;.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('886', 'Caches not found', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('887', 'Last&nbsp;login', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('888', 'Within the last month', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('889', 'Between 1 and 6 months', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('890', 'Between 6 and 12 months', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('891', 'More than 12 months ago', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('892', 'The user account has been disabled.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('893', 'A new activation mail has been sent.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('894', 'of', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('895', 'Show in Google Maps', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('896', '(in GM)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('897', 'The user has not hidden any caches yet.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('898', 'Geocaching.de', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('899', 'Google Maps', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('900', 'Donations', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('901', 'Logtype', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('902', 'Text', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('903', 'Recommend this cache?', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('904', '(only if you have free ratings)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('905', 'OC-Waypoint', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('906', 'Terms of use', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('907', 'Our Team', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('914', 'Nature protection area', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('915', 'Scan complete', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('916', 'Current file:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('921', 'Info', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('922', 'INTERNAL_LANG', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('923', 'The compilation of the template faild. This should be a temporary failure. Please try again in some minutes.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('933', 'Scan source codes', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('954', 'Default', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('957', 'Chat/IRC', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1059', 'There already exists an account with that username.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1060', 'Problems with login', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1061', 'Terms of use and legal information', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1062', 'Page performance', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1063', 'Page creation', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1097', 'D/T', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1100', '.gpx', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1123', 'Cachename', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1141', 'N', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1142', 'S', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1143', 'E', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1144', 'W', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1146', 'Kilometer', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1164', 'Some more items found...', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1165', 'Search for city, cache or waypoint', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1166', 'Show link to this map', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1206', 'km', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1208', 'h', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1212', 'Seite:', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1269', 'Map', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1272', 'Switch to full screen', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1275', 'Main menu', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1278', 'Editor', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1279', '\&lt;html\&gt;', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1292', 'Setting smilies is not supported', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1296', 'Only the following picture formats are allowed: BMP, GIF, PNG and JPEG.', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1297', 'at (time)', '2010-08-28 11:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1298', 'The following list is generated automatically by the given recommendations of the users. You can find more informations on regional classification in the <a href=\"http://wiki.opencaching.de/index.php/Empfehlungen\">Wiki</a>.<br /> <br /> The numbers in the list below means:<br /> <img src=\"images/rating-star.gif\" border=\"0\" alt=\"Recommendations\"> Number of users that recommend this cache<br /> <img src=\"resource2/%1/images/log/16x16-found.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"Found\"> Checks = Number of time the cache was found<br /> Index tries to take the number of recommendations and founds in an order to show \'the best\' geocache first.<br /> <img src=\"images/tops-formula.png\" border=\"0\" alt=\"Formula\">', '2010-08-28 12:03:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1299', 'File upload failed!', '2010-08-29 17:44:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1300', 'XML file could not be loaded!', '2010-08-29 17:44:53');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1301', 'SQL Export', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1302', 'XML Download', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1303', 'XML Import', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1304', 'XML file containing the translations:', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1305', 'Check the following languages in the XML file:', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1306', 'Scan file', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1307', 'Source code changed, text no longer used', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1308', 'New translation', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1309', 'Modified translation', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1310', 'old', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1311', 'Toggle all', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1312', 'Commit', '2010-08-29 17:45:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1315', 'Date:', '2010-09-06 22:30:43');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1316', 'Log-entry:', '2010-09-06 22:30:43');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1317', 'passwort to log:', '2010-09-06 22:30:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1319', 'Invalid password!', '2010-09-06 22:30:49');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1320', '(only for found-logs)', '2010-09-06 22:30:53');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1321', 'only listed here!', '2010-09-06 22:30:53');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1322', 'New log-entry', '2010-09-06 22:30:56');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1323', 'Type of log-entry:', '2010-09-06 22:30:56');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1326', 'Recommendations:', '2010-09-06 22:31:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1327', 'A recommendation can only be made within a \"found\"-log!', '2010-09-06 22:31:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1328', 'This cache is one of my recommendations.', '2010-09-06 22:31:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1329', 'Alternatively, you can withdraw a <a href=\"mytop5.php\">existing recommendation</a>.', '2010-09-06 22:31:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1330', 'You have given {curr} of {max} possible recommendations.', '2010-09-06 22:31:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1331', 'Dangers', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1332', 'Infrastructure', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1333', 'Waypoints', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1334', 'Common', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1335', 'Time', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1336', 'Seasonal', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1337', 'System', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1338', 'Tools needed', '2010-09-07 19:19:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1339', 'Preparation needed', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1340', 'Persons', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1341', 'Transportation', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1342', 'Properties', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1343', 'Restrictions / Preconditions', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1344', 'Recommendations / Prohibitions', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1345', 'Only loggable at Opencaching', '2010-09-07 19:19:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1346', 'Time and effort (optional):', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1347', 'Of course, this effort can only be estimated and can vary depending on enviromental influences. If you cannot make sufficiently detailed information, fill both fields up with a O (zero).', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1348', 'Waypoints (optional):', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1349', 'This waypoints will be used to show links in the view cache and the log page.', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1350', 'No data will be imported automatically from these listing services.', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1351', 'Descriptions', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1352', 'Add an additional description', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1353', 'Your description contains at least one link to a picture hosted on geocaching.com!', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1354', 'To prevent any problems with geocaching.com we want to please you to upload all linked pictures to opencaching.de as well and link the pictures in the HTML code to these on opencaching.de', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1355', 'Upload a picture', '2010-09-07 19:19:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1356', 'Listed since:', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1357', 'This cache is yours', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1358', 'You found this cache', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1359', 'You havn\'t found this cache, yet', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1360', 'This cache stores a GeoKrety', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1361', 'This cache has %1 recommandations', '2010-09-07 19:20:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1362', 'Edit log entry for the cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-07 20:18:59');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1363', 'Type of log-enrty', '2010-09-07 20:18:59');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1364', 'JavaScript is disabled in your browser, you can enter text only. To use HTML, or the editor, please enable JavaScript.', '2010-09-07 20:18:59');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1365', 'New cache', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1366', 'Owner:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1367', 'Cachetype:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1368', 'Size:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1369', 'Coordinates:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1370', 'Rating:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1371', 'Difficulty:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1372', 'Terrain:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1373', 'Time effort:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1374', 'Notice', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1375', 'Create a new description', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1376', 'Hidden since:', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1377', '(leave blank for no password)', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1378', 'Please note the <a href=\"articles.php?page=cacheinfo#logpw\" target=\"_blank\">description</a>', '2010-09-07 20:19:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1379', 'Less', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1380', 'Search for caches', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1381', 'JavaScrupt is not activated, you cannot use the following options - basic search is supported nevertheless.', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1382', 'Sorting of result:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1383', 'Last log', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1384', 'Show recommendation from other users first', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1385', 'Distance can only be used if you are signed in and entered your home coordinates.<br />For the search by distance the entered coordinates are used to calculate the distance.', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1386', 'Hide following caches:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1387', 'My owned', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1388', 'My finds', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1389', 'My ignored', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1390', 'Only usable if signed in.', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1391', 'Inactive', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1392', 'Cache attributes:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1393', 'Search by distance', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1394', 'Of coordinates:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1395', 'Maximum distance:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1396', 'Miles', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1397', 'Seamiles', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1398', 'Search for city', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1399', 'Postal code:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1400', 'City:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1401', 'Search for text', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1402', 'Search for Owner', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1403', 'Search for Logs', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1404', 'Logtype:', '2010-09-07 20:19:02');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1405', 'error while loading the page', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1406', 'In an attempt to create the page, an error has occurred. If you pass through a hyperlink on our side and the problem persists do not hesitate to contact us by email.', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1407', 'The following error occurred:', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1408', 'Page:', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1409', 'error message:', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1411', 'are you sure that this log entry shall be removed?', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1412', 'do you want to send {log_user_name} a note?', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1413', 'Remove log entry', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1414', 'date is invalid', '2012-08-26 09:10:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1415', '(only for found logs)', '2010-09-07 20:19:03');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1416', 'Submit a new cache', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1417', 'If this is your first cache on Opencaching.de, be sure to check out the <a href=\"articles.php?page=cacheinfo\">description</a> of the individual fields.', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1418', 'Distance:', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1419', 'The effort is of course only be estimated and can vary depending on environmental influences. If you can not make sufficiently detailed information, write 0 (zero) in both fields. (See also: <a href=\"articles.php?page=cacheinfo#time\" target=\"_blank\">description</a>)', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1420', 'Language:', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1421', 'You can add more descriptions in other languages publishing the cache.', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1422', 'Short description:', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1423', 'Description:', '2010-09-07 20:19:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1425', 'Additional note:', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1426', 'You can add additional pictures after creating the cache.', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1427', 'Publication:', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1428', 'Publish now', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1429', 'Publish on', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1430', 'Do not publish now.', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1431', 'I have read and agree to the <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de Terms of Service</a> and the <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Opencaching.de Datalicense</a>', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1432', 'Info: Your log entry has been removed from the cache owner', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1433', 'Selection of city', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1434', 'Total of {resultscount} cities matched', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1435', 'For the search criterion no clear result was found. Please choose the correct location.', '2010-09-07 20:19:05');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1436', 'Add log-entry for the cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1437', 'Cachename is invalid', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1438', 'The used coordinates are invalid.', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1439', 'The entered time is invalid.', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1440', 'The distance you have entered is invalid. Format aa.aaa', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1441', 'The cache-status does not fit to your publishing options', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1442', 'Choose both valuations!', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1443', 'No pictures available', '2010-09-07 20:19:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1444', '{results_count} caches matched.', '2010-09-07 20:19:07');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1445', 'Result {startatp1} to {endat} (as zip):', '2010-09-07 20:19:07');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1446', 'this description was created on another Opencaching-webserver and can only be deleted there.', '2010-09-07 20:19:07');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1447', 'the cache description has been deleted', '2010-09-07 20:19:07');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1448', 'delete this cache-description', '2010-09-07 20:19:07');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1450', 'Your HTML code will be changed again by a special filter. This is nacessary to avoid dangerous HTML-tags, such as \&lt;script\&gt;. A list of allowed HTML tags can be find <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">here</a>.', '2010-09-07 20:19:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1451', 'Please do not use any images that are hosted on geocaching.com. Upload your fotos instead on our server as well.', '2010-09-07 20:19:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1452', 'Encrypted note:', '2010-09-07 20:19:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1453', 'Do you really want to delete the description of your cache \&quot;{cachename}\&quot;', '2010-09-07 20:19:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1454', 'Yes, delete cache description', '2010-09-07 20:19:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1455', 'Submit cache', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1456', 'Format:\&nbsp;DD-MM-YYYY', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1457', 'Some errors occured, please check the marked fields.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1458', 'Your chosen coordinated are invalid', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1459', 'The entered distance is invalid, Format: aa.aaa', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1460', 'Invalid date, format:DD-MM-JJJJ', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1461', 'The cache can only be adopted if you agree our terms of use.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1462', 'This HTML-code is invalid. To find out the exact cause of the error, you should use the <a href=\"htmlprev.php\" target=\"_blank\">HTML preview</a>.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1463', 'No cache-type is chosen.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1464', 'No cache-size is chosen.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1465', 'This HTML-Code is invalid.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1466', 'Your cache is successfully added to the database. You will be redirected to the cache page, now.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1467', 'Select', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1468', '(internal error) the description is not available.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1469', '(internal error) it already exists a description for this language.', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1471', 'There already exists a description in this language', '2010-09-07 20:19:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1473', 'Are you sure to remove your log entry?', '2010-09-10 23:08:21');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1475', 'A database command could not be performed.', '2010-09-11 01:38:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1476', 'Edit cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2010-09-11 01:38:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1477', 'offer for adoption', '2010-09-11 01:38:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1478', 'State:', '2010-09-11 01:38:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1479', 'Waypoint search:', '2010-09-11 01:38:47');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1480', 'Country sites', '2010-09-11 01:38:47');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1482', 'Waypoints:', '2010-09-11 01:38:49');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1483', '#time_suffix_label#', '2010-09-11 01:38:49');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1486', 'If your browser does not support automatic forwarding please click here.', '2010-09-11 01:38:50');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1489', 'EN', '2010-09-11 01:38:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1490', 'Password:', '2010-09-11 01:38:53');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1491', 'Edit cache description for <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-11 01:38:53');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1494', 'Add', '2010-09-11 01:38:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1495', 'Enter a name, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1496', 'Fill out the text field, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1497', 'You have to check at least one field!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1498', 'Longitude has to be a number!\\nFormat: hh° mm.mmm', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1499', 'Latitude has to be a number!\\nFormat: hh° mm.mmm', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1500', 'The maximum distance has to be a number!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1501', 'The distance has to be between 0 and 9999', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1502', 'Enter the postal code, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1503', 'Enter the city, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1504', 'Enter the owner, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1505', 'Enter the username, please!', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1506', 'Multiple listings (waypoint is also set on gc.com or nc.com)', '2010-09-11 02:13:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1507', 'The selected output format is unknown!', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1508', 'The search operation could not be executed, please reenter the search data.', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1509', 'Find', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1511', 'No Rating', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1512', 'The postal code could not be found', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1513', 'There does no city exist with this name', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1514', 'There are no Koordinates available for the selected city', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1515', 'The entered city is not valid.', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1516', 'The entered text is invalid.', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1517', 'The entered text contains more than 50 words.', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1518', 'All countries', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1519', 'All cachetypes', '2010-09-11 02:13:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1520', 'Search result', '2010-09-11 02:13:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1521', 'This cache has been created on another Opencaching website. The cache can only be edited there.', '2010-09-11 02:13:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1522', 'Save options', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1523', 'Edit options', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1524', 'Type', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1525', 'Last logs', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1526', 'Downloads', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1527', 'Results on this page:', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1528', 'Download for local application', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1529', 'With the download you accept the <a href=\"articles.php?page=impressum#tos\">terms of use</a> from opencaching.de.\&nbsp;\&nbsp;', '2010-09-11 02:13:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1530', 'This log entry has been created on another Opencaching website. The cache can only be edited there.', '2010-09-11 02:17:13');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1531', 'This description has been created on another Opencaching website. The cache can only be edited there.', '2010-09-11 02:17:19');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1532', 'The owner of the has written you the following comment:', '2010-09-11 02:21:06');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1533', 'For virtual and webcam caches, the cache size has to be -no container-!', '2010-09-11 02:26:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1537', 'Your HTML code will be changed again by a special filter. This is necessary to avoid dangerous HTML-tags, such as \&lt;script\&gt;. A list of allowed HTML tags, you can find <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">here</a>', '2010-09-11 02:55:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1538', 'Language', '2010-09-11 02:56:20');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1539', 'Didn\\\'t find', '2010-09-12 22:26:15');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1541', 'Only at night', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1542', 'Hyperlink to another caching portal only', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1543', 'Letterbox (needs stamp)', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1544', 'Dangerous area', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1545', 'This geocache can be found at night only - it is a so-called night cache. There may be reflectors which have to be flashlighted and will point to the hiding place, or other special night-caching mechanisms.', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1546', 'This geocache is listed at Opencaching only. This attribute will enable users of other geocaching platforms to find interesting OC caches quickly.', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1547', 'This cache ist listed at Opencaching and at other geocaching sites. This applies to caches which have been linked by their owners to the corresponding listings at other sites. Please note that descriptions and status of multiple-listed caches have to be equally maintained at all sites including Opencaching, according to our terms of use.', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1548', 'There is a stamp in the cache for stamping your personal logbook, and the cache’s logbook will be stamped with your personal stamp. Take care not to mix up stamps and to leave the cache’s stamp in the cache! Frequently letterboxes can be found without GPS, maybe with a compass and paces from a location - add the \"without GPS\" attribute for those.', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1549', 'The cache is located within a dangerous area. Use this attribute to mark non-obvious dangers, like high-traffic roads, steep ground or falling rocks. Security measures should be taken or the cache be omitted, especially when geocaching with children, large groups or at unfavourable weather conditions.', '2010-09-12 22:52:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1550', 'Active railway nearby', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1551', 'Cliff / Rocks', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1552', 'Hunting', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1553', 'Thorns', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1554', 'Ticks', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1555', 'Abandoned mines', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1556', 'Poisonous plants', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1557', 'Dangerous animals', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1558', 'Parking area nearby', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1559', 'Public transportation', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1560', 'Drinking water nearby', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1561', 'Public restrooms nearby', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1562', 'Public phone nearby', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1563', 'First aid available', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1564', 'Near the parking area', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1565', 'Long walk', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1566', 'Swamp or marsh', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1567', 'Hilly area', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1568', 'Some climbing (no gear needed)', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1569', 'Swimming required', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1570', 'Point of interest', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1571', 'Moving target', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1572', 'Webcam ', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1573', 'Wihin enclosed rooms (caves, buildings etc.)', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1575', 'Without GPS (letterboxes, cistes, compass juggling ...)', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1576', 'Access or parking fee', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1577', 'Overnight stay necessary', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1578', 'Available 24 hours', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1579', 'Only available at specified times', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1580', 'by day only', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1581', 'Tide', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1582', 'All seasons', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1583', 'Breeding season / protected nature', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1584', 'Snow-proof hiding place', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1585', 'Special equipment', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1586', 'Compass', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1587', 'Flashlight', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1588', 'Climbing gear', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1589', 'Cave equipment', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1590', 'Diving equipment', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1591', 'Watercraft', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1592', 'Aircraft', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1593', 'Investigation', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1594', 'Puzzle / Mystery', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1595', 'Arithmetical problem', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1596', 'Other cache type', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1597', 'Ask owner for start conditions', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1598', 'Suited for children', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1599', 'There are active railroads nearby. Please be careful, keep a safe distance and cross the rails only at level crossings etc.!', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1600', 'There are cliffs or dangerous rocks nearby. Beware of falling rocks at the lower side, and be careful at the upper side of cliffs - especially with children and while mountain biking. It can be very dangerous to take a steep slope towards a cliff, because you may not notice in time where the former ends and the latter starts.', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1601', 'The geocache is placed within a hunting ground. At twilight and in the dark, a flashlight or headlight should always be used for security reasons. Be considerate when meeting hunters.', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1602', 'There are thorns near the cache. Wear appropriate clothes.', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1603', 'There are seasonably many ticks in this area. It is recommended to wear long trousers and to check yourself for ticks after geocaching. There are risk maps for tick-borne encephalitis in the internet, e.g. for Germany at sites like www.meningitis.de (look for FSME there).', '2010-09-12 23:11:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1604', 'In the water', '2010-09-12 23:18:21');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1605', 'This cache can be done both at daylight and at night.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1606', 'This cache can only be done at certain times of day - see the cache description for more details. For example, the cache may be placed in an area with restricted opening hours.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1607', 'This cache shoud be attempted during daylight only. For example, the area may be dangerous and contain cliffs or abysses. Or using flashlights may be unfeasable because it would look suspicious within a residential area.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1608', 'This cache can be done only at low-tide or only at high-tide.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1609', 'This cache can be found the whole year round, while difficulty may depend on seasons. Specify difficulty for good conditions.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1610', 'Don’t seek this cache during animal breeding season! Please indicate in the cache description which time of year must be avoided. Also, pay attention to the local terms and signs regarding nature protection.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1611', 'This cache can be found even after heavy snowing. All stages and the geocache are hidden in a snow-safe way: they will not be covered by fallen snow an not by snow-piles created by snow-clearing vehicles.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1612', 'You will need special equipment which is not specified by other attributes, e.g. a laser pointer, walkie-talkies or a car jack.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1613', 'A compass is required.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1614', 'A flashlight is required for finding this cache. Don’t forget spare batteries!', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1615', 'For this cache, you will need climbing equipment and the knowledge how to use it properly. If you are a beginner, don’t do it alone but use the support of a experienced climber or mountaineer.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1616', 'This geocache is hidden in a cave, and you should use appropriate equipment to access it. Beware: Even small caves may confront you with unforeseen problems and dangers, like thunder storms (water!) or a sprained ankle. Have advice first from cave-experienced people! Also take care of protected nature; e.g. bat places must not be disturbed.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1617', 'You will need diving equipment to find this geocache. The water depth of the cache location is specified in the description. Please note that secure diving requires special training. Without diving experience, you may search this cache in company of a diving teacher.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1618', 'This cache usually can be found only using a watercraft. Swimming is impossible because of the distance or currents. See the cache description for more details.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1619', 'You must investigate additional information before you can seek this cache. This commonly applies to puzzle/mystery caches.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1620', 'Puzzles or mysteries have to be solved before or while seeking this cache.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1621', 'Before or while seeking this cache, arithmetical problems must be solved which go beyond very basic calculations.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1622', 'This is none of the standard, pre-defined types of cache. Use this attribute for special, unusual caches.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1623', 'Before doing this cache, you must ask the owner for the starting conditions. E.g. the cache may be linked to certain events at varying dates.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1624', 'This geocache is created for children. All challenges can be solved by child in the age of 10 to 12 years and the terrain has no risks (like highways, abysms). There is a large geocache container with trading items inside and the challenges are interesting.', '2010-09-12 23:27:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1625', 'This cache leads into a (former) mining area. There may be dangers by collapsing adits, or you may need to enter adits. Be careful and use appropriate equipment, especially in the dark. Old mines may be covered by historic preservation.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1626', 'There are poisonous plants near the cache. Take care and prevent children and dogs from touching or eating them.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1627', 'The area is inhabited by possibly dangerous animals, e.g. rabies areas, venomous snakes, scorpions or bears.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1628', 'A nearby parking area is situated as starting point for doing this cache. If no free parking is available, add the \"access or parking fee\" attribute.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1629', 'This cache is located outside of urban areas and has a public transport station nearby. Don’t set this attribute for geocaches in urban areas that are commonly equipped with public transportation.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1630', 'There is drinking water along the trail or near the cache. This attribute is useful especially for planning event caches, longer hikes or caches at probably dirty locations like caves.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1631', 'There are public restrooms along the way or near the cache. This attribute is useful especially for planning event caches or extensive multicaches.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1632', 'There is a public phone along the way or near the cache. Especially for event caches you should enquire for nearby phones and set this attribute if applicable.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1633', 'There is a first aid station, call box, mountain rescue or similar arrangement near the cache. This attribute is useful especially in demanding areas, like climbing caches, cave caches, high mountains or at the water. Check if you can add emergency phone numbers (like a mountain rescue) to your cache listing.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1634', 'The geocache is located close to a parking area, only a few steps away - it’s a \"cache and dash\".', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1635', 'This cache requires a long walk - more than 5 km round trip. In the mountains and other steep areas, the distance for a \"long walk\" may be shorter. Walking shoes and appropriate equipment are recommended.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1636', 'This cache requires passing swampy or marshy ground. Wear appropriate clothes. After rainfall, the terrain may be very demanding or not passable at all.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1637', 'One or more ascents lie between you and the cache.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1638', 'This cache requires some climbing and you may have to use your hands, but you won’t need climbing gear. Be very careful during rainy weather or before thunderstorms!', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1639', 'This cache requires crossing a river or a lake. The water is steep ', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1640', 'There is a point of interest at the cache, like a nice scenic overlook or a larger castle ruin. This place is worth visiting it even without a geocache nearby.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1641', 'This geocache is moving around. For example, the owner might regularly move the cache from one place to another, or the finders will do this task and post new coordinates in their log entries. The owner must update coordinates in the cache description after each move.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1642', 'There is a webcam at the target location. You must record a webcam picture of your visit and include it in your \"found\" log entry. There may be additional requirements like a geocaching banner on the photo. The webcam’s address is included in the cache description, and it must be publicly accessible, i.e. no user account or similar is required.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1643', 'This geocache is not hidden in the open air, but within a building, a cave or similar.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1644', 'This cache or one of the stages is placed underwater. You will have to enter the water, swim or dive.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1645', 'This cache can be found without a GPS device. No additional coordinates are used besides of the starting coordinates.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1646', 'You must pay an access or parking fee to access this cache, e.g. if the cache is located within a theme park. If there are alternative free parking areas nearby, please include them in the cache description. Please note our current terms of use regarding \"commercial geocaches\".', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1647', 'This cache cannot be done within a single day or a single night. You will have to visit the location for more than one time, or you must stay overnight. Preparation time is not included in this calculation, but only the time on site.', '2010-09-12 23:39:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1648', 'A newsentry was created on opencaching', '2010-09-13 00:14:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1649', 'Runtime: {time} seconds', '2010-09-13 00:14:45');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1650', 'The called page does not exist!', '2010-09-13 00:14:45');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1651', 'Search by cachename', '2010-09-13 00:14:48');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1652', 'Redirect - opencaching', '2010-09-13 00:14:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1653', 'Do you really want to delete the saved search?', '2010-09-13 00:15:15');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1654', 'State', '2010-09-13 00:15:18');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1655', 'Set state', '2010-09-13 00:15:22');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1656', 'Country (nodes)', '2010-09-13 00:15:26');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1657', 'to', '2010-09-14 01:25:28');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1658', 'Route', '2010-09-15 15:04:49');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1659', 'Cachesize:', '2010-09-15 15:05:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1660', 'Link', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1661', 'Open', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1662', 'Add to favorites...', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1663', 'Caches displayed', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1664', 'Time to load', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1665', 'Sec.', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1666', 'Only show Geocaches with the following properties:', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1667', 'Cachetype', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1668', 'Cache container', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1669', 'Hide', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1670', 'My owns', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1671', 'Not active', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1672', 'Double listings', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1673', 'Rating', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1674', 'Min. recommendations', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1675', 'Drag Zoom', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1676', 'Drag a region on the map (click here to reset)', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1677', 'Drag Zoom Back', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1678', 'Enter a search text, please!', '2010-09-19 00:23:51');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1680', 'Waypoint %1 not found!', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1681', 'D/T:', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1682', 'Maps \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1683', 'Error: Unable to download the search result (HTTP error code %1)', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1684', 'Error: Unable to download the search result. The data was not available on the server.', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1685', 'There are %1 Geocaches in the selected area, matching the filter options. Please zoom in to display the caches.', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1686', 'The filter options have been changed. Click OK to reload the map content.', '2010-09-27 00:19:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1687', 'Create a logentry', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1688', 'Edit logentry', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1689', 'Remove logentry', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1690', 'Edit cache', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1691', 'Add description', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1692', 'Edit description', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1693', 'Remove description', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1694', 'Select city', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1695', 'Show search result', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1696', 'Result', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1697', 'Description - Create a cache', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1698', 'Add picture', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1699', 'Message', '2010-10-03 19:23:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1700', 'There is no google maps key registered for this domain.', '2010-10-03 22:21:58');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1701', 'Attention! This Geocache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> There is no physical container at the specified (or to be determined) coordinates. In the interest of the place it should not be necessarily to search!', '2010-10-06 22:27:56');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1702', 'Attention! This Geocache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> The geocache itself or parts of it are missing or there are other issues that make a successful search impossible. In the interest of the place it should not be necessarily to search!', '2010-10-06 22:27:56');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1703', 'You have attended this event!', '2010-10-06 22:28:13');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1704', 'You have already found this cache!', '2010-10-06 22:28:13');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1705', '<br /><i>Obsolete: This attribute is cannot be assigned to new caches, because it does not fit our current terms of use.</i><br />\r\nThis cache ist listed at Opencaching and at other geocaching sites. This applies to caches which have been linked by their owners to the corresponding listings at other sites. Please note that descriptions and status of multiple-listed caches have to be equally maintained at all sites including Opencaching, according to our terms of use.', '2010-10-18 21:30:14');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1706', 'This OC node', '2010-10-18 21:30:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1707', 'Other OC nodes', '2010-10-18 21:30:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1708', 'The next events in %1', '2010-10-21 22:54:23');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1709', 'Geocaches with most ratings in the last 30 days in %1.', '2010-10-21 22:54:23');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1710', 'Newest caches in %1', '2010-10-21 22:54:23');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1711', 'You need additional {anzahl} finds, to make another recommandation.', '2010-11-29 21:04:17');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1712', 'Add log-entry for the cache <a href=\"viewcache.php?cacheid=%1\">%2</a>', '2010-11-29 21:04:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1713', 'You have recommended this cache.', '2010-11-29 21:04:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1714', 'Revoke the recommendation', '2010-11-29 21:04:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1715', 'You have given %1 of %2 possible recommendations.', '2010-11-29 21:04:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1716', 'You need additional %1 finds, to make another recommandation.', '2010-11-29 21:04:55');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1717', 'Please select!', '2010-12-05 00:00:40');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1718', 'Results on this page', '2010-12-05 00:00:57');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1719', 'Result {startatp1} to {endat} (as zip)', '2010-12-05 00:00:57');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1722', 'Do you really want to delete this entry?', '2010-12-05 00:01:46');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1723', 'Do you really want to remove this recommendation?', '2010-12-05 00:01:49');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1724', 'Waylength', '2010-12-05 00:02:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1725', 'Download as...', '2010-12-05 00:02:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1726', 'remove log entry for <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-12-06 20:02:27');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1727', 'Add new cache description to <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2010-12-18 23:12:16');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1728', 'Send to GPS device', '2010-12-19 22:25:21');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1729', 'Geokrety history', '2010-12-19 22:25:36');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1730', 'New forum topcis (%1)', '2010-12-19 22:25:46');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1731', 'Teamblog', '2011-02-04 19:51:15');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1732', 'Forum', '2011-02-04 19:51:16');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1733', 'Geokrety', '2011-02-04 19:51:16');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1734', 'GPX Import', '2011-02-04 19:51:56');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1735', 'For Events: The date of event!', '2011-02-12 20:06:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1736', 'User-ID:', '2011-02-12 20:08:11');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1737', 'List', '2011-02-12 20:08:14');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1738', 'Event date', '2011-02-12 20:08:14');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1739', 'Finds: %1 Hidden: %2', '2011-04-04 20:44:22');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1740', '<User not known>', '2011-04-04 20:44:22');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1741', 'The account is already activated. Please try to <a href=\"login.php\">login</a>.<br /> If you cannot login, please read the following page: <a href=\"{$opt.cms.login}\">problems with login</a>', '2011-04-04 20:45:18');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1742', 'Your browser has rejected our cookie.<br /> You can find more informations about this topic in the <a href=\"{$opt.cms.login}\">Opencaching.de-help</a>.', '2011-04-04 20:45:26');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1743', 'This geocache is probably placed within a nature protection area! See <a href=\"{$opt.cms.npa}\">here</a> for further informations, please.', '2011-04-04 20:45:35');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1744', 'This geocache is probably placed within the following nature protection areas (<a href=\"{$opt.cms.npa}\">Info</a>):', '2011-04-04 20:45:35');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1745', 'Standardlogo', '2011-04-24 22:18:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1747', 'Alternative by nybbler', '2011-04-24 22:18:08');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1752', 'Alternative logo', '2011-04-24 22:23:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1753', 'Slimline', '2011-04-24 22:23:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1754', 'Red logo, slimline', '2011-04-24 22:23:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1755', 'Slimline, without statistics', '2011-04-24 22:23:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1756', 'Slimline red, without statistics', '2011-04-24 22:23:38');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1757', 'Round corners', '2011-05-20 23:46:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1758', 'The account is already activated. Please try to <a href=\"login.php\">login</a>.<br /> If you cannot login, please read the following page: <a href=\"%1\">problems with login</a>', '2011-05-20 23:48:09');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1759', 'Note:', '2011-05-20 23:48:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1760', 'Include a coordinate in the note', '2011-05-20 23:48:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1761', 'The note is not visible to other users. The note and the optional coordinate will be included in GPX-file downloads and sent to the GPS device.', '2011-05-20 23:48:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1762', 'Subscribe to feeds from opencaching', '2011-05-20 23:48:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1763', 'Your browser has rejected our cookie.<br /> You can find more informations about this topic in the <a href=\"%1\">Opencaching.de-help</a>.', '2011-05-20 23:48:15');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1764', 'Personal cache note', '2011-05-20 23:48:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1765', 'This geocache is probably placed within a nature protection area! See <a href=\"%1\">here</a> for further informations, please.', '2011-05-20 23:48:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1766', 'This geocache is probably placed within the following nature protection areas (<a href=\"%1\">Info</a>):', '2011-05-20 23:48:29');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1767', 'Quick translation', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1768', 'Disable', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1769', 'Enable - new', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1770', 'Enable - all', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1771', 'Text Download (new)', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1772', 'Text Download (all)', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1773', 'Text Import', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1774', 'Text file containing the translations:', '2011-07-10 18:02:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1775', 'Child waypoint', '2011-07-10 18:02:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1776', 'Waypoint type:', '2011-07-10 18:02:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1777', 'Please select type', '2011-07-10 18:02:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1778', 'Coordinate:', '2011-07-10 18:02:37');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1779', 'Download GPX file (max. 500)', '2011-07-10 18:02:57');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1780', 'Add waypoint', '2011-07-10 18:55:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1781', 'Add new', '2011-07-10 18:55:32');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1782', 'Delete waypoint', '2011-07-10 18:55:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1783', 'Edit waypoint', '2011-07-10 18:55:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1788', 'Parking', '2011-07-15 20:08:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1789', 'Reference point', '2011-07-15 20:08:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1790', 'Additional waypoints', '2011-07-15 22:33:19');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1791', 'Add a waypoint', '2011-07-15 22:33:19');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1792', 'Additional waypoints can be entered to make searching easier, for example by pointing to a suitable parking location or start of a path (the waypoint\'s description may contain more information). The waypoints are included in GPX-file downloads and will be sent to the GPS device.', '2011-07-15 22:33:19');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1793', 'No waypoints available', '2011-07-15 22:33:33');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1794', 'Additional waypoints can make searching easier, for example by pointing to a suitable parking location or start of a path. The waypoints are included in GPX-file downloads and will be sent to the GPS device.', '2011-07-15 22:34:44');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1795', 'Maps:', '2012-07-23 22:26:31');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1796', 'Published on', '2012-07-24 19:16:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1797', 'Changelog', '2012-08-08 14:16:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1798', 'Operator Association', '2012-08-08 14:16:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1799', 'Only available during specified seasons', '2012-10-29 14:28:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1800', 'This cache can be done at certain seasons only - see the cache description for more details. For example, the cache may be placed in a corn labyrinth, which only exists from bloom to harvest season.', '2012-10-29 14:28:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1801', 'Help', '2012-11-09 19:28:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1802', 'Warning: This report is already assigned to another admin. Consult him first before you assume the report!', '2013-01-30 16:26:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1803', 'nano', '2012-11-10 15:51:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1804', 'Datalicense', '2013-02-09 18:28:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1805', 'The www.opencaching.de content is licensed under <br /><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/de/deed.en\" target=\"_blank\">Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Germany</a> License.', '2013-02-09 18:28:52');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1806', 'Please select only one of the delete/disable options!', '2013-02-09 17:34:01');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1807', 'By submitting I accept the <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de Terms of Service</a> and the <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Opencaching.de Datalicense</a>', '2013-02-09 19:12:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1808', 'I\'ve read and understand the <a target=\"_blank\" href=\"articles.php?page=dsb\">privacy statement</a>, the <a target=\"_blank\" href=\"articles.php?page=impressum#tos\">terms of service</a> and the <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datalicense</a> and accept them.', '2013-02-09 19:06:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1809', 'You have to accept the privacy statement, terms of service and the datalicense to register at opencaching.de', '2013-02-09 19:06:41');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1810', 'When downloading this file, you accept our <a href=\"articles.php?page=impressum#tos\">terms of use</a> and <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datalicense</a>.', '2013-02-09 19:12:30');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1811', 'Disable (and lock all geocaches owned) and remove all foreign licensed content', '2013-02-09 19:28:12');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1812', 'ID', '2013-02-09 19:28:46');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1813', 'Owner', '2013-02-09 19:28:46');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1814', 'Reporter', '2013-02-09 19:28:46');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1815', 'You have to check that you are sure!', '2013-02-09 17:34:01');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1816', 'cache description was removed because owner declined content license', '2013-02-09 17:34:01');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1817', 'User status was successfully changed.', '2013-02-09 17:34:01');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1818', 'Spoiler', '2013-02-11 11:40:00');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1819', 'After saving, you may need to press the reload button in your browser to see the selected picture in your profile.', '2013-02-15 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1820', 'You can now <a href=\"login.php\">login</a> with the new password.', '2013-02-14 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1821', 'OC.de new', '2013-02-15 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1822', 'OC.de new, slimline', '2013-02-15 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1823', 'OC.de new, without statistics', '2013-02-15 00:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1824', 'Verify e-mail address', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1825', 'One or more e-mails could not be delivered to the address you specified in your user profile', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1826', 'Please confirm that this email address is correct, or enter a new one.', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1827', 'Enter new email address', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1828', 'Confirm this email address', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1829', 'Mark e-mail address as invalid', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1830', 'data license mail was not delivered', '2013-02-17 18:48:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1831', 'Admins', '2013-02-19 05:40:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1832', 'Rights', '2013-02-19 05:40:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1833', 'Admin rights can be granted and revoked by a system administrator with database access.', '2013-02-19 05:40:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1834', 'declined data license', '2013-02-19 05:40:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1835', 'The user account has been disabled, because the user declined the <a href=\"articles.php?page=impressum#datalicense\">data license</a>. Cache descriptions, log texts and pictures have been deleted.', '2013-02-19 05:40:04');
INSERT INTO `sys_trans` (`id`, `text`, `last_modified`) VALUES ('1839', 'You must select a search to overwrite.', '2013-02-23 19:00:04');

-- Table sys_trans_ref
SET NAMES 'utf8';
TRUNCATE TABLE `sys_trans_ref`;
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1', './templates2/ocstyle/translate.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('2', './templates2/ocstyle/error.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('3', './templates2/ocstyle/sys_main.tpl', '164');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('4', './lang/de/ocstyle/varset.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('4', './templates2/ocstyle/adoptcache.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('4', './templates2/ocstyle/sys_main.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('4', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('4', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('5', './lib2/menuEditor.class.php', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('5', './lib2/menuEditor.class.php', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('6', './templates2/ocstyle/sys_main.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('7', './lang/de/ocstyle/varset.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('7', './templates2/ocstyle/sys_main.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('8', './templates2/ocstyle/sys_main.tpl', '190');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('9', './templates2/ocstyle/sys_main.tpl', '235');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './lang/de/ocstyle/main.tpl.php', '254');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './lang/de/ocstyle/main.tpl.php', '255');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './templates2/ocstyle/sys_main.tpl', '235');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './templates2/ocstyle/sys_sqldebugger.tpl', '337');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './templates2/ocstyle/sys_sqldebugger.tpl', '341');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './templates2/ocstyle/sys_sqldebugger.tpl', '345');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('10', './templates2/ocstyle/sys_sqldebugger.tpl', '349');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('11', './templates2/ocstyle/sys_main.tpl', '237');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('12', './templates2/ocstyle/sys_main.tpl', '239');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('13', './templates2/ocstyle/sys_main.tpl', '244');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('14', './lang/de/ocstyle/main.tpl.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('14', './templates2/ocstyle/sys_main.tpl', '272');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('14', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('14', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('15', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('15', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('16', './lang/de/ocstyle/main.tpl.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('16', './templates2/ocstyle/sys_main.tpl', '272');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('16', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('16', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './lang/de/ocstyle/lib/menu.php', '237');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './lang/de/ocstyle/lib/menu.php', '240');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './lang/de/ocstyle/main.tpl.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './lang/de/ocstyle/varset.inc.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './templates2/ocstyle/sitemap.tpl', '7');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', './templates2/ocstyle/sys_main.tpl', '272');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('17', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './lang/de/ocstyle/editlog.tpl.php', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './lang/de/ocstyle/error.tpl.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './lang/de/ocstyle/login.tpl.php', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './templates2/ocstyle/login.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './templates2/ocstyle/register.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './templates2/ocstyle/register.tpl', '54');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', './templates2/ocstyle/register.tpl', '221');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('18', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('19', './templates2/ocstyle/register.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './lang/de/ocstyle/search.inc.php', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/picture.tpl', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/register.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/register.tpl', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/register.tpl', '198');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/res_logentry.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', './templates2/ocstyle/res_logtype.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('20', 'table:log_types;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('21', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('22', './templates2/mail/register.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('22', './templates2/ocstyle/login.tpl', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('22', './templates2/ocstyle/mobilelog.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('22', './templates2/ocstyle/register.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('22', './templates2/ocstyle/register.tpl', '70');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('23', './templates2/ocstyle/activation.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('23', './templates2/ocstyle/register.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('23', './templates2/ocstyle/register.tpl', '117');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('24', './templates2/mail/register.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('24', './templates2/ocstyle/register.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('24', './templates2/ocstyle/register.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('25', './templates2/mail/register.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('25', './templates2/ocstyle/register.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('25', './templates2/ocstyle/register.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('26', './templates2/mail/register.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('26', './templates2/ocstyle/register.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('26', './templates2/ocstyle/register.tpl', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('26', './templates2/ocstyle/viewprofile.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('27', './templates2/ocstyle/register.tpl', '55');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('28', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('29', './templates2/ocstyle/myprofile.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('29', './templates2/ocstyle/register.tpl', '74');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('30', './templates2/ocstyle/viewcache.tpl', '189');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('31', './templates2/ocstyle/myprofile.tpl', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('31', './templates2/ocstyle/register.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('32', './templates2/ocstyle/myprofile.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('32', './templates2/ocstyle/register.tpl', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('33', './templates2/ocstyle/register.tpl', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/editcache.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/editdesc.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/newcache.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/newdesc.inc.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/search.tpl.php', '246');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './lang/de/ocstyle/search.tpl.php', '417');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/myhome.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/myhome.tpl', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/myprofile.tpl', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/register.tpl', '110');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/viewprofile.tpl', '105');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/viewprofile.tpl', '134');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/viewprofile.tpl', '159');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/viewprofile.tpl', '166');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('34', './templates2/ocstyle/viewprofile.tpl', '175');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('35', './templates2/ocstyle/newemail.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('35', './templates2/ocstyle/register.tpl', '121');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('36', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('37', './templates2/ocstyle/register.tpl', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('38', './templates2/ocstyle/newpw.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('39', './templates2/ocstyle/newpw.tpl', '95');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('39', './templates2/ocstyle/register.tpl', '160');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('40', './templates2/ocstyle/register.tpl', '135');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('41', './templates2/ocstyle/register.tpl', '168');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('42', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('43', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('44', './templates2/ocstyle/register.tpl', '185');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('45', './templates2/ocstyle/register.tpl', '150');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('45', './templates2/ocstyle/register.tpl', '186');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('46', './templates2/ocstyle/register.tpl', '187');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('47', './templates2/ocstyle/register.tpl', '188');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('48', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('49', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('50', './templates2/ocstyle/register.tpl', '211');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './lang/de/expressions.inc.php', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './lang/de/ocstyle/login.tpl.php', '55');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/activation.tpl', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/login.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/mailto.tpl', '89');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/mywatches.tpl', '95');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/newemail.tpl', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/newpw.tpl', '114');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/picture.tpl', '110');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/register.tpl', '220');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('51', './templates2/ocstyle/reportcache.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', './lang/de/ocstyle/lib/menu.php', '193');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', './lang/de/ocstyle/lib/menu.php', '194');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', './templates2/ocstyle/tops.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', './templates2/ocstyle/tops.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('52', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('54', './templates2/ocstyle/tops.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './lang/de/ocstyle/lib/menu.php', '154');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './lang/de/ocstyle/lib/menu.php', '155');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './templates2/ocstyle/tops.tpl', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './templates2/ocstyle/usertops.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './templates2/ocstyle/viewcache.tpl', '220');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './templates2/ocstyle/viewcache_print.tpl', '139');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', './templates2/ocstyle/viewprofile.tpl', '174');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('55', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', './templates2/ocstyle/res_logentry.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', './templates2/ocstyle/res_logtype.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', './templates2/ocstyle/tops.tpl', '85');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', './templates2/ocstyle/viewcache.tpl', '212');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', './templates2/ocstyle/viewcache_print.tpl', '132');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('56', 'table:log_types;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './lang/de/ocstyle/search.inc.php', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/adoptcache.tpl', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/coordinates.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/event_attendance.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/garmin.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/garmin_down.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/map.tpl', '533');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/map2.tpl', '789');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/myhome.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/newcaches.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/newcaches_withoutown.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/recommendations.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/start.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/start.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/start.tpl', '136');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/tops.tpl', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/viewcache.tpl', '119');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/viewcache.tpl', '459');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('57', './templates2/ocstyle/viewcache_print.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', './lang/de/ocstyle/lib/menu.php', '177');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', './lang/de/ocstyle/lib/menu.php', '178');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', './templates2/ocstyle/htmlprev.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', './templates2/ocstyle/htmlprev.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('58', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('59', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('60', './templates2/ocstyle/htmlprev.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('60', './templates2/ocstyle/newemail.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('60', './templates2/ocstyle/newpw.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('61', './templates2/ocstyle/htmlprev.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('62', './templates2/ocstyle/htmlprev.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('63', './templates2/ocstyle/htmlprev.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('63', './templates2/ocstyle/newemail.tpl', '59');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('63', './templates2/ocstyle/newpw.tpl', '55');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('64', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('65', './templates2/ocstyle/htmlprev.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('65', './templates2/ocstyle/htmlprev.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('66', './templates2/ocstyle/htmlprev.tpl', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('67', './templates2/ocstyle/htmlprev.tpl', '71');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('68', './templates2/ocstyle/htmlprev.tpl', '71');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('69', './templates2/ocstyle/htmlprev.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/news.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/news.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/newsapprove.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/newsapprove.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/start.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', './templates2/ocstyle/start.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('70', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('71', './templates2/ocstyle/newcaches.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('71', './templates2/ocstyle/newcaches.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('72', './templates2/ocstyle/newcaches_withoutown.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('72', './templates2/ocstyle/newcaches_withoutown.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('73', './templates2/ocstyle/newlogs.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('73', './templates2/ocstyle/newlogs.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('74', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('75', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('76', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('77', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('78', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('79', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('80', './lang/de/ocstyle/lib/menu.php', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('80', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('81', './templates2/ocstyle/start.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('82', './templates2/ocstyle/start.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('83', './templates2/ocstyle/picture.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('84', './templates2/ocstyle/picture.tpl', '77');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('85', './templates2/ocstyle/picture.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('86', './templates2/ocstyle/viewcache.tpl', '422');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('87', './templates2/ocstyle/viewcache.tpl', '236');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('90', './templates2/ocstyle/start.tpl', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('91', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('92', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('93', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './lang/de/expressions.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './templates2/ocstyle/adminuser.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './templates2/ocstyle/mobilelog.tpl', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './templates2/ocstyle/mydetails.tpl', '78');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './templates2/ocstyle/sys_main.tpl', '237');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('94', './templates2/ocstyle/sys_main.tpl', '240');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './lang/de/expressions.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './templates2/ocstyle/adminuser.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './templates2/ocstyle/mobilelog.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './templates2/ocstyle/mydetails.tpl', '80');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './templates2/ocstyle/sys_main.tpl', '237');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('95', './templates2/ocstyle/sys_main.tpl', '240');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('96', './templates2/mail/sys_main.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('99', './templates2/mail/sys_main.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('100', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('101', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('102', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('103', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('104', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('105', './templates2/ocstyle/error.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('105', './templates2/ocstyle/newpw.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('105', './templates2/ocstyle/remindemail.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('106', './templates2/ocstyle/error.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('107', './templates2/ocstyle/error.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('108', './templates2/ocstyle/error.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('109', './templates2/ocstyle/error.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('110', './lang/de/ocstyle/varset.inc.php', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('110', './templates2/ocstyle/error.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('111', './templates2/ocstyle/error.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('112', './templates2/ocstyle/error.tpl', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('113', './lang/de/ocstyle/lib/menu.php', '184');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('113', './lang/de/ocstyle/lib/menu.php', '185');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('113', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('113', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', './lang/de/ocstyle/lib/menu.php', '171');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', './lang/de/ocstyle/newcache.tpl.php', '264');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', './lang/de/ocstyle/search.tpl.php', '725');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', './templates2/ocstyle/viewcache.tpl', '259');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', './templates2/ocstyle/viewcache_print.tpl', '197');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('114', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('115', './lang/de/ocstyle/lib/menu.php', '163');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('115', './lang/de/ocstyle/lib/menu.php', '164');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('115', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('115', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('116', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('116', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './config2/settings.inc.php', '550');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './config2/settings.inc.php', '551');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './config2/settings.inc.php', '671');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './config2/settings.inc.php', '672');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './lib/settings.inc.php', '270');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('117', './lib/settings.inc.php', '271');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('118', './lang/de/ocstyle/lib/menu.php', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('118', './lang/de/ocstyle/lib/menu.php', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('118', './templates2/ocstyle/myhome.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('118', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('118', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('119', './lang/de/ocstyle/lib/menu.php', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('119', './lang/de/ocstyle/lib/menu.php', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('119', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('119', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('120', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('120', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('121', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('121', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('122', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('122', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('123', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('123', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('124', './lib2/menuEditor.class.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('124', './lib2/menuEditor.class.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('124', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('124', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/lib/menu.php', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/lib/menu.php', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.result.caches.tpl.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '491');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '564');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '622');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '660');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '717');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '780');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/search.tpl.php', '836');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './lang/de/ocstyle/varset.inc.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', './templates2/ocstyle/map2.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('125', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('126', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('126', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('127', './templates2/ocstyle/activation.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('127', './templates2/ocstyle/activation.tpl', '27');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('127', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('127', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('128', './templates2/ocstyle/viewprofile.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('128', './templates2/ocstyle/viewprofile.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('128', './templates2/ocstyle/viewprofile.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('128', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('128', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('129', './templates2/ocstyle/error.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('130', './templates2/ocstyle/error.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('131', './templates2/ocstyle/error.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('132', './templates2/ocstyle/error.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('133', './lang/de/ocstyle/lib/menu.php', '223');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('133', './lang/de/ocstyle/lib/menu.php', '224');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('133', './templates2/ocstyle/error.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('133', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('133', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('134', './templates2/ocstyle/newlogs.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('135', './templates2/ocstyle/newlogs.tpl', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('136', './templates2/ocstyle/newlogs.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('137', './templates2/ocstyle/newlogs.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('138', './templates2/ocstyle/newlogs.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('139', './lib2/logic/user.class.php', '585');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('140', './templates2/mail/register.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('141', './templates2/mail/register.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('142', './templates2/ocstyle/sys_main.tpl', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('143', './templates2/mail/register.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('144', './templates2/mail/register.tpl', '27');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('145', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('146', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('147', './templates2/ocstyle/viewprofile.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('148', './templates2/ocstyle/viewprofile.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('148', './templates2/ocstyle/viewprofile.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('148', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('148', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('149', './lang/de/ocstyle/editcache.tpl.php', '328');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('149', './lang/de/ocstyle/main.tpl.php', '147');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('149', './lang/de/ocstyle/newcache.tpl.php', '343');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('149', './templates2/ocstyle/sys_main.tpl', '116');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('149', './templates2/ocstyle/viewprofile.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('150', './templates2/ocstyle/viewprofile.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('151', './templates2/ocstyle/viewprofile.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('152', './templates2/ocstyle/viewprofile.tpl', '103');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('153', './templates2/ocstyle/viewprofile.tpl', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('153', './templates2/ocstyle/viewprofile.tpl', '130');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('154', './templates2/ocstyle/viewprofile.tpl', '175');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('155', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('156', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('157', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('158', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('159', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('160', 'table:languages;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('161', './templates2/ocstyle/myprofile.tpl', '166');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('162', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('163', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('164', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('165', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('166', './templates2/ocstyle/register.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('167', './templates2/ocstyle/register.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('168', './templates2/ocstyle/newemail.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('168', './templates2/ocstyle/newemail.tpl', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('168', './templates2/ocstyle/register.tpl', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('170', './templates2/ocstyle/register.tpl', '182');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('171', './templates2/ocstyle/activation.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('172', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('173', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('174', './templates2/ocstyle/sys_main.tpl', '190');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('175', './templates2/ocstyle/sys_main.tpl', '162');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('177', './templates2/ocstyle/htmlprev.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('178', './templates2/ocstyle/htmlprev.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('179', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('180', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('180', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('181', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('182', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('183', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('184', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('185', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('186', './templates2/ocstyle/translate.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('187', './templates2/ocstyle/translate.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('188', './templates2/ocstyle/translate.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('189', './templates2/ocstyle/myprofile.tpl', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('190', './templates2/ocstyle/translate.tpl', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('191', './templates2/ocstyle/translate.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('192', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('193', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('194', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('195', './templates2/ocstyle/translate.tpl', '110');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('196', './templates2/ocstyle/translate.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('197', './templates2/ocstyle/translate.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('198', './templates2/ocstyle/translate.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('199', './templates2/ocstyle/translate.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('201', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('202', './templates2/ocstyle/activation.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('202', './templates2/ocstyle/adminuser.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('203', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('204', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('206', './templates2/ocstyle/event_attendance.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './lang/de/ocstyle/login.tpl.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './lang/de/ocstyle/login.tpl.php', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './lang/de/ocstyle/varset.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './templates2/ocstyle/login.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './templates2/ocstyle/login.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './templates2/ocstyle/login.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', './templates2/ocstyle/sys_main.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('207', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('208', './lang/de/ocstyle/varset.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('208', './templates2/ocstyle/login.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('208', './templates2/ocstyle/mobilelog.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('208', './templates2/ocstyle/sys_main.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('209', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('210', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('211', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('212', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('213', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('214', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('215', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('216', './lang/de/ocstyle/login.tpl.php', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('216', './templates2/ocstyle/login.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('217', './lang/de/ocstyle/login.tpl.php', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('217', './templates2/ocstyle/login.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('218', './lang/de/ocstyle/login.tpl.php', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('218', './templates2/ocstyle/login.tpl', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './lang/de/ocstyle/login.tpl.php', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './templates2/ocstyle/login.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './templates2/ocstyle/login.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './templates2/ocstyle/login.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './templates2/ocstyle/login.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('219', './templates2/ocstyle/login.tpl', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('220', './templates2/ocstyle/viewcache.tpl', '188');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('221', './lang/de/ocstyle/login.tpl.php', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('221', './templates2/ocstyle/login.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('222', './lang/de/ocstyle/login.tpl.php', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('222', './templates2/ocstyle/login.tpl', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('223', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('224', './templates2/ocstyle/login.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('225', './templates2/ocstyle/login.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('226', './templates2/ocstyle/login.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('226', './templates2/ocstyle/login.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('226', './templates2/ocstyle/login.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('227', './templates2/ocstyle/login.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('228', './templates2/ocstyle/login.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('229', './templates2/ocstyle/login.tpl', '27');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('230', './templates2/ocstyle/login.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('231', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('232', './templates2/ocstyle/activation.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('233', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('234', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('235', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('236', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('237', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('238', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('239', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('240', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './lang/de/ocstyle/search.result.caches.tpl.php', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './lang/de/ocstyle/search.tpl.php', '724');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/myignores.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/mytop5.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/mywatches.tpl', '124');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/query.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/recommendations.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('241', './templates2/ocstyle/usertops.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('242', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('243', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('244', './templates2/ocstyle/usertops.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('245', './templates2/ocstyle/usertops.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('246', './templates2/ocstyle/usertops.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('248', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('248', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('249', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('250', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('251', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('252', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('253', './templates2/ocstyle/error.tpl', '54');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('254', './templates2/ocstyle/error.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('255', './templates2/ocstyle/error.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('256', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('257', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('258', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('259', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('260', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('261', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('262', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('263', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('264', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('265', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('266', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('267', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('268', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('269', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('270', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('271', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('272', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('273', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('274', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('275', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('276', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('277', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('278', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('279', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('280', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('281', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('282', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('283', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('284', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('285', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('286', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('287', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('288', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('289', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('290', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('291', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('292', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('293', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('294', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('295', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('296', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('297', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('298', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('299', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('300', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('301', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('302', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('303', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('304', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('305', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('306', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('307', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('308', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('309', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('310', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('311', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('312', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('313', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('314', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('315', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('316', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('317', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('318', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('319', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('320', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('321', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('322', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('323', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('324', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('325', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('326', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('327', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('328', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('329', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('330', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('331', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('332', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('333', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('334', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('335', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('336', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('337', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('338', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('339', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('340', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('341', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('342', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('343', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('344', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('345', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('346', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('347', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('348', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('349', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('350', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('351', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('352', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('353', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('354', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('355', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('356', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('357', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('358', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('359', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('360', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('361', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('362', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('363', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('364', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('365', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('366', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('367', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('368', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('369', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('370', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('371', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('372', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('373', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('374', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('375', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('376', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('377', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('378', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('379', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('380', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('381', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('382', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('383', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('384', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('385', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('386', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('387', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('388', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('389', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('390', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('391', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('392', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('393', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('394', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('395', './lang/de/ocstyle/search.inc.php', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('395', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('396', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('397', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('398', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('399', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('400', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('401', './templates2/ocstyle/event_attendance.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('402', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('403', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('404', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('405', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('406', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('407', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('408', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('409', './lang/de/ocstyle/search.inc.php', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('409', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('410', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('411', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('412', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('413', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('414', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('415', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('416', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('417', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('418', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('419', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('420', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('421', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('422', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('423', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('424', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('425', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('426', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('427', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('428', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('429', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('430', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('431', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('432', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('433', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('434', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('435', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('436', './lang/de/ocstyle/search.inc.php', '89');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('436', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('437', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('438', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('439', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('440', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('441', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('442', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('443', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('444', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('445', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('446', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('447', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('448', './templates2/ocstyle/error.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('449', './templates2/ocstyle/translate.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('450', './templates2/ocstyle/sys_outofservice.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('452', './templates2/ocstyle/newstopic.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('453', './templates2/ocstyle/newstopic.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('454', './templates2/ocstyle/newstopic.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/activation.tpl', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/adminuser.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/adminuser.tpl', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/adoptcache.tpl', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/adoptcache.tpl', '147');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/mobilelog.tpl', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/mydetails.tpl', '100');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/myprofile.tpl', '239');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/newstopic.tpl', '99');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/picture.tpl', '111');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('455', './templates2/ocstyle/remindemail.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('456', './templates2/ocstyle/newstopic.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('457', './templates2/ocstyle/newstopic.tpl', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('458', './templates2/ocstyle/newstopic.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('459', './templates2/ocstyle/activation.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('459', './templates2/ocstyle/newstopic.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('460', './templates2/ocstyle/newstopic.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('461', './templates2/ocstyle/newstopic.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('462', './templates2/ocstyle/newstopic.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('463', './templates2/ocstyle/newstopic.tpl', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('464', './templates2/ocstyle/newstopic.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('465', './templates2/ocstyle/newstopic.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('466', './templates2/ocstyle/activation.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('467', './templates2/ocstyle/activation.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('468', './templates2/ocstyle/activation.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('468', './templates2/ocstyle/activation.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('469', './templates2/ocstyle/sys_outofservice.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('470', './templates2/ocstyle/sys_outofservice.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('471', './templates2/ocstyle/register.tpl', '172');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('472', './templates2/ocstyle/register.tpl', '199');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('473', './templates2/ocstyle/newstopic.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('474', './templates2/ocstyle/login.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('475', './templates2/ocstyle/sys_outofservice.tpl', '7');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('476', './templates2/ocstyle/sys_sqldebugger.tpl', '352');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('477', './templates2/ocstyle/sys_sqldebugger.tpl', '348');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('478', './templates2/ocstyle/sys_sqldebugger.tpl', '344');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('479', './templates2/ocstyle/sys_sqldebugger.tpl', '340');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('480', './templates2/ocstyle/sys_sqldebugger.tpl', '336');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('481', './templates2/ocstyle/sys_sqldebugger.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('482', './templates2/ocstyle/sys_sqldebugger.tpl', '337');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('482', './templates2/ocstyle/sys_sqldebugger.tpl', '341');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('482', './templates2/ocstyle/sys_sqldebugger.tpl', '345');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('482', './templates2/ocstyle/sys_sqldebugger.tpl', '349');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('483', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('484', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('484', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('485', './templates2/ocstyle/query.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('485', './templates2/ocstyle/query.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('485', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('485', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('486', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('486', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('487', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('487', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('488', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('488', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('489', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('489', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('490', './templates2/ocstyle/myprofile.tpl', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('491', './templates2/ocstyle/newpw.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('491', './templates2/ocstyle/newpw.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('491', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('491', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('492', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('492', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('493', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('493', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('494', './templates2/ocstyle/res_cachestatus.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('495', './templates2/ocstyle/res_cachestatus.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('496', './templates2/ocstyle/adminreports.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('496', './templates2/ocstyle/res_cachestatus.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('496', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', './templates2/ocstyle/res_logentry.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', './templates2/ocstyle/res_logtype.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', './templates2/ocstyle/viewcache.tpl', '213');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', './templates2/ocstyle/viewcache_print.tpl', '133');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', './templates2/ocstyle/viewprofile.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('497', 'table:log_types;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('498', './templates2/ocstyle/res_logentry.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('498', './templates2/ocstyle/res_logtype.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('498', './templates2/ocstyle/viewcache.tpl', '212');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('498', './templates2/ocstyle/viewcache_print.tpl', '132');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('498', 'table:log_types;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('499', './templates2/ocstyle/res_logentry.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('499', './templates2/ocstyle/res_logtype.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('499', './templates2/ocstyle/viewcache.tpl', '213');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('499', './templates2/ocstyle/viewcache_print.tpl', '133');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('499', 'table:log_types;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('500', './templates2/ocstyle/myhome.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('501', './lang/de/ocstyle/search.tpl.php', '728');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('501', './templates2/ocstyle/myhome.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('502', './templates2/ocstyle/myhome.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('503', './templates2/ocstyle/myhome.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('504', './templates2/ocstyle/myhome.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('505', './templates2/ocstyle/myhome.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('506', './templates2/ocstyle/myhome.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('507', './templates2/ocstyle/myhome.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('508', './templates2/ocstyle/myhome.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('509', './templates2/ocstyle/myhome.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('510', './templates2/ocstyle/myhome.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('511', './templates2/ocstyle/myhome.tpl', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('512', './templates2/ocstyle/res_cacheicon.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('512', './templates2/ocstyle/res_cacheicon_15.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('512', './templates2/ocstyle/res_cacheicon_22.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('513', './templates2/ocstyle/res_cacheicon.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('513', './templates2/ocstyle/res_cacheicon_15.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('513', './templates2/ocstyle/res_cacheicon_22.tpl', '12');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('514', './lang/de/ocstyle/search.tpl.php', '328');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('514', './templates2/ocstyle/res_cacheicon.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('514', './templates2/ocstyle/res_cacheicon_15.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('514', './templates2/ocstyle/res_cacheicon_22.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('514', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('515', './templates2/ocstyle/res_cacheicon.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('515', './templates2/ocstyle/res_cacheicon_15.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('515', './templates2/ocstyle/res_cacheicon_22.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('516', './templates2/ocstyle/res_cacheicon.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('516', './templates2/ocstyle/res_cacheicon_15.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('516', './templates2/ocstyle/res_cacheicon_22.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('517', './templates2/ocstyle/res_cacheicon.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('517', './templates2/ocstyle/res_cacheicon_15.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('517', './templates2/ocstyle/res_cacheicon_22.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('517', './templates2/ocstyle/start.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('518', './lang/de/ocstyle/search.tpl.php', '333');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('518', './templates2/ocstyle/res_cacheicon.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('518', './templates2/ocstyle/res_cacheicon_15.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('518', './templates2/ocstyle/res_cacheicon_22.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('518', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('519', './templates2/ocstyle/res_cacheicon.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('519', './templates2/ocstyle/res_cacheicon_15.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('519', './templates2/ocstyle/res_cacheicon_22.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('520', './templates2/ocstyle/res_cacheicon.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('520', './templates2/ocstyle/res_cacheicon_15.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('520', './templates2/ocstyle/res_cacheicon_22.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('521', './templates2/ocstyle/res_cacheicon.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('521', './templates2/ocstyle/res_cacheicon_15.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('521', './templates2/ocstyle/res_cacheicon_22.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('524', './lang/de/ocstyle/search.tpl.php', '364');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('524', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('525', './lang/de/ocstyle/search.tpl.php', '356');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('525', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('526', './lang/de/ocstyle/search.tpl.php', '357');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('526', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('527', './lang/de/ocstyle/search.tpl.php', '358');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('527', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('528', './lang/de/ocstyle/search.tpl.php', '359');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('528', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('529', './lang/de/ocstyle/search.tpl.php', '362');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('529', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('530', './lang/de/ocstyle/search.tpl.php', '363');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('530', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('531', './templates2/ocstyle/adminreports.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('531', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('532', './templates2/ocstyle/adminreports.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('532', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('533', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('534', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('535', './lang/de/ocstyle/search.tpl.php', '340');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('535', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('536', './lang/de/ocstyle/search.tpl.php', '327');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('536', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('537', './lang/de/ocstyle/search.tpl.php', '339');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('537', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('538', './lang/de/ocstyle/search.tpl.php', '329');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('538', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('539', './lang/de/ocstyle/search.tpl.php', '330');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('539', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('540', './lang/de/ocstyle/search.tpl.php', '334');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('540', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('541', './lang/de/ocstyle/search.tpl.php', '335');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('541', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('542', './lang/de/ocstyle/search.tpl.php', '336');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('542', 'table:cache_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('544', './templates2/ocstyle/myprofile.tpl', '128');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('545', './templates2/ocstyle/myprofile.tpl', '217');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('546', './templates2/ocstyle/myprofile.tpl', '212');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('547', './templates2/ocstyle/change_statpic.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('548', './templates2/ocstyle/myprofile.tpl', '211');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('549', './templates2/ocstyle/change_statpic.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('550', './templates2/ocstyle/change_statpic.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('551', './templates2/ocstyle/change_statpic.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('552', './templates2/ocstyle/change_statpic.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('552', './templates2/ocstyle/childwp.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('552', './templates2/ocstyle/imagebrowser.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('552', './templates2/ocstyle/mydetails.tpl', '99');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('552', './templates2/ocstyle/myprofile.tpl', '238');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('553', '../lib/classes/ChildWp/EditPresenter.php', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('553', './lang/de/ocstyle/search.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('553', './templates2/ocstyle/cache_note.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('553', './templates2/ocstyle/change_statpic.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('554', './templates2/ocstyle/change_statpic.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('555', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('555', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('556', './templates2/ocstyle/myprofile.tpl', '205');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('557', './templates2/ocstyle/myprofile.tpl', '189');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('558', './templates2/ocstyle/myprofile.tpl', '177');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('558', './templates2/ocstyle/myprofile.tpl', '181');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('559', './templates2/ocstyle/myprofile.tpl', '162');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('559', './templates2/ocstyle/myprofile.tpl', '172');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('560', './templates2/ocstyle/myprofile.tpl', '153');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('560', './templates2/ocstyle/myprofile.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('561', './templates2/ocstyle/myprofile.tpl', '149');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('562', './templates2/ocstyle/myprofile.tpl', '140');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('563', './templates2/ocstyle/myprofile.tpl', '138');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('564', './templates2/ocstyle/myprofile.tpl', '121');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('565', './templates2/ocstyle/myprofile.tpl', '107');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './lang/de/ocstyle/editcache.tpl.php', '195');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './lang/de/ocstyle/main.tpl.php', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './lang/de/ocstyle/newcache.tpl.php', '192');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './lang/de/ocstyle/search.tpl.php', '403');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './templates2/ocstyle/myprofile.tpl', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('566', './templates2/ocstyle/sys_main.tpl', '105');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('567', './templates2/ocstyle/adminuser.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('567', './templates2/ocstyle/myprofile.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('568', './templates2/ocstyle/adminuser.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('568', './templates2/ocstyle/myprofile.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('569', './templates2/ocstyle/res_logentry_logitem.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('570', './templates2/ocstyle/res_logentry_logitem.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('571', './templates2/ocstyle/res_logentry_logitem.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('572', './templates2/ocstyle/res_logentry_logitem.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('573', './templates2/ocstyle/res_logentry_logitem.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('574', './templates2/ocstyle/res_logentry_logitem.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('575', './templates2/ocstyle/res_logentry_logitem.tpl', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './lang/de/ocstyle/editcache.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './lang/de/ocstyle/editcache.inc.php', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './lang/de/ocstyle/editcache.inc.php', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './templates2/ocstyle/query.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './templates2/ocstyle/res_logentry_logitem.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('576', './templates2/ocstyle/viewcache.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', '../lib/classes/ChildWp/DeletePresenter.php', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './lang/de/ocstyle/editcache.inc.php', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './lang/de/ocstyle/editcache.inc.php', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './lang/de/ocstyle/editcache.inc.php', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './templates2/ocstyle/adminuser.tpl', '118');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './templates2/ocstyle/newsapprove.tpl', '27');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './templates2/ocstyle/query.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './templates2/ocstyle/res_logentry_logitem.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('577', './templates2/ocstyle/res_logentry_logitem.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('578', './templates2/ocstyle/res_logentry_logitem.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('579', './templates2/ocstyle/res_logentry_logitem.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('580', './templates2/ocstyle/res_logentry.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('581', './templates2/ocstyle/myprofile.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('581', './templates2/ocstyle/newpw.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('581', './templates2/ocstyle/newpw.tpl', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('582', './templates2/ocstyle/res_logentry.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('583', './templates2/ocstyle/imagebrowser.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('584', './templates2/ocstyle/imagebrowser.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('585', './templates2/ocstyle/imagebrowser.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('586', './templates2/ocstyle/imagebrowser.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('587', './templates2/ocstyle/myprofile.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('588', './templates2/ocstyle/myprofile.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('589', './templates2/ocstyle/myprofile.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './lang/de/ocstyle/login.tpl.php', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './lang/de/ocstyle/search.tpl.php', '834');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './templates2/ocstyle/adminuser.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './templates2/ocstyle/adminuser.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './templates2/ocstyle/adoptcache.tpl', '63');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './templates2/ocstyle/myprofile.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('590', './templates2/ocstyle/remindemail.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('591', './templates2/ocstyle/myprofile.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('592', './templates2/ocstyle/myprofile.tpl', '134');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('593', './templates2/ocstyle/myprofile.tpl', '196');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('593', './templates2/ocstyle/newemail.tpl', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('593', './templates2/ocstyle/newemail.tpl', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('594', './templates2/mail/register.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('595', './templates2/ocstyle/newpw.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('596', './templates2/ocstyle/newemail.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './lang/de/ocstyle/editcache.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './lang/de/ocstyle/editdesc.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './lang/de/ocstyle/editlog.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './templates2/ocstyle/mywatches.tpl', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './templates2/ocstyle/newemail.tpl', '105');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('597', './templates2/ocstyle/newpw.tpl', '115');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('598', './templates2/ocstyle/newpw.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('599', './lib2/logic/user.class.php', '474');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('600', './templates2/mail/newpw.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('601', './templates2/mail/newemail.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('601', './templates2/mail/newpw.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('602', './templates2/mail/newemail.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('602', './templates2/mail/newpw.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('603', './templates2/mail/newpw.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('604', './templates2/ocstyle/newpw.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('605', './templates2/ocstyle/newpw.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('605', './templates2/ocstyle/newpw.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('606', './templates2/ocstyle/newemail.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('606', './templates2/ocstyle/newpw.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('607', './templates2/ocstyle/newpw.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('608', './templates2/ocstyle/newpw.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('609', './templates2/ocstyle/newpw.tpl', '77');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('610', './templates2/ocstyle/newemail.tpl', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('610', './templates2/ocstyle/newpw.tpl', '80');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('611', './templates2/ocstyle/newemail.tpl', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('611', './templates2/ocstyle/newpw.tpl', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('612', './templates2/ocstyle/newemail.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('612', './templates2/ocstyle/newpw.tpl', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('613', './templates2/ocstyle/newpw.tpl', '102');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('614', './templates2/ocstyle/newpw.tpl', '109');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('615', './lib2/logic/user.class.php', '526');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('616', './templates2/mail/newemail.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('617', './templates2/mail/newemail.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('618', './templates2/ocstyle/newemail.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('618', './templates2/ocstyle/newemail.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('619', './templates2/ocstyle/newemail.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('620', './templates2/ocstyle/newemail.tpl', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('620', './templates2/ocstyle/newemail.tpl', '70');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('621', './templates2/ocstyle/newemail.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('622', './templates2/ocstyle/newemail.tpl', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('623', './templates2/ocstyle/newemail.tpl', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('624', './templates2/ocstyle/newemail.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('625', './templates2/ocstyle/newemail.tpl', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('626', './templates2/ocstyle/query.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('627', './templates2/ocstyle/query.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('628', './templates2/ocstyle/query.tpl', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('629', './templates2/ocstyle/query.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('629', './templates2/ocstyle/query.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('630', './templates2/ocstyle/query.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('631', './templates2/ocstyle/query.tpl', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('631', './templates2/ocstyle/query.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('632', './templates2/ocstyle/query.tpl', '71');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('633', './templates2/ocstyle/query.tpl', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('634', './templates2/ocstyle/query.tpl', '78');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('634', './templates2/ocstyle/query.tpl', '114');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('635', './templates2/ocstyle/query.tpl', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('636', './templates2/ocstyle/query.tpl', '102');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('637', './templates2/ocstyle/query.tpl', '106');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('638', './templates2/ocstyle/mytop5.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('639', './templates2/ocstyle/mytop5.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('640', './templates2/ocstyle/mytop5.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('641', './templates2/ocstyle/mytop5.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('642', './templates2/ocstyle/myignores.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('643', './templates2/ocstyle/myignores.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('643', './templates2/ocstyle/mywatches.tpl', '141');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('644', './templates2/ocstyle/myignores.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('645', './templates2/ocstyle/mywatches.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('646', './templates2/ocstyle/mywatches.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('647', './templates2/ocstyle/mywatches.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('648', './templates2/ocstyle/mywatches.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('649', './templates2/ocstyle/mywatches.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('650', './templates2/ocstyle/mywatches.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('651', './templates2/ocstyle/mywatches.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('652', './templates2/ocstyle/mywatches.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('653', './templates2/ocstyle/mywatches.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('654', './templates2/ocstyle/mywatches.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('655', './templates2/ocstyle/mywatches.tpl', '89');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('656', './templates2/ocstyle/mywatches.tpl', '114');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('657', './templates2/ocstyle/mywatches.tpl', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('658', './templates2/ocstyle/mywatches.tpl', '144');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('659', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('659', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('660', './templates2/ocstyle/remindemail.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('660', './templates2/ocstyle/remindemail.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('661', './templates2/ocstyle/remindemail.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('662', './templates2/ocstyle/remindemail.tpl', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('663', './templates2/ocstyle/remindemail.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('664', './templates2/ocstyle/remindemail.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('665', './lib2/logic/user.class.php', '568');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('666', './templates2/mail/remindemail.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('667', './templates2/mail/remindemail.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('668', './templates2/ocstyle/recommendations.tpl', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('668', './templates2/ocstyle/recommendations.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('669', './templates2/ocstyle/recommendations.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('670', './templates2/ocstyle/recommendations.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('671', './templates2/ocstyle/recommendations.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('672', './templates2/ocstyle/dbmaintain.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('672', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('673', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('674', './templates2/ocstyle/dbmaintain.tpl', '22');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('675', './templates2/ocstyle/dbmaintain.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('676', './templates2/ocstyle/mailto.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('676', './templates2/ocstyle/reportcache.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('676', './templates2/ocstyle/viewcache.tpl', '192');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('676', './templates2/ocstyle/viewcache.tpl', '425');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('677', './lib2/logic/user.class.php', '642');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('678', './templates2/ocstyle/error.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('679', './templates2/ocstyle/error.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('680', './templates2/ocstyle/mailto.tpl', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('681', './templates2/mail/usercontactmail.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('682', './templates2/mail/usercontactmail.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('682', './templates2/ocstyle/mailto.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('682', './templates2/ocstyle/mailto.tpl', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('683', './templates2/ocstyle/mailto.tpl', '78');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('684', './templates2/mail/usercontactmail.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('685', './templates2/ocstyle/mailto.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('686', './templates2/ocstyle/mailto.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('686', './templates2/ocstyle/mailto.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('687', './templates2/ocstyle/mailto.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('688', './templates2/ocstyle/mailto.tpl', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('689', './templates2/ocstyle/mailto.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('690', './templates2/ocstyle/mailto.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('691', './templates2/ocstyle/mailto.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('692', './templates2/ocstyle/mailto.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('693', './templates2/ocstyle/mailto.tpl', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('694', './templates2/ocstyle/mailto.tpl', '77');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('696', './templates2/ocstyle/error.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('697', './templates2/ocstyle/viewcache.tpl', '475');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('697', './templates2/ocstyle/viewcache.tpl', '476');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('697', './templates2/ocstyle/viewcache_print.tpl', '452');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('698', './lang/de/ocstyle/lib/menu.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('698', './lang/de/ocstyle/lib/menu.php', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('698', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('698', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('699', './templates2/ocstyle/error.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('700', './templates2/ocstyle/viewcache.tpl', '438');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('701', './templates2/ocstyle/garmin.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('701', './templates2/ocstyle/garmin_down.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('701', './templates2/ocstyle/viewcache.tpl', '108');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('701', './templates2/ocstyle/viewcache_print.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('702', './templates2/ocstyle/garmin.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('702', './templates2/ocstyle/garmin_down.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('702', './templates2/ocstyle/viewcache.tpl', '109');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('702', './templates2/ocstyle/viewcache_print.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('703', './templates2/ocstyle/garmin_down.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('703', './templates2/ocstyle/viewcache.tpl', '138');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('703', './templates2/ocstyle/viewcache_print.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('704', './lang/de/ocstyle/log_cache.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('704', './templates2/ocstyle/viewcache.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('705', './templates2/ocstyle/viewcache.tpl', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('706', './templates2/ocstyle/viewcache.tpl', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('707', './templates2/ocstyle/viewcache.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('708', './templates2/ocstyle/viewcache.tpl', '93');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('709', './templates2/ocstyle/viewcache.tpl', '187');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('710', './templates2/ocstyle/viewcache.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('710', './templates2/ocstyle/viewcache_print.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('711', './templates2/ocstyle/viewcache.tpl', '159');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('711', './templates2/ocstyle/viewcache_print.tpl', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('712', './templates2/ocstyle/viewcache.tpl', '166');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('712', './templates2/ocstyle/viewcache_print.tpl', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('713', './lang/de/ocstyle/search.tpl.php', '279');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('713', './templates2/ocstyle/viewcache_print.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('715', './templates2/ocstyle/viewcache.tpl', '172');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('715', './templates2/ocstyle/viewcache_print.tpl', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('716', './lang/de/ocstyle/search.tpl.php', '280');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('716', './templates2/ocstyle/viewcache.tpl', '173');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('716', './templates2/ocstyle/viewcache_print.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('717', './templates2/ocstyle/viewcache.tpl', '174');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('717', './templates2/ocstyle/viewcache_print.tpl', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('718', './templates2/ocstyle/garmin.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('718', './templates2/ocstyle/garmin_down.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('718', './templates2/ocstyle/viewcache.tpl', '175');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('718', './templates2/ocstyle/viewcache_print.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('719', './templates2/ocstyle/viewcache.tpl', '177');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('719', './templates2/ocstyle/viewcache_print.tpl', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('720', './templates2/ocstyle/viewcache.tpl', '214');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('720', './templates2/ocstyle/viewcache_print.tpl', '134');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('720', './templates2/ocstyle/viewprofile.tpl', '164');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('721', './templates2/ocstyle/viewcache.tpl', '215');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('721', './templates2/ocstyle/viewcache_print.tpl', '135');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('722', './templates2/ocstyle/viewcache.tpl', '216');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('722', './templates2/ocstyle/viewcache_print.tpl', '136');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('723', './templates2/ocstyle/viewcache.tpl', '217');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('723', './templates2/ocstyle/viewcache_print.tpl', '137');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('724', './lang/de/ocstyle/editcache.tpl.php', '255');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('724', './lang/de/ocstyle/newcache.tpl.php', '250');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('724', './templates2/ocstyle/viewcache.tpl', '246');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('724', './templates2/ocstyle/viewcache_print.tpl', '164');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('725', './templates2/ocstyle/viewcache.tpl', '331');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('725', './templates2/ocstyle/viewcache_print.tpl', '242');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '246');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '250');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '254');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '263');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '267');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('726', './templates2/ocstyle/viewcache_print.tpl', '271');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('727', './lang/de/ocstyle/editcache.tpl.php', '292');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('727', './lang/de/ocstyle/search.tpl.php', '729');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('727', './templates2/ocstyle/viewcache.tpl', '358');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('727', './templates2/ocstyle/viewcache.tpl', '359');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('727', './templates2/ocstyle/viewcache_print.tpl', '325');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('728', './templates2/ocstyle/viewcache.tpl', '381');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('728', './templates2/ocstyle/viewcache.tpl', '382');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('728', './templates2/ocstyle/viewcache_print.tpl', '356');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('729', './templates2/ocstyle/viewcache.tpl', '414');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('730', './templates2/ocstyle/viewcache.tpl', '419');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('731', './templates2/ocstyle/viewcache.tpl', '420');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('732', './templates2/ocstyle/viewcache.tpl', '421');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('733', './templates2/ocstyle/viewcache.tpl', '426');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('734', './lang/de/ocstyle/search.result.caches.tpl.php', '105');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('734', './lang/de/ocstyle/search.result.caches.tpl.php', '120');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('734', './templates2/ocstyle/viewcache.tpl', '427');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('735', './lang/de/ocstyle/search.result.caches.tpl.php', '106');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('735', './lang/de/ocstyle/search.result.caches.tpl.php', '121');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('735', './templates2/ocstyle/viewcache.tpl', '428');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('736', './lang/de/ocstyle/search.result.caches.tpl.php', '107');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('736', './lang/de/ocstyle/search.result.caches.tpl.php', '122');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('736', './templates2/ocstyle/viewcache.tpl', '429');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('737', './lang/de/ocstyle/search.result.caches.tpl.php', '109');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('737', './lang/de/ocstyle/search.result.caches.tpl.php', '124');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('737', './templates2/ocstyle/viewcache.tpl', '431');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('738', './lang/de/ocstyle/search.result.caches.tpl.php', '110');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('738', './lang/de/ocstyle/search.result.caches.tpl.php', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('738', './templates2/ocstyle/viewcache.tpl', '432');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('739', './lang/de/ocstyle/search.result.caches.tpl.php', '111');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('739', './lang/de/ocstyle/search.result.caches.tpl.php', '126');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('739', './templates2/ocstyle/viewcache.tpl', '433');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('740', './templates2/mail/usercontactmail.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('741', './lang/de/ocstyle/lib/menu.php', '216');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('741', './lang/de/ocstyle/lib/menu.php', '219');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('741', './templates2/ocstyle/picture.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('741', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('741', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('742', './templates2/ocstyle/error.tpl', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('743', './templates2/ocstyle/error.tpl', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('744', 'table:profile_options;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('745', 'table:profile_options;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('746', 'table:profile_options;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('747', 'table:profile_options;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('748', 'table:profile_options;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('749', './templates2/ocstyle/viewcache.tpl', '100');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('750', './templates2/ocstyle/adminreports.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('750', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('750', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('751', './templates2/ocstyle/picture.tpl', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('752', './templates2/ocstyle/picture.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('753', './templates2/ocstyle/picture.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('754', './templates2/ocstyle/picture.tpl', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('755', './templates2/ocstyle/picture.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('756', './templates2/ocstyle/picture.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('757', './lang/de/ocstyle/editcache.tpl.php', '130');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('757', './lang/de/ocstyle/newcache.tpl.php', '149');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('757', './lang/de/ocstyle/search.tpl.php', '489');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('757', './templates2/ocstyle/map2.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('757', './templates2/ocstyle/picture.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('758', './templates2/ocstyle/picture.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('759', './templates2/ocstyle/picture.tpl', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('760', './templates2/ocstyle/picture.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('761', './templates2/ocstyle/picture.tpl', '111');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('762', './templates2/ocstyle/picture.tpl', '99');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('763', './templates2/ocstyle/picture.tpl', '100');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('764', './templates2/ocstyle/reportcache.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('765', './templates2/ocstyle/adminreports.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('765', './templates2/ocstyle/reportcache.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('765', './templates2/ocstyle/reportcache.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('766', './templates2/ocstyle/adminreports.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('766', './templates2/ocstyle/reportcache.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('767', './templates2/ocstyle/reportcache.tpl', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('768', './templates2/ocstyle/reportcache.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('769', './templates2/ocstyle/reportcache.tpl', '70');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('770', './templates2/ocstyle/reportcache.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('771', './templates2/ocstyle/reportcache.tpl', '85');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('772', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('772', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('773', './lang/de/ocstyle/search.inc.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('773', './templates2/ocstyle/translate.tpl', '196');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('773', 'table:cache_report_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('774', 'table:cache_report_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('775', 'table:cache_report_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('776', 'table:cache_report_reasons;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('777', 'table:cache_report_reasons;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('778', 'table:cache_report_reasons;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('779', 'table:cache_report_reasons;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('780', './templates2/ocstyle/adminreports.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('781', './templates2/ocstyle/adminreports.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('782', './templates2/ocstyle/adminreports.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('783', './templates2/ocstyle/adminreports.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('784', './templates2/ocstyle/adminreports.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('785', './templates2/ocstyle/adminreports.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('786', './templates2/ocstyle/adminreports.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('787', './templates2/ocstyle/adminreports.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('788', './templates2/ocstyle/adminreports.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('789', './templates2/ocstyle/adminreports.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('792', './templates2/ocstyle/adminreports.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('793', './templates2/ocstyle/adminreports.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('794', './templates2/ocstyle/reportcache.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('795', './templates2/ocstyle/picture.tpl', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('796', './templates2/ocstyle/mydetails.tpl', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('797', './templates2/ocstyle/viewcache.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('797', './templates2/ocstyle/viewcache_print.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('798', './templates2/ocstyle/viewcache.tpl', '450');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('798', './templates2/ocstyle/viewcache.tpl', '451');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('798', './templates2/ocstyle/viewcache_print.tpl', '411');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('799', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('799', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('800', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('800', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('801', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('801', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('802', './templates2/ocstyle/mydetails.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('803', './templates2/ocstyle/mydetails.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('804', './templates2/ocstyle/mydetails.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('805', './templates2/ocstyle/mydetails.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('806', './templates2/ocstyle/mydetails.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('807', './templates2/ocstyle/mydetails.tpl', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('808', './templates2/ocstyle/mydetails.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('809', './templates2/ocstyle/mydetails.tpl', '55');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('810', './templates2/ocstyle/mydetails.tpl', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('811', './templates2/ocstyle/mydetails.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('812', './templates2/ocstyle/adminreports.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('814', './templates2/ocstyle/viewprofile.tpl', '93');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('814', './templates2/ocstyle/viewprofile.tpl', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('815', './templates2/ocstyle/newsapprove.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('815', './templates2/ocstyle/viewprofile.tpl', '115');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('815', './templates2/ocstyle/viewprofile.tpl', '144');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('816', './templates2/ocstyle/viewprofile.tpl', '150');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('817', './templates2/ocstyle/viewcache.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('817', './templates2/ocstyle/viewcache_print.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('818', './templates2/ocstyle/translate.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('819', './templates2/ocstyle/error.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('821', './templates2/ocstyle/adminreports.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('821', './templates2/ocstyle/res_cachestatus.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('821', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('822', './templates2/ocstyle/adminreports.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('822', './templates2/ocstyle/res_cachestatus.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('822', 'table:cache_status;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('823', './templates2/ocstyle/adminreports.tpl', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('823', './templates2/ocstyle/adminuser.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('826', './templates2/ocstyle/reportcache.tpl', '54');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('827', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('827', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('828', './templates2/ocstyle/adoptcache.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('828', './templates2/ocstyle/mobilelog.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('829', './templates2/ocstyle/adoptcache.tpl', '139');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('830', './templates2/ocstyle/adoptcache.tpl', '133');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('831', './templates2/ocstyle/adoptcache.tpl', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('832', './templates2/ocstyle/adoptcache.tpl', '128');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('833', './templates2/ocstyle/adoptcache.tpl', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('834', './templates2/ocstyle/adoptcache.tpl', '114');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('835', './templates2/ocstyle/adoptcache.tpl', '105');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('836', './templates2/ocstyle/adoptcache.tpl', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('837', './templates2/ocstyle/adoptcache.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('838', './templates2/ocstyle/adoptcache.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('839', './templates2/ocstyle/adoptcache.tpl', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('840', './templates2/ocstyle/adoptcache.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('841', './templates2/ocstyle/adoptcache.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('841', './templates2/ocstyle/adoptcache.tpl', '108');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('842', './templates2/ocstyle/adoptcache.tpl', '14');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('843', './templates2/ocstyle/adminuser.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('843', './templates2/ocstyle/adoptcache.tpl', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('844', './templates2/ocstyle/adoptcache.tpl', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('845', './templates2/ocstyle/adoptcache.tpl', '80');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('846', './templates2/ocstyle/adoptcache.tpl', '144');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('847', './templates2/ocstyle/register.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('848', './templates2/ocstyle/register.tpl', '155');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('849', './templates2/ocstyle/register.tpl', '154');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('850', './templates2/ocstyle/register.tpl', '153');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('851', './templates2/ocstyle/register.tpl', '152');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('852', './templates2/ocstyle/register.tpl', '151');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('853', './templates2/ocstyle/register.tpl', '149');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('854', './templates2/ocstyle/register.tpl', '147');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('855', './templates2/ocstyle/register.tpl', '146');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('856', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('857', 'table:countries;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('858', './templates2/ocstyle/adminuser.tpl', '102');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('859', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('859', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('860', './templates2/ocstyle/adminuser.tpl', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('861', './templates2/ocstyle/adminuser.tpl', '112');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('862', './templates2/ocstyle/adminuser.tpl', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('862', './templates2/ocstyle/viewprofile.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('863', './templates2/ocstyle/adminuser.tpl', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('864', './templates2/ocstyle/adminuser.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('865', './templates2/ocstyle/adminuser.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('866', './templates2/ocstyle/adminuser.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('867', './templates2/ocstyle/adminuser.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('868', './templates2/ocstyle/adminuser.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('869', './templates2/ocstyle/adminuser.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('870', './templates2/ocstyle/adminuser.tpl', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('871', './templates2/ocstyle/adminuser.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('872', './templates2/ocstyle/garmin.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('872', './templates2/ocstyle/garmin_down.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('873', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('873', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('874', './templates2/ocstyle/newsapprove.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('875', './templates2/ocstyle/garmin.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('875', './templates2/ocstyle/garmin_down.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('875', './templates2/ocstyle/map2.tpl', '197');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('875', './templates2/ocstyle/viewcache_print.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('876', './templates2/ocstyle/garmin.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('876', './templates2/ocstyle/garmin_down.tpl', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('876', './templates2/ocstyle/map2.tpl', '167');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('876', './templates2/ocstyle/viewcache_print.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('877', './templates2/ocstyle/viewcache.tpl', '425');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('882', './templates2/ocstyle/start.tpl', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('884', './templates2/ocstyle/start.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('884', './templates2/ocstyle/start.tpl', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('884', './templates2/ocstyle/start.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('884', './templates2/ocstyle/start.tpl', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('885', './templates2/ocstyle/start.tpl', '99');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('886', './templates2/ocstyle/viewprofile.tpl', '157');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('887', './templates2/ocstyle/viewprofile.tpl', '54');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('888', './templates2/ocstyle/viewprofile.tpl', '56');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('889', './templates2/ocstyle/viewprofile.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('890', './templates2/ocstyle/viewprofile.tpl', '60');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('891', './templates2/ocstyle/viewprofile.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('892', './templates2/ocstyle/viewprofile.tpl', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('893', './templates2/ocstyle/adminuser.tpl', '71');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('894', './templates2/ocstyle/translate.tpl', '293');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('895', './lang/de/ocstyle/search.result.caches.tpl.php', '108');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('895', './lang/de/ocstyle/search.result.caches.tpl.php', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('895', './templates2/ocstyle/viewcache.tpl', '430');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('896', './lang/de/ocstyle/search.result.caches.tpl.php', '108');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('896', './lang/de/ocstyle/search.result.caches.tpl.php', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('896', './templates2/ocstyle/viewcache.tpl', '430');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('897', './templates2/ocstyle/viewprofile.tpl', '121');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('898', './templates2/ocstyle/viewcache_print.tpl', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('899', './templates2/ocstyle/viewcache.tpl', '237');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('899', './templates2/ocstyle/viewcache_print.tpl', '130');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', './lang/de/ocstyle/main.tpl.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', './lang/de/ocstyle/main.tpl.php', '244');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', './templates2/ocstyle/sys_main.tpl', '222');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', './templates2/ocstyle/sys_main.tpl', '225');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('900', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('901', './templates2/ocstyle/mobilelog.tpl', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './lang/de/ocstyle/editdesc.tpl.php', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './lang/de/ocstyle/editlog.tpl.php', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './lang/de/ocstyle/log_cache.tpl.php', '120');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './lang/de/ocstyle/newcache.tpl.php', '298');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './lang/de/ocstyle/newdesc.tpl.php', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('902', './templates2/ocstyle/mobilelog.tpl', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('903', './templates2/ocstyle/mobilelog.tpl', '74');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('904', './templates2/ocstyle/mobilelog.tpl', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('905', './templates2/ocstyle/mobilelog.tpl', '23');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('906', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('906', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('907', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('907', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('914', './templates2/ocstyle/viewcache_print.tpl', '372');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('915', './templates2/ocstyle/translate.tpl', '288');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('916', './templates2/ocstyle/translate.tpl', '231');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('921', './templates2/ocstyle/viewcache.tpl', '394');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('921', './templates2/ocstyle/viewcache.tpl', '405');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('921', './templates2/ocstyle/viewcache_print.tpl', '379');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('921', './templates2/ocstyle/viewcache_print.tpl', '396');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('922', './lib2/OcSmarty.class.php', '244');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('923', './templates2/ocstyle/error.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('933', './templates2/ocstyle/translate.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('954', './templates2/ocstyle/reportcache.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('957', './lib/settings.inc.php', '294');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('957', './lib/settings.inc.php', '295');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1059', './templates2/ocstyle/myprofile.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1059', './templates2/ocstyle/register.tpl', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './lang/de/ocstyle/login.tpl.php', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './templates2/ocstyle/login.tpl', '21');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './templates2/ocstyle/login.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './templates2/ocstyle/login.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './templates2/ocstyle/login.tpl', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1060', './templates2/ocstyle/login.tpl', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1061', './lang/de/ocstyle/main.tpl.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1061', './templates2/ocstyle/sys_main.tpl', '272');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1062', './lang/de/ocstyle/main.tpl.php', '254');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1063', './lang/de/ocstyle/main.tpl.php', '255');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1097', './lang/de/ocstyle/search.result.caches.tpl.php', '85');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1123', './lang/de/ocstyle/search.tpl.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1141', './lang/de/ocstyle/editcache.tpl.php', '176');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1141', './lang/de/ocstyle/newcache.tpl.php', '174');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1141', './lang/de/ocstyle/search.tpl.php', '540');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1141', './templates2/ocstyle/coordinate_input.tpl', '5');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1142', './lang/de/ocstyle/editcache.tpl.php', '177');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1142', './lang/de/ocstyle/newcache.tpl.php', '175');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1142', './lang/de/ocstyle/search.tpl.php', '541');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1142', './templates2/ocstyle/coordinate_input.tpl', '6');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1143', './lang/de/ocstyle/editcache.tpl.php', '184');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1143', './lang/de/ocstyle/newcache.tpl.php', '182');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1143', './lang/de/ocstyle/search.tpl.php', '547');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1143', './templates2/ocstyle/coordinate_input.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1144', './lang/de/ocstyle/editcache.tpl.php', '185');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1144', './lang/de/ocstyle/newcache.tpl.php', '183');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1144', './lang/de/ocstyle/search.tpl.php', '548');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1144', './templates2/ocstyle/coordinate_input.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1146', './lang/de/ocstyle/search.tpl.php', '559');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1164', './templates2/ocstyle/map.tpl', '400');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1164', './templates2/ocstyle/map2.tpl', '626');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1165', './templates2/ocstyle/map.tpl', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1165', './templates2/ocstyle/map2.tpl', '289');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1166', './templates2/ocstyle/map.tpl', '26');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1166', './templates2/ocstyle/map2.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1206', './lang/de/ocstyle/newcache.tpl.php', '219');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1208', './lang/de/ocstyle/newcache.tpl.php', '216');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1212', './lib/search.html.inc.php', '266');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1212', './lib/search.html.inc.php', '270');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './lang/de/ocstyle/lib/menu.php', '202');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './lang/de/ocstyle/lib/menu.php', '203');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './templates2/ocstyle/map.tpl', '11');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './templates2/ocstyle/map.tpl', '257');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './templates2/ocstyle/map2.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', './templates2/ocstyle/map2.tpl', '485');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1269', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1272', './templates2/ocstyle/map.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1272', './templates2/ocstyle/map2.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1275', './lang/de/ocstyle/main.tpl.php', '213');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1275', './templates2/ocstyle/sys_main.tpl', '199');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1278', './lang/de/ocstyle/editdesc.tpl.php', '77');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1278', './lang/de/ocstyle/editlog.tpl.php', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1278', './lang/de/ocstyle/log_cache.tpl.php', '124');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1278', './lang/de/ocstyle/newcache.tpl.php', '302');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1278', './lang/de/ocstyle/newdesc.tpl.php', '77');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1279', './lang/de/ocstyle/editdesc.tpl.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1279', './lang/de/ocstyle/editlog.tpl.php', '127');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1279', './lang/de/ocstyle/log_cache.tpl.php', '122');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1279', './lang/de/ocstyle/newcache.tpl.php', '300');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1279', './lang/de/ocstyle/newdesc.tpl.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1292', './lang/de/ocstyle/log_cache.tpl.php', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1296', './templates2/ocstyle/picture.tpl', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1297', './templates2/ocstyle/event_attendance.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1298', './templates2/ocstyle/tops.tpl', '15');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1299', './translate.php', '566');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1299', './translate.php', '705');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1300', './translate.php', '575');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1301', './templates2/ocstyle/translate.tpl', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1302', './templates2/ocstyle/translate.tpl', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1303', './templates2/ocstyle/translate.tpl', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1304', './templates2/ocstyle/translate.tpl', '130');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1305', './templates2/ocstyle/translate.tpl', '133');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1306', './templates2/ocstyle/translate.tpl', '141');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1306', './templates2/ocstyle/translate.tpl', '151');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1307', './templates2/ocstyle/translate.tpl', '169');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1308', './templates2/ocstyle/translate.tpl', '171');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1309', './templates2/ocstyle/translate.tpl', '173');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1310', './templates2/ocstyle/translate.tpl', '188');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1311', './templates2/ocstyle/translate.tpl', '206');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1312', './templates2/ocstyle/translate.tpl', '208');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1315', './lang/de/ocstyle/editlog.tpl.php', '106');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1315', './lang/de/ocstyle/log_cache.tpl.php', '101');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1316', './lang/de/ocstyle/editlog.tpl.php', '119');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1316', './lang/de/ocstyle/log_cache.tpl.php', '115');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/editcache.tpl.php', '348');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/editlog.inc.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/editlog.inc.php', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/log_cache.inc.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/log_cache.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1317', './lang/de/ocstyle/newcache.tpl.php', '389');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1319', './lang/de/ocstyle/editlog.inc.php', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1319', './lang/de/ocstyle/log_cache.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1320', './lang/de/ocstyle/log_cache.inc.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1321', './lang/de/ocstyle/log_cache.inc.php', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1322', './lang/de/ocstyle/log_cache.tpl.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1323', './lang/de/ocstyle/log_cache.tpl.php', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1326', './lang/de/ocstyle/rating.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1327', './lang/de/ocstyle/rating.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1328', './lang/de/ocstyle/rating.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1329', './lang/de/ocstyle/rating.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1330', './lang/de/ocstyle/rating.inc.php', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1331', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1332', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1333', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1334', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1335', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1336', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1337', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1338', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1339', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1340', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1341', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1342', 'table:attribute_categories;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1343', 'table:attribute_categories;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1344', 'table:attribute_categories;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1345', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1346', './lang/de/ocstyle/editcache.tpl.php', '217');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1346', './lang/de/ocstyle/newcache.tpl.php', '213');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1347', './lang/de/ocstyle/editcache.tpl.php', '229');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1348', './lang/de/ocstyle/editcache.tpl.php', '235');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1349', './lang/de/ocstyle/editcache.tpl.php', '244');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1349', './lang/de/ocstyle/newcache.tpl.php', '240');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1350', './lang/de/ocstyle/editcache.tpl.php', '245');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1350', './lang/de/ocstyle/newcache.tpl.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1351', './lang/de/ocstyle/editcache.tpl.php', '271');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1352', './lang/de/ocstyle/editcache.tpl.php', '273');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1353', './lang/de/ocstyle/editcache.tpl.php', '281');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1354', './lang/de/ocstyle/editcache.tpl.php', '282');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1355', './lang/de/ocstyle/editcache.tpl.php', '294');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1356', './templates2/ocstyle/map.tpl', '535');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1356', './templates2/ocstyle/map2.tpl', '791');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1357', './templates2/ocstyle/map.tpl', '538');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1357', './templates2/ocstyle/map2.tpl', '794');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1358', './templates2/ocstyle/map.tpl', '541');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1358', './templates2/ocstyle/map2.tpl', '797');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1359', './templates2/ocstyle/map.tpl', '544');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1359', './templates2/ocstyle/map2.tpl', '800');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1360', './templates2/ocstyle/map.tpl', '547');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1360', './templates2/ocstyle/map2.tpl', '803');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1361', './templates2/ocstyle/map.tpl', '550');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1361', './templates2/ocstyle/map2.tpl', '806');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1362', './lang/de/ocstyle/editlog.tpl.php', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1363', './lang/de/ocstyle/editlog.tpl.php', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1364', './lang/de/ocstyle/editdesc.tpl.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1364', './lang/de/ocstyle/editlog.tpl.php', '135');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1364', './lang/de/ocstyle/log_cache.tpl.php', '130');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1364', './lang/de/ocstyle/newcache.tpl.php', '308');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1364', './lang/de/ocstyle/newdesc.tpl.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1365', './lang/de/ocstyle/editcache.tpl.php', '120');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1365', './lang/de/ocstyle/editdesc.tpl.php', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1365', './lang/de/ocstyle/newcache.tpl.php', '128');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1365', './lang/de/ocstyle/newdesc.tpl.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1366', './lang/de/ocstyle/editcache.tpl.php', '136');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1366', './lang/de/ocstyle/search.tpl.php', '778');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1367', './lang/de/ocstyle/editcache.tpl.php', '156');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1367', './lang/de/ocstyle/newcache.tpl.php', '154');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1367', './lang/de/ocstyle/search.tpl.php', '323');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1368', './lang/de/ocstyle/editcache.tpl.php', '164');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1368', './lang/de/ocstyle/newcache.tpl.php', '162');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1369', './lang/de/ocstyle/editcache.tpl.php', '173');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1369', './lang/de/ocstyle/newcache.tpl.php', '171');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1370', './lang/de/ocstyle/editcache.tpl.php', '205');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1370', './lang/de/ocstyle/newcache.tpl.php', '201');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1371', './lang/de/ocstyle/editcache.tpl.php', '207');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1371', './lang/de/ocstyle/newcache.tpl.php', '203');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1371', './lang/de/ocstyle/search.tpl.php', '375');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1372', './lang/de/ocstyle/editcache.tpl.php', '211');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1372', './lang/de/ocstyle/newcache.tpl.php', '207');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1372', './lang/de/ocstyle/search.tpl.php', '387');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1373', './lang/de/ocstyle/editcache.tpl.php', '219');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1373', './lang/de/ocstyle/newcache.tpl.php', '215');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editcache.tpl.php', '228');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editcache.tpl.php', '243');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editcache.tpl.php', '281');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editcache.tpl.php', '318');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editcache.tpl.php', '353');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editdesc.tpl.php', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/editdesc.tpl.php', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '143');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '224');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '239');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '281');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '320');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '350');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '366');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newcache.tpl.php', '394');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newdesc.tpl.php', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/newdesc.tpl.php', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/search.tpl.php', '294');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1374', './lang/de/ocstyle/search.tpl.php', '308');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1375', './lang/de/ocstyle/editcache.tpl.php', '272');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1376', './lang/de/ocstyle/editcache.tpl.php', '335');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1376', './lang/de/ocstyle/newcache.tpl.php', '356');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1377', './lang/de/ocstyle/editcache.tpl.php', '349');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1377', './lang/de/ocstyle/newcache.tpl.php', '390');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1378', './lang/de/ocstyle/editcache.tpl.php', '354');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1378', './lang/de/ocstyle/newcache.tpl.php', '395');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1379', './lang/de/ocstyle/search.tpl.php', '254');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1380', './lang/de/ocstyle/search.tpl.php', '267');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1381', './lang/de/ocstyle/search.tpl.php', '274');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1382', './lang/de/ocstyle/search.tpl.php', '276');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1383', './lang/de/ocstyle/search.tpl.php', '281');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1384', './lang/de/ocstyle/search.tpl.php', '288');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1385', './lang/de/ocstyle/search.tpl.php', '295');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1386', './lang/de/ocstyle/search.tpl.php', '303');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1387', './lang/de/ocstyle/search.tpl.php', '305');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1388', './lang/de/ocstyle/search.tpl.php', '306');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1388', './templates2/ocstyle/map2.tpl', '137');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1389', './lang/de/ocstyle/search.tpl.php', '307');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1389', './templates2/ocstyle/map2.tpl', '143');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1390', './lang/de/ocstyle/search.tpl.php', '308');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1391', './lang/de/ocstyle/search.tpl.php', '314');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1392', './lang/de/ocstyle/search.tpl.php', '416');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1393', './lang/de/ocstyle/search.tpl.php', '525');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1394', './lang/de/ocstyle/search.tpl.php', '537');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1395', './lang/de/ocstyle/search.tpl.php', '555');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1396', './lang/de/ocstyle/search.tpl.php', '560');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1397', './lang/de/ocstyle/search.tpl.php', '561');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1398', './lang/de/ocstyle/search.tpl.php', '574');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1399', './lang/de/ocstyle/search.tpl.php', '620');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1400', './lang/de/ocstyle/search.tpl.php', '658');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1401', './lang/de/ocstyle/search.tpl.php', '702');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1402', './lang/de/ocstyle/search.tpl.php', '766');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1403', './lang/de/ocstyle/search.tpl.php', '814');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1404', './lang/de/ocstyle/search.tpl.php', '826');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1405', './lang/de/ocstyle/error.tpl.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1406', './lang/de/ocstyle/error.tpl.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1407', './lang/de/ocstyle/error.tpl.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1408', './lang/de/ocstyle/error.tpl.php', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1409', './lang/de/ocstyle/error.tpl.php', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1411', './lang/de/ocstyle/removelog_cacheowner.tpl.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1412', './lang/de/ocstyle/removelog_cacheowner.tpl.php', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1413', './lang/de/ocstyle/removelog_cacheowner.tpl.php', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1413', './lang/de/ocstyle/removelog_logowner.tpl.php', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1414', './lang/de/ocstyle/editcache.inc.php', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1414', './lang/de/ocstyle/editlog.inc.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1414', './lang/de/ocstyle/log_cache.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1415', './lang/de/ocstyle/editlog.inc.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1416', './lang/de/ocstyle/newcache.tpl.php', '129');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1417', './lang/de/ocstyle/newcache.tpl.php', '144');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1418', './lang/de/ocstyle/editcache.tpl.php', '222');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1418', './lang/de/ocstyle/newcache.tpl.php', '218');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1419', './lang/de/ocstyle/newcache.tpl.php', '225');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1420', './lang/de/ocstyle/editdesc.tpl.php', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1420', './lang/de/ocstyle/main.tpl.php', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1420', './lang/de/ocstyle/newcache.tpl.php', '271');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1420', './lang/de/ocstyle/newdesc.tpl.php', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1421', './lang/de/ocstyle/newcache.tpl.php', '282');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1422', './lang/de/ocstyle/editdesc.tpl.php', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1422', './lang/de/ocstyle/newcache.tpl.php', '287');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1422', './lang/de/ocstyle/newdesc.tpl.php', '63');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1423', './lang/de/ocstyle/editdesc.tpl.php', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1423', './lang/de/ocstyle/newcache.tpl.php', '293');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1423', './lang/de/ocstyle/newdesc.tpl.php', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1423', './templates2/ocstyle/childwp.tpl', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1425', './lang/de/ocstyle/newcache.tpl.php', '329');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1425', './lang/de/ocstyle/newdesc.tpl.php', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1426', './lang/de/ocstyle/newcache.tpl.php', '351');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1427', './lang/de/ocstyle/editcache.inc.php', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1427', './lang/de/ocstyle/newcache.tpl.php', '373');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1428', './lang/de/ocstyle/editcache.inc.php', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1428', './lang/de/ocstyle/newcache.tpl.php', '375');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1429', './lang/de/ocstyle/editcache.inc.php', '69');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1429', './lang/de/ocstyle/newcache.tpl.php', '376');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1430', './lang/de/ocstyle/editcache.inc.php', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1430', './lang/de/ocstyle/newcache.tpl.php', '383');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1431', './lang/de/ocstyle/newcache.tpl.php', '403');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1432', './lang/de/ocstyle/removelog.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1433', './lang/de/ocstyle/selectlocid.tpl.php', '5');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1434', './lang/de/ocstyle/selectlocid.tpl.php', '5');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1435', './lang/de/ocstyle/selectlocid.tpl.php', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1436', './lang/de/ocstyle/log_cache.tpl.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1437', './lang/de/ocstyle/editcache.inc.php', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1437', './lang/de/ocstyle/newcache.inc.php', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1438', './lang/de/ocstyle/editcache.inc.php', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1439', './lang/de/ocstyle/editcache.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1439', './lang/de/ocstyle/newcache.inc.php', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1440', './lang/de/ocstyle/editcache.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1441', './lang/de/ocstyle/editcache.inc.php', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1442', './lang/de/ocstyle/editcache.inc.php', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1442', './lang/de/ocstyle/newcache.inc.php', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1443', './lang/de/ocstyle/editcache.inc.php', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1443', './lang/de/ocstyle/editdesc.inc.php', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1444', './lang/de/ocstyle/search.result.caches.tpl.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1445', './lang/de/ocstyle/search.result.caches.tpl.php', '119');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1446', './lang/de/ocstyle/removedesc.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1447', './lang/de/ocstyle/removedesc.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1448', './lang/de/ocstyle/removedesc.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1448', './lang/de/ocstyle/removedesc.tpl.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1450', './lang/de/ocstyle/editdesc.tpl.php', '95');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1450', './lang/de/ocstyle/newdesc.tpl.php', '95');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1451', './lang/de/ocstyle/editdesc.tpl.php', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1451', './lang/de/ocstyle/newdesc.tpl.php', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1452', './lang/de/ocstyle/editdesc.tpl.php', '103');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1453', './lang/de/ocstyle/removedesc.tpl.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1454', './lang/de/ocstyle/removedesc.tpl.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1455', './lang/de/ocstyle/newcache.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1456', './lang/de/ocstyle/newcache.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1457', './lang/de/ocstyle/editcache.inc.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1457', './lang/de/ocstyle/newcache.inc.php', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1458', './lang/de/ocstyle/newcache.inc.php', '37');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1459', './lang/de/ocstyle/newcache.inc.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1460', './lang/de/ocstyle/newcache.inc.php', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1461', './lang/de/ocstyle/newcache.inc.php', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1462', './lang/de/ocstyle/newcache.inc.php', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1463', './lang/de/ocstyle/newcache.inc.php', '44');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1464', './lang/de/ocstyle/newcache.inc.php', '45');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1465', './lang/de/ocstyle/editdesc.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1465', './lang/de/ocstyle/newcache.inc.php', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1466', './lang/de/ocstyle/newcache.inc.php', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1467', './lang/de/ocstyle/newcache.inc.php', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1468', './lang/de/ocstyle/editdesc.inc.php', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1469', './lang/de/ocstyle/editdesc.inc.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1471', './lang/de/ocstyle/newdesc.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1473', './lang/de/ocstyle/removelog_logowner.tpl.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1475', './lang/de/ocstyle/varset.inc.php', '67');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1476', './lang/de/ocstyle/editcache.tpl.php', '121');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1477', './lang/de/ocstyle/editcache.tpl.php', '138');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1478', './lang/de/ocstyle/editcache.tpl.php', '146');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1478', './templates2/ocstyle/adminreports.tpl', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1479', './lang/de/ocstyle/main.tpl.php', '202');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1480', './lang/de/ocstyle/main.tpl.php', '222');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1482', './lang/de/ocstyle/newcache.tpl.php', '232');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1483', './lang/de/ocstyle/editcache.inc.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1483', './lang/de/ocstyle/newcache.tpl.php', '382');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1486', './lang/de/ocstyle/redirect.tpl.php', '55');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1489', './lang/de/ocstyle/editcache.inc.php', '61');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1489', './lang/de/ocstyle/newcache.inc.php', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1489', './lang/de/ocstyle/newcache.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1489', './lang/de/ocstyle/newdesc.inc.php', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1489', './lang/de/ocstyle/search.inc.php', '92');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1490', './lang/de/ocstyle/login.tpl.php', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1491', './lang/de/ocstyle/editdesc.tpl.php', '42');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1494', './lang/de/ocstyle/newdesc.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1495', './lang/de/ocstyle/search.tpl.php', '38');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1496', './lang/de/ocstyle/search.tpl.php', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1497', './lang/de/ocstyle/search.tpl.php', '57');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1498', './lang/de/ocstyle/search.tpl.php', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1499', './lang/de/ocstyle/search.tpl.php', '73');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1500', './lang/de/ocstyle/search.tpl.php', '78');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1501', './lang/de/ocstyle/search.tpl.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1502', './lang/de/ocstyle/search.tpl.php', '93');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1503', './lang/de/ocstyle/search.tpl.php', '103');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1504', './lang/de/ocstyle/search.tpl.php', '113');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1505', './lang/de/ocstyle/search.tpl.php', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1506', './lang/de/ocstyle/search.tpl.php', '315');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1507', './lang/de/ocstyle/search.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1508', './lang/de/ocstyle/search.inc.php', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1509', './lang/de/ocstyle/search.inc.php', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1511', './lang/de/ocstyle/search.inc.php', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1512', './lang/de/ocstyle/search.inc.php', '81');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1513', './lang/de/ocstyle/search.inc.php', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1514', './lang/de/ocstyle/search.inc.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1515', './lang/de/ocstyle/search.inc.php', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1516', './lang/de/ocstyle/search.inc.php', '85');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1517', './lang/de/ocstyle/search.inc.php', '86');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1518', './lang/de/ocstyle/search.inc.php', '93');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1519', './lang/de/ocstyle/search.inc.php', '94');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1520', './lang/de/ocstyle/search.result.caches.tpl.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1520', './lang/de/ocstyle/selectlocid.tpl.php', '5');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1521', './lang/de/ocstyle/editcache.inc.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1522', './lang/de/ocstyle/search.result.caches.tpl.php', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1523', './lang/de/ocstyle/search.result.caches.tpl.php', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1524', './lang/de/ocstyle/search.result.caches.tpl.php', '84');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1524', './templates2/ocstyle/myignores.tpl', '18');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1524', './templates2/ocstyle/mytop5.tpl', '24');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1524', './templates2/ocstyle/mywatches.tpl', '122');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1524', './templates2/ocstyle/usertops.tpl', '17');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1525', './lang/de/ocstyle/search.result.caches.tpl.php', '88');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1526', './lang/de/ocstyle/search.result.caches.tpl.php', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1526', './lang/de/ocstyle/search.result.caches.tpl.php', '102');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1527', './lang/de/ocstyle/search.result.caches.tpl.php', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1528', './lang/de/ocstyle/search.result.caches.tpl.php', '116');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1529', './lang/de/ocstyle/search.result.caches.tpl.php', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1530', './lang/de/ocstyle/editlog.inc.php', '30');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1530', './lang/de/ocstyle/removelog.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1531', './lang/de/ocstyle/editdesc.inc.php', '28');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1532', './lang/de/ocstyle/removelog.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1533', './lang/de/ocstyle/editcache.inc.php', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1533', './lang/de/ocstyle/newcache.inc.php', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1537', './lang/de/ocstyle/newcache.tpl.php', '321');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1538', './templates2/ocstyle/sys_main.tpl', '99');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1539', './lang/de/ocstyle/search.inc.php', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1541', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1542', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1543', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1544', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1545', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1546', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1548', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1549', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1550', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1551', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1552', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1553', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1554', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1555', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1556', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1557', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1558', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1559', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1560', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1561', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1562', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1563', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1564', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1565', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1566', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1567', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1568', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1569', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1570', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1571', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1572', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1573', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1575', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1576', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1577', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1578', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1579', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1580', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1581', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1582', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1583', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1584', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1585', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1586', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1587', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1588', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1589', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1590', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1591', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1592', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1593', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1594', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1595', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1596', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1597', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1598', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1599', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1600', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1601', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1602', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1603', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1604', 'table:cache_attrib;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1605', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1606', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1607', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1608', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1609', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1610', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1611', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1612', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1613', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1614', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1615', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1616', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1617', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1618', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1619', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1620', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1621', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1622', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1623', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1624', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1625', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1626', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1627', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1628', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1629', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1630', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1631', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1632', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1633', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1634', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1635', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1636', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1637', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1638', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1639', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1640', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1641', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1642', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1643', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1644', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1645', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1646', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1647', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1648', './newstopic.php', '63');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1649', './lang/de/expressions.inc.php', '31');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1650', './lang/de/expressions.inc.php', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1651', './lang/de/ocstyle/search.tpl.php', '477');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1652', './lang/de/ocstyle/redirect.tpl.php', '8');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1653', './templates2/ocstyle/query.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/myignores.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/mytop5.tpl', '25');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/mywatches.tpl', '123');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/usertops.tpl', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/viewcache.tpl', '161');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/viewcache.tpl', '163');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/viewcache_print.tpl', '91');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1654', './templates2/ocstyle/viewcache_print.tpl', '93');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1655', './templates2/ocstyle/adminreports.tpl', '58');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1656', './templates2/ocstyle/sys_main.tpl', '205');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1657', './lang/de/ocstyle/search.tpl.php', '380');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1657', './lang/de/ocstyle/search.tpl.php', '392');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1657', './templates2/ocstyle/map2.tpl', '181');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1657', './templates2/ocstyle/map2.tpl', '211');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1658', 'table:attribute_groups;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1659', './lang/de/ocstyle/search.tpl.php', '352');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1660', './templates2/ocstyle/map2.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1661', './templates2/ocstyle/map2.tpl', '66');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1662', './templates2/ocstyle/map2.tpl', '68');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1663', './templates2/ocstyle/map2.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1664', './templates2/ocstyle/map2.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1665', './templates2/ocstyle/map2.tpl', '79');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1666', './templates2/ocstyle/map2.tpl', '87');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1667', './templates2/ocstyle/map2.tpl', '98');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1668', './templates2/ocstyle/map2.tpl', '112');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1669', './templates2/ocstyle/map2.tpl', '126');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1670', './templates2/ocstyle/map2.tpl', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1671', './templates2/ocstyle/map2.tpl', '149');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1672', './templates2/ocstyle/map2.tpl', '155');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1673', './templates2/ocstyle/map2.tpl', '163');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1674', './templates2/ocstyle/map2.tpl', '227');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1675', './templates2/ocstyle/map2.tpl', '376');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1676', './templates2/ocstyle/map2.tpl', '377');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1677', './templates2/ocstyle/map2.tpl', '379');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1678', './templates2/ocstyle/map2.tpl', '582');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1680', './templates2/ocstyle/map2.tpl', '717');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1681', './templates2/ocstyle/map2.tpl', '790');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1682', './templates2/ocstyle/map2.tpl', '829');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1683', './templates2/ocstyle/map2.tpl', '1061');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1684', './templates2/ocstyle/map2.tpl', '1074');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1685', './templates2/ocstyle/map2.tpl', '1218');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1686', './templates2/ocstyle/map2.tpl', '1242');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1687', './lang/de/ocstyle/lib/menu.php', '82');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1687', './lang/de/ocstyle/lib/menu.php', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1687', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1687', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1688', './lang/de/ocstyle/lib/menu.php', '89');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1688', './lang/de/ocstyle/lib/menu.php', '90');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1689', './lang/de/ocstyle/lib/menu.php', '96');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1689', './lang/de/ocstyle/lib/menu.php', '97');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1689', './lang/de/ocstyle/lib/menu.php', '103');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1689', './lang/de/ocstyle/lib/menu.php', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1690', './lang/de/ocstyle/lib/menu.php', '110');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1690', './lang/de/ocstyle/lib/menu.php', '111');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1691', './lang/de/ocstyle/lib/menu.php', '117');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1691', './lang/de/ocstyle/lib/menu.php', '118');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1692', './lang/de/ocstyle/lib/menu.php', '124');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1692', './lang/de/ocstyle/lib/menu.php', '125');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1693', './lang/de/ocstyle/lib/menu.php', '131');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1693', './lang/de/ocstyle/lib/menu.php', '132');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1694', './lang/de/ocstyle/lib/menu.php', '140');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1694', './lang/de/ocstyle/lib/menu.php', '141');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1695', './lang/de/ocstyle/lib/menu.php', '147');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1696', './lang/de/ocstyle/lib/menu.php', '148');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1697', './lang/de/ocstyle/lib/menu.php', '170');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1698', './lang/de/ocstyle/lib/menu.php', '209');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1698', './lang/de/ocstyle/lib/menu.php', '212');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1699', './lang/de/ocstyle/lib/menu.php', '230');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1699', './lang/de/ocstyle/lib/menu.php', '233');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1700', './map.php', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1700', './map2.php', '65');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1701', './templates2/ocstyle/res_state_warning.tpl', '9');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1702', './templates2/ocstyle/res_state_warning.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1703', './templates2/ocstyle/viewcache.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1704', './templates2/ocstyle/viewcache.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1705', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1706', './lang/de/ocstyle/main.tpl.php', '143');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1706', './templates2/ocstyle/sys_main.tpl', '112');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1707', './lang/de/ocstyle/main.tpl.php', '145');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1707', './templates2/ocstyle/sys_main.tpl', '114');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1708', './templates2/ocstyle/start.tpl', '47');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1709', './templates2/ocstyle/start.tpl', '76');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1710', './templates2/ocstyle/start.tpl', '126');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1711', './lang/de/ocstyle/rating.inc.php', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1717', './newcache.php', '327');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1717', './newcache.php', '344');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1718', './lang/de/ocstyle/search.result.caches.tpl.php', '53');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1719', './lang/de/ocstyle/search.result.caches.tpl.php', '64');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1722', './templates2/ocstyle/myignores.tpl', '29');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1722', './templates2/ocstyle/mywatches.tpl', '141');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1723', './templates2/ocstyle/mytop5.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1724', './templates2/ocstyle/viewcache.tpl', '169');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1725', './templates2/ocstyle/viewcache.tpl', '197');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1726', './lang/de/ocstyle/removelog_cacheowner.tpl.php', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1726', './lang/de/ocstyle/removelog_logowner.tpl.php', '36');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1727', './lang/de/ocstyle/newdesc.tpl.php', '41');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1728', './templates2/ocstyle/garmin_down.tpl', '43');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1728', './templates2/ocstyle/viewcache.tpl', '192');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1729', './templates2/ocstyle/viewcache.tpl', '218');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1730', './templates2/ocstyle/start.tpl', '107');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1731', './lib/settings.inc.php', '278');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1731', './lib/settings.inc.php', '279');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1732', './lib/settings.inc.php', '286');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1732', './lib/settings.inc.php', '287');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1733', './lib/settings-dist.inc.php', '300');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1733', './lib/settings-dist.inc.php', '301');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1733', './lib/settings.inc.php', '302');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1733', './lib/settings.inc.php', '303');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1735', './lang/de/ocstyle/newcache.tpl.php', '367');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1736', './templates2/ocstyle/adminuser.tpl', '40');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1737', './templates2/ocstyle/viewcache.tpl', '138');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1738', './templates2/ocstyle/viewcache.tpl', '172');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1739', './ocstats.php', '39');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1740', './ocstats.php', '46');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1745', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1747', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1752', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1753', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1754', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1755', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1756', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1757', 'table:statpics;field=description', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1758', './templates2/ocstyle/activation.tpl', '62');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1759', './templates2/ocstyle/cache_note.tpl', '5');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1760', './templates2/ocstyle/cache_note.tpl', '10');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1761', './templates2/ocstyle/cache_note.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1763', './templates2/ocstyle/error.tpl', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1764', './templates2/ocstyle/viewcache.tpl', '292');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1764', './templates2/ocstyle/viewcache.tpl', '293');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1765', './templates2/ocstyle/viewcache.tpl', '391');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1765', './templates2/ocstyle/viewcache_print.tpl', '375');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1766', './templates2/ocstyle/viewcache.tpl', '402');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1766', './templates2/ocstyle/viewcache_print.tpl', '393');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1767', './templates2/ocstyle/translate.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1768', './templates2/ocstyle/translate.tpl', '33');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1769', './templates2/ocstyle/translate.tpl', '34');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1770', './templates2/ocstyle/translate.tpl', '35');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1771', './templates2/ocstyle/translate.tpl', '49');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1772', './templates2/ocstyle/translate.tpl', '50');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1773', './templates2/ocstyle/translate.tpl', '51');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1774', './templates2/ocstyle/translate.tpl', '148');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1775', './templates2/ocstyle/childwp.tpl', '7');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1776', './templates2/ocstyle/childwp.tpl', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1777', './templates2/ocstyle/childwp.tpl', '16');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1778', './templates2/ocstyle/childwp.tpl', '32');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1779', './templates2/ocstyle/map2.tpl', '52');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1780', '../lib/classes/ChildWp/AddPresenter.php', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1781', '../lib/classes/ChildWp/AddPresenter.php', '19');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1782', '../lib/classes/ChildWp/DeletePresenter.php', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1783', '../lib/classes/ChildWp/EditPresenter.php', '13');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1788', 'table:coordinates_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1789', 'table:coordinates_type;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1790', './lang/de/ocstyle/editcache.tpl.php', '308');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1790', './templates2/ocstyle/viewcache.tpl', '307');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1790', './templates2/ocstyle/viewcache.tpl', '308');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1791', './lang/de/ocstyle/editcache.tpl.php', '309');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1792', './lang/de/ocstyle/editcache.tpl.php', '319');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1793', './lang/de/ocstyle/editcache.inc.php', '48');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1794', './templates2/ocstyle/viewcache.tpl', '323');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1795', './templates2/ocstyle/viewcache.tpl', '235');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1796', './templates2/ocstyle/viewcache.tpl', '173');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1797', './lang/de/ocstyle/main.tpl.php', '282');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1797', './templates2/ocstyle/sys_main.tpl', '271');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1797', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1797', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1798', 'table:sys_menu;field=menustring', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1798', 'table:sys_menu;field=title', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1799', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1800', 'table:cache_attrib;field=html_desc', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1801', './lang/de/ocstyle/lib/menu.php', '199');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1802', './lang/de/ocstyle/adminreports.tpl', '83');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1803', './lang/de/ocstyle/search.tpl.php', '326');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1803', 'table:cache_size;field=name', '0');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1804', './lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1805', './lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1806', './adminuser.php', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1807', './lang/de/ocstyle/editcache.tpl.php', '353');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1807', './lang/de/ocstyle/editdesc.tpl.php', '104');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1807', './lang/de/ocstyle/editlog.tpl.php', '146');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1807', './lang/de/ocstyle/log_cache.tpl.php', '140');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1808', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1809', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1810', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1811', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1812', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1813', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1814', '/mnt/server-3.0/htdocs/lib2/smarty/ocplugins/prefilter.t.php', '241');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1815', './adminuser.php', '75');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1816', './lib2/logic/user.class.php', '765');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1817', './templates2/ocstyle/adminuser.tpl', '20');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1818', './lib/search.gpx.inc.php', '698');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1819', './lang/de/ocstyle/change_statpic.tpl', '72');
INSERT INTO `sys_trans_ref` (`trans_id`, `resource_name`, `line`) VALUES ('1820', './lang/de/ocstyle/newpw.tpl', '14');

-- Table sys_trans_text
SET NAMES 'utf8';
TRUNCATE TABLE `sys_trans_text`;
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'DA', 'DA', '2011-05-15 11:46:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1', 'DE', 'ID\'s neu sortieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('2', 'DE', 'Die Verbindung mit der Datenbank konnte nicht wiederhergestellt werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'DE', 'Testbetrieb - bitte nicht einloggen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'DE', 'Benutzer', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('5', 'DE', '(leer)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'DE', 'Eingeloggt als', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'DE', 'Abmelden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'DE', 'Wegpunkt-Suche', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('9', 'DE', 'Seitenberechnung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('10', 'DE', 'sek', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('11', 'DE', 'Zwischengespeichert', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'DE', 'Datenbankverbindung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('13', 'DE', 'Erstellt am', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'DE', 'Datenschutzbelehrung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'DE', 'Impressum', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'DE', 'Kontakt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'DE', 'Sitemap', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'DE', 'Registrieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'DE', 'Neuer Benutzer wurde registriert', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'DE', 'Hinweis', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('21', 'DE', 'Vietnamesisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'DE', 'Benutzername', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'DE', 'E-Mail', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'DE', 'Vorname', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'DE', 'Nachname', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'DE', 'Land', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'DE', 'Neuen Benutzer registrieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'DE', 'Usbekisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'DE', 'Der Benutzername ist nicht gültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'DE', 'Druck 5 Logs', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('31', 'DE', 'Der Familienname enthält ungültige Zeichen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('32', 'DE', 'Der Vorname enthält ungültige Zeichen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'DE', 'Keine Angabe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'DE', 'Alle anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'DE', 'Die E-Mail-Adresse ist nicht gültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'DE', 'Türkisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'DE', 'Dein Passwort', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('38', 'DE', 'Das Passwort enthält ungültige Zeichen oder ist zu kurz.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'DE', 'Die beiden Passwörter waren nicht identisch.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'DE', 'Wiederholen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'DE', 'Mit * gekennzeichnete Felder müssen eingegeben werden.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'DE', 'Schwedisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'DE', 'Slowenisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('44', 'DE', 'mindestens 6 Zeichen lang', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'DE', 'mindestens 4 unterschiedliche Zeichen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('46', 'DE', 'keine Teile des Benutzernamen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('47', 'DE', 'nicht Teil einer Wörterliste mit oft verwendeten Passwörtern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'DE', 'Slowakisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'DE', 'Russisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'DE', 'Du musst mit der Datenschutzbelehrung und den Nutzungsbedingungen einverstanden sein, um dich bei Opencaching.de zu registrieren.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'DE', 'Zurücksetzen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('52', 'DE', 'Besondere Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'DE', 'Index', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'DE', 'Empfehlungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'DE', 'gefunden', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'DE', 'von', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('58', 'DE', 'HTML Vorschau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'DE', 'Rumänisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'DE', 'Schritt 1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('61', 'DE', 'Als erstes musst du in das folgende Textfeld deinen Text eingeben und auf Weiter klicken.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'DE', 'Weiter', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'DE', 'Schritt 2', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'DE', 'Portugiesisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('65', 'DE', 'Zurück', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('66', 'DE', 'Vorschau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('67', 'DE', 'Schritt 3', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('68', 'DE', 'So sieht dein HTML-Code in einem Browser aus:', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('69', 'DE', 'Hier nochmals der HTML-Code, den du nun abspeichern oder direkt als Beschreibung eingeben kannst.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'DE', 'Aktuelles', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'DE', 'Neueste Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'DE', 'Neueste Caches ohne Deutschland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'DE', 'Neueste Logeinträge', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'DE', 'Polnisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'DE', 'Norwegisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'DE', 'Lettisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'DE', 'Litauisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'DE', 'Italienisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'DE', 'Isländisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'DE', 'Startseite', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'DE', 'Was finde ich auf dieser Website?', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'DE', 'Hier findest du Geocaches aus der ganzen Welt, mit Schwerpunkt Deutschland, \&Ouml;sterreich, Schweiz, Italien und Spanien. Au\&szlig;erdem gibt es Informationsangebote rund ums Geocaching, und ein Forum und einen Chat zum Austausch mit Gleichgesinnten.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('83', 'DE', 'Bei der Dateiübertragung ist ein Fehler aufgetreten.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('84', 'DE', 'Die Datei war zu groß. Es sind maximal 150 kB erlaubt.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('85', 'DE', 'Kein Bild angegeben.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'DE', 'Gleiche Cacheart', '2010-09-04 21:39:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'DE', 'Opencaching.de', '2010-08-29 17:36:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'DE', 'Insgesamt %1 aktive Caches und %2 Funde von %3 Benutzern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'DE', 'Ungarisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'DE', 'Kroatisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'DE', 'Finnisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'DE', 'Ja', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'DE', 'Nein', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'DE', 'Hallo', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('99', 'DE', 'Diese E-Mail wurde von der Opencaching.de-Webseite generiert, weil ein Benutzeraccount mit dieser E-Mail-Adresse angemeldet wurde. Falls du in Zukunft keine E-Mails mehr von Opencaching.de erhalten möchtest oder der falsche Empfänger bist, schreib uns bitte eine E-Mail an %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'DE', 'Baskisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'DE', 'Estnisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'DE', 'Esperanto', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'DE', 'Griechisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'DE', 'Dänisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('105', 'DE', 'Ein unbekannter Fehler ist aufgetreten.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('106', 'DE', 'Das Template existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('107', 'DE', 'Entschuldigung, aber diese Seite darfst du nicht sehen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('108', 'DE', 'Entschuldigung, aber der angeforderte Cache existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('109', 'DE', 'Entschuldigung, aber der angeforderte Vorgang konnte nicht ausgeführt werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('110', 'DE', 'Entschuldigung, aber der angeforderte Vorgang konnte nicht ausgeführt werden, weil du nicht angemeldet bist.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('111', 'DE', 'Entschuldigung, aber der angeforderte Benutzer existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('112', 'DE', 'Das E-Mail Template existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('113', 'DE', 'Erlaubte HTML Tags', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'DE', 'Beschreibung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'DE', 'Verstecken', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'DE', 'Admin', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'DE', 'Informationen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'DE', 'Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'DE', 'Mein Profil', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'DE', 'Neueste Logs', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'DE', 'Ohne Deutschland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'DE', 'Neueste Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'DE', 'Über Geocaching', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('124', 'DE', 'Neuer Eintrag', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'DE', 'Suchen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'DE', 'Übersetzung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'DE', 'Aktivierung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'DE', 'Benutzerprofil', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('129', 'DE', 'Beim Aufruf der Seite ist ein Fehler aufgetreten.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('130', 'DE', 'Bei dem Versuch die Seite zu erstellen ist ein Fehler aufgetreten. Sollten Sie durch einen Hyperlink, auf unserer Seite, hierher gekommen sein und dieses Problem längere Zeit bestehen, weisen sie uns bitte per E-Mail darauf hin.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('131', 'DE', 'Der folgende Fehler ist aufgetreten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'DE', 'Seite', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'DE', 'Fehlermeldung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'DE', '%2 hat %1 gefunden', '2010-08-29 18:00:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'DE', '%2 hat %1 nicht gefunden', '2010-08-29 18:00:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'DE', '%2 hat %1 kommentiert', '2010-08-29 17:59:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'DE', '%2 hat %1 besucht', '2010-08-29 17:59:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'DE', '%2 möchte %1 besuchen', '2010-08-29 17:59:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('139', 'DE', 'Registrierungsbestätigung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'DE', 'Herzlich Willkommen bei www.opencaching.de!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('141', 'DE', 'Für deine E-Mail-Adresse %1 wurden folgende Benutzerdaten eingetragen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'DE', 'Slawisch', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('143', 'DE', 'Die Aktivierungsseite ist unter folgender URL erreichbar:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('144', 'DE', 'Solltest du dich innerhalb der nächsten 14 Tage nicht einloggen, wird der Benutzeraccount wieder entfernt.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'DE', 'Tschechisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'DE', 'Bulgarisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'DE', 'Benutzerprofil von %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'DE', 'E-Mail senden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'DE', 'Sonstiges', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('150', 'DE', 'Ich nehme ein PMR Funkgerät auf Kanal 2 mit zum Geocaching', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'DE', 'Registriert&nbsp;seit', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'DE', 'Versteckte Geocaches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'DE', 'Gefundene Geocaches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'DE', '%1 von %2 möglichen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'DE', 'Niederländisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'DE', 'Japanisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'DE', 'Spanisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'DE', 'Französisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'DE', 'Englisch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'DE', 'Deutsch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('161', 'DE', 'Vorsicht: Wenn Du diese Option verwenden, vergiss niemals auf Logout zu klicken, wenn Du dich von einem PC aus angemeldet hast der auch Fremden zugänglich ist. Ansonsten kann ein Fremder Deine persönlichen Account-Daten auslesen und ändern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'DE', 'Simbabwe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'DE', 'Sambia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'DE', 'Südafrika', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'DE', 'Mayotte', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'DE', 'Der Aktivierungscode wurde per E-Mail versendet.<br />Für den Abschluss der Registrierung folge bitte den weiteren Anweisungen in der E-Mail.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'DE', 'Um dir einen Benutzeraccount auf opencaching.de einzurichten, musst du nur eine gültige E-Mail-Adresse und einen Benutzername \'Nickname\' angeben. An die angegebene E-Mail-Adresse wird eine E-Mail gesendet, mit der du deinen Account aktivieren kannst. Pro E-Mail-Adresse kann nur ein Benutzeraccount eingerichtet werden. Familienname, Vorname und Land müssen nicht angegeben werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('168', 'DE', 'Es ist bereits ein Account mit dieser E-Mail-Adresse vorhanden. Es ist nicht möglich, einen zweiten Account auf diese E-Mail-Adresse zu registrieren.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('170', 'DE', 'Das gewählte Passwort ist zu einfach. Zu deinem eigenen Schutz muss das Passwort eine bestimmte Komplexität besitzen\"', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('171', 'DE', 'Der Aktivierungscode oder die E-Mail-Adresse ist nicht korrekt.<br />\r\nDie Aktivierung deines Account war nicht erfolgreich.<br />\r\nVerwende bitte die E-Mail-Adresse aus der Registrierungsbestätigung, die du per E-Mail bekommen hast.<br />\r\n<br />\r\nÜberprüfe bitte, ob du dich vertippt hast - sollten die Probleme längere Zeit bestehen, melde dich bitte unter <a href=\"mailto:%1\">%1</a>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'DE', 'Jemen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'DE', 'Samoa', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('174', 'DE', 'Go', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('175', 'DE', 'Entwicklersystem - nur Testdaten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('176', 'DE', 'Die <a target=\"_blank\" href=\"articles.php?page=dsb\">Datenschutzbelehrung</a> und <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Nutzungsbedingungen</a> habe ich gelesen und bin damit einverstanden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('177', 'DE', 'Du willst in deiner Cachebeschreibung einen Teil des Textes <b>fett</b> oder <i>kursiv</i> machen, hast jedoch keine Ahnung von HTML?<br /><p>Kein Problem, mit dieser Anleitung wird das zum Kinderspiel!</p>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('178', 'DE', 'Hier siehst du den HTML Code deines Textes. Wenn du ein Wort oder Satz <b>fett</b> schreiben möchtest, füge vor den Satz ein \&lt;b\&gt; und hinter den Satz ein \&lt;/b\&gt;.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'DE', 'Wallis und Futuna', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'DE', 'Neuen Newseintrag erstellen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'DE', 'Vanuatu', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'DE', 'Vietnam', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'DE', 'die Amerikanischen Jungferninseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'DE', 'die Britischen Jungferninseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'DE', 'Venezuela', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('186', 'DE', 'Zu übersetzende Sprache auswählen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('187', 'DE', 'Neue Übersetzungen anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('188', 'DE', 'Smarty-Cache löschen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('189', 'DE', 'keine Angabe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('190', 'DE', 'Übersetzung ohne Referenz anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('191', 'DE', 'Alle Übersetzungen anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'DE', 'St. Vincent und die Grenadinen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'DE', 'der Heilige Stuhl (Vatikan)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'DE', 'Usbekistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('195', 'DE', 'Vorhandene Übersetzungen verwenden:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('196', 'DE', 'Alle Übersetzung:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('197', 'DE', 'Neue Übersetzungen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('198', 'DE', 'Übersetzung ohne Referenz:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'DE', 'Sprachen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'DE', 'Uruguay', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'DE', 'Aktivierungscode:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'DE', 'Vereinigte Staaten von Amerika', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'DE', 'Amerikanisch-Ozeanien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('206', 'DE', 'Insgesamt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'DE', 'Anmelden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'DE', 'Passwort', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'DE', 'Uganda', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'DE', 'Ukraine', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'DE', 'Tansania', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'DE', 'Taiwan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'DE', 'Tuvalu', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'DE', 'Trinidad und Tobago', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'DE', 'Türkei', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'DE', 'Noch nicht registriert?', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'DE', 'Passwort vergessen?', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'DE', 'E-Mail-Adresse vergessen?', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'DE', 'Weitere Hilfestellungen findest du im', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'DE', 'Druck ohne Logs', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'DE', 'Neues Passwort eingeben', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'DE', 'Erinnerung schicken', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'DE', 'Tonga', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'DE', 'Bitte die Felder Benutzer und Passwort ausfüllen!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'DE', 'Logout war erfolgreich.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('226', 'DE', 'Der Login war nicht erfolgreich.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('227', 'DE', 'Die eingegebene Benutzername/E-Mail-Adresse war ungültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('228', 'DE', 'Du hast versucht dich in der letzten Stunde %1 mal auf Opencaching.de einzuloggen. Weitere Loginversuche sind erst wieder möglich, wenn eine Stunde seit dem ersten Login vergangen ist.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'DE', 'Dein Account wurde noch nicht aktiviert oder wieder deaktiviert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('230', 'DE', 'Du kannst deinen Account \&gt;<a href=\"activation.php\">hier</a>\&lt; aktivieren.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'DE', 'Tunesien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'DE', 'Um die Registrierung abzuschließen, musst du noch die E-Mail-Adresse und den Aktivierungscode eingeben und bestätigen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'DE', 'Turkmenistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'DE', 'Tokelau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'DE', 'Tadschikistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'DE', 'Thailand', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'DE', 'Togo', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'DE', 'Französische Süd- und Antarktisgebiete', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'DE', 'Tschad', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'DE', 'Turks- und Caicosinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'DE', 'Name', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'DE', 'Swasiland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'DE', 'Syrien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('244', 'DE', 'Empfehlungen von <a href=\"viewprofile.php?userid=%1\">%2</a>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('245', 'DE', '<a href=\"viewcache.php?cacheid=%1\">%2</a> von %3', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('246', 'DE', '%1 hat noch keinen Geocache empfohlen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'DE', 'Empfehlungen anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'DE', 'El Salvador', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'DE', 'Sao Tomé und Principe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'DE', 'Suriname', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'DE', 'Somalia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('253', 'DE', 'Unbekanntes Waypoint-Format. Zulässig sind die Formate OCxxxx, NCxxxx und GCxxxx, wobei xxxx jeweils für beliebige Zahlen und Buchstaben steht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('254', 'DE', 'Mehrere Caches mit dem Waypoint \&quot;%1\&quot; gefunden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('255', 'DE', 'Kein Cache mit dem Wegpunkt \&quot;%1\&quot; gefunden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'DE', 'Senegal', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'DE', 'San Marino', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'DE', 'Sierra Leone', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'DE', 'Slowakai', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'DE', 'Svalbard und Jan Mayen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'DE', 'Slowenien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'DE', 'St. Helena', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'DE', 'Singapur', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'DE', 'Schweden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'DE', 'Sudan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'DE', 'Seychellen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('267', 'DE', 'Salomonen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'DE', 'Saudi-Arabien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'DE', 'Ruanda', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'DE', 'Russische Föderation', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'DE', 'Rumänien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'DE', 'Réunion', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'DE', 'Katar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'DE', 'Paraguay', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'DE', 'Palau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'DE', 'Portugal', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'DE', 'Puerto Rico', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'DE', 'die Pitcairninseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'DE', 'St. Pierre und Miquelon', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'DE', 'Polen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'DE', 'Pakistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'DE', 'Philippinen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'DE', 'Papua-Neuguinea', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'DE', 'Französisch-Polynesien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'DE', 'Peru', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'DE', 'Panama', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'DE', 'Oman', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'DE', 'Neuseeland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'DE', 'Niue', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'DE', 'Nauru', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'DE', 'Nepal', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'DE', 'Norwegen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'DE', 'Niederlande', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'DE', 'Nicaragua', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'DE', 'Nigeria', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'DE', 'Norfolkinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'DE', 'Niger', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'DE', 'Neukaledonien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'DE', 'Namibia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'DE', 'Mosambik', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'DE', 'Malaysia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'DE', 'Mexiko', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'DE', 'Malwai', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'DE', 'Malediven', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'DE', 'Mauritius', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'DE', 'Malta', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'DE', 'Montserrat', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'DE', 'Mauretanien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'DE', 'Martinique', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'DE', 'Marianen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'DE', 'Macau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'DE', 'Mongolei', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'DE', 'Myanmar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'DE', 'Mali', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'DE', 'Mazedonien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'DE', 'Marshallinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'DE', 'Madagaskar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'DE', 'Moldau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'DE', 'Monaco', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'DE', 'Marokko', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'DE', 'Libyen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'DE', 'Lettland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'DE', 'Luxemburg', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'DE', 'Litauen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'DE', 'Lesotho', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'DE', 'Liberia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'DE', 'Sri Lanka', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'DE', 'Liechtenstein', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'DE', 'St. Lucia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'DE', 'Libanon', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'DE', 'Laos', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'DE', 'Kasachstan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'DE', 'Kaimaninseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'DE', 'Kuwait', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'DE', 'Republik Korea', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'DE', 'Demokratische Volksrepublik Korea', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'DE', 'St. Kitts und Nevis', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'DE', 'Komoren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'DE', 'Kiribati', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'DE', 'Kambodscha', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'DE', 'Kirgistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'DE', 'Kenia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'DE', 'Japan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'DE', 'Jordanien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'DE', 'Jamaika', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'DE', 'Italien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'DE', 'Island', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'DE', 'Iran', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'DE', 'Irak', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'DE', 'Britisches Territorium im Indischen Ozean', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'DE', 'Indien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'DE', 'Israel', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'DE', 'Irland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'DE', 'Indonesien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'DE', 'Ungarn', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'DE', 'Haiti', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'DE', 'Kroatien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'DE', 'Honduras', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'DE', 'Heard und McDonaldinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'DE', 'Honkong', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'DE', 'Guyana', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'DE', 'Guinea-Bissau', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'DE', 'Guam', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'DE', 'Guatemala', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'DE', 'Südgeorgien und die Südlichen Sandwichinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'DE', 'Griechenland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'DE', 'Guadelope', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'DE', 'Guinea', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'DE', 'Gambia', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'DE', 'Grönland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'DE', 'Gibraltar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'DE', 'Ghana', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'DE', 'Guayana', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'DE', 'Georgien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'DE', 'Granada', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'DE', 'Großbritannien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'DE', 'Gabun', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'DE', 'Frankreich', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'DE', 'Färöer (zu Dänemark)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'DE', 'Mikronesien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'DE', 'Falklandinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'DE', 'Fidschi', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'DE', 'Finnland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'DE', 'Äthiopien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'DE', 'Spanien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'DE', 'Eritrea', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'DE', 'Westsahara', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'DE', 'Ägypten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'DE', 'Estland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'DE', 'Ecuador', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'DE', 'Algerien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'DE', 'Dominikanische Republik', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'DE', 'Dänemark', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'DE', 'Dschibuti', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'DE', 'Deutschland', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'DE', 'Tschechische Republik', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'DE', 'Zypern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'DE', 'Weihnachtsinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'DE', 'Kapverden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'DE', 'Kuba', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('401', 'DE', 'Teilnehmer', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'DE', 'Costa Rica', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'DE', 'Kolumbien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'DE', 'Volksrepublik China', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'DE', 'Kamerun', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'DE', 'Chile', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'DE', 'Cookinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'DE', 'Elfenbeinküste', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'DE', 'Schweiz', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'DE', 'Kongo', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'DE', 'Zentralafrikanische Republik', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'DE', 'Kokosinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'DE', 'Kanada', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'DE', 'Belize', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'DE', 'Belarus (Weißrußland)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'DE', 'Botsuana', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'DE', 'die Bouvetinseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'DE', 'Bhutan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'DE', 'Bahamas', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'DE', 'Brasilien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'DE', 'Bolivien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'DE', 'Brunei', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'DE', 'Bermuda', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'DE', 'Benin', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'DE', 'Burundi', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'DE', 'Bahrain', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'DE', 'Bulgarien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'DE', 'Burkina Faso', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'DE', 'Belgien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'DE', 'Bangladesch', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'DE', 'Barbados', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'DE', 'Bosnien-Herzegowina', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'DE', 'Aserbaidschan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'DE', 'Aruba', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'DE', 'Australien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'DE', 'Österreich', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'DE', 'Amerikanisch-Samoa', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'DE', 'Argentinien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'DE', 'Angola', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'DE', 'Niederländische Antillen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'DE', 'Armenien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'DE', 'Albanien', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'DE', 'Anguilla', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'DE', 'Antigua und Barbuda', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'DE', 'Afghanistan', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'DE', 'Vereinigte Arabische Emirate', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'DE', 'Andorra', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('448', 'DE', 'Die Anmeldung an der Datenbank als root ist fehlgeschlagen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('449', 'DE', '(vor einem Export)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('450', 'DE', 'Opencaching.de wird gerade umgebaut und um Fehler in der Datenverarbeitung zu vermeiden, haben wir die\r\ngesamte Seite gerade außer Betrieb genommen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('452', 'DE', 'Newseintrag gespeichert', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('453', 'DE', 'Vielen Dank für deinen Newseintrag. Wir werden uns bemühen die Überprüfung möglichst schnell durchzuführen.<br />\r\n<br />\r\nZurück zur <a href=\"index.php\">Startseite</a>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'DE', 'Neuen Newseintrag erstellen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'DE', 'Bestätigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('456', 'DE', 'Eingabe war nicht korrekt.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'DE', '... und jetzt bitte noch den Schutz gegen Spammer umgehen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'DE', 'Was zeigt das Bild?', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('459', 'DE', 'E-Mail-Adresse ungültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'DE', 'Deine E-Mail-Adresse für Rückfragen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'DE', 'Bitte nur HTML-Elemente zur Textgestaltung verwenden - z.B. Fettschrift, Textfarbe, Hyperlink usw. Unerwünscht sind z.B. Tabellen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'DE', 'Die Nachricht wurde als HTML-Code eingegeben', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'DE', 'Nachricht:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'DE', 'Thema:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('465', 'DE', 'Gibt es was neues zum Thema Geocaching?<br />\r\nHier kannst du einen Newseintrag erstellen, der auf der Startseite angezeigt wird.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('466', 'DE', 'Dein Account wurde erfolgreich aktiviert. Du kannst dich nun auf der Loginseite anmelden.<br /><br />\r\n<a href=\"login.php\">Zur Loginseite</a>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('467', 'DE', 'Hinweis', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'DE', 'Account aktivieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('469', 'DE', 'Vielen Dank,<br/>das Opencaching.de-Team', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('470', 'DE', 'Wir bitten um etwas Geduld und bemühen uns die Seite wieder m\&ouml;glichst schnell  \r\nfunktionsbereit zu machen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('471', 'DE', 'Der Benutzer konnte nicht angelegt werden. Die Ursache ist unbekannt. Sollte dieser Fehler längere Zeit bestehen und du dich nicht registrieren können, schicke uns bitte eine <a href=\"mailto:%1\">E-Mail</a>.\r\n', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'DE', 'Wir achten auf dein Recht auf informationelle Selbstbestimmung. Deine persönlichen Daten werden in unserer Datenbank gespeichert, jedoch nicht an Dritte weitergegeben. Bitte beachte die genauen Ausführungen in unserer <a target=\"_blank\" href=\"articles.php?page=dsb\">Datenschutzbelehrung</a>. Solltest du Fragen dazu haben, möchten wir dich bitten mit uns in Kontakt zu treten, <b>bevor</b> du dich registrierst.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('473', 'DE', 'Dein Newseintrag kann leider erst nach einer Überprüfung angezeigt werden i.d.R. wird diese Überprüfung innerhalb von 24 bis \r\n						48 Stunden durchgeführt. Der Newseintrag kann nach der Bestätigung nicht mehr verändert werden. Sollten Änderungen notwendig \r\n						sein, bitte die korrigierte Nachricht einfach nochmals eingeben. Erlaubt sind Newseinträge zu allen Themen rund um\'s Geocaching.\r\n						Nicht erlaubt ist direkte Werbung für\r\n						Produkte oder einen Geocache. Die Freischaltung eines Newseintrags für die Anzeige auf der Webseite liegt ausschließlich im\r\n						Ermessen des Betreibers der Webseite - es besteht kein Anspruch auf eine Veröffentlichung. Im Zweifelsfall bitte den Newseintrag\r\n						melden und abwarten, ob er veröffentlicht wird, oder per E-Mail an <a href=\"mailto:%1\">%1</a>\r\n						vorher erkundigen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('474', 'DE', 'Sollte das Problem längere Zeit bestehen, wende dich bitte an <a href=\"mailto:%1\">%1</a>.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('475', 'DE', 'Opencaching.de momentan außer Betrieb', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('476', 'DE', 'Erstellt am:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('477', 'DE', 'Gesamt:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('478', 'DE', 'Businesslayer:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('479', 'DE', 'Framework:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'DE', 'User:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('481', 'DE', 'SQL Debugger', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('482', 'DE', '%1 Befehle', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('483', 'DE', 'Übersicht', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'DE', 'Profildaten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('485', 'DE', 'Gespeicherte Suchen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('486', 'DE', 'Beobachtete Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'DE', 'Ignorierte Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'DE', 'Einstellungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'DE', 'Profildaten ändern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'DE', 'Der Radius darf maximal 150km betragen. Zum Deaktivieren der Benachrichtigung setze den Umkreis auf den Wert 0.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'DE', 'Passwort ändern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('492', 'DE', 'Statistikbild wählen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'DE', 'E-Mail-Adresse ändern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('494', 'DE', 'Kann gesucht werden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('495', 'DE', 'Momentan nicht verfügbar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('496', 'DE', 'Archiviert', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'DE', 'nicht gefunden', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('498', 'DE', 'teilgenommen', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('499', 'DE', 'möchte teilnehmen', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('500', 'DE', 'Herzlich Willkommen %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('501', 'DE', 'Logs', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'DE', 'Gefundene Caches: %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'DE', 'Deine letzten Logeinträge:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'DE', 'Keine Einträge gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'DE', 'Versteckte Caches: %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'DE', 'Deine letzten versteckten Caches:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'DE', 'Keine versteckten Geocaches gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('508', 'DE', 'Deine noch nicht veröffentlichten Caches:', '2012-07-23 15:54:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'DE', 'Keine nicht veröffentlichten Caches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('510', 'DE', 'Versendete E-Mails', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'DE', 'Versendete E-Mails: %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('512', 'DE', 'Unbekannter Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('513', 'DE', 'Normaler Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('514', 'DE', 'Multicache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('515', 'DE', 'Virtueller Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('516', 'DE', 'Webcam Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('517', 'DE', 'Event Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('518', 'DE', 'Rätselcache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('519', 'DE', 'Mathe/Physik-Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('520', 'DE', 'Beweglicher Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('521', 'DE', 'Drive-In Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('522', 'DE', 'Motorrad Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('524', 'DE', 'andere Größe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('525', 'DE', 'mikro', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('526', 'DE', 'klein', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('527', 'DE', 'normal', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('528', 'DE', 'groß', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('529', 'DE', 'extrem groß', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('530', 'DE', 'kein Behälter', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('531', 'DE', 'Kann gesucht werden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('532', 'DE', 'Momentan nicht verfügbar', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('533', 'DE', 'Von den Approvern entfernt, um geürpft zu werden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('534', 'DE', 'Noch nicht veröffentlicht', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('535', 'DE', 'unbekannter Cachetyp', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('536', 'DE', 'normaler Cache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('537', 'DE', 'virtueller Cache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('538', 'DE', 'Webcam-Cache', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('539', 'DE', 'Event-Cache', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('540', 'DE', 'Mathe-/Physikcache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('541', 'DE', 'beweglicher Cache', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('542', 'DE', 'Drive-In Cache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'DE', 'Ich möchte über neue Caches im Umkreis von %1 km benachrichtigt werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'DE', 'BBCode (für Foren):', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('546', 'DE', 'Opencaching.de-Statistik von %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('547', 'DE', 'Statistikbild wählen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'DE', 'HTML-Code:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('549', 'DE', 'Angezeigter Text:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('550', 'DE', 'Ungültige Zeichen im Text!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('551', 'DE', 'Verfügbare Logos:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'DE', 'Abbrechen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('553', 'DE', 'Speichern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('554', 'DE', 'Folgende Einstellungen sind für dein Statistikbild gespeichert:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('555', 'DE', 'Logeinträge anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('556', 'DE', 'Statistikbild:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'DE', 'Registriert&nbsp;seit:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('558', 'DE', 'Als Vorgabe kein HTML-Editor verwenden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('559', 'DE', 'Der automatische Logout 15 Minuten nach verlassen der Webseite ist deaktiviert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('560', 'DE', 'Ich nehme ein PMR-Funkgerät auf Kanal 2 mit zum Cachen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('561', 'DE', 'Sonstiges:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('562', 'DE', 'Benachrichtigung über neue Caches ist deaktiviert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('563', 'DE', 'Benachrichtigung über neue Caches im Umkreis von %1 km.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'DE', 'Benachrichtigung:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'DE', 'Koordinaten:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'DE', 'Land:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'DE', 'Nachname:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'DE', 'Vorname:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('569', 'DE', 'Empfohlen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'DE', '%1 hat den Geocache gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('571', 'DE', '%1 hat den Geocache nicht gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('572', 'DE', '%1 hat eine Bemerkung geschrieben', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('573', 'DE', '%1 hat das Event besucht', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('574', 'DE', '%1 möchte das Event besuchen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('575', 'DE', '%1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('576', 'DE', 'Bearbeiten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('577', 'DE', 'Löschen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('578', 'DE', 'Bild hinzufügen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('579', 'DE', 'Bilder für diesen Logeintrag:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('580', 'DE', 'Zurück zum Geocache', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'DE', 'E-Mail-Adresse:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'DE', 'Logeinträge für %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('583', 'DE', 'Bilderauswahl', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('584', 'DE', 'Bilderauswahl für %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('585', 'DE', 'Für diesen Cache wurden noch keine Bilder hochgeladen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('586', 'DE', 'Vorschaubild einfügen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'DE', 'Profildaten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'DE', 'Folgende Daten sind in meinem Benutzerprofil gespeichert:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'DE', 'Graue Einträge sind für andere Benutzer nicht sichtbar.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'DE', 'Benutzername:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('591', 'DE', 'Das Land ist nicht gültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('592', 'DE', 'Der eingegebene Radius ist nicht gültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('593', 'DE', 'Ein unbekannter Fehler ist aufgetreten.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('594', 'DE', 'Vor dem ersten Einloggen musst du deinen Account mit folgendem Code aktivieren:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'DE', 'Neues Passwort', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('596', 'DE', 'Anfordern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'DE', 'Ändern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'DE', 'Anfordern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('599', 'DE', 'Sicherheitscode für ein neues Passwort', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('600', 'DE', 'du hast am %1 einen Sicherheits-Code angefordert, um dein Passwort zu ändern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('601', 'DE', 'Folgender Sicherheits-Code wurde generiert: %1', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('602', 'DE', 'Der Sicherheits-Code bleibt 3 Tage gültig.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('603', 'DE', 'Dein neues Passwort kannst du unter %1newpw.php eingeben.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'DE', 'Um ein neues Passwort einzugeben musst Du zunächst einen Sicherheits-Code anfordern, dieser wird per E-Mail an Dich gesendet.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('605', 'DE', 'Die E-Mail-Adresse gehört zu keinem gültigen Benutzer.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('606', 'DE', 'Ihnen wurde eine EMail mit dem Sicherheits-Code gesendet.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('607', 'DE', 'Der Sicherheitscode konnte wegen einem Fehler nicht gesendet werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'DE', 'Gib bitten deine E-Mail-Adresse, den Sicherheitscode und das neue Passwort ein. Der Sicherheits-Code bleibt 3 Tage gültig, danach musst Du ihn erneut anfordern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('609', 'DE', 'Der angegebene Benutzer ist noch nicht aktiviert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'DE', 'Sicherheitscode:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('611', 'DE', 'Der Sicherheits-Code ist abgelaufen. Fordern Sie einen neuen an.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('612', 'DE', 'Der Sicherheitscode stimmt nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'DE', 'Passwort wiederholen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('614', 'DE', 'Das Passwort wurde geändert.', '2013-02-14 00:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('615', 'DE', 'Sicherheitscode für eine neue E-Mail-Adresse', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('616', 'DE', 'du hast am %1 einen Sicherheitscode angefordert, um deine E-Mail-Adresse zu ändern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('617', 'DE', 'Deine neue E-Mail-Adresse kannst du unter %1newemail.php aktivieren.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'DE', 'E-Mail-Adresse ändern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'DE', 'Um die E-Mail-Adresse zu ändern, musst Du zunächst einen Sicherheitscode anfordern, der an Deine neue E-Mail-Adresse gesendet wird.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'DE', 'Neue E-Mail-Adresse:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('621', 'DE', 'Ihr Account ist bereits auf diese E-Mail-Adresse registriert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'DE', 'Gib bitte nun den Sicherheitscode hier ein, den du per E-Mail erhalten hast. Der Sicherheits-Code bleibt 3 Tage gültig, danach musst Du ihn erneut anfordern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'DE', 'Zuerst Sicherheitscode anfordern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('624', 'DE', 'Es wurde noch keine neue E-Mail-Adresse hinterlegt. Fordere zuerst einen Sicherheitscode an.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('625', 'DE', 'Die E-Mail-Adresse wurde geändert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('626', 'DE', 'Download', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('627', 'DE', 'Es sind keine gespeicherten Suchen vorhanden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('628', 'DE', 'Mit dem Download werden die <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> von Opencaching.de akzeptiert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('629', 'DE', 'Suche speichern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('630', 'DE', 'Suchoptionen als neue Suche abspeichern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('631', 'DE', 'Name der Suche', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('632', 'DE', 'Es muss ein Name der Suche angegeben werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('633', 'DE', 'Es existiert bereits eine Suche unter diesem Namen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('634', 'DE', 'Speichern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('635', 'DE', 'Alte Suchoptionen überschreiben', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('636', 'DE', '-- Bitte zu überschreibende Suche auswählen --', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('637', 'DE', '-- noch keine Suchoptionen vorhanden --', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'DE', 'Meine Empfehlungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('639', 'DE', 'Deine Empfehlung für \"<a href=\"viewcache.php?wp=%1\">%2</a>\" wurde zurückgezogen!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('640', 'DE', 'Bewertung zurückziehen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('641', 'DE', 'Du hast noch keine Geocaches empfohlen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'DE', 'Ignorierte Geocaches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('643', 'DE', 'entfernen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'DE', 'Keine ignorierten Caches gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('645', 'DE', 'Beobachtete Caches - Einstellungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('646', 'DE', 'Versandart:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('647', 'DE', 'sofort', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('648', 'DE', 'täglich', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('649', 'DE', 'wöchentlich', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('650', 'DE', 'versenden um:', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('651', 'DE', 'Uhr', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('652', 'DE', 'Versenden am:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('653', 'DE', 'Versandstunde und -tag wird nur bei täglichem/wöchentlichem Versand berücksichtigt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('654', 'DE', 'Fehler beim Speichern!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('655', 'DE', 'Die Einstellungen wurden erfolgreich gespeichert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('656', 'DE', 'Beobachtete Geocaches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('657', 'DE', 'Zuletzt gefunden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('658', 'DE', 'Keine beobachteten Geocaches gefunden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('659', 'DE', 'E-Mail-Addresse erinnern', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('660', 'DE', 'E-Mail Erinnerung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('661', 'DE', 'Gibt hier deinen Benutzername ein und wir senden dir eine E-Mail an die E-Mail-Adresse, die du bei der Registrierung verwendet hast.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('662', 'DE', 'Gib deinen Benutzername ein.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('663', 'DE', 'Der Benutzername existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('664', 'DE', 'Die Erinnerungsmail wurde gesendet.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('665', 'DE', 'Erinnerung an deine E-Mail-Adresse', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('666', 'DE', 'Deine E-Mail-Adresse mit der du dich einloggen kannst ist:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('667', 'DE', 'du hast am %date% eine Erinnerung an deine E-Mail-Adresse angefordert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('668', 'DE', 'Cache-Empfehlungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('669', 'DE', 'Benutzer, die %1 von %2 empfahlen, haben auch folgende Geocaches empfohlen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('670', 'DE', 'Trefferquote', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('671', 'DE', 'Es können keine Empfehlungen gegeben werden, da keine weiteren Bewertungen vorliegen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('672', 'DE', 'Datenbank Maintainance', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('673', 'DE', 'DB Maintainance', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('674', 'DE', '%1 hat %2 Einträge korrigiert', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'DE', 'Ausführen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'DE', 'Senden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'DE', 'E-Mail von', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('678', 'DE', 'Entschuldigung, aber der Benutzer ist deaktiviert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('679', 'DE', 'Entschuldigung, für den angegebenen Benutzer ist keine E-Mail-Adresse hinterlegt.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('680', 'DE', 'Die E-Mail konnte wegen einem unbekannten Fehler nicht versendet werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('681', 'DE', '\'%1\' kontaktierte dich über %2\r\nDas Benutzerprofil: %2viewprofile.php?userid=%3\r\nUm diese Email zu beantworten musst du die Funktion \'Email senden\' im Profil verwenden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'DE', 'Betreff:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('683', 'DE', 'Alle Daten werden selbstverständlich vertraulich behandelt und keinen Dritten zugänglich gemacht!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('684', 'DE', '\'%1\' mit Emailadresse %2 kontaktierte dich über %3\r\nDas Benutzerprofil: %3viewprofile.php?userid=%4\r\nUm diese Email zu beantworten verwende die Antwort-Funktion deines Email-Programms.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('685', 'DE', 'E-Mail an %1 versendet', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'DE', 'Inhalt:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('687', 'DE', 'E-Mail an %1 schicken', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('688', 'DE', 'Du musst einen Betreff angeben!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('689', 'DE', 'Du musst einen Inhalt eingeben!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('690', 'DE', 'Meine E-Mail-Adresse soll mit dieser E-Mail mitgesendet werden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('691', 'DE', 'Damit kennt der Empfänger deine E-Mail-Adresse und hat die Möglichkeit direkt auf die E-Mail zu antworten.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('692', 'DE', 'Um Missbrauch zu verhindern müssen wir zu Eurem und auch unserem Schutz folgende Maßnahmen treffen:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('693', 'DE', 'Es dürfen nur Emails zum Thema versendet werden, jede Form nicht notwendiger Belästigung z.B. Spam ist nicht erlaubt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('694', 'DE', 'Es werden alle relevanten Informationen protokolliert (Datum/Uhrzeit, Absender/Empfänger und IP-Adresse)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('696', 'DE', 'Entschuldigung, der Geocache ist noch nicht veröffentlicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'DE', 'Alle Logeinträge anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'DE', 'Geocache anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'DE', 'Du bist bereits eingeloggt.<br />\r\nDu musst duch erst <a href=\"login.php?action=logout\">abmelden</a>, um dich erneut anzumelden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'DE', 'Mit dem Download werden die <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> von Opencaching.de akzeptiert.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'DE', 'Schwierigkeit: %1 von 5', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('702', 'DE', 'Gelände: %1 von 5', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('703', 'DE', 'Teilnehmerliste', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'DE', 'Log eintragen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('705', 'DE', 'Nicht beobachten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'DE', 'Beobachten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('707', 'DE', 'Nicht ignorieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'DE', 'Ignorieren', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'DE', 'Druckansicht', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'DE', 'andere Koordinatensysteme', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'DE', 'Größe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'DE', 'Zeitaufwand', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'DE', 'Entfernung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'DE', 'Versteckt am', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'DE', 'Gelistet seit', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'DE', 'Letzte Änderung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'DE', 'Wegpunkt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'DE', 'Auch gelistet auf', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'DE', 'Bemerkungen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'DE', 'Beobachter', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'DE', 'Ignorierer', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'DE', 'Aufrufe', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'DE', 'Cacheattribute', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'DE', 'Verschlüsselter Hinweis', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'DE', 'Entschlüsseln', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'DE', 'Bilder', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'DE', 'Hilfreiches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('729', 'DE', 'Cache-Empfehlungen, von Benutzern die diesen Geocache empfohlen haben: <a href=\"recommendations.php?cacheid=%1\">alle</a>', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'DE', 'Suche Caches im Umkreis:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'DE', 'alle', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'DE', 'suchbare', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'DE', 'Download als Datei:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'DE', 'GPS Exchange Format .gpx', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('735', 'DE', 'Wegpunktdatei .loc', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'DE', 'Google Earth .kml', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('737', 'DE', 'TomTom POI .ov2', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('738', 'DE', 'TOP50-Overlay .ovl', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'DE', 'Textdatei .txt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'DE', 'K O P I E', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('741', 'DE', 'Bild bearbeiten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('742', 'DE', 'Das angegebene Bild existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('743', 'DE', 'Der angegebene Logeintrag existiert nicht.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('744', 'DE', 'Statistikdetails anzeigen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('745', 'DE', 'Alter', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('746', 'DE', 'Beschreibung', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('747', 'DE', 'Wohnort', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('748', 'DE', 'MiniMap-Zoom', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('749', 'DE', 'Cache melden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('750', 'DE', 'Gemeldete Geocaches', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('751', 'DE', 'Dateiname:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('752', 'DE', 'Kein Titel angegeben!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('753', 'DE', 'Bild für Geocache %1 hinzufügen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('754', 'DE', 'Bild für Logeintrag %1 hinzufügen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('755', 'DE', 'Bild für Geocache %1 bearbeiten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('756', 'DE', 'Bild für Logeintrag %1 bearbeiten', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'DE', 'Name:', '2010-09-13 00:12:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('758', 'DE', 'Kein Titel angegeben!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('759', 'DE', 'Nach dem Bestätigen kann der nächste Seitenaufbau je nach Bildgröße eine Weile dauern.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('760', 'DE', 'Dieses Bild ist ein Spoiler - keine Vorschau anzeigen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('761', 'DE', 'Hinzufügen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('762', 'DE', 'Es sind nur die Bildformate BMP, GIF, PNG und JPEG erlaubt - für Fotos ist JPEG empfohlen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('763', 'DE', 'Außerdem ist eine maximale Dateigröße von 150 KB zu beachten. Als Bildgröße sind 480 Pixel Breite und 360 Pixel Höhe empfohlen.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('764', 'DE', 'Meldebericht für %1 eingetragen', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('765', 'DE', 'Ursache:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('766', 'DE', 'Kommentar:', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('767', 'DE', '%1 melden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('768', 'DE', 'Es muss eine Ursache angegeben werden!', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('769', 'DE', 'Kommentar: (muss eingetragen werden)', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('770', 'DE', 'Es muss ein Kommentar eingetragen werden, um einen Geocache zu melden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('771', 'DE', 'Ein Fehler ist aufgetreten und der Meldebericht konnte nicht erstellt werden.', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('772', 'DE', 'Cache melden', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('773', 'DE', 'Neu', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('774', 'DE', 'In Arbeit', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('775', 'DE', 'Erledigt', '2010-08-28 11:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('776', 'DE', 'Cache auf Privatgrund', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('777', 'DE', 'Urheberrechtsverletzung', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('778', 'DE', 'Cache ist weg', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('779', 'DE', 'Sonstiges', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('780', 'DE', 'Der Bericht ist bereits einem anderen Admin zugeordnet! Du kannst ihn erst übernehmen, wenn er mindestens zwei Wochen alt ist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('781', 'DE', 'Der Bericht wurde dir bereits zugeordnet!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('782', 'DE', 'Du kannst diesen Bericht nicht bearbeiten, weil er bereits von einem anderen Admin bearbeitet wird.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('783', 'DE', 'Um einen Bericht zu bearbeiten, musst du ihn dir zuordnen!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('784', 'DE', 'Keine Meldeberichte vorhanden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('785', 'DE', 'Report von ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('786', 'DE', 'von', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('787', 'DE', 'Nicht zugeordnet', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('788', 'DE', 'Mir zuordnen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('789', 'DE', 'E-Mail an Besitzer', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('792', 'DE', 'Als erledigt markieren', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('793', 'DE', 'Aktion', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('794', 'DE', 'Bevor du einen Cache an das Opencaching-Team meldest, solltest du versuchen, Kontakt mit dem Owner aufzunehmen, um mögliche Probleme direkt untereinander zu klären. Davon ausgenommen sind Caches, die durch ihre Beschreibung oder das Versteck eine sofortige Archivierung notwendig machen.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('795', 'DE', 'Dieses Bild nicht anzeigen (Hintergrundbild in HTML Beschreibung o.ä.)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('796', 'DE', 'Es wurden keine Benutzerdetails eingegeben.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('797', 'DE', 'Koordinaten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('798', 'DE', 'Geokrets', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('799', 'DE', 'Meine Details', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('800', 'DE', 'Details bearbeiten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('801', 'DE', 'Benutzerdetails', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('802', 'DE', 'Meine Details', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('803', 'DE', 'Die folgenden Informationen sind in deinem Benutzerprofil gespeichert:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('804', 'DE', 'Markierte Einträge werden anderen Benutzern angezeigt.<br />\r\nEinträge, die nicht markiert werden können, werden nur für interne Zwecke verwendet und nicht anderen Benutzern angezeigt.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('805', 'DE', 'Fehler beim Speichern.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('806', 'DE', 'Ungültige Zeichen gefunden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('807', 'DE', 'Feldinhalt zu lange.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('808', 'DE', 'Ursprüngliche Daten wurden wiederhergestellt.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('809', 'DE', 'Angezeigt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('810', 'DE', 'Nicht angezeigt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('811', 'DE', 'Intern', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('812', 'DE', '(*) Neue Meldungen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('814', 'DE', 'Benutzerstatistik', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('815', 'DE', 'Anzeigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('816', 'DE', 'Der Benutzer hat bisher keinen Geocache gefunden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('817', 'DE', 'Der Geocache wurde durch einen Administrator gesperrt, weil er nicht den Nutzungsbedingungen von Opencaching.de entspricht. Wenn du die Sperrung aufheben möchtest, kontaktiere uns mit der \'Cache melden\' Funktion. Bitte wähle Sonstiges als Ursache und beschreibe uns, was du geändert hast, um die Nutzungsbedingungen einzuhalten. Danke!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('818', 'DE', 'doc/sql/static-data/data.sql wurde mit dem letzten CVS checkout geändert.<br /> \r\nVor Änderung der Übersetzungen, erst data.sql neu einspielen!<br /> \r\n\&nbsp;', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('819', 'DE', 'Entschuldigung, der Geocache wurde gesperrt und kann nicht angezeigt werden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('821', 'DE', 'Gesperrt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('822', 'DE', 'Gesperrt, versteckt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('823', 'DE', 'Zuletzt geändert:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('826', 'DE', '=== Bitte auswählen ===', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('827', 'DE', 'Adoptieren', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('828', 'DE', 'Datum', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('829', 'DE', 'Ja, ich habe die <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> von Opencaching.de gelesen und werde sie befolgen.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('830', 'DE', 'Um die Adoption abzuschließen, musst du diese Seite bestätigen.<br />\r\nNachdem du die Seite bestätigt hast, bist du für diesen Geocache als Besitzer verantwortlich.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('831', 'DE', '%1 hat dir diesen Geocache am %2 zur Adoption angeboten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('832', 'DE', 'Vielen Dank für die Adoption von %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('833', 'DE', 'Die Adoption von %1 bestätigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('834', 'DE', 'Es werden dir derzeit keine Geocaches zu Adoption angeboten.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('835', 'DE', 'Adoptieren', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('836', 'DE', 'Geocaches, die dir zu Adoption angeboten wurden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('837', 'DE', 'Ja, ich habe obige Bedingungen gelesen, verstanden und bin damit einverstanden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('838', 'DE', 'Wenn du einen Benutzer gefunden hast, der deinen Geocache adoptieren möchte, trage bitte unten den Benutzername ein und bestätige den Vorgang. Der Benutzer wird diesen Geocache dann unter Mein Profil \&gt; Adoptionen. Um die Adoption abzuschließen muss der Benutzer die Nutzungsbedingungen von Opencaching.de akzeptieren und die Adoption bestätigen. Du kannst einen Geocache mehreren Benutzern zur Adoption anbieten. Der erste Benutzer, der die Adoption bestätigt, wird der neue Besitzer des Geocaches. Mit der Adoption gibst du dem Benutzer ein unbeschränktes Recht urheberrechlich geschützte Inhalte dieses Geocaches zu nutzen, modifizieren und weiter zu geben.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('839', 'DE', '%1 zur Adoption anbieten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('840', 'DE', 'Du hast diesen Geocache keinem Benutzer zur Adoption angeboten.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('841', 'DE', 'Adoption ablehnen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('842', 'DE', 'Benutzer, denen du %1 zur Adoption angeboten hast', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('843', 'DE', 'Benutzername unbekannt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('844', 'DE', 'Du kannst nicht deinen eigenen Geocache adoptieren!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('845', 'DE', 'Entschuldigung, du musst dies lesen und akzeptieren, um fortzufahren!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('846', 'DE', 'Entschuldigung, du musst die Nutzungsbedingungen lesen und akzeptieren, um fortzufahren!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('847', 'DE', 'Durch diese Regeln ist dein Passwort sicher und kann nicht durch automatisierte Programme oder andere Benutzer erraten werden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('848', 'DE', 'a-z A-Z 0-9 und .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~# \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('849', 'DE', 'Es sind nicht alle Sonderzeichen erlaubt. Verwende nur die Folgenden:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('850', 'DE', 'Verwende keine Wörter aus dem Wörterbuch z.B. \'geheim\'', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('851', 'DE', 'Verwende keine Begriffe aus dem Geocaching', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('852', 'DE', 'Verwende keine Teile deines Benutzernamen, Namen oder deiner E-Mail', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'DE', 'Zwischen 6 und 60 Zeichen lang', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('854', 'DE', 'Überprüfe, dass dein Passwort folgende Kriterien erfüllt:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('855', 'DE', 'Dein Passwort hat unsere Sicherheitsprüfung nicht bestanden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'DE', 'Montenegro', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'DE', 'Serbien', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('858', 'DE', '* Wenn der Benutzer sich beim letzten Besuch abgemeldet hat oder <br /> der letzte Besuch mehr als 90 Tage zurückliegt, kann der letzte Login nicht bestimmt werden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('859', 'DE', 'Benutzer verwalten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('860', 'DE', 'Sicher?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('861', 'DE', 'Deaktivieren (und Geocaches sperren)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('862', 'DE', 'Unbekannt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('863', 'DE', 'Letzter bekannter Login:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('864', 'DE', 'Aktive Geocaches:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('865', 'DE', 'Insgesamt versteckt:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('866', 'DE', 'Logeinträge:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('867', 'DE', 'Benutzer aktiv:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('868', 'DE', 'Datum erstellt:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('869', 'DE', 'Benutzeraccount Details anzeigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('870', 'DE', 'Benutzeraccount Details', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('871', 'DE', 'E-Mail:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('872', 'DE', 'Wegpunkt Download', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('873', 'DE', 'Newseinträge', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('874', 'DE', 'Ausblenden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('875', 'DE', 'Gelände', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('876', 'DE', 'Schwierigkeit', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('877', 'DE', 'Wegpunkt an GPS-Gerät senden:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('882', 'DE', 'Aktuelle Empfehlungen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('884', 'DE', '%1 Empfehlungen innerhalb der letzten 30 Tage', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('885', 'DE', 'Weitere Empfehlungen und besondere Geocaches findet ihr \&gt;<a href=\"tops.php\">hier</a>\&lt;', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('886', 'DE', 'Nicht gefundene Geocaches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('887', 'DE', 'Letzter&nbsp;Login', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('888', 'DE', 'Innerhalb des letzten Monats', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('889', 'DE', 'Zwischen 1 und 6 Monaten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('890', 'DE', 'Zwischen 6 und 12 Monaten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('891', 'DE', 'Vor mehr als 12 Monaten', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('892', 'DE', 'Der Benutzeraccount wurde deaktiviert.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('893', 'DE', 'Eine neue Aktivierungsmail wurde versendet.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('894', 'DE', 'von', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('895', 'DE', 'In Google Maps anzeigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('896', 'DE', '(in GM)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('897', 'DE', 'Der Benutzer hat bisher keinen Geocache versteckt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('898', 'DE', 'Geocaching.de', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('899', 'DE', 'Google Maps', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'DE', 'Spenden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('901', 'DE', 'Art des Logeintrag', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('902', 'DE', 'Text', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('903', 'DE', 'Diesen Geocache empfehlen?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('904', 'DE', '(nur wenn du freie Empfehlungen hast)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('905', 'DE', 'OC-Waypoint', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'DE', 'Nutzungsbedingungen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('907', 'DE', 'Unser Team', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('914', 'DE', 'Schutzgebiet', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('915', 'DE', 'Suche beendet', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('916', 'DE', 'Aktuelle Datei:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('921', 'DE', 'Info', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'DE', 'DE', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('923', 'DE', 'Die Erstellung der Seite ist fehlgeschlagen. Dieser Fehler sollte nur kurzzeitig auftreten, bitte rufe die Seite in wenigen Minuten nochmals auf.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('933', 'DE', 'Quelltext durchsuchen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('954', 'DE', 'Standard', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('957', 'DE', 'Chat/IRC', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1059', 'DE', 'Es ist bereits ein Account mit diesem Benutzername vorhanden.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1060', 'DE', 'Opencaching-Wiki', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1061', 'DE', 'Impressum', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1062', 'DE', 'Seitenberechnung', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1063', 'DE', 'Seitenerstellung', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1097', 'DE', 'D/T', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1100', 'DE', '.gpx', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1123', 'DE', 'Cachename', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1141', 'DE', 'N', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1142', 'DE', 'S', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1143', 'DE', 'E', '2010-08-28 11:48:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1144', 'DE', 'W', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1146', 'DE', 'Kilometer', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1164', 'DE', 'Weitere Einträge gefunden...', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1165', 'DE', 'Nach Ort, Cache oder Wegpunkt suchen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1166', 'DE', 'Link zu dieser Ansicht anzeigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1206', 'DE', 'km', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1208', 'DE', 'h', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1212', 'DE', 'Seite:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'DE', 'Karte', '2010-08-29 16:29:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1272', 'DE', 'Vollbild anzeigen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'DE', 'Hauptmenü', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1278', 'DE', 'Editor', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1279', 'DE', '\&lt;html\&gt;', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1292', 'DE', 'Smilies werden nicht unterstützt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1296', 'DE', 'Nur die folgenden Dateiformate sind für Bilder erlaubt: BMP, GIF, PNG and JPEG.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1297', 'DE', 'am', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1298', 'DE', 'Die Liste wird automatisch anhand der Empfehlungen unserer Benutzer aktualisiert. Mehr Informationen zur regionalen Einteilung kannst du in der <a href=\"http://wiki.opencaching.de/index.php/Empfehlungen\" target=\"_blank\">Wiki</a> finden.<br />\r\n<br />\r\nDie Zahlen bedeuten Folgendes:<br />\r\n<img src=\"images/rating-star.gif\" border=\"0\" alt=\"Empfehlungen\"> Anzahl der Benutzer die diesen Geocache empfohlen haben<br />\r\n<img src=\"resource2/%1/images/log/16x16-found.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"Gefunden\"> Anzahl der Funde des Geocache<br />\r\nDer Index setzt die beiden Zahlen in Relation, um den besten Geocache zu ermitteln<br />\r\n<img src=\"images/tops-formula.png\" border=\"0\" alt=\"Formel\">', '2010-08-28 12:10:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1299', 'DE', 'Datei upload fehlerhaft!', '2010-08-29 17:46:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1300', 'DE', 'XML Datei konnte nicht geladen werden!', '2010-08-29 17:50:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1301', 'DE', 'SQL Export', '2010-08-29 17:50:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1302', 'DE', 'XML Download', '2010-08-29 17:49:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1303', 'DE', 'XML Import', '2010-08-29 17:49:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1304', 'DE', 'Die XML Datei enthält folgende Übersetzungen:', '2010-08-29 17:50:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1305', 'DE', 'Folgende Sprachen in der XML-Datei prüfen:', '2010-08-29 17:51:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1306', 'DE', 'Datei verarbeiten', '2010-08-29 17:49:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1307', 'DE', 'Source code geändert, Text wird nicht mehr verwendet', '2010-08-29 17:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1308', 'DE', 'Neue Übersetzung', '2010-08-29 17:47:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1309', 'DE', 'Geänderte Übersetzung', '2010-09-03 22:50:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1310', 'DE', 'alt', '2010-08-29 17:46:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1311', 'DE', 'Alle auswählen', '2010-08-29 17:46:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1312', 'DE', 'Senden', '2010-08-29 17:46:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1315', 'DE', 'Datum:', '2010-09-10 23:33:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1316', 'DE', 'Logeintrag:', '2010-09-10 23:56:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1317', 'DE', 'Kennwort zum Loggen:', '2010-09-10 23:57:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1319', 'DE', 'Das Kennwort stimmt nicht!', '2010-09-11 00:06:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1320', 'DE', '(nur für Gefunden-Logs)', '2010-09-11 00:07:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1321', 'DE', 'Nur hier gelistet!', '2010-09-11 00:07:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1322', 'DE', 'Neuer Logeintrag', '2010-09-11 00:07:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1323', 'DE', 'Art des Logeintrages:', '2010-09-11 00:06:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1326', 'DE', 'Empfehlung:', '2010-09-11 00:06:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1327', 'DE', 'Eine Empfehlung kann nur bei einem Gefunden-Logeintrag vorgenommen werden!', '2010-09-11 00:05:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1328', 'DE', 'Dieser Cache gehört zu meinen Empfehlungen.', '2010-09-11 00:05:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1329', 'DE', 'Alternativ kannst du eine <a href=\"mytop5.php\">vorhandene Empfehlung</a> zurückziehen.', '2010-09-11 00:05:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1330', 'DE', 'Du hast {curr} von {max} möglichen Empfehlungen abgegeben.', '2010-09-11 00:05:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1331', 'DE', 'Gefahren', '2010-09-15 14:22:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'DE', 'Infrastruktur', '2010-09-11 00:05:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1333', 'DE', 'Wegpunkte', '2010-09-11 00:05:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1334', 'DE', 'Allgemein', '2010-09-11 00:08:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1335', 'DE', 'Zeitlich', '2010-09-11 00:04:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1336', 'DE', 'Saisonbedingt', '2010-09-11 00:04:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1337', 'DE', 'Systembedingt', '2010-09-11 00:03:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1338', 'DE', 'Benötigt Werkzeug', '2010-09-11 00:03:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1339', 'DE', 'Benötigt Vorarbeit', '2010-09-11 00:03:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1340', 'DE', 'Personen', '2010-09-11 00:03:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1341', 'DE', 'Fortbewegung', '2010-09-11 00:03:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1342', 'DE', 'Eigenschaften', '2010-09-11 00:02:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1343', 'DE', 'Einschränkungen / Voraussetzungen', '2010-09-11 00:02:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1344', 'DE', 'Empfehlungen / Verbote', '2010-09-11 00:02:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1345', 'DE', 'Nur bei Opencaching logbar', '2010-09-11 00:02:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1346', 'DE', 'Aufwand (optional):', '2010-09-11 00:02:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1347', 'DE', 'Der Aufwand kann natürlich nur geschätzt werden und kann auch je nach Umwelteinflüssen sehr verschieden sein. Solltest du keine ausreichend genauen Angaben machen können, schreibe in beide Felder 0 (Null).', '2010-09-11 00:02:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1348', 'DE', 'Wegpunkte (optional):', '2010-09-11 00:02:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1349', 'DE', 'Diese Wegpunkte dienen zur Generierung entsprechender Links in der Cacheansicht bzw. beim Loggen.', '2010-09-11 00:01:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1350', 'DE', 'Es werden keine Daten automatisch von diesen Cachedatenbanken übernommen.', '2010-09-11 00:00:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1351', 'DE', 'Beschreibungen', '2010-09-11 00:00:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1352', 'DE', 'Neue Beschreibung hinzuf\&uuml;gen', '2010-09-11 00:00:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1353', 'DE', 'Deine Beschreibungen enthalten mindestens einen Link auf ein Bild das bei geocaching.com gespeichert ist!', '2010-09-11 00:00:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1354', 'DE', 'Um etwaige Probleme mit geocaching.com zu vermeiden bitten wir dich diese Bilder auch hier hochzuladen und zu verlinken.', '2010-09-11 00:00:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1355', 'DE', 'Neues Bild hinzuf\&uuml;gen', '2010-09-10 23:59:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1356', 'DE', 'Gelistet seit:', '2010-09-10 23:59:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1357', 'DE', 'Dies ist dein Cache', '2010-09-10 23:57:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1358', 'DE', 'Du hast diesen Cache gefunden', '2010-09-10 23:59:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1359', 'DE', 'Du hast diesen Cache nicht gefunden', '2010-09-10 23:58:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1360', 'DE', 'In diesem Cache ist ein GeoKrety', '2010-09-10 23:58:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1361', 'DE', 'Dieser Cache hat %1 Empfehlungen', '2010-09-10 23:58:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1362', 'DE', 'Logeintrag f\&uuml;r den Cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a> bearbeiten', '2010-09-10 23:58:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1363', 'DE', 'Art des Logeintrags:', '2010-09-10 23:57:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1364', 'DE', 'JavaScript ist bei deinem Browser deaktiviert, du kannst nur Text eingeben. Um HTML oder den Editor zu verwenden, aktiviere bitte JavaScript.', '2010-09-10 23:57:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1365', 'DE', 'Neuer Cache', '2010-09-10 23:57:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1366', 'DE', 'Besitzer:', '2010-09-10 23:56:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1367', 'DE', 'Cacheart:', '2010-09-10 23:55:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'DE', 'Gr\&ouml;\&szlig;e:', '2010-09-10 23:55:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'DE', 'Koordinaten:', '2010-09-10 23:55:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1370', 'DE', 'Empfehlung:', '2010-09-11 02:28:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1371', 'DE', 'Schwierigkeit:', '2010-09-10 23:54:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1372', 'DE', 'Gel\&auml;nde:', '2010-09-10 23:54:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1373', 'DE', 'Zeitaufwand:', '2010-09-10 23:54:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1374', 'DE', 'Hinweis', '2010-09-10 23:54:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1375', 'DE', 'Beschreibung hinzufügen', '2010-09-10 23:54:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1376', 'DE', 'Versteckt seit:', '2010-09-10 23:53:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1377', 'DE', '(Leer lassen für kein Kennwort)', '2010-09-10 23:53:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1378', 'DE', 'Bitte die <a href=\"articles.php?page=cacheinfo#logpw\" target=\"_blank\">Beschreibung</a> beachten!', '2010-09-10 23:53:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1379', 'DE', 'Weniger', '2010-09-10 23:52:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1380', 'DE', 'Cachesuche', '2010-09-10 23:52:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1381', 'DE', 'JavaScript ist bei dir deaktiviert, du kannst die folgenden Optionen nicht nutzen - die Suche funktioniert aber trotzdem.', '2010-09-10 23:52:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1382', 'DE', 'Ausgabe sortieren nach:', '2010-09-10 23:52:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1383', 'DE', 'letzte Logs', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1384', 'DE', 'Empfehlungen von anderen Benutzern zuerst anzeigen', '2010-09-10 23:51:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1385', 'DE', 'Entfernung nur nutzbar falls eingeloggt und Heimkoordinaten vorhanden<br />Bei Suche nach Entfernung wird die Entfernung von den eingegebenen Koordinaten verwendet.', '2010-09-10 23:51:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1386', 'DE', 'Caches ausblenden:', '2010-09-10 23:51:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1387', 'DE', 'eigene', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1388', 'DE', 'gefundene', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1389', 'DE', 'ignorierte', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1390', 'DE', 'Nur nutzbar falls eingeloggt.', '2010-09-10 23:51:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1391', 'DE', 'inaktive', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1392', 'DE', 'Cacheattribute:', '2010-09-10 23:50:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1393', 'DE', 'Suche nach Entfernung', '2010-09-10 23:50:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1394', 'DE', 'Von Koordinaten:', '2010-09-10 23:50:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1395', 'DE', 'Maximale Entfernung:', '2010-09-10 23:50:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1396', 'DE', 'Meilen', '2010-09-10 23:50:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1397', 'DE', 'Seemeilen', '2010-09-10 23:49:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1398', 'DE', 'Suche nach Ortschaft', '2010-09-10 23:49:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1399', 'DE', 'Postleitzahl:', '2010-09-10 23:49:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1400', 'DE', 'Ortsname:', '2010-09-10 23:47:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1401', 'DE', 'Suche nach Text', '2010-09-10 23:49:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1402', 'DE', 'Suche nach Cachebesitzer', '2010-09-10 23:49:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1403', 'DE', 'Suche nach Logeintr\&auml;gen', '2010-09-10 23:49:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1404', 'DE', 'Art des Logeintrag:', '2010-09-10 23:48:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1405', 'DE', 'Fehler beim Aufruf der Seite', '2010-09-10 23:48:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1406', 'DE', 'Bei dem Versuch die Seite zu erstellen ist ein Fehler aufgetreten. Sollten sie durch einen Hyperlink, auf unserer Seite, hierher gekommen sein und dieses Problem l\&auml;ngere Zeit bestehen, weisen sie uns bitte per EMail darauf hin.', '2010-09-10 23:48:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1407', 'DE', 'Folgender Fehler ist aufgetreten:', '2010-09-10 23:48:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1408', 'DE', 'Seite:', '2010-09-10 23:48:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1409', 'DE', 'Fehlermeldung:', '2010-09-10 23:47:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1411', 'DE', 'Bist du sicher, dass dieser Logeintrag entfernt werden soll?', '2010-09-10 23:47:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1412', 'DE', 'M\&ouml;chtest du {log_user_name} eine Bemerkung dazu senden?', '2010-09-10 23:46:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1413', 'DE', 'Logeintrag entfernen', '2010-09-10 23:46:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1414', 'DE', 'ungültiges Datum', '2012-08-26 09:10:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1415', 'DE', '(nur für Gefunden-Logs)', '2010-09-10 23:44:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1416', 'DE', 'Neuen Cache eintragen', '2010-09-10 23:44:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1417', 'DE', 'Falls dies dein erster Cache auf Opencaching.de sein sollte, lies bitte zuerst die <a href=\"articles.php?page=cacheinfo\">Beschreibung</a> zu den einzelnen Feldern durch.', '2010-09-10 23:46:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1418', 'DE', 'Wegstrecke', '2010-09-10 23:32:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1419', 'DE', 'Der Aufwand kann natürlich nur geschätzt werden und kann auch je nach Umwelteinflüssen sehr verschieden sein. Solltest du keine ausreichend genauen Angaben machen können, schreibe in beide Felder 0 (Null). (Siehe auch: <a href=\"articles.php?page=cacheinfo#time\" target=\"_blank\">Beschreibung</a>)', '2010-09-10 23:46:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1420', 'DE', 'Sprache:', '2010-09-10 23:45:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1421', 'DE', 'Weitere Beschreibungen in anderen Sprachen können nach dem Veröffentlichen des Caches eingetragen werden.', '2010-09-10 23:44:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1422', 'DE', 'Kurzbeschreibung:', '2010-09-10 23:44:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1423', 'DE', 'Beschreibung:', '2010-09-10 23:43:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1425', 'DE', 'Zus\&auml;tzlicher Hinweis:', '2010-09-10 23:42:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1426', 'DE', 'Bilder für diesen Cache können nach dem Anlegen des Caches hinzugefügt werden.', '2010-09-10 23:42:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1427', 'DE', 'Veröffentlichung:', '2010-09-10 23:40:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1428', 'DE', 'sofort veröffentlichen', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1429', 'DE', 'veröffentlichen am', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1430', 'DE', 'noch nicht veröffentlichen', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1431', 'DE', 'Die <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de-Nutzungsbedingungen</a> und -<a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datenlizenz</a> habe ich gelesen und bin damit einverstanden.', '2010-09-10 23:39:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1432', 'DE', 'Info: dein Logeintrag wurde vom Cachebesitzer entfernt', '2010-09-10 23:39:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1433', 'DE', 'Ortsauswahl', '2010-09-10 23:39:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1434', 'DE', 'Insgesamt {resultscount} Ortschaften gefunden', '2010-09-10 23:38:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1435', 'DE', 'Für das Suchkriterium wurde kein eindeutiges Ergebnis gefunden. Bitte wähle die richtige Ortschaft aus.', '2010-09-10 23:38:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1436', 'DE', 'Logeintrag f\&uuml;r den Cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a> hinzuf\&uuml;gen', '2010-09-10 23:38:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1437', 'DE', 'Cachename ung\&uuml;ltig', '2010-09-10 23:34:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1438', 'DE', 'Die angegebene Koordinate ist ung\&uuml;ltig.', '2010-09-10 23:38:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1439', 'DE', 'Die eingebebene Zeit ist ung\&uuml;ltig.', '2010-09-10 23:37:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1440', 'DE', 'Die eingegebene Strecke ist ungültig. Format aa.aaa', '2010-09-11 02:38:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1441', 'DE', 'Der Cachestatus paßt nicht zu den Veröffentlichungsoptionen.', '2010-09-10 23:34:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1442', 'DE', 'Wählen Sie beide Bewertungsangaben aus!', '2010-09-10 23:33:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1443', 'DE', 'Keine Bilder vorhanden', '2010-09-10 23:32:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1444', 'DE', '{results_count} Caches gefunden.', '2010-09-10 23:33:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1445', 'DE', 'Einträge {startatp1} bis {endat} (als zip):', '2010-09-10 23:33:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1446', 'DE', 'Diese Beschreibung wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem gelöscht werden.', '2010-09-10 23:31:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1447', 'DE', 'Die Cache Beschreibung wurde gel\&ouml;scht.', '2010-09-10 23:31:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1448', 'DE', 'Cachebeschreibung l\&ouml;schen', '2010-09-10 23:30:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1450', 'DE', 'Dein HTML-Code wird nochmals durch einen speziellen Filter verändert, dies ist notwendig um gefährliche HTML-Tages wie z.B. \&lt;script\&gt; zu filtern. Eine Liste mit erlaubten HTML-Tags findest du <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">hier</a>.', '2010-09-11 02:45:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1451', 'DE', 'Bitte verwende keine Bilder die auf geocaching.com gehostet sind. Lade sie statt dessen auch auf unseren Server.', '2010-09-10 23:28:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1452', 'DE', 'Verschlüsselter Hinweis:', '2010-09-10 23:27:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1453', 'DE', 'Möchtest du wirklich die Beschreibung deines Cache \&quot;{cachename}\&quot; löschen?', '2010-09-11 02:40:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1454', 'DE', 'Ja, Cachebeschreibung l\&ouml;schen', '2010-09-10 23:26:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1455', 'DE', 'Cache\&nbsp;senden', '2010-09-10 23:26:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1456', 'DE', 'Format:\&nbsp;TT-MM-JJJJ', '2010-09-10 23:26:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1457', 'DE', 'Es sind Fehler aufgetreten, bitte unten markierte Fehler beheben!', '2010-09-10 23:27:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1458', 'DE', 'Die angegebenen Koordinaten sind ung\&uuml;ltig.', '2010-09-10 23:19:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1459', 'DE', 'Die eingegebene Strecke ist ungültig. Format aa.aaa', '2010-09-10 23:25:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1460', 'DE', 'Datum nicht g\&uuml;ltig,\&nbsp;Format:\&nbsp;TT-MM-JJJJ', '2010-09-10 23:20:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1461', 'DE', 'Der Cache kann nur \&uuml;bernommen werden, wenn unseren Nutzungsbedingungen zugestimmt wird.', '2010-09-10 23:19:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1462', 'DE', 'Der HTML-code ist ungültig. Um die Fehlerursache herauszufinden, kannst du die <a href=\"htmlprev.php\" target=\"_blank\">HTML Vorschau</a> verwenden.', '2010-09-11 02:39:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1463', 'DE', 'Kein Cachetyp ausgewählt!', '2010-09-10 23:18:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1464', 'DE', 'Keine Cachegröße ausgewählt!', '2010-09-10 23:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1465', 'DE', 'Der HTML-Code ist nicht gültig.', '2010-09-10 23:17:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1466', 'DE', 'Dein Cache wurde in der Datenbank eingetragen. Du wirst nun auf die Cacheseite weitergeleitet.', '2010-09-10 23:17:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1467', 'DE', 'wählen', '2012-07-24 21:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1468', 'DE', '(Interner Fehler) Die Beschreibung wurde nicht gefunden.', '2010-09-10 23:17:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1469', 'DE', '(Interner Fehler) Es existiert bereits eine Beschreibung mit dieser Sprache.', '2010-09-10 23:16:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1471', 'DE', 'Es existiert bereits eine Beschreibung in dieser Sprache', '2010-09-10 23:16:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1473', 'DE', 'Bist du sicher, dass dein Logeintrag entfernt werden soll?', '2010-09-10 23:15:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1475', 'DE', 'Ein Datenbankbefehl konnte nicht ausgeführt werden.', '2010-09-11 02:35:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1476', 'DE', 'Cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a> bearbeiten', '2010-09-11 02:36:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1477', 'DE', 'zur Adoption anbieten', '2010-09-11 02:34:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1478', 'DE', 'Status:', '2010-09-11 02:33:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1479', 'DE', 'Wegpunkt-Suche:', '2010-09-11 02:35:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1480', 'DE', 'Länderknoten', '2010-09-11 02:34:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1482', 'DE', 'Wegpunkte:', '2010-09-11 02:33:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1483', 'DE', 'Uhr', '2010-09-11 02:34:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1486', 'DE', 'Sollte ihr Browser keine automatische Weiterleitung unterstützen, klicken sie bitte hier.', '2010-09-11 02:34:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1489', 'DE', 'DE', '2010-09-11 02:33:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'DE', 'Passwort:', '2010-09-11 02:33:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1491', 'DE', 'Cachebeschreibung für <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a> bearbeiten', '2010-09-11 02:32:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1494', 'DE', 'Hinzuf\&uuml;gen', '2010-09-11 02:33:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1495', 'DE', 'Bitte im Namensfeld etwas eingeben!', '2010-09-11 02:32:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1496', 'DE', 'Bitte im Textfeld etwas eingeben!', '2010-09-11 02:32:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1497', 'DE', 'Es muss mindestens ein Feld angekreuzt sein!', '2010-09-11 02:32:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1498', 'DE', 'Längengrad muss eine Zahl sein!\\nFormat: hh° mm.mmm', '2010-09-11 02:32:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1499', 'DE', 'Breitengrad muss eine Zahl sein!\\nFormat: hh° mm.mmm', '2010-09-11 02:32:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1500', 'DE', 'max. Entfernung muss eine Zahl sein!', '2010-09-11 02:32:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1501', 'DE', 'Zulässiger Wert für max. Entfernung: 0 - 9999', '2010-09-11 02:32:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1502', 'DE', 'Bitte im Feld für Postleitzahl etwas eingeben!', '2010-09-11 02:32:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1503', 'DE', 'Bitte im Feld für Ortsname etwas eingeben!', '2010-09-11 02:32:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1504', 'DE', 'Bitte im Feld für Besitzer etwas eingeben!', '2010-09-11 02:31:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1505', 'DE', 'Bitte im Feld für Finder etwas eingeben!', '2010-09-11 02:31:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1506', 'DE', 'Mehrfach-Listings (Wegpunkt bei gc.com oder nc.com gesetzt)', '2010-09-11 02:31:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1507', 'DE', 'Das ausgewählte Ausgabeformat existiert nicht!', '2010-09-11 02:31:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1508', 'DE', 'Die Suchanfrage konnte nicht ausgeführt werden, geben sie bitte die Suchdaten erneut ein.', '2010-09-11 02:31:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1509', 'DE', 'Gefunden', '2010-09-11 02:31:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1511', 'DE', 'Keine Wertung', '2010-09-11 02:30:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1512', 'DE', 'Die Postleitzahl wurde nicht gefunden', '2010-09-11 02:30:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1513', 'DE', 'Es wurde kein Ort mit diesem Namen gefunden', '2010-09-11 02:30:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1514', 'DE', 'Für den ausgewählten Ort sind keine Koordinaten vorhanden', '2010-09-11 02:31:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1515', 'DE', 'Der eingegebene Ort ist ungültig.', '2010-09-11 02:31:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1516', 'DE', 'Der eingegebene Text ist ungültig.', '2010-09-11 02:30:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1517', 'DE', 'Der eingegebene Text enthält mehr als 50 Wörter.', '2010-09-11 02:39:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1518', 'DE', 'Alle Länder', '2010-09-11 02:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1519', 'DE', 'Alle Cachetypen', '2010-09-11 02:29:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1520', 'DE', 'Suchergebnis', '2010-09-11 02:29:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1521', 'DE', 'Dieser Cache wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:42:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1522', 'DE', 'Optionen speichern', '2010-09-11 02:29:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1523', 'DE', 'Optionen bearbeiten', '2010-09-11 02:29:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1524', 'DE', 'Typ', '2010-09-11 02:28:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1525', 'DE', 'Letzte Logs', '2010-09-11 02:29:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1526', 'DE', 'Downloads', '2010-09-11 02:28:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1527', 'DE', 'Einträge auf dieser Seite:', '2010-09-11 02:27:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1528', 'DE', 'Für lokale Anwendungen herunterladen', '2010-09-11 02:27:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1529', 'DE', 'Mit dem Download werden die <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> von Opencaching.de akzeptiert.\&nbsp;\&nbsp;', '2010-09-11 02:27:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1530', 'DE', 'Dieser Logeintrag wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:42:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1531', 'DE', 'Diese Beschreibung wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:42:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1532', 'DE', 'Der Besitzer des Caches hat dir folgende Bemerkung geschrieben:', '2010-09-11 02:23:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1533', 'DE', 'Cachegröße für Virtual oder Webcam muß \'kein Behälter\' sein!', '2010-09-11 02:41:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1537', 'DE', 'Dein HTML-Code wird nochmals durch einen speziellen Filter verändert, dies ist notwendig um gefährliche HTML-Tages wie z.B. \&lt;script\&gt; zu filtern. Eine Liste mit erlaubten HTML-Tags findest du <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">hier</a>.', '2010-09-11 02:56:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1538', 'DE', 'Sprache:', '2010-09-11 02:57:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1539', 'DE', 'Nicht gefunden', '2010-09-12 22:28:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1541', 'DE', 'nur bei Nacht', '2010-09-12 22:54:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1542', 'DE', 'nur Hyperlink zu OC-externen Portalen', '2010-09-12 22:54:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1543', 'DE', 'Letterbox (benötigt Stempel)', '2010-09-12 22:55:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1544', 'DE', 'gefährliches Gebiet', '2010-09-12 22:55:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1545', 'DE', 'Der Geocache kann nur bei Nacht gel\&ouml;st werden und wird deshalb Nachtcache genannt. Zum Beispiel m\&uuml;ssen Reflektoren mit einer Taschenlampe angeleuchtet werden, die dann den Weg zum Versteck zeigen. Bitte ggf. auch das Attribut \&quot;Taschenlampe\&quot; setzen.', '2010-09-12 22:54:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1546', 'DE', 'Der Geocache ist nur bei Opencaching gelistet. Benutzer von anderen Geocache-Datenbanken haben so einen schnellen \&Uuml;berblick, welche Geocaches sich lohnen n\&auml;her anzusehen.', '2010-09-12 22:54:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1547', 'DE', 'Dieser Cache ist nicht nur auf Opencaching.de gelistet, sondern auch auf weiteren Portalen. Es gibt einen Link auf die Portale, wenn der Eigent\&uuml;mer des Caches in der Beschreibung eine entsprechende Kennung eingetragen hat. Wir weisen darauf hin, dass auch stets auf Opencaching.de die Beschreibungen und Sperrungen vom Eigent\&uuml;mer aktuell gehalten werden m\&uuml;ssen. Dieses Attribut erm\&ouml;glicht es z.B. PDA-Benutzern Geocaches gezielt zu filtern, die keine vollst\&auml;ndige Beschreibung enthalten und deshalb nicht unterwegs gel\&ouml;st werden k\&ouml;nnen.', '2010-09-12 22:54:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1548', 'DE', 'In dem Beh\&auml;lter vor Ort befindet sich ein Stempel, mit dem man sein pers\&ouml;nliches Logbuch abstempeln kann. Das Logbuch im Geocache wird ebenfalls mit einem pers\&ouml;nlichen Stempel signiert. Bitte unbedingt darauf achten, dass man den Stempel aus dem Geocache nicht mitnimmt oder tauscht! Die Aufgaben bei Letterboxen sind h\&auml;ufig so gestaltet, dass man auch ohne GPS-Ger\&auml;t den Geocache finden kann - wie bei einer klassichen Schnitzeljagd. Dann bitte auch das Attribut \&quot;ohne GPS\&quot; angeben.', '2010-09-12 22:55:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1549', 'DE', 'In dem Gebiet, wo der Geocache versteckt wurde, ist mit Gefahren zu rechnen. Mit diesem Attribut kann man auch auf Gefahren aufmerksam machen, die nicht auf den ersten Blick offensichtlich sind. Das k\&ouml;nnen z.B. stark befahrene Stra\&szlig;en, steile Abh\&auml;nge oder Steinschlag sein. Deshalb sollte man bei Geocaching-Touren mit Kindern oder gr\&ouml;\&szlig;eren Gruppen entsprechende Vorsichtsma\&szlig;nahmen ergreifen und je nachdem auch auf die Witterung achten (z.B. Regen bei steilen Abh\&auml;ngen). N\&auml;heres zu den Gefahren ist in der Cachebeschreibung erl\&auml;utert.', '2010-09-12 22:53:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1550', 'DE', 'aktive Eisenbahnlinien in der Nähe', '2010-09-12 23:13:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1551', 'DE', 'Klippen / Felsen', '2010-09-12 23:17:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1552', 'DE', 'Jäger', '2010-09-12 23:17:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1553', 'DE', 'Dornen', '2010-09-12 23:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1554', 'DE', 'Zecken', '2010-09-12 23:17:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1555', 'DE', 'Folgen des Bergbaus', '2010-09-12 23:17:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1556', 'DE', 'giftige Pflanzen', '2010-09-12 23:17:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1557', 'DE', 'giftige/gefährliche Tiere', '2010-09-12 23:16:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1558', 'DE', 'Parkplatz in der Nähe', '2010-09-12 23:17:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1559', 'DE', 'erreichbar mit ÖVM', '2010-09-12 23:17:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1560', 'DE', 'Trinkwasser in der Nähe', '2010-09-12 23:16:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1561', 'DE', 'öffentliche Toilette in der Nähe', '2010-09-12 23:16:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1562', 'DE', 'Telefon in der Nähe', '2010-09-12 23:16:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1563', 'DE', 'Erste Hilfe verfügbar', '2010-09-12 23:16:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1564', 'DE', 'nahe beim Auto', '2010-09-12 23:16:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1565', 'DE', 'längere Wanderung', '2010-09-12 23:16:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1566', 'DE', 'sumpfig/matschiges Gelände', '2010-09-12 23:16:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1567', 'DE', 'hügeliges Gelände', '2010-09-12 23:16:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1568', 'DE', 'leichtes Klettern (ohne Ausrüstung)', '2010-09-12 23:15:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1569', 'DE', 'Schwimmen erforderlich', '2010-09-12 23:15:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1570', 'DE', 'interessanter Ort', '2010-09-12 23:16:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1571', 'DE', 'bewegliches Ziel', '2010-09-12 23:15:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1572', 'DE', 'Webcam am Ziel', '2010-09-12 23:15:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1573', 'DE', 'in geschlossenen Räumen (Höhle, Gebäude, etc.)', '2010-09-12 23:16:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1575', 'DE', 'ohne GPS (Letterboxen, Cistes, compass-juggling,...)', '2010-09-12 23:15:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1576', 'DE', 'Zugangs- bzw. Parkentgelt', '2010-09-12 23:15:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1577', 'DE', 'Übernachtung erforderlich', '2010-09-12 23:15:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1578', 'DE', 'rund um die Uhr machbar', '2010-09-12 23:15:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1579', 'DE', 'nur zu bestimmten Uhrzeiten', '2010-09-12 23:16:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1580', 'DE', 'nur tagüber', '2010-09-12 23:15:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1581', 'DE', 'Gezeiten', '2010-09-12 23:15:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1582', 'DE', 'ganzjähig zugänglich', '2010-09-12 23:14:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1583', 'DE', 'Brutsaison/Naturschutz', '2010-09-12 23:15:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1584', 'DE', 'schneesicheres Versteck', '2010-09-12 23:14:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1585', 'DE', 'spezielle Ausrüstung', '2010-09-12 23:14:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'DE', 'Kompass', '2010-09-12 23:14:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'DE', 'Taschenlampe', '2010-09-12 23:14:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'DE', 'Kletterzeug', '2010-09-12 23:14:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'DE', 'Höhlenzeug', '2010-09-12 23:14:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1590', 'DE', 'Taucherausrüstung', '2010-09-12 23:14:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'DE', 'Wasserfahrzeug', '2010-09-12 23:14:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1592', 'DE', 'Fluggerät', '2010-09-12 23:14:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1593', 'DE', 'Recherche', '2010-09-12 23:13:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'DE', 'Rätsel', '2010-09-12 23:13:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'DE', 'Rechenaufgabe', '2010-09-12 23:13:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1596', 'DE', 'anderer Cache', '2010-09-12 23:13:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1597', 'DE', 'Startbedingungen beim Owner erfragen', '2010-09-12 23:13:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'DE', 'kindgerecht', '2010-10-23 19:05:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'DE', 'In der N\&auml;he dieses Caches gibt es genutzte Eisenbahnlinien. Bitte seid entsprechend vorsichtig und achtet darauf, abseits von Bahn\&uuml;berg\&auml;ngen keine Gleise zu betreten.', '2010-09-12 23:13:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1600', 'DE', 'In der N\&auml;he des Caches gibt es Klippen oder Felsen. Unterhalb von Felsen sollte man auf Steinschlag achten, von der Oberseite der Klippen sollte man sich entsprechend vorsichtig n\&auml;hern (insbesondere mit Kindern oder Mountainbikes). Besonders gef\&auml;hrlich - und nicht immer erkennbar - ist es, sich \&uuml;ber einen Steilhang von oben an eine Klippe zu n\&auml;hern.', '2010-09-12 23:13:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'DE', 'Der Geocache liegt in einem Jagdgebiet. Bei D\&auml;mmerung oder Dunkelheit sollte man aus Sicherheitsgr\&uuml;nden immer eine Taschenlampe oder Stirnlampe verwenden. Bei Begegnungen mit J\&auml;gern ist gegenseitige R\&uuml;cksichtnahme angebracht.', '2010-09-12 23:13:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'DE', 'In er N\&auml;he des Geocaches gibt es Dornen. Ihr solltet f\&uuml;r die Suche entsprechende Handschuhe und Kleidung parat haben.', '2010-09-12 23:12:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'DE', 'Je nach Saison gibt es in dem Gebiet besonders viele Zecken. Es wird daher empfohlen entsprechend lange Kleidung zu tragen und nach der Cachetour nach Zecken Ausschau zu halten. FSME-Risikogebiete und weitere Informationen zum Thema Zecken k\&ouml;nnt ihr z.B. auf <a href=\"http://www.meningitis.de\" target=\"_blank\">www.meningitis.de</a> nachsehen.', '2010-09-12 23:12:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1604', 'DE', 'Im Wasser', '2010-09-12 23:19:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'DE', 'Dieser Cache ist jederzeit machbar, sowohl am Tage als auch in der Nacht.', '2010-09-12 23:30:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1606', 'DE', 'Dieser Cache l\&auml;sst sich nur zu bestimmten Tageszeiten absolvieren. N\&auml;here Angaben sind in der Beschreibung des Caches zu finden. Der Cache kann zum Beispiel auf einem Gel\&auml;nde mit festgelegten Öffnungszeiten versteckt sein.', '2010-09-12 23:30:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1607', 'DE', 'Dieser Cache l\&auml;sst sich nur tags\&uuml;ber angehen. Ein Beispiel w\&auml;ren Gebiete mit Klippen oder Abgr\&uuml;nden. Ein anderes Beispiel sind Orte, an denen die Suche mit Taschenlampen in der Dunkelheit besonders negativ auffallen w\&uuml;rde (z.B. Wohngebiete).', '2010-09-12 23:30:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1608', 'DE', 'Der Geocache kann nur bei einem bestimmten Tidenstand (Ebbe oder Flut) gesucht werden.', '2010-09-12 23:30:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1609', 'DE', 'Dieser Cache l\&auml;sst sich w\&auml;hrend des gesamten Jahres finden, wobei je nach Jahreszeit die Schwierigkeit bei der Suche schwanken kann. Die Schwierigkeit soll bei guten Bedingungen angegeben werden.', '2010-09-12 23:30:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1610', 'DE', 'Dieser Cache sollte in der Brutsaison nicht absolviert werden. Bitte gebt in der Beschreibung an, welche Jahreszeit davon betroffen ist. Achtet bitte auch auf die örtliche Beschilderung zum Naturschutz.', '2010-09-12 23:32:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1611', 'DE', 'Dieser Cache l\&auml;sst sich auch nach starkem Schneefall suchen. Die einzelnen Stationen und der Geocache sind so versteckt, dass sie nicht von Schnee verdeckt werden. Bitte auch an Schneehaufen denken, die ggf. durch R\&auml;umfahrzeuge entstehen.', '2010-09-12 23:30:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1612', 'DE', 'F\&uuml;r diesen Cache ben\&ouml;tigst du weitere Ausr\&uuml;stung, die nicht durch die anderen Attribute angegeben ist und nicht zur Standardausr\&uuml;stung eines Geocachers geh\&ouml;rt. Zum Beispiel Laserpointer, Funkger\&auml;te oder Wagenheber. Was genau du ben\&ouml;tigst, ist in der Beschreibung angegeben.', '2010-09-12 23:30:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'DE', 'F\&uuml;r diesen Cache braucht ihr einen funktionierenden Kompass f\&uuml;r Peilungen oder Orientierungen.', '2010-09-12 23:29:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'DE', 'Um diesen Cache anzugehen benötigt ihr eine funktionstüchtige Taschenlampe. Denkt immer auch an Ersatzbatterien.', '2010-09-12 23:31:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'DE', 'Um diesen Cache absolvieren zu k\&ouml;nnen, ben\&ouml;tigt ihr neben der normalen Ausr\&uuml;stung auch noch Kletterausr\&uuml;stung und entsprechendes Wissen um die Handhabung der Kletterausr\&uuml;stung und ums Klettern \&ndash; Laien sollten sich auf jeden Fall von einem erfahrenen Kletterer oder Bergsteiger unterst\&uuml;tzen lassen.', '2010-09-12 23:31:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'DE', 'Der Geocache ist in einer H\&ouml;hle versteckt und man sollte entsprechende Ausr\&uuml;stung mitbringen. Vorsicht: Bereits kleinste H\&ouml;hlensysteme k\&ouml;nnen bei unvorhergesehenen Problem z.B. Gewittern (Wasser!) oder einem verstauchten Kn\&ouml;chel sehr gef\&auml;hrlich werden! Ihr solltet euch vorab gr\&uuml;ndlich bei erfahreren H\&ouml;hlengehern informieren. Beachtet auch den Naturschutz \&ndash; Fledermausquartiere d\&uuml;rfen nicht gest\&ouml;rt werden!', '2010-09-12 23:29:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1617', 'DE', 'Um den Geocache zu finden ben\&ouml;tigt ihr eine Tauchausr\&uuml;stung. In welcher Tiefe der Geocache liegt ist in der Beschreibung angegeben. Bitte beachtet, dass Ihr f\&uuml;r einen sicheren Tauchgang eine entsprechende Ausbildung ben\&ouml;tigt. Als Nicht-Taucher k\&ouml;nnt ihr den Geocache evtl. zusammen mit einem Tauchlehrer suchen.', '2010-09-12 23:29:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'DE', 'Der Geocache kann \&ndash; normalerweise \&ndash; nicht ohne ein Wasserfahrzeug gefunden werden. Zum Geocache kann wegen der Entfernung oder Str\&ouml;mung nicht geschwommen werden. Details dazu sind in der Beschreibung des Geocaches angegeben.', '2010-09-12 23:29:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1619', 'DE', 'F\&uuml;r diesen Cache muss vorab nach Informationen gesucht werden. Besonders h\&auml;ufig kommt dies bei R\&auml;tselcaches vor.', '2010-09-12 23:29:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1620', 'DE', 'Bei diesem Cache sind als Vorarbeit oder w\&auml;hrend der Suche R\&auml;tsel zu l\&ouml;sen.', '2010-09-12 23:29:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'DE', 'Es m\&uuml;ssen vorab oder w\&auml;hrend der Suche Rechenaufgaben gel\&ouml;st werden, die \&uuml;ber das kleine Geocacher 1x1 hinausgehen. Zum Beispiel Mittelpunktberechnungen und Peilungen.', '2010-09-12 23:29:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1622', 'DE', 'Dieser Cache passt in keine der bisherigen Kategorien von Caches (Cachearten). Daher gibt dieses Attribut euch die M\&ouml;glichkeit, auf besondere Caches aufmerksam zu machen.', '2010-09-12 23:28:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1623', 'DE', 'Bei diesem Cache ist es n\&ouml;tig, sich vor dem Angehen des Caches beim Eigent\&uuml;mer \&uuml;ber die Bedingungen zum Angehen zu informieren. Ein Beispiel w\&auml;ren Stadtmeisterschaften.', '2010-09-12 23:28:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1624', 'DE', 'Der Geocache ist kindgerecht aufgebaut: Alle Aufgaben sind von Kindern im Alter von 10 bis 12 Jahren selbstständig lösbar und das Gelände ist nicht gefährlich (keine Haupstraßen, Klippen o.ä.). Am Ende des Geocaches ist eine Box mit Tauschgegenständen und die Aufgaben sind interessant aufgebaut.', '2010-09-12 23:28:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1625', 'DE', 'Der Cache f\&uuml;hrt in eine (ehemalige) Bergbauregion. M\&ouml;glicherweise bestehen Gefahren durch verst\&uuml;rzte Stollenmundl\&ouml;cher oder es m\&uuml;ssen Stollen betreten werden. Entsprechende Ausr\&uuml;stung und Vorsicht, besonders bei Dunkelheit, wird empfohlen. Historische Bergwerke stehen m\&ouml;glicherweise unter Denkmalschutz.', '2010-09-12 23:43:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1626', 'DE', 'In der N\&auml;he des Caches gibt es giftige Pflanzen. Achtet also insbesondere darauf, dass Kinder und Hunde diese nicht anfassen oder essen.', '2010-09-12 23:43:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1627', 'DE', 'In dem Gebiet sind Wildtiere angesiedelt, die f\&uuml;r Menschen eine Gefahr darstellen k\&ouml;nnen, z.B. Tollwutgebiete, giftige Schlangen, Skorpione oder B\&auml;ren.', '2010-09-12 23:43:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1628', 'DE', 'Es gibt in der Nähe einen Parklplatz, der sich als Startpunkt für die Cachesuche eignet. Falls alle Parkplätze gebührenpflichtig sind, bitte auch das Attribut Zugangs bzw. Parkentgelt angeben.', '2010-09-12 23:47:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1629', 'DE', 'Dieser Cache lässt sich mit Hilfe von öffentlichen Verkehrsmitteln erreichen und liegt außerhalb von Städten. Besonders bei Geocaches die an abgelegenen Aussichtspunkten, Wanderparkplätzen oder Ausflugszielen liegen, ist dieses Attribut hilfreich. Für Geocaches in Städten soll dieses Attribut hingegen nicht angegeben werden, da diese in der Regel immer per ÖVM erreichbar sind.', '2010-09-12 23:47:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1630', 'DE', 'W\&auml;hrend der Cachetour oder in der N\&auml;he des Geocaches ist Trinkwasser verf\&uuml;gbar. Besonders bei Event-Caches, l\&auml;ngeren Multicaches und bei Geocaches wo man vermutlich schmutzig wird (z.B. manche H\&ouml;hlencaches), hilft dieses Attribut bei der Planung der Cachetour.', '2010-09-12 23:43:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1631', 'DE', 'W\&auml;hrend der Cachetour oder in der N\&auml;he des Geocaches ist eine \&ouml;ffentliche Toilette verf\&uuml;gbar. Besonders bei Event-Caches und bei l\&auml;ngeren Multicaches hilft dieses Attribut bei der Planung der Cachetour.', '2010-09-12 23:43:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1632', 'DE', 'W\&auml;hrend der Cachetour oder in der N\&auml;he des Geocaches gibt es ein \&ouml;ffentliches Telefon. Besonders bei Event-Caches sollte gepr\&uuml;ft werden, ob ein Telefon in der N\&auml;he verf\&uuml;gbar ist, und das Attribut ggf. ausgew\&auml;hlt werden.', '2010-09-12 23:42:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1633', 'DE', 'In der N\&auml;he des Caches findet ihr eine Erste Hilfe-Station, Notrufs\&auml;ule, Bergwacht oder entsprechende Ausr\&uuml;stung. Besonders bei Geocaches in schwierigem Gel\&auml;nde ist die Angabe bzw. Pr\&uuml;fung dieses Attribut sinnvoll. Z.B. bei Klettercaches, Caches in H\&ouml;hlen, im Hochgebirge oder rund um Wildwasserfl\&uuml;sse. Es ist auch sinnvoll die Notrufnummern z.B. der Bergwacht im Cachelisting aufzuf\&uuml;hren.', '2010-09-12 23:42:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1634', 'DE', 'Der Parkplatz befindet sich in unmittelbarer Nähe zum Geocache. Es sind nicht mehr als einige Schritte notwendig um den Geocache zu finden.', '2010-09-12 23:46:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1635', 'DE', 'Bei diesem Cache erwartet euch eine längere Wanderung. Geocaches, bei denen der kürzeste Fußweg vom Parkplatz zum Geocache und zurück weiter als 5 Kilometer ist, sollte man dieses Attribut zuweisen. Im Gebirge und entsprechenden Steigungen ist das Attribut auch bei kürzeren Wegstrecken sinnvoll. Gute Wanderschuhe und entsprechende Ausrüstung empfehlen sich.', '2010-09-12 23:46:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1636', 'DE', 'Bei diesem Cache geht es durch sumpfiges oder matschiges Gel\&auml;nde. Entsprechende Kleidung wird empfohlen. Nach Regenf\&auml;llen kann das Gel\&auml;nde wesentlich schwerer oder \&uuml;berhaupt nicht begehbar sein.', '2010-09-12 23:42:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1637', 'DE', 'Auf dem Weg zum Geocache bzw. w\&auml;hrend der Cachesuche sind eine oder mehrere Steigungen zu \&uuml;berwinden.', '2010-09-12 23:42:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1638', 'DE', 'Während der Cachesuche ist leichtes Klettern notwendig, bei dem man sich z.B. mit den Händen festhalten muss. Gute Trittsicherheit und Schwindelfreiheit empfehlen sich. Es ist jedoch keine Spezialausrüstung notwendig wie z.B. Sicherungsseil, Klettersteigset oder Steigeisen. Besonders bei feuchter Witterung oder vor Gewittern sollte man jedoch mit der entsprechenden Vorsicht handeln.', '2010-09-12 23:45:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1639', 'DE', 'Auf dem Weg zum Geocache muss ein Fluß oder See überquert werden. Das Wasser ist tief genug um zu schwimmen. Je nach Örtlichkeit kann auch ein Schlauchboot, Kajak oder ähnliches verwendet werden (näheres ist in der Beschreibung zum Geocache zu finden). Die Entfernung ist aber ohne besondere Ausdauer noch zu schwimmen.', '2010-09-12 23:45:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1640', 'DE', 'Der Geocache ist in unmittelbarer N\&auml;he zu einer Sehensw\&uuml;rdigkeit versteckt. Das kann ein z.B. sch\&ouml;ner Aussichtspunkt oder eine gr\&ouml;\&szlig;ere Burgruine sein. Ein Besuch w\&uuml;rde sich auch ohne besonderen Anlass (den Geocache) lohnen.', '2010-09-12 23:42:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1641', 'DE', 'Der Geocache ver\&auml;ndert seine Position und ist deshalb nicht immer am gleichen Ort zu finden. Es gibt Varianten, bei denen der Geocache-Besitzer den Geocache regelm\&auml;\&szlig;ig an anderen Orten versteckt, oder der Finder den Geocache an einem neuen Ort versteckt. Danach muss durch den Besitzer jeweils die Beschreibung aktualisiert werden.', '2010-09-12 23:41:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1642', 'DE', 'Am Ziel befindet sich eine Webcam und für einen Fund muss man das Bild der Webcam von sich selbst aufnehmen, um nachzuweisen, dass man vor Ort war. Manche Webcam-Caches setzen auch weitere Bedingungen z.B. einen Geocaching-Banner auf dem Bild. Die Webadresse der Webcam ist in der Beschreibung angegeben und erfordert kein Benutzerkonto o.ä., um das Webcam-Bild abzurufen.', '2010-09-12 23:44:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1643', 'DE', 'Das Ziel des Geocaches liegt nicht im Freien, sondern zum Beispiel in einem Geb\&auml;ude oder einer H\&ouml;hle.', '2010-09-12 23:41:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1644', 'DE', 'Der Geocache oder eine der Stationen ist im Wasser versteckt. Um die Aufgabe zu l\&ouml;sen muss man das Wasser betreten, schwimmen oder tauchen.', '2010-09-12 23:41:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1645', 'DE', 'Dieser Cache l\&auml;sst sich auch ohne GPS-Empf\&auml;nger finden. Die Aufgaben sind so gestellt, dass man außer den Startkoordinaten keine weiteren Koordinaten verwenden muss.', '2010-09-12 23:41:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1646', 'DE', 'Um zum Cache zu gelangen, müsst ihr entweder einen Eintritt oder eine Parkgebühr bezahlen. Ein Eintrittsgeld könnte z.B. in einem Freizeitpark anfallen. Falls es trotzdem nahegelegene, entgeltfreie Parkmöglichkeiten gibt, möchten wie euch bitten darauf in der Beschreibung hinzuweisen. Bitte beachtet auch die aktuellen Nutzungsbedingungen zum Thema \&bdquo;kommerzielle Geocaches\&ldquo;.', '2010-09-12 23:44:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1647', 'DE', 'Der Geocache kann nicht mit einer einzigen Tages- oder Nachttour gel\&ouml;st werden. Er muss entweder mehrmals angefahren werden oder es muss vor Ort \&uuml;bernachtet werden. Bei diesem Attribut soll die Zeit f\&uuml;r Recherchen vorab nicht ber\&uuml;cksichtigt werden, sondern nur die Zeit vor Ort.', '2010-09-12 23:41:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1648', 'DE', 'Ein Newseintrag wurde auf Opencaching erstellt', '2010-09-13 00:17:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1649', 'DE', 'Laufzeit: [time} Sekunden', '2010-09-13 00:17:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1650', 'DE', 'Die aufgerufene Seite existiert nicht!', '2010-09-13 00:17:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1651', 'DE', 'Suche nach Cachename', '2010-09-13 00:17:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1652', 'DE', 'Weiterleitung - opencaching', '2010-09-13 00:17:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1653', 'DE', 'Soll die gespeicherte Suche wirklich gel\&ouml;scht werden?', '2010-09-13 00:16:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'DE', 'Status', '2010-09-13 00:16:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1655', 'DE', 'Status ändern', '2010-09-13 00:16:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'DE', 'Länderknoten', '2010-09-13 00:16:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1657', 'DE', 'bis', '2010-09-14 01:26:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'DE', 'Der Weg', '2010-09-15 15:06:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'DE', 'Cachegröße:', '2010-09-27 00:34:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1660', 'DE', 'Link', '2010-09-27 00:34:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1661', 'DE', 'Öffnen', '2010-09-27 00:33:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1662', 'DE', 'Zu den Favoriten hinzufügen...', '2010-09-27 00:33:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1663', 'DE', 'Angezeigte Geocaches', '2010-09-27 00:33:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1664', 'DE', 'Ladezeit', '2010-09-27 00:33:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1665', 'DE', 'Sek.', '2010-09-27 00:33:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1666', 'DE', 'Nur Geocaches mit folgenden Eigenschaften anzeigen:', '2010-09-27 00:33:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1667', 'DE', 'Cacheart', '2010-09-27 00:32:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1668', 'DE', 'Cache Behälter', '2010-09-27 00:32:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1669', 'DE', 'Ausblenden', '2010-09-27 00:32:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1670', 'DE', 'Meine Eigenen', '2010-09-27 00:30:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1671', 'DE', 'Inaktiv', '2010-09-27 00:30:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1672', 'DE', 'Mehrfach gelistet', '2010-09-27 00:30:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1673', 'DE', 'Bewertung', '2010-09-27 00:30:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1674', 'DE', 'Min. Empfehlungen', '2010-09-27 00:29:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1675', 'DE', 'Drag Zoom', '2010-09-27 00:29:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1676', 'DE', 'Gebiet auf der Karte mit der Maus markieren (hier klicken um abzubrechen)', '2010-09-27 00:29:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1677', 'DE', 'Drag Zoom Back', '2010-09-27 00:28:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1678', 'DE', 'Bitte Suchtext eingeben!', '2010-09-27 00:28:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1680', 'DE', 'Wegpunkt %1 nicht gefunden!', '2010-09-27 00:28:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1681', 'DE', 'D/T:', '2010-09-27 00:27:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1682', 'DE', 'Kartendaten \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2010-09-27 00:27:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1683', 'DE', 'Fehler: Das Suchergebnis konnte nicht heruntergeladen werden (HTTP Fehler Code %1)', '2010-09-27 00:27:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1684', 'DE', 'Fehler: Das Suchergebnis konnte nicht heruntergeladen werden. Die Daten waren auf dem Server nicht verfügbar.', '2010-09-27 00:26:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1685', 'DE', 'Es sind %1 Geocaches gefunden. Bitte vergrößere die Ansicht, um die Geocaches anzuzeigen.', '2010-09-27 00:36:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1686', 'DE', 'Die Sucheinstellungen haben sich geändert. Klicke bitte auf OK um die Ansicht zu aktualisieren.', '2010-09-27 00:24:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1687', 'DE', 'Neuer Logeintrag', '2010-10-03 20:29:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1688', 'DE', 'Logeintrag bearbeiten', '2010-10-03 20:28:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1689', 'DE', 'Logeintrag entfernen', '2010-10-03 20:28:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1690', 'DE', 'Cache bearbeiten', '2010-10-03 20:27:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1691', 'DE', 'Beschreibung hinzufügen', '2010-10-03 20:27:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1692', 'DE', 'Beschreibung bearbeiten', '2010-10-03 20:26:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1693', 'DE', 'Beschreibung löschen', '2010-10-03 20:26:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1694', 'DE', 'Ortschaft auswählen', '2010-10-03 20:25:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1695', 'DE', 'Suchergebnis anzeigen', '2010-10-03 20:25:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1696', 'DE', 'Ergebnis', '2010-10-03 20:24:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1697', 'DE', 'Beschreibung - Neuen Cache eintragen', '2010-10-03 20:23:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1698', 'DE', 'Bild hinzufügen', '2010-10-03 20:23:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1699', 'DE', 'Meldung', '2010-10-03 19:30:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1700', 'DE', 'Es ist kein Google Maps Key für diese Domain registriert.', '2010-10-03 22:27:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1701', 'DE', 'Achtung! Dieser Geocache ist \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> Es befindet sich kein Behälter an den angegebenen (oder zu ermittelnden) Koordinaten. Im Interesse des Ortes sollte von einer Suche unbedingt abgesehen werden!', '2010-10-06 22:30:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1702', 'DE', 'Achtung! Dieser Geocache ist \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> Der Geocache selbst oder Teile davon sind nicht vorhanden oder es gibt andere Probleme, die eine erfolgreiche Suche unmöglich machen. Im Interesse des Ortes sollte von einer Suche unbedingt abgesehen werden!', '2010-10-06 22:29:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1703', 'DE', 'Du hast dieses Event besucht!', '2010-10-06 22:30:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1704', 'DE', 'Du hast diesen Geocache bereits gefunden!', '2010-10-06 22:34:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1705', 'DE', '<br /><i>Veraltet: Dieses Attribut kann bei neuen Geocaches nicht mehr verwendet werden, weil das Attribut unsere aktuellen Nutzungsbedingungen nicht erfüllt</i><br />Dieser Cache ist nicht nur auf Opencaching.de gelistet, sondern auch auf weiteren Portalen. Es gibt einen Link auf die Portale, wenn der Eigentümer des Caches in der Beschreibung eine entsprechende Kennung eingetragen hat. Wir weisen darauf hin, dass auch stets auf Opencaching.de die Beschreibungen und Sperrungen vom Eigentümer aktuell gehalten werden müssen. Dieses Attribut ermöglicht es z.B. PDA-Benutzern Geocaches gezielt zu filtern, die keine vollständige Beschreibung enthalten und deshalb nicht unterwegs gelöst werden können. ', '2011-02-05 22:55:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1706', 'DE', 'Diese OC-Seite', '2010-10-18 21:33:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1707', 'DE', 'Andere OC-Seiten', '2010-10-18 21:33:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1708', 'DE', 'Die nächsten Events in %1', '2010-10-21 22:57:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1709', 'DE', 'Geocaches mit den meisten Empfehlungen innerhalb der letzten 30 Tage in %1.', '2010-10-21 22:57:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'DE', 'Neueste Caches in %1', '2010-10-21 22:56:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1711', 'DE', 'Du benötigst noch {anzahl} Funde, um eine weitere Empfehlung vorzunehmen.', '2010-11-29 21:06:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1712', 'DE', 'Logeintrag für den Cache <a href=\"viewcache.php?cacheid=%1\">%2</a> hinzufügen', '2010-12-18 23:18:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1713', 'DE', 'Du hast diesen Cache empfohlen.', '2010-12-18 23:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1714', 'DE', 'Die Empfehlung zurückziehen', '2010-12-18 23:17:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1715', 'DE', 'Du hast %1 von %2 möglichen Empfehlungen vergeben.', '2010-12-18 23:19:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1716', 'DE', 'Du benötigst noch %1 Funde, um eine weitere Empfehlung vorzunehmen.', '2010-11-29 21:06:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1717', 'DE', 'Bitte auswählen!', '2010-12-18 23:16:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1718', 'DE', 'Ergebnisse auf dieser Seite', '2010-12-18 23:16:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1719', 'DE', 'Ergebnis {startatp1} bis {endat} (als zip)', '2010-12-18 23:16:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1722', 'DE', 'Möchtest du diesen Eintrag wirkliche entfernen?', '2010-12-18 23:15:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1723', 'DE', 'Möchtest du wirklich die Empfehlung widerrufen?', '2010-12-18 23:15:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1724', 'DE', 'Strecke', '2010-12-18 23:14:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1725', 'DE', 'Download als ...', '2010-12-18 23:14:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1726', 'DE', 'Logeintrag für <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a> entfernen', '2010-12-18 23:17:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1727', 'DE', 'Neue Beschreibung für <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a> hinzufügen', '2010-12-18 23:18:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1728', 'DE', 'An GPS-Gerät senden', '2011-02-12 20:10:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1729', 'DE', 'Geokrety-Verlauf', '2011-02-12 20:10:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1730', 'DE', 'Aktuelle Forenthemen (%1):', '2011-02-12 20:12:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1731', 'DE', 'Teamblog', '2011-02-12 20:10:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1732', 'DE', 'Forum', '2011-02-12 20:10:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1733', 'DE', 'Geokrety', '2011-02-12 20:10:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1735', 'DE', 'Bei Events: Eventdatum!', '2011-02-12 20:09:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1736', 'DE', 'User-ID:', '2011-02-12 20:11:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1737', 'DE', 'Liste', '2011-02-12 20:11:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1738', 'DE', 'Eventdatum', '2011-02-12 20:09:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1739', 'DE', 'Gefunden: %1  Versteckt: %2', '2011-04-04 20:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1740', 'DE', '<Benutzer unbekannt>', '2011-04-04 21:27:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1741', 'DE', 'Der Account ist bereits aktiviert. Versuche dich bitte <a href=\"login.php\">einzuloggen</a>.<br />\r\nSollte der Login nicht möglich sein, lese bitte unter <a href=\"{$opt.cms.login}\">Loginprobleme</a> nach, wie du das Problem beheben kannst.\r\n', '2011-04-04 21:35:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1742', 'DE', 'Dein Browser hat das Cookie von Opencaching.de nicht gespeichert.<br />\r\nMehr Informationen findest du in der <a href=\"{$opt.cms.login}\">Opencaching.de-Hilfe</a>.', '2011-04-04 21:31:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1743', 'DE', 'Dieser Geocache liegt vermutlich in einem Naturschutzgebiet. Bitte verhalte dich entsprechend umsichtig! <font size=\"1\">(<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>)</font>', '2011-04-04 21:26:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1744', 'DE', 'Dieser Geocache liegt vermutlich in den folgenden Schutzgebieten (<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>):', '2011-04-04 21:23:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1745', 'DE', 'Standardlogo', '2011-04-24 22:21:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1747', 'DE', 'Alternative by nybbler', '2011-04-24 22:21:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1752', 'DE', 'Alternativlogo', '2011-04-24 22:20:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1753', 'DE', 'Slimline', '2011-04-24 22:20:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1754', 'DE', 'rotes Logo, slimline', '2011-04-24 22:20:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1755', 'DE', 'Slimline, ohne Statistik', '2011-04-24 22:20:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1756', 'DE', 'Slimline rot, ohne Statistik', '2011-04-24 22:17:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1757', 'DE', 'Runde Ecken', '2011-05-21 00:03:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1758', 'DE', 'Der Account ist bereits aktiviert. Versuche dich bitte <a href=\"login.php\">einzuloggen</a>.<br /> Sollte der Login nicht möglich sein, lese bitte unter <a href=\"%1\">Loginprobleme</a> nach, wie du das Problem beheben kannst.', '2011-05-23 22:27:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1759', 'DE', 'Notiz:', '2011-05-20 23:52:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1760', 'DE', 'Koordinaten:', '2011-05-21 00:01:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1761', 'DE', 'Diese Notiz ist für andere Benutzer nicht sichtbar. Die Notiz und die Koordinaten sind in heruntergeladenen GPX-Dateien enthalten und werden an das GPS-Ger\&auml;t gesendet.', '2011-05-21 00:00:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1763', 'DE', 'Dein Browser hat das Cookie von Opencaching.de nicht gespeichert.<br /> Mehr Informationen findest du in der <a href=\"%1\">Opencaching.de-Hilfe</a>.', '2011-05-23 22:25:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1764', 'DE', 'Persönliche Notiz', '2011-05-21 00:02:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1765', 'DE', 'Dieser Geocache liegt vermutlich in einem Naturschutzgebiet. Bitte verhalte dich entsprechend umsichtig! <font size=\"1\">(<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>)</font>', '2011-05-23 22:24:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1766', 'DE', 'Dieser Geocache liegt vermutlich in den folgenden Schutzgebieten (<a href=\"%1\" target=\"_blank\">Info</a>):', '2011-05-23 22:18:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1767', 'DE', 'Schnellübersetzung', '2011-07-10 18:09:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1768', 'DE', 'Deaktivieren', '2011-07-10 18:10:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1769', 'DE', 'Aktivieren - neu', '2011-07-10 18:10:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1770', 'DE', 'Aktivieren - Alle', '2011-07-10 18:10:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1771', 'DE', 'Text Download (neu)', '2011-07-15 20:22:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1772', 'DE', 'Text Download (Alle)', '2011-07-10 18:11:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1773', 'DE', 'Text Import', '2011-07-10 18:11:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1774', 'DE', 'Text Datei mit den Übersetzungen', '2011-07-10 18:11:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1775', 'DE', 'Zusätzliche Wegpunkte', '2011-07-17 20:52:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1776', 'DE', 'Wegpunkt Typ:', '2011-07-10 18:12:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1777', 'DE', 'Bitte auswählen', '2011-07-10 18:12:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1778', 'DE', 'Koordinaten:', '2011-07-10 18:13:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1779', 'DE', 'Download GPX Datei (max. 500)', '2011-07-10 18:13:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1780', 'DE', 'Wegpunkt hinzufügen', '2011-07-10 20:16:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1781', 'DE', 'Hinzufügen', '2011-07-10 20:17:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1782', 'DE', 'Wegpunkt Löschen', '2011-07-10 20:17:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1783', 'DE', 'Wegpunkt bearbeiten', '2011-07-10 20:18:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1788', 'DE', 'Parkplatz', '2011-07-15 20:13:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1789', 'DE', 'Referenzpunkt', '2011-07-15 20:12:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1790', 'DE', 'Zusätzliche Wegpunkte', '2011-07-17 20:52:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1791', 'DE', 'Wegpunkt hinzufügen', '2011-07-17 20:53:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1792', 'DE', 'Zusätzliche Wegpunkte können angelegt werden um die Suche zu erleichtern. Zum Beispiel ein Parkplatz oder Startpunkt für die Suche. Die Wegpunkte sind in heruntergeladenen GPX-Dateien enthalten und werden ans GPS-Gerät gesendet.', '2011-07-17 20:50:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1793', 'DE', 'Keine zusätzlichen Wegpunkte angelegt', '2011-07-17 20:51:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1794', 'DE', 'Zusätzliche Wegpunkte können die Suche vereinfachen, indem sie z.B. auf einem Parkplatz oder den Anfang der Strecke zeigen. Die Wegpunkte sind in heruntergeladenen GPX-Dateien enthalten und werden ans GPS-Gerät gesendet.', '2011-07-17 20:52:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1795', 'DE', 'Karten:', '2012-07-23 22:26:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1796', 'DE', 'Veröffentlicht am', '2012-07-23 22:26:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1797', 'DE', 'Versionsgeschichte', '2012-07-08 14:50:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1798', 'DE', 'Verein', '2012-07-08 14:50:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1799', 'DE', 'Nur zu bestimmten Zeiten im Jahr', '2012-10-29 14:28:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1800', 'DE', 'Dieser Cache l\&auml;sst sich nur zu bestimmten Zeite im Jahr absolvieren. N\&auml;here Angaben sind in der Beschreibung des Caches zu finden. Der Cache kann beispielsweise in einem Maislabyrinth versteckt sein, das nur zwischen Bl\&uuml;te- und Erntezeit existiert.', '2012-10-29 14:28:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1801', 'DE', 'Hilfe', '2012-11-09 19:32:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1802', 'DE', 'Warnung: Diese Cachemeldung wird bereits von einem anderen Admin bearbeitet. Bitte sprich dich mit ihm ab, bevor du sie \&uuml;bernimmst!', '2013-01-30 16:28:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1803', 'DE', 'nano', '2012-11-10 15:56:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1804', 'DE', 'Datenlizenz', '2013-02-09 18:29:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1805', 'DE', 'Der Inhalt von www.opencaching.de steht unter einer <br /><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/de/\" target=\"_blank\">Creative Commons Namensnennung-NichtKommerziell-KeineBearbeitung-3.0-Deutschland</a>-Lizenz.', '2013-02-09 18:30:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1806', 'DE', 'Bitte waehle nur eine der Lösch-/Sperroptionen aus!', '2013-02-09 17:34:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1807', 'DE', 'Mit dem Absenden akzeptiere ich die <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de-Nutzungsbedingungen</a> und -<a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datenlizenz</a>.', '2013-02-09 19:13:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1808', 'DE', 'Die <a target=\"_blank\" href=\"articles.php?page=dsb\">Datenschutzbelehrung</a>, die <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Nutzungsbedingungen</a> und die <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datenlizenz</a> habe ich gelesen und bin damit einverstanden.', '2013-02-09 19:07:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1809', 'DE', 'Du musst die Datenschutzbelehrung, die Nutzungsbedingungen  und die Datenlizenz akzeptieren, um dich bei Opencaching.de zu registrieren.', '2013-02-09 19:21:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1810', 'DE', 'Mit dem Herunterladen dieser Datei akzeptierst du unsere <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> und <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Datenlizenz</a>.', '2013-02-09 19:20:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1811', 'DE', 'Deaktivieren (und Geocaches sperren) und alle Fremdlizenz-Inhalte löschen', '2013-02-09 19:30:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1812', 'DE', 'ID', '2013-02-09 19:31:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1813', 'DE', 'Besitzer', '2013-02-09 19:31:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1814', 'DE', 'Melder', '2013-02-09 19:31:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1815', 'DE', 'Du muss bestaetigen, dass du sicher bist!', '2013-02-09 19:31:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1816', 'DE', 'Die Cachebeschreibung wurde gel\&ouml;scht, weil der Besitzer die Opencaching.de-Datenlizenz abgelehnt hat.', '2013-02-09 19:31:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1817', 'DE', 'Der Benutzerstatus wurde erfolgreich geändert.', '2013-02-09 19:31:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1818', 'DE', 'Spoiler', '2013-02-11 11:40:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1819', 'DE', 'Nach dem Speichern musst du evtl. auf den Seiten-Neuladeknopf deines Browsers drücken, um das gewählte Bild in deinem Profil zu sehen.', '2013-02-15 00:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1820', 'DE', 'Du kannst dich nun mit dem neuen Passwort <a href=\"login.php\">anmelden</a>.', '2013-02-14 00:48:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1821', 'DE', 'OC.de neu', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1822', 'DE', 'OC.de neu, slimline', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1823', 'DE', 'OC.de neu, ohne Statistik', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1824', 'DE', 'E-Mail-Adresse bestätigen', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1825', 'DE', 'Eine oder mehrere Emails konnte nicht an deine hinterlegte Adresse zugestellt werden', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1826', 'DE', 'Bitte bestätige, dass diese Adresse korrekt ist, oder gib eine neue ein!', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1827', 'DE', 'Neue Adresse eingeben', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1828', 'DE', 'Diese Adresse bestätigen', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1829', 'DE', 'E-Mail-Adresse als ungültig markieren', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1830', 'DE', 'Datenlizenzmail wurde nicht zugestellt', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1831', 'DE', 'Admins', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1832', 'DE', 'Rechte', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1833', 'DE', 'Adminrechte können von einem Systemadministrator mit Datenbankzugriff vergeben oder entzogen werden.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1834', 'DE', 'Datenlizenz abgelehnt', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1835', 'DE', 'Das Benutzerprofil wurde deaktiviert, weil der Benutzer die <a href=\"articles.php?page=impressum#datalicense\">Datenlizenz</a> abgelehnt hat. Cachebeschreibungen, Logtexte und Bilder des Benutzers wurden entfernt.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1839', 'DE', 'Es muss eine zu überschreibende Suche gewählt werden.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1', 'EN', 'Reorder IDs \r', '2010-09-02 00:15:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('2', 'EN', 'The database could not be reconnected.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'EN', 'Testing – please do not login', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'EN', 'User', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('5', 'EN', '(empty)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'EN', 'Logged in as', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'EN', 'Logout', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'EN', 'Waypoint search', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('9', 'EN', 'Page timing', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('10', 'EN', 'sec', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('11', 'EN', 'Page cached', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'EN', 'DB connected', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('13', 'EN', 'Created at', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'EN', 'Privacy statement', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'EN', 'Legal information', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'EN', 'Contact', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'EN', 'Sitemap', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'EN', 'Register', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'EN', 'New user registered', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'EN', 'Note', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('21', 'EN', 'Vietnamese', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'EN', 'Username', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'EN', 'E-mail', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'EN', 'First name', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'EN', 'Last name', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'EN', 'Country', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'EN', 'Register new user', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'EN', 'Uzbek', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'EN', 'The username is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'EN', 'Print last logs', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('31', 'EN', 'The last name is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('32', 'EN', 'The first name is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'EN', 'Not specified', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'EN', 'Show all', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'EN', 'The e-mail address is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'EN', 'Turkish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'EN', 'Your password', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('38', 'EN', 'The password contains invalid characters or is too short.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'EN', 'The passwords did not match.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'EN', 'Please repeat', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'EN', 'Fields marked with * are mandatory', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'EN', 'Swedish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'EN', 'Slovenian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('44', 'EN', 'length at least 6 characters', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'EN', 'at least 4 different characters', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('46', 'EN', 'not part of the username', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('47', 'EN', 'not in the list of commonly used passwords', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'EN', 'Slovak', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'EN', 'Russian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'EN', 'You have to accept the privacy statement and terms of use to register at opencaching.de', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'EN', 'Reset', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('52', 'EN', 'Recommendations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'EN', 'Index', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'EN', 'Recommendations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'EN', 'Found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'EN', 'by', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('58', 'EN', 'HTML preview', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'EN', 'Romanian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'EN', 'Step 1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('61', 'EN', 'Enter the text here:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'EN', 'Next', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'EN', 'Step 2', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'EN', 'Portuguese', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('65', 'EN', 'Back', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('66', 'EN', 'Preview', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('67', 'EN', 'Step 3', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('68', 'EN', 'The browser will show your HTML code as follows:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('69', 'EN', 'You can save the following HTML code and enter it in the cache description.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'EN', 'News', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'EN', 'Latest caches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'EN', 'Latest caches without Germany', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'EN', 'Latest log entries', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'EN', 'Polish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'EN', 'Norwegian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'EN', 'Latvian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'EN', 'Lithuanian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'EN', 'Italian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'EN', 'Icelandic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'EN', 'Home', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'EN', 'Welcome to opencaching.de', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'EN', 'On this page you will find Geocaches from all over the world, with focus on Germany, Austria, Switzerland, Italy and Spain. We also offer information on miscellaneous geocaching topics, and a forum (message board) and chat for communicating with other cachers.<br /><br />If you would like to propagate geocaching in your own country, you may run your own Opencaching site in your own language, using our <a href=\"https://github.com/OpencachingDeutschland/oc-server3\" target=\"_blank\">software</a> and known-how. Please contact us in our international forum for more information.', '2013-02-11 14:25:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('83', 'EN', 'The file was not uploaded correctly.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('84', 'EN', 'The file was too big. The maximum file size is 150 KB.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('85', 'EN', 'No picture file given.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'EN', 'same type', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'EN', 'Opencaching.de', '2010-08-29 17:36:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'EN', '%1 active caches and %2 founds by %3 users total', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'EN', 'Hungarian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'EN', 'Croatian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'EN', 'Finnish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'EN', 'Yes', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'EN', 'No', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'EN', 'Hello', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('99', 'EN', 'This e-mail was generated by the opencaching.de website, because an account with your e-mail address has been created. If you don\'t want to receive further e-mails, please contact us via %1.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'EN', 'Basque', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'EN', 'Estonian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'EN', 'Esperanto', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'EN', 'Greek', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'EN', 'Danish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('105', 'EN', 'An unkown error occurred.\r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('106', 'EN', 'Template does not exist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('107', 'EN', 'Sorry, you are not allowed to view this page.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('108', 'EN', 'Sorry, the requested cache does not exist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('109', 'EN', 'Sorry, the requested operation cannot be performed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('110', 'EN', 'Sorry, the requested operation cannot be performed because you are not logged in with an user account.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('111', 'EN', 'Sorry, the requested user does not exist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('112', 'EN', 'Mail template does not exist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('113', 'EN', 'HTML Tags', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'EN', 'Description', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'EN', 'Hide a cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'EN', 'Admin', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'EN', 'Information', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'EN', 'Caches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'EN', 'My profile', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'EN', 'Latest logs', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'EN', 'Without Germany', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'EN', 'New caches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'EN', 'About geocaching', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('124', 'EN', 'New item', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'EN', 'Search', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'EN', 'Translation', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'EN', 'Activation', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'EN', 'Userprofile', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('129', 'EN', 'An error occurred while processing the page.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('130', 'EN', 'An error occurred while processing the page. If you have called this page by a hyperlink on our site and this error persists for some time, please contact us via e-mail. ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('131', 'EN', 'The following error occurred', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'EN', 'Site', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'EN', 'Error message', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'EN', '%2 found %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'EN', '%2 didn\'t find %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'EN', '%2 wrote a note for %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'EN', '%2 visited %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'EN', '%2 wants to visit %1 \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('139', 'EN', 'Registration confirmation', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'EN', 'Welcome at www.opencaching.de!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('141', 'EN', 'The following data has been stored for your e-mail address %1: \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'EN', 'Slave', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('143', 'EN', 'The activation can be performed at the following web address:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('144', 'EN', 'If you don\'t login within the next 14 days, your account will be deleted.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'EN', 'Czech', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'EN', 'Bulgarian', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'EN', 'User profile of %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'EN', 'Send e-mail', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'EN', 'Others', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('150', 'EN', 'I\'m taking a PMR walkie-talkie on channel 2 with me', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'EN', 'Registered&nbsp;since', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'EN', 'Caches hidden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'EN', 'Caches found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'EN', '%1 of %2 possible', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'EN', 'Dutch', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'EN', 'Japanese', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'EN', 'Spanish', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'EN', 'French', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'EN', 'English', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'EN', 'German', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('161', 'EN', 'Attention: If you are using this option, don\'t forget to log out before other persons have access to your computer. Otherwise, they may use and modify your personal data.\r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'EN', 'Zimbabwe', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'EN', 'Zambia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'EN', 'South Africa', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'EN', 'Mayotte', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'EN', 'The activation code was sent to you by e-mail.<br> Please follow the instructions in the e-mail.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'EN', 'To create an account at opencaching.de, you have to enter a vaild e-mail address and a user name. An activation code will be sent to the e-mail address you supplied. Only one account can be created per e-mail address. First name, last name and country are optional.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('168', 'EN', 'An account with that e-mail address already exists. It is not possible to create a second account with the same e-mail address.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('170', 'EN', 'The password you have entered is too simple. For your own security, we recommend a stronger password:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('171', 'EN', 'The activation code or e-mail address was incorrect.<br /> The activation of your account was not successful.<br /> Please use the same e-mail address to which the registration mail was sent.<br /> <br /> Please check if you have mistyped. If you cannot solve the problem, contact us via <a href=\"mailto:%1\">%1</a>.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'EN', 'Yemen', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'EN', 'Samoa', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('174', 'EN', 'Go', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('175', 'EN', 'Developer system – testing only', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('177', 'EN', 'With this wizard, you can make some part of your description <b>bold</b> or <i>italic</i>. No HTML knowledge required.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('178', 'EN', 'Here you can see the HTML code generated from your text. If you want to make a word <b>bold</b>, insert \&lt;b\&gt; before the word and \&lt;/b\&gt; after.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'EN', 'Wallis And Futuna Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'EN', 'Create a news entry', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'EN', 'Vanuatu', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'EN', 'Viet Nam', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'EN', 'Virgin Islands (U.S.)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'EN', 'Virgin Islands (British)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'EN', 'Venezuela', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('186', 'EN', 'Select target language:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('187', 'EN', 'Show new translations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('188', 'EN', 'Clear smarty cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('189', 'EN', 'Not defined', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('190', 'EN', 'Show translations no longer referenced', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('191', 'EN', 'Show all translations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'EN', 'Saint Vincent And The Grenadines', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'EN', 'Vatican City State (Holy See)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'EN', 'Uzbekistan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('195', 'EN', 'Use existing translations:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('196', 'EN', 'All translations:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('197', 'EN', 'New translations:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('198', 'EN', 'Translations no longer referenced:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'EN', 'Languages', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'EN', 'Uruguay', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'EN', 'Activation code:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'EN', 'United States', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'EN', 'United States Minor Outlying Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('206', 'EN', 'Total', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'EN', 'Login', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'EN', 'Password', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'EN', 'Uganda', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'EN', 'Ukraine', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'EN', 'Tanzania, United Republic Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'EN', 'Taiwan, Province Of China', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'EN', 'Tuvalu', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'EN', 'Trinidad And Tobago', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'EN', 'Turkey', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'EN', 'Not registered?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'EN', 'Forgot your password?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'EN', 'Forgot your e-mail address?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'EN', 'For more troubleshooting hints, see', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'EN', 'Print no logs', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'EN', 'Enter a new password', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'EN', 'Send a reminder', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'EN', 'Tonga', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'EN', 'Please fill in username and password!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'EN', 'Logout was successful.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('226', 'EN', 'login failed', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('227', 'EN', 'The entered username/e-mail or the specified password did not match.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('228', 'EN', 'Your tried to login more than %1 times within the last hour. The next login will not be allowed before one hour since the first try has passed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'EN', 'Your account is not acivated.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('230', 'EN', '\&gt;<a href=\"activation.php\">Here</a>\&lt; you can activate your account. \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'EN', 'Tunisia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'EN', 'To complete the registration, you have to enter your e-mail address and activation code.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'EN', 'Turkmenistan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'EN', 'Tokelau', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'EN', 'Tajikistan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'EN', 'Thailand', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'EN', 'Togo', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'EN', 'French Southern Territories', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'EN', 'Chad', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'EN', 'Turks And Caicos Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'EN', 'Name', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'EN', 'Swaziland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'EN', 'Syrian Arab Republic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('244', 'EN', 'Recommendations of <a href=\"viewprofile.php?userid=%1\">%2</a>', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('245', 'EN', '<a href=\"viewcache.php?cacheid=%1\">%2</a> by %3', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('246', 'EN', '%1 has not recommended any geocache.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'EN', 'Show recommendations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'EN', 'El Salvador', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'EN', 'Sao Tome And Principe', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'EN', 'Suriname', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'EN', 'Somalia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('253', 'EN', 'Unkown waypoint format. The following formats are valid: OCxxxx, NCxxxx and GCxxxx, where xxxx is any number or characters.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('254', 'EN', 'More than one cache with the waypoint \&quot;%1\&quot; exists.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('255', 'EN', 'The waypoint \&quot;%1\&quot; was not found.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'EN', 'Senegal', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'EN', 'San Marino', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'EN', 'Sierra Leone', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'EN', 'Slovakia (Slovak Republic)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'EN', 'Svalbard And Jan Mayen Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'EN', 'Slovenia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'EN', 'St. Helena', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'EN', 'Singapore', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'EN', 'Sweden', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'EN', 'Sudan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'EN', 'Seychelles', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('267', 'EN', 'Solomon Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'EN', 'Saudi Arabia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'EN', 'Rwanda', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'EN', 'Russian Federation', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'EN', 'Romania', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'EN', 'Reunion', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'EN', 'Qatar', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'EN', 'Paraguay', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'EN', 'Palau', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'EN', 'Portugal', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'EN', 'Puerto Rico', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'EN', 'Pitcairn', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'EN', 'St. Pierre And Miquelon', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'EN', 'Poland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'EN', 'Pakistan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'EN', 'Philippines', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'EN', 'Papua New Guinea', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'EN', 'French Polynesia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'EN', 'Peru', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'EN', 'Panama', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'EN', 'Oman', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'EN', 'New Zealand', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'EN', 'Niue', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'EN', 'Nauru', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'EN', 'Nepal', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'EN', 'Norway', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'EN', 'Netherlands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'EN', 'Nicaragua', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'EN', 'Nigeria', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'EN', 'Norfolk Island', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'EN', 'Niger', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'EN', 'New Caledonia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'EN', 'Namibia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'EN', 'Mozambique', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'EN', 'Malaysia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'EN', 'Mexico', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'EN', 'Malawi', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'EN', 'Maldives', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'EN', 'Mauritius', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'EN', 'Malta', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'EN', 'Montserrat', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'EN', 'Mauritania', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'EN', 'Martinique', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'EN', 'Northern Mariana Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'EN', 'Macau', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'EN', 'Mongolia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'EN', 'Myanmar', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'EN', 'Mali', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'EN', 'Macedonia, The Former Yugoslav Republic Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'EN', 'Marshall Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'EN', 'Madagascar', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'EN', 'Moldova, Republic Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'EN', 'Monaco', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'EN', 'Morocco', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'EN', 'Libyan Arab Jamahiriya', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'EN', 'Latvia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'EN', 'Luxembourg', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'EN', 'Lithuania', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'EN', 'Lesotho', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'EN', 'Liberia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'EN', 'Sri Lanka', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'EN', 'Liechtenstein', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'EN', 'Saint Lucia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'EN', 'Lebanon', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'EN', 'Lao People\'s Democratic Republic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'EN', 'Kazakhstan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'EN', 'Cayman Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'EN', 'Kuwait', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'EN', 'Korea, Republic Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'EN', 'Korea, Democratic People\'s Republic Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'EN', 'Saint Kitts And Nevis', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'EN', 'Comoros', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'EN', 'Kiribati', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'EN', 'Cambodia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'EN', 'Kyrgyzstan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'EN', 'Kenya', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'EN', 'Japan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'EN', 'Jordan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'EN', 'Jamaica', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'EN', 'Italy', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'EN', 'Iceland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'EN', 'Iran (Islamic Republic Of)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'EN', 'Iraq', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'EN', 'British Indian Ocean Territory', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'EN', 'India', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'EN', 'Israel', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'EN', 'Ireland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'EN', 'Indonesia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'EN', 'Hungary', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'EN', 'Haiti', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'EN', 'Croatia (local name: Hrvatska)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'EN', 'Honduras', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'EN', 'Heard And Mc Donald Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'EN', 'Hong Kong', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'EN', 'Guyana', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'EN', 'Guinea-Bissau', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'EN', 'Guam', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'EN', 'Guatemala', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'EN', 'South Georgia And The South Sandwich Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'EN', 'Greece', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'EN', 'Guadeloupe', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'EN', 'Guinea', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'EN', 'Gambia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'EN', 'Greenland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'EN', 'Gibraltar', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'EN', 'Ghana', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'EN', 'French Guiana', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'EN', 'Georgia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'EN', 'Grenada', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'EN', 'United Kingdom (UK)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'EN', 'Gabon', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'EN', 'France', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'EN', 'Faroe Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'EN', 'Micronesia, Federated States Of', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'EN', 'Falkland Islands (Malvinas)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'EN', 'Fiji', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'EN', 'Finland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'EN', 'Ethiopia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'EN', 'Spain', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'EN', 'Eritrea', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'EN', 'Western Sahara', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'EN', 'Egypt', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'EN', 'Estonia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'EN', 'Ecuador', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'EN', 'Algeria', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'EN', 'Dominican Republic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'EN', 'Denmark', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'EN', 'Djibouti', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'EN', 'Germany', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'EN', 'Czech Republic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'EN', 'Cyprus', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'EN', 'Christmas Island', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'EN', 'Cape Verde', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'EN', 'Cuba', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('401', 'EN', 'Attendees', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'EN', 'Costa Rica', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'EN', 'Colombia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'EN', 'China', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'EN', 'Cameroon', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'EN', 'Chile', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'EN', 'Cook Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'EN', 'Cote d\'Ivoire', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'EN', 'Switzerland', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'EN', 'Congo', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'EN', 'Central African Republic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'EN', 'Cocos (Keeling) Islands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'EN', 'Canada', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'EN', 'Belize', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'EN', 'Belarus', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'EN', 'Botswana', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'EN', 'Bouvet Island', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'EN', 'Bhutan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'EN', 'Bahamas', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'EN', 'Brazil', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'EN', 'Bolivia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'EN', 'Brunei Darussalam', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'EN', 'Bermuda', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'EN', 'Benin', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'EN', 'Burundi', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'EN', 'Bahrain', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'EN', 'Bulgaria', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'EN', 'Burkina Faso', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'EN', 'Belgium', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'EN', 'Bangladesh', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'EN', 'Barbados', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'EN', 'Bosnia And Herzegowina', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'EN', 'Azerbaijan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'EN', 'Aruba', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'EN', 'Australia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'EN', 'Austria', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'EN', 'American Samoa', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'EN', 'Argentina', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'EN', 'Angola', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'EN', 'Netherlands Antilles', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'EN', 'Armenia', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'EN', 'Albania', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'EN', 'Anguilla', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'EN', 'Antigua And Barbuda', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'EN', 'Afghanistan', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'EN', 'United Arab Emirates', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'EN', 'Andorra', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('448', 'EN', 'Switching to db-root failed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('449', 'EN', '(before an export)', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('450', 'EN', 'We are currently updating opencaching.de. To protect against faults while processing, the entire page is offline.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('452', 'EN', 'News entry has been saved', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('453', 'EN', 'Thank you very much for your news entry. We will try to validate your entry as soon as possible.<br /><br />Back to <a href=\"index.php\">Start</a> \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'EN', 'Submit a news entry', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'EN', 'Submit', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('456', 'EN', 'The code did not match.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'EN', 'And now fill in the spam protection code:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'EN', 'What does this picture show?', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('459', 'EN', 'E-mail address is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'EN', 'Your e-mail address for queries:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'EN', 'Please use only text formatting HTML tags - e.g. bold, color or hyperlinks. Do not enter tables, divs etc.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'EN', 'The news entry was entered with HTML tags ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'EN', 'News entry:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'EN', 'Topic:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('465', 'EN', 'You know some interesting news about Geocaching?<br /> Here you can create a news entry which will be shown on the homepage.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('466', 'EN', 'The activation of your account was successful. You may now login at the login page.<br /><br /> <a href=\"login.php\">Go to the login page</a>', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('467', 'EN', 'Hint', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'EN', 'Activate account', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('469', 'EN', 'Best regards,<br/>your Opencaching.de team', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('470', 'EN', 'Please be patient, we will do our best to get the site back online as soon as possible.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('471', 'EN', 'The account could not be created, the reason is not known. If you cannot solve this problem by yourself, please contact us via <a href=\"mailto:%1\">e-mail</a>.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'EN', 'We respect your privacy. Your personal data will be stored in our database but not disclosed to third parties. Please note our detailed <a href=\"articles.php?page=dsb\">privacy statement</a>. If you have further questions, please <a href=\"mailto:%1\">contact us</a> <b>before</b> you create an account.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('473', 'EN', 'We have to approve your news entry before we can display it. We will try to do this within 24 to 48 hours. The news entry cannot be modified after you have submitted it. If you want to make changes, please resubmit the corrected entry. You may submit any news concerning Geocaching, but you may not submit advertisement for products or geocaches. The decision to approve or not approve a news entry is exclusively up to the operator of the web page - there is no claim for publication. In the case of doubts, please wait if your news entry will be published, or ask via e-mail to <a href=\"mailto:%1\">%1</a> before submitting.\r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('474', 'EN', 'If this problem persists over a longer time, please contact us via <a href=\"mailto:%1\">%1</a>.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('475', 'EN', 'Opencaching is currently out of service', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('476', 'EN', 'Created at:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('477', 'EN', 'Total runtime:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('478', 'EN', 'Business layer runtime:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('479', 'EN', 'Framework runtime:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'EN', 'User runtime:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('481', 'EN', 'SQL Debugger', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('482', 'EN', '%1 commands', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('483', 'EN', 'Overview', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'EN', 'Profile', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('485', 'EN', 'Stored queries', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('486', 'EN', 'Watched caches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'EN', 'Ignored caches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'EN', 'Settings', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'EN', 'Edit profile', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'EN', 'The notification radius must not be greater than 150 km. To deactivate notifications, set the radius to 0.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'EN', 'Change password', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('492', 'EN', 'Change statpic', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'EN', 'E-mail address \r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('494', 'EN', 'Available', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('495', 'EN', 'Temporarily disabled', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('496', 'EN', 'Archived', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'EN', 'Not found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('498', 'EN', 'Attended', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('499', 'EN', 'Will attend', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('500', 'EN', 'Hello %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('501', 'EN', 'Logs', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'EN', 'Geocaches found: %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'EN', 'Your latest log entries:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'EN', 'No entries found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'EN', 'Geocaches hidden: %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'EN', 'Your latest geocaches hidden:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'EN', 'No geocaches hidden ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('508', 'EN', 'Your pending geocaches:', '2012-07-23 15:54:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'EN', 'All your geocaches are published.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('510', 'EN', 'E-mails sent', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'EN', 'E-mails sent: %1 ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('512', 'EN', 'Unknown Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('513', 'EN', 'Traditional Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('514', 'EN', 'Multi cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('515', 'EN', 'Virtual Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('516', 'EN', 'Webcam Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('517', 'EN', 'Event Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('518', 'EN', 'Quiz cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('519', 'EN', 'Math/Physics Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('520', 'EN', 'Moving Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('521', 'EN', 'Drive-In Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('522', 'EN', 'Motorcycle Geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('524', 'EN', 'other size', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('525', 'EN', 'micro', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('526', 'EN', 'small', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('527', 'EN', 'normal', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('528', 'EN', 'large', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('529', 'EN', 'very large', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('530', 'EN', 'no container', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('531', 'EN', 'Available', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('532', 'EN', 'Temporarily not available', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('533', 'EN', 'Hidden by approvers to check', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('534', 'EN', 'Not yet published', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('535', 'EN', 'unknown cache type', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('536', 'EN', 'Traditional Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('537', 'EN', 'Virtual Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('538', 'EN', 'Webcam Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('539', 'EN', 'Event Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('540', 'EN', 'Math/Physics Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('541', 'EN', 'Moving Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('542', 'EN', 'Drive-in Cache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'EN', 'I want to be notified about new geocaches within a radius of %1 km.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'EN', 'BBCode for web forums:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('546', 'EN', 'Opencaching.de statstics of %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('547', 'EN', 'Choose logo', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'EN', 'HTML code:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('549', 'EN', 'Text displayed:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('550', 'EN', 'Text contains invalid characters!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('551', 'EN', 'Available logos:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'EN', 'Cancel', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('553', 'EN', 'Save', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('554', 'EN', 'The following settings are stored for your logo:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('555', 'EN', 'Show log entries', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('556', 'EN', 'Statistics picture:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'EN', 'Registered&nbsp;since:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('558', 'EN', 'Don\'t use the HTML editor by default.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('559', 'EN', 'Don\'t log me out after 15 minutes of inactivity.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('560', 'EN', 'I\'m taking a PMR walkie talkie on channel 2 with me.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('561', 'EN', 'Others:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('562', 'EN', 'Notification about new geocaches is disabled.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('563', 'EN', 'Notify me about new geocaches within a radius of %1 km.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'EN', 'Notifications:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'EN', 'Home coordinates:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'EN', 'Country:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'EN', 'Last name:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'EN', 'First name:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('569', 'EN', 'Recommended', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'EN', '%1 found the geocache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('571', 'EN', '%1 did not find the geoacache', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('572', 'EN', '%1 wrote a note', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('573', 'EN', '%1 has visited the event', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('574', 'EN', '%1 wants to visit the event', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('575', 'EN', '%1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('576', 'EN', 'Edit', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('577', 'EN', 'Delete', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('578', 'EN', 'Upload picture', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('579', 'EN', 'Pictures for this log entry: ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('580', 'EN', 'Back to the geocache listing', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'EN', 'E-mail address:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'EN', 'Log entries for %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('583', 'EN', 'Picture selection', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('584', 'EN', 'Picture selection for %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('585', 'EN', 'There are no pictures for this geocache.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('586', 'EN', 'As preview picture', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'EN', 'My profile data', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'EN', 'The following information is stored in your user profile:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'EN', 'Gray entries will be hidden to other users.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'EN', 'Username:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('591', 'EN', 'The country is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('592', 'EN', 'The entered radius is not valid.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('593', 'EN', 'An unknown error occurred.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('594', 'EN', 'Before you can login for the first time, you have to activate your account by entering the following code:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'EN', 'New password', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('596', 'EN', 'Request', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'EN', 'Change', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'EN', 'Request code', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('599', 'EN', 'New password code', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('600', 'EN', 'on %1 you requested a security code to change your password.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('601', 'EN', 'The following code has been generated: %1', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('602', 'EN', 'This code is valid for 3 days.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('603', 'EN', 'You can enter your new password at %1newpw.php', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'EN', 'To change your password, you have to request a security code which will be sent to you by e-mail.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('605', 'EN', 'This e-mail address is not registered with a valid username.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('606', 'EN', 'An e-mail has been sent to you containing the security code.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('607', 'EN', 'An unknown error occurred. The security code could not be sent to you.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'EN', 'Please enter your e-mail address, the security code you received and your new password. The security code is valid for 3 days only. You have to request a new one if that period of time has elapsed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('609', 'EN', 'This user account has not been activated yet.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'EN', 'Security code:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('611', 'EN', 'The security code is expired. Please request a new one.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('612', 'EN', 'The security code does not match.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'EN', 'Please repeat:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('614', 'EN', 'The password has been changed.', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('615', 'EN', 'Security code for new e-mail address ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('616', 'EN', 'on %1 you requested a security code to change your e-mail address.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('617', 'EN', 'You can verify your new e-mail address at %1newemail.php', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'EN', 'Change e-mail address', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'EN', 'To change your e-mail address, you have to request a security code. It will be sent to your new e-mail address.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'EN', 'New e-mail address:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('621', 'EN', 'This e-mail address is already assigned to your account.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'EN', 'Please enter the security code you received. The security code is valid for 3 days only. You have to request a new one if that period of time has elapsed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'EN', 'Please request a security code first.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('624', 'EN', 'No new e-mail address has been stored. Please request a security code first.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('625', 'EN', 'The e-mail address has been changed.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('626', 'EN', 'Download', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('627', 'EN', 'No stored queries found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('628', 'EN', 'By downloading you accept the opencaching.de <a href=\"articles.php?page=impressum#tos\">terms of use</a>.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('629', 'EN', 'Store query', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('630', 'EN', 'Store options as a new search', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('631', 'EN', 'Name of the search', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('632', 'EN', 'You have to enter a name for this search.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('633', 'EN', 'A search with this name already exists.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('634', 'EN', 'Store', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('635', 'EN', 'Overwrite old search options', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('636', 'EN', '-- Select search to overwrite --', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('637', 'EN', '-- no stored search found --', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'EN', 'My recommendations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('639', 'EN', 'Your recommendation for \"<a href=\"viewcache.php?wp=%1\">%2</a>\" has been removed!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('640', 'EN', 'Remove recommendation', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('641', 'EN', 'You haven\'t recommended a geocache. ', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'EN', 'Ignored geocaches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('643', 'EN', 'remove', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'EN', 'No ignored geocaches found.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('645', 'EN', 'Watched geocaches - settings', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('646', 'EN', 'Delivery:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('647', 'EN', 'Immediate', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('648', 'EN', 'Daily', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('649', 'EN', 'Weekly', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('650', 'EN', 'Send at:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('651', 'EN', '\&nbsp;', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('652', 'EN', 'Send on:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('653', 'EN', 'Sending time and day will only be used for daily or weekly delivery.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('654', 'EN', 'Error while trying to save settings!', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('655', 'EN', 'Settings have been stored.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('656', 'EN', 'Watched geocaches', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('657', 'EN', 'Last found', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('658', 'EN', 'No watched geocaches.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('659', 'EN', 'Remind e-mail address', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('660', 'EN', 'E-mail address reminder', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('661', 'EN', 'Enter your username and we will send a reminder e-mail to your e-mail address.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('662', 'EN', 'Enter an username.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('663', 'EN', 'Username does not exist.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('664', 'EN', 'The reminder e-mail has been sent.\r\n', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('665', 'EN', 'Reminder to your e-mail address', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('666', 'EN', 'Your login e-mail address:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('667', 'EN', 'you requested a reminder e-mail on %1 .', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('668', 'EN', 'Cache recommendations', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('669', 'EN', 'Users that recommended %1 by %2 also recommended the following geocaches:', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('670', 'EN', 'Quota', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('671', 'EN', 'No recommendations found.', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('672', 'EN', 'Database maintenance', '2010-08-28 11:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('673', 'EN', 'DB maintenance', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('674', 'EN', '%1 corrected %2 entries ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'EN', 'Execute', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'EN', 'Send', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'EN', 'E-mail from', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('678', 'EN', 'Sorry, the requested user account is deactivated.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('679', 'EN', 'Sorry, there is no e-mail address for this user.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('680', 'EN', 'An unkown error occurred and the e-mail was not sent.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('681', 'EN', '\'%1\' contacted you via %2 The user profile: %2viewprofile.php?userid=%3 To answer this e-mail use the e-mail link at the user\'s profile.\r\n', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'EN', 'Subject:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('683', 'EN', 'All information will be handled confidential and will not be disclosed to third parties!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('684', 'EN', '\'%1\' with e-mail address %2 contacted you via %3 The user profile: %3viewprofile.php?userid=%4 Use the reply button of your e-mail client to answer this mail.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('685', 'EN', 'E-mail to %1 has been sent.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'EN', 'Content:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('687', 'EN', 'Send E-Mail to %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('688', 'EN', 'You have to enter a subject!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('689', 'EN', 'You have to enter a content!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('690', 'EN', 'Send my e-mail address with this message', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('691', 'EN', 'This enables the receiver to answer your e-mail directly using his e-mail client.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('692', 'EN', 'To protect you and us from abuse:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('693', 'EN', 'Only e-mails concerning geocaching are allowed. Spamming is prohibited!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('694', 'EN', 'All relevant information will be logged (date/time, sender/receiver and IP address).', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('696', 'EN', 'Sorry, this geocache is not published.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'EN', 'Show all log entries', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'EN', 'Show geocache', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'EN', 'You are already logged in.<br /> Please <a href=\"login.php?action=logout\">logout</a> first to login again.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'EN', 'By downloading this file, you accept our <a href=\"articles.php?page=impressum#tos\">terms of use</a>.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'EN', 'Difficulty: %1 of 5', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('702', 'EN', 'Terrain: %1 of 5', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('703', 'EN', 'List of attendees', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'EN', 'Log this cache', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('705', 'EN', 'Don\'t watch', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'EN', 'Watch', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('707', 'EN', 'Don\'t ignore', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'EN', 'Ignore', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'EN', 'Print', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'EN', 'Convert coordinates', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'EN', 'Size', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'EN', 'Time required', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'EN', 'Distance', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'EN', 'Hidden on', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'EN', 'Listed since', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'EN', 'Last update', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'EN', 'Waypoint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'EN', 'Also listed at', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'EN', 'Notes', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'EN', 'Watched', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'EN', 'Ignored', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'EN', 'Page visits', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'EN', 'Cache attributes', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'EN', 'Additional hint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'EN', 'Decrypt', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'EN', 'Pictures', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'EN', 'Utilities', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('729', 'EN', 'Show cache recommendations from users that recommended this geocache: <a href=\"recommendations.php?cacheid=%1\">all</a>', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'EN', 'Search geocaches nearby:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'EN', 'all', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'EN', 'searchable', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'EN', 'Download as file:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'EN', 'GPS Exchange Format .gpx', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('735', 'EN', 'Waypoint file .loc', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'EN', 'Google Earth .kml', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('737', 'EN', 'TomTom POI .ov2', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('738', 'EN', 'TOP50 Overlay .ovl', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'EN', 'Text file .txt', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'EN', 'C O P Y', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('741', 'EN', 'Edit picture', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('742', 'EN', 'Sorry, the requested picture does not exist.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('743', 'EN', 'Sorry, the requested cachelog does not exist.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('744', 'EN', 'Show statistics', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('745', 'EN', 'Age', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('746', 'EN', 'Description', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('747', 'EN', 'Location', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('748', 'EN', 'MiniMap-Zoom', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('749', 'EN', 'Report this cache', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('750', 'EN', 'Reported caches', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('751', 'EN', 'File:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('752', 'EN', 'Please name the picture!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('753', 'EN', 'Add picture for geocache %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('754', 'EN', 'Add picture for log entry %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('755', 'EN', 'Edit picture for geocache %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('756', 'EN', 'Edit picture for log entry %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'EN', 'Name:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('758', 'EN', 'Name the picture!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('759', 'EN', 'After clicking <i>upload</i>, it may take a while until the next page appears.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('760', 'EN', 'This picture is a spoiler - don\'t show a thumbnail.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('761', 'EN', 'Upload', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('762', 'EN', 'Only the following picture formats are allowed: BMP, GIF, PNG and JPEG. We recommend JPEG for photos.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('763', 'EN', 'The file size of the picture must not exeed 150 KB. We recommend 480x360 pixels picture size.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('764', 'EN', 'Report for %1 has been submitted.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('765', 'EN', 'Reason:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('766', 'EN', 'Comment:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('767', 'EN', 'Report %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('768', 'EN', 'You have to select a reason for your report!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('769', 'EN', 'Comment: (required)', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('770', 'EN', 'It is required to enter a comment for reporting a cache!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('771', 'EN', 'An unknown error occurred. Reporting failed.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('772', 'EN', 'Report cache', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('773', 'EN', 'New', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('774', 'EN', 'In progress', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('775', 'EN', 'Done', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('776', 'EN', 'Cache on private property', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('777', 'EN', 'Copyright violation', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('778', 'EN', 'Cache is gone', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('779', 'EN', 'Other reason', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('780', 'EN', 'This report is already assigned to another admin! It must be at least two weeks old before you can assume it.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('781', 'EN', 'This report is already assigned to you! ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('782', 'EN', 'You cannot work on this report, it is already assigned to another admin!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('783', 'EN', 'To work on a report you have to assign it to you!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('784', 'EN', 'No reported caches', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('785', 'EN', 'Details for report of ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('786', 'EN', ' by ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('787', 'EN', 'not assigned', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('788', 'EN', 'Assign to me', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('789', 'EN', 'Contact owner', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('792', 'EN', 'Mark as done', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('793', 'EN', 'Action', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('794', 'EN', 'Prior to reporting a cache to the Opencaching team, you should try to contact the owner and try to solve the presumed problems yourself. This does not apply for caches violating the Opencaching terms of use in a way that requires immediate action of an Opencaching administrator.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('795', 'EN', 'Do not display this picture (which is only used in HTML description etc.)', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('796', 'EN', 'No information on user details found.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('797', 'EN', 'Coordinates', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('798', 'EN', 'Geokrets', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('799', 'EN', 'My details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('800', 'EN', 'Edit details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('801', 'EN', 'User details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('802', 'EN', 'My profile details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('803', 'EN', 'The following detailed information is stored in your user profile:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('804', 'EN', 'Unchecked entries are not visible to other users.<br /> Entries without checkbox are only used for internal purposes and will never show up in your public profile.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('805', 'EN', 'Error while saving.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('806', 'EN', 'Illegal characters found in', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('807', 'EN', 'Field values too long in', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('808', 'EN', 'Original values have been restored.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('809', 'EN', 'visible', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('810', 'EN', 'invisible', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('811', 'EN', 'internal', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('812', 'EN', '(*) New reports', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('814', 'EN', 'User statistics', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('815', 'EN', 'show', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('816', 'EN', 'This user has not found any caches yet.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('817', 'EN', 'This geocache has been locked by an administrator because it did not comply with the Opencaching terms of use. If you wish to unlock it, contact us using the \"report cache\" link. Please choose \"other\" as reason and explain briefly what you have changed to make the listing compliant with our terms of use. Thank you!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('818', 'EN', 'doc/sql/static-data/data.sql has been changed with last CVS checkout.<br /> Before you edit translastions, update database from data.sql!<br /> \&nbsp;', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('819', 'EN', 'Sorry, this geocache is locked and cannot be viewed.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('821', 'EN', 'Locked, visible', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('822', 'EN', 'Locked, invisible', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('823', 'EN', 'Last modified:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('826', 'EN', '=== Please select ===', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('827', 'EN', 'Adoptions', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('828', 'EN', 'Date', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('829', 'EN', 'Yes, I have read and will comply with the Opencaching.de <a href=\"articles.php?page=impressum#tos\">terms of use</a>.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('830', 'EN', 'To complete the adoption, you have to submit this form.<br /> By submitting this form, you will become the responsible owner of this geocache.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('831', 'EN', 'on %2, %1 offered this geocache to you for adoption ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('832', 'EN', 'Thank you for adopting %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('833', 'EN', 'Commit the adoption of %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('834', 'EN', 'There are no caches that can be adopted by you at the moment.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('835', 'EN', 'Adopt now', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('836', 'EN', 'Geocaches which are offered to you for adoption', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('837', 'EN', 'Yes, I have read and understand the above and agree with it. \r\n', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('838', 'EN', 'When you have found a user who wants to adopt your geocache, fill in the username here and submit. The user will see this geocache in My Profile \&gt; Adoptions. To complete the adoption, the user has to accept our terms of use and commit the adoption. You may offer this geocache to more than one user. The first user committing the adoption will become the new owner of this cache. With the adoption, you will grant to the committing user an unlimited right to use, modifiy, publish and sublicense content of this geocache.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('839', 'EN', 'Offer %1 for adoption', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('840', 'EN', 'You have not invited any users to adopt this cache.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('841', 'EN', 'Reject adoption', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('842', 'EN', 'List of users you offered %1 for adoption', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('843', 'EN', 'Username unknown', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('844', 'EN', 'You cannot adopt your own cache!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('845', 'EN', 'Sorry, you have to read and accept the above to proceed!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('846', 'EN', 'Sorry, you have to read and accept the terms of use to proceed!', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('847', 'EN', 'This rules ensures that your password cannot be guessed by an automated script.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('848', 'EN', 'a-z A-Z 0-9 and .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~#', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('849', 'EN', 'Not all special characters are allowed. You may only use', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('850', 'EN', 'Do not use dictionary words like \'master\'', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('851', 'EN', 'Do not use common geocaching words', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('852', 'EN', 'Do not use parts of your username, real name or e-mail address.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'EN', 'Between 6 and 60 characters long', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('854', 'EN', 'Please verify that your password matches the following criteria:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('855', 'EN', 'Your password did not pass our security check.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'EN', 'Montenegro', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'EN', 'Serbia', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('858', 'EN', '* If the user explicitly logged out after his last visit or more than<br /> 90 days have passed since last login, the last login cannot be determined. ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('859', 'EN', 'Manage users', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('860', 'EN', 'Sure?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('861', 'EN', 'Disable (and lock all geocaches owned)', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('862', 'EN', 'Unknown', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('863', 'EN', 'Last known login:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('864', 'EN', 'Active geocaches:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('865', 'EN', 'Total hidden:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('866', 'EN', 'Log entries:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('867', 'EN', 'User active:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('868', 'EN', 'Date created:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('869', 'EN', 'View user account details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('870', 'EN', 'User account details', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('871', 'EN', 'E-mail:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('872', 'EN', 'Waypoint download', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('873', 'EN', 'News entries', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('874', 'EN', 'Hide', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('875', 'EN', 'Terrain', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('876', 'EN', 'Difficulty', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('877', 'EN', 'Send this waypoint to GPS device:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('882', 'EN', 'Current top ratings', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('884', 'EN', '%1 recommendations within the last 30 days ', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('885', 'EN', 'You can find more recommendations \&gt;<a href=\"tops.php\">here</a>\&lt;.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('886', 'EN', 'Caches not found', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('887', 'EN', 'Last&nbsp;login', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('888', 'EN', 'Within the last month', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('889', 'EN', 'Between 1 and 6 months', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('890', 'EN', 'Between 6 and 12 months', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('891', 'EN', 'More than 12 months ago', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('892', 'EN', 'The user account has been disabled.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('893', 'EN', 'A new activation mail has been sent.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('894', 'EN', 'of', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('895', 'EN', 'Show in Google Maps', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('896', 'EN', '(in GM)', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('897', 'EN', 'This user has not hidden any caches yet. \r\n', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('898', 'EN', 'Geocaching.de', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('899', 'EN', 'Google Maps', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'EN', 'Donations', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('901', 'EN', 'Logtype', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('902', 'EN', 'Text', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('903', 'EN', 'Recommend this cache?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('904', 'EN', '(only if you have unused ratings)', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('905', 'EN', 'OC waypoint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'EN', 'Terms of use', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('907', 'EN', 'Our team', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('914', 'EN', 'Nature reserve', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('915', 'EN', 'Scan complete', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('916', 'EN', 'Current file:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('921', 'EN', 'Info', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'EN', 'EN', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('923', 'EN', 'The compilation of the template failed. This should be a temporary failure. Please try again in some minutes.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('933', 'EN', 'Scan source codes', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('954', 'EN', 'Default', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('957', 'EN', 'Chat/IRC', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1059', 'EN', 'An account with that username already exists.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1060', 'EN', 'Opencaching-Wiki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1061', 'EN', 'Terms of use and legal information', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1062', 'EN', 'Page performance', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1063', 'EN', 'Page creation', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1097', 'EN', 'D/T', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1100', 'EN', '.gpx', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1123', 'EN', 'Cachename', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1141', 'EN', 'N', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1142', 'EN', 'S', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1143', 'EN', 'E', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1144', 'EN', 'W', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1146', 'EN', 'Kilometer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1164', 'EN', 'Some more items found...', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1165', 'EN', 'Search for city, cache or waypoint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1166', 'EN', 'Show link to this map', '2010-08-29 23:43:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1206', 'EN', 'km', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1208', 'EN', 'h', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1212', 'EN', 'Page:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'EN', 'map', '2010-09-02 00:15:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1272', 'EN', 'show fullscreen', '2010-09-02 00:15:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'EN', 'main menu', '2010-09-02 00:15:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1278', 'EN', 'Editor', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1279', 'EN', '\&lt;html\&gt;', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1292', 'EN', 'Setting smilies is not supported', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1296', 'EN', 'Only the following picture formats are allowed: BMP, GIF, PNG and JPEG.', '2010-08-28 11:50:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1297', 'EN', 'am', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1298', 'EN', 'The following list is generated automatically by the given recommendations of the users. You can find more informations on regional classification in the <a href=\"http://wiki.opencaching.de/index.php/Empfehlungen\" target=\"_blank\">Wiki</a>.<br /> <br /> The numbers in the list below means:<br /> <img src=\"images/rating-star.gif\" border=\"0\" alt=\"Recommendations\"> Number of users that recommend this cache<br /> <img src=\"resource2/%1/images/log/16x16-found.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"Found\"> Checks = Number of time the cache was found<br /> Index tries to take the number of recommendations and founds in an order to show \'the best\' geocache first.<br /> <img src=\"images/tops-formula.png\" border=\"0\" alt=\"Formula\">', '2010-08-29 22:49:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1299', 'EN', 'File upload failed!', '2010-08-29 22:50:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1300', 'EN', 'XML file could not be loaded!', '2010-08-29 22:50:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1301', 'EN', 'SQL Export', '2010-08-29 23:28:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1302', 'EN', 'XML Download', '2010-08-29 23:29:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1303', 'EN', 'XML Import', '2010-08-29 23:29:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1304', 'EN', 'XML file containing the translations:', '2010-08-29 23:30:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1305', 'EN', 'Check the following languages in the XML file:', '2010-08-29 23:31:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1306', 'EN', 'Scan file', '2010-08-29 23:32:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1307', 'EN', 'Source code changed, text no longer used', '2010-08-29 23:32:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1308', 'EN', 'New translation', '2010-08-29 23:32:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1309', 'EN', 'Modified translation', '2010-08-29 23:33:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1310', 'EN', 'old', '2010-08-29 23:33:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1311', 'EN', 'Toggle all', '2010-08-29 23:33:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1312', 'EN', 'Commit', '2010-08-29 23:27:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1315', 'EN', 'Date:', '2010-09-10 23:33:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1316', 'EN', 'Log-entry:', '2010-09-10 23:56:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1317', 'EN', 'Passwort to log:', '2010-09-10 23:57:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1319', 'EN', 'Invalid password!', '2010-09-11 00:06:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1320', 'EN', '(only for found logs)', '2010-09-11 00:07:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1321', 'EN', 'Only listed here!', '2010-09-11 00:07:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1322', 'EN', 'New log-entry', '2010-09-11 00:07:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1323', 'EN', 'Type of log-entry', '2010-09-11 00:06:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1326', 'EN', 'Recommendations:', '2010-09-11 00:06:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1327', 'EN', 'A recommendation can only be made within a \"found\"-log!', '2010-09-11 00:05:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1328', 'EN', 'This cache is one of my recommendations.', '2010-09-11 00:05:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1329', 'EN', 'Alternatively, you can withdraw a <a href=\"mytop5.php\">existing recommendation</a>.', '2010-09-11 00:05:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1330', 'EN', 'You have given {curr} of {max} possible recommendations.', '2010-09-11 00:05:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1331', 'EN', 'Dangers', '2010-09-10 23:58:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'EN', 'Infrastructure', '2010-09-11 00:05:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1333', 'EN', 'Waypoints', '2010-09-11 00:05:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1334', 'EN', 'Common', '2010-09-11 00:05:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1335', 'EN', 'Time', '2010-09-11 00:04:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1336', 'EN', 'Seasonal', '2010-09-11 00:04:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1337', 'EN', 'System', '2010-09-11 00:03:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1338', 'EN', 'Tools needed', '2010-09-11 00:03:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1339', 'EN', 'Preparation needed', '2010-09-11 00:03:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1340', 'EN', 'Persons', '2010-09-11 00:03:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1341', 'EN', 'Transportation', '2010-09-11 00:03:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1342', 'EN', 'Properties', '2010-09-11 00:02:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1343', 'EN', 'Restrictions / Preconditions', '2010-09-11 00:02:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1344', 'EN', 'Recommendations / Prohibitions', '2010-09-11 00:02:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1345', 'EN', 'Only loggable at Opencaching', '2010-09-11 00:02:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1346', 'EN', 'Time and effort (optional):', '2010-09-11 00:02:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1347', 'EN', 'Of course, this effort can only be estimated and can vary depending on enviromental influences. If you cannot make sufficiently detailed information, fill both fields up with a O (zero)', '2010-09-11 00:02:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1348', 'EN', 'Waypoints (optional):', '2010-09-11 00:02:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1349', 'EN', 'This waypoints will be used to show links in the view cache and the log page.', '2010-09-11 00:01:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1350', 'EN', 'No data will be imported automatically from these listing services.', '2010-09-11 00:00:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1351', 'EN', 'Descriptions', '2010-09-11 00:00:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1352', 'EN', 'Add an additional description', '2010-09-11 00:00:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1353', 'EN', 'Your description contains at least one link to a picture hosted on geocaching.com!', '2010-09-11 00:00:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1354', 'EN', 'To prevent any problems with geocaching.com we want to please you to upload all linked pictures to opencaching.de as well and link the pictures in the HTML code to these on opencaching.de', '2010-09-11 00:00:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1355', 'EN', 'Upload a picture', '2010-09-10 23:59:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1356', 'EN', 'Listed since:', '2010-09-10 23:59:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1357', 'EN', 'This cache is yours', '2010-09-10 23:57:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1358', 'EN', 'You found this cache', '2010-09-10 23:59:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1359', 'EN', 'You havn\'t found this cache, yet', '2010-09-10 23:59:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1360', 'EN', 'This cache stores a GeoKrety', '2010-09-10 23:58:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1361', 'EN', 'This cache has %1 recommandations', '2010-09-10 23:58:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1362', 'EN', 'Edit log entry for the cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-10 23:58:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1363', 'EN', 'Type of log-enrty', '2010-09-10 23:57:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1364', 'EN', 'JavaScript is disabled in your browser, you can enter text only. To use HTML, or the editor, please enable JavaScript.', '2010-09-10 23:57:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1365', 'EN', 'New cache', '2010-09-10 23:57:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1366', 'EN', 'Owner:', '2010-09-10 23:56:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1367', 'EN', 'Cache type:', '2010-09-10 23:55:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'EN', 'Size:', '2010-09-10 23:55:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'EN', 'Coordinates:', '2010-09-10 23:55:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1370', 'EN', 'Rating:', '2010-09-10 23:55:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1371', 'EN', 'Difficulty:', '2010-09-10 23:54:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1372', 'EN', 'Terrain:', '2010-09-10 23:54:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1373', 'EN', 'Time effort:', '2010-09-10 23:54:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1374', 'EN', 'Notice', '2010-09-10 23:54:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1375', 'EN', 'Create a new description', '2010-09-10 23:54:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1376', 'EN', 'Hidden since:', '2010-09-10 23:53:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1377', 'EN', '(leave blank for no password)', '2010-09-10 23:53:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1378', 'EN', 'Please note the <a href=\"articles.php?page=cacheinfo#logpw\" target=\"_blank\">description</a>', '2010-09-10 23:53:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1379', 'EN', 'Less', '2010-09-10 23:52:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1380', 'EN', 'Search for caches', '2010-09-10 23:52:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1381', 'EN', 'JavaScrupt is not activated, you cannot use the following options - basic search is supported nevertheless.', '2010-09-10 23:52:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1382', 'EN', 'Sorting of result:', '2010-09-10 23:52:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1383', 'EN', 'Last logs', '2010-09-10 23:52:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1384', 'EN', 'Show recommendation from other users first', '2010-09-10 23:51:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1385', 'EN', 'Distance can only be used if you are signed in and entered your home coordinates.<br />For the search by distance the entered coordinates are used to calculate the distance.', '2010-09-10 23:51:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1386', 'EN', 'Hide following caches:', '2010-09-10 23:51:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1387', 'EN', 'My owned', '2010-09-10 23:51:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1388', 'EN', 'My finds', '2010-09-10 23:51:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1389', 'EN', 'My ignored', '2010-09-10 23:51:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1390', 'EN', 'Only usable if signed in.', '2010-09-10 23:51:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1391', 'EN', 'Inactive', '2010-09-10 23:50:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1392', 'EN', 'Cache attributes:', '2010-09-10 23:50:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1393', 'EN', 'Search by distance', '2010-09-10 23:50:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1394', 'EN', 'Of coordinates:', '2010-09-10 23:50:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1395', 'EN', 'Maximum distance:', '2010-09-10 23:50:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1396', 'EN', 'Miles', '2010-09-10 23:50:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1397', 'EN', 'Seamiles', '2010-09-10 23:49:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1398', 'EN', 'Search for city', '2010-09-10 23:49:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1399', 'EN', 'Postal code:', '2010-09-10 23:49:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1400', 'EN', 'City:', '2010-09-10 23:47:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1401', 'EN', 'Search for text', '2010-09-10 23:49:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1402', 'EN', 'Search for owner', '2010-09-10 23:49:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1403', 'EN', 'Search for logs', '2010-09-10 23:49:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1404', 'EN', 'Logtype:', '2010-09-10 23:48:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1405', 'EN', 'Error while loading the page', '2010-09-10 23:48:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1406', 'EN', 'In an attempt to create the page, an error has occurred. If you pass through a hyperlink on our side and the problem persists do not hesitate to contact us by email.', '2010-09-10 23:48:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1407', 'EN', 'The following error occurred:', '2010-09-10 23:48:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1408', 'EN', 'Page:', '2010-09-10 23:48:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1409', 'EN', 'Error message:', '2010-09-10 23:47:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1411', 'EN', 'Are you sure that this log entry shall be removed?', '2010-09-10 23:47:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1412', 'EN', 'do you want to send {log_user_name} a note? ', '2010-09-10 23:46:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1413', 'EN', 'Remove log entry', '2010-09-10 23:46:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1414', 'EN', 'Date is invalid', '2012-08-26 09:10:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1415', 'EN', '(only for found logs)', '2010-09-10 23:44:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1416', 'EN', 'Submit a new cache', '2010-09-10 23:44:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1417', 'EN', 'If this is your first cache on Opencaching.de, be sure to check out the <a href=\"articles.php?page=cacheinfo\">description</a> of the individual fields.', '2010-09-10 23:46:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1418', 'EN', 'Distance', '2010-09-10 23:32:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1419', 'EN', 'The effort is of course only be estimated and can vary depending on environmental influences. If you can not make sufficiently detailed information, write 0 (zero) in both fields. (See also: <a href=\"articles.php?page=cacheinfo#time\" target=\"_blank\">description</a>)', '2010-09-10 23:46:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1420', 'EN', 'Language:', '2010-09-10 23:45:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1421', 'EN', 'You can add more descriptions in other languages publishing the cache.', '2010-09-10 23:44:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1422', 'EN', 'Short description:', '2010-09-10 23:44:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1423', 'EN', 'Description:', '2010-09-10 23:43:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1425', 'EN', 'Additional note:', '2010-09-10 23:42:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1426', 'EN', 'You can add additional pictures after creating the cache.', '2010-09-10 23:42:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1427', 'EN', 'Publication:', '2010-09-10 23:40:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1428', 'EN', 'Publish now', '2010-09-10 23:40:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1429', 'EN', 'Publish on', '2010-09-10 23:40:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1430', 'EN', 'Do not publish now.', '2010-09-10 23:40:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1431', 'EN', 'I have read and agree to the <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de Terms of Service</a> and <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Opencaching.de Data license</a>.', '2010-09-10 23:39:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1432', 'EN', 'Info: Your log entry has been removed from the cache owner', '2010-09-10 23:39:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1433', 'EN', 'Selection of city', '2010-09-10 23:39:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1434', 'EN', 'Total of {resultscount} cities matched', '2010-09-10 23:38:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1435', 'EN', 'For the search criterion no clear result was found. Please choose the correct location.', '2010-09-10 23:38:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1436', 'EN', 'Add log-entry for the cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-10 23:38:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1437', 'EN', 'Cachename is invalid', '2010-09-10 23:34:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1438', 'EN', 'The used coordinates are invalid.', '2010-09-10 23:38:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1439', 'EN', 'The entered time is invalid.', '2010-09-10 23:37:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1440', 'EN', 'The distance you have entered is invalid. Format aa.aaa', '2010-09-10 23:37:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1441', 'EN', 'The cache-status does not fit to your publishing options', '2010-09-10 23:34:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1442', 'EN', 'Choose both valuations!', '2010-09-10 23:33:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1443', 'EN', 'No pictures available', '2010-09-10 23:32:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1444', 'EN', '{results_count} caches matched.', '2010-09-10 23:33:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1445', 'EN', 'Result {startatp1} to {endat} (as zip):', '2010-09-10 23:33:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1446', 'EN', 'This description was created on another Opencaching-webserver and can only be deleted there.', '2010-09-10 23:31:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1447', 'EN', 'The cache description has been deleted', '2010-09-10 23:31:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1448', 'EN', 'Delete this cache description', '2010-09-10 23:31:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1450', 'EN', 'Your HTML code will be changed again by a special filter. This is nacessary to avoid dangerous HTML-tags, such as \&lt;script\&gt;. A list of allowed HTML tags can be find <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">here</a>.', '2010-09-10 23:29:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1451', 'EN', 'Please do not use any images that are hosted on geocaching.com. Upload your fotos instead on our server as well.', '2010-09-10 23:28:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1452', 'EN', 'Encrypted note:', '2010-09-10 23:28:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1453', 'EN', 'Do you really want to delete the description of your cache \&quot;{cachename}\&quot;', '2010-09-10 23:26:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1454', 'EN', 'Yes, delete cache description', '2010-09-10 23:26:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1455', 'EN', 'Submit cache', '2010-09-10 23:26:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1456', 'EN', 'Format: DD-MM-YYYY', '2010-09-10 23:26:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1457', 'EN', 'Some errors occured, please check the marked fields.', '2010-09-10 23:27:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1458', 'EN', 'Your entered coordinates are invalid', '2010-09-10 23:19:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1459', 'EN', 'The entered distance is invalid, Format: aa.aaa', '2010-09-10 23:24:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1460', 'EN', 'Invalid date, format:TT-MM-JJJJ', '2010-09-10 23:20:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1461', 'EN', 'The cache can only be adopted if you agree our terms of use.', '2010-09-10 23:19:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1462', 'EN', 'This HTML-code is invalid. To find out the exact cause of the error, you should use the <a href=\"htmlprev.php\" target=\"_blank\">HTML preview</a>.', '2010-09-10 23:26:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1463', 'EN', 'No cache-type is chosen.', '2010-09-10 23:18:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1464', 'EN', 'No cache-size is chosen.', '2010-09-10 23:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1465', 'EN', 'This HTML-Code is invalid.', '2010-09-10 23:17:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1466', 'EN', 'Your cache is successfully added to the database. You will be redirected to the cache page, now.', '2010-09-10 23:17:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1467', 'EN', 'Select', '2010-09-10 23:17:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1468', 'EN', '(internal error) The description is not available.', '2010-09-10 23:17:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1469', 'EN', '(internal error) There already exists a description for this language.', '2010-09-10 23:17:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1471', 'EN', 'There already exists a description in this languag', '2010-09-10 23:16:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1473', 'EN', 'Are you sure to remove your log entry?', '2010-09-10 23:15:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1475', 'EN', 'A database command could not be performed.', '2010-09-11 02:46:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1476', 'EN', 'Edit cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2010-09-11 02:36:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1477', 'EN', 'offer for adoption', '2010-09-11 02:34:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1478', 'EN', 'Status:', '2010-09-11 02:33:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1479', 'EN', 'Waypoint search', '2010-09-11 02:35:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1480', 'EN', 'Country sites', '2010-09-11 02:46:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1482', 'EN', 'Waypoints:', '2010-09-11 02:33:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1483', 'EN', '\&nbsp;', '2010-09-11 02:46:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1486', 'EN', 'If your browser does not support automatic forwarding please click here.', '2010-09-11 02:34:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1489', 'EN', 'EN', '2010-09-11 02:33:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'EN', 'Password', '2010-09-11 02:33:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1491', 'EN', 'edit cache description for <a href=\"viewcache.php?cacheid={cacheid}\";> cache (name) </a;>', '2010-09-11 02:32:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1494', 'EN', 'Add', '2010-09-11 02:33:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1495', 'EN', 'Enter a name, please!', '2010-09-11 02:32:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1496', 'EN', 'Fill out the text field, please!', '2010-09-11 02:32:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1497', 'EN', 'You have to check at least one field!', '2010-09-11 02:32:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1498', 'EN', 'Longitude has to be a number!\\nFormat: hh° mm.mmm', '2010-09-11 02:32:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1499', 'EN', 'Latitude has to be a number!\\nFormat: hh° mm.mmm', '2010-09-11 02:32:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1500', 'EN', 'The maximum distance has to be a number!', '2010-09-11 02:32:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1501', 'EN', 'The distance has to be between 0 and 9999', '2010-09-11 02:32:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1502', 'EN', 'Enter the postal code, please!', '2010-09-11 02:32:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1503', 'EN', 'Enter the city, please!', '2010-09-11 02:32:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1504', 'EN', 'Enter the owner, please!', '2010-09-11 02:31:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1505', 'EN', 'Enter the username, please!', '2010-09-11 02:31:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1506', 'EN', 'multiple listings (waypoint is also set on gc.com or nc.com)', '2010-09-11 02:31:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1507', 'EN', 'The selected output format is unknown!', '2010-09-11 02:31:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1508', 'EN', 'The search operation could not be executed, please reenter the search data.', '2010-09-11 02:31:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1509', 'EN', 'Find', '2010-09-11 02:31:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1511', 'EN', 'No rating', '2010-09-11 02:30:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1512', 'EN', 'The postal code could not be found', '2010-09-11 02:30:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1513', 'EN', 'There does no city exist with this name', '2010-09-11 02:30:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1514', 'EN', 'There are no Koordinates available for the selected city', '2010-09-11 02:31:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1515', 'EN', 'The entered city is not valid.', '2010-09-11 02:31:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1516', 'EN', 'The entered text is invalid.', '2010-09-11 02:30:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1517', 'EN', 'The entered text contains more than 50 words.', '2010-09-11 02:45:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1518', 'EN', 'All countries', '2010-09-11 02:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1519', 'EN', 'All cachetypes', '2010-09-11 02:29:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1520', 'EN', 'Search result', '2010-09-11 02:29:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1521', 'EN', 'Dieser Cache wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:14:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1522', 'EN', 'Save options', '2010-09-11 02:45:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1523', 'EN', 'Edit options', '2010-09-11 02:45:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1524', 'EN', 'Type', '2010-09-11 02:28:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1525', 'EN', 'Last logs', '2010-09-11 02:29:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1526', 'EN', 'Downloads', '2010-09-11 02:45:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1527', 'EN', 'Results on this page:', '2010-09-11 02:27:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1528', 'EN', 'Download for local application', '2010-09-11 02:27:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1529', 'EN', 'With the download you accept the <a href=\"articles.php?page=impressum#tos\">terms of use</a> from opencaching.de.\&nbsp;\&nbsp;', '2010-09-11 02:27:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1530', 'EN', 'Dieser Logeintrag wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:18:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1531', 'EN', 'Diese Beschreibung wurde auf einem anderen Opencaching-Webserver erstellt und kann nur auf diesem bearbeitet werden.', '2010-09-11 02:18:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1532', 'EN', 'The owner of the has written you the following comment:', '2010-09-11 02:23:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1533', 'EN', 'For virtual and webcam caches, the cache size has to be -no container-!', '2010-09-11 02:45:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1537', 'EN', 'Your HTML code will be changed again by a special filter. This is nacessary to avoid dangerous HTML-tags, such as \&lt;script\&gt;. A list of allowed HTML tags can be find <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">here</a>.', '2010-09-11 02:56:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1538', 'EN', 'Language:', '2010-09-11 02:57:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1539', 'EN', 'Didn\'t find', '2010-09-12 22:28:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1541', 'EN', 'Only at night', '2010-09-12 22:54:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1542', 'EN', 'Hyperlink to another caching portal only', '2010-09-12 22:54:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1543', 'EN', 'Letterbox (needs stamp)', '2010-09-12 22:55:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1544', 'EN', 'Dangerous area', '2010-09-12 22:55:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1545', 'EN', 'This geocache can be found at night only - it is a so-called <i>night cache</i>. There may be reflectors which have to be flashlighted and will point to the hiding place, or other special night-caching mechanisms.', '2010-09-12 22:54:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1546', 'EN', 'This geocache is listed at Opencaching only. This attribute will enable users of other geocaching platforms to find interesting OC caches quickly.', '2010-09-12 22:54:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1547', 'EN', 'This cache ist listed at Opencaching and at other geocaching sites. This applies to caches which have been linked by their owners to the corresponding listings at other sites. Please note that descriptions and status of multiple-listed caches have to be equally maintained at all sites including Opencaching, according to our terms of use. ', '2010-09-12 22:54:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1548', 'EN', 'There is a stamp in the cache for stamping your personal logbook, and the cache’s logbook will be stamped with your personal stamp. Take care not to mix up stamps and to leave the cache’s stamp in the cache! Frequently letterboxes can be found without GPS, maybe with a compass and paces from a location - add the \"without GPS\" attribute for those.', '2010-09-12 22:54:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1549', 'EN', 'The cache is located within a dangerous area. Use this attribute to mark non-obvious dangers, like high-traffic roads, steep ground or falling rocks. Security measures should be taken or the cache be omitted, especially when geocaching with children, large groups or at unfavourable weather conditions.', '2010-09-12 22:53:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1550', 'EN', 'Active railway nearby', '2010-09-12 23:13:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1551', 'EN', 'Cliff / Rocks', '2010-09-12 23:17:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1552', 'EN', 'Hunting', '2010-09-12 23:17:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1553', 'EN', 'Thorns', '2010-09-12 23:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1554', 'EN', 'Ticks', '2010-09-12 23:17:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1555', 'EN', 'Abandoned mines', '2010-09-12 23:17:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1556', 'EN', 'Poisonous plants', '2010-09-12 23:17:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1557', 'EN', 'Dangerous animals', '2010-09-12 23:16:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1558', 'EN', 'Parking area nearby', '2010-09-12 23:17:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1559', 'EN', 'Public transportation', '2010-09-12 23:17:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1560', 'EN', 'Drinking water nearby', '2010-09-12 23:16:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1561', 'EN', 'Public restrooms nearby', '2010-09-12 23:16:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1562', 'EN', 'Public phone nearby', '2010-09-12 23:16:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1563', 'EN', 'First aid available', '2010-09-12 23:16:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1564', 'EN', 'Near the parking area', '2010-09-12 23:16:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1565', 'EN', 'Long walk', '2010-09-12 23:16:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1566', 'EN', 'Swamp or marsh', '2010-09-12 23:16:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1567', 'EN', 'Hilly area', '2010-09-12 23:16:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1568', 'EN', 'Some climbing (no gear needed)', '2010-09-12 23:15:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1569', 'EN', 'Swimming required', '2010-09-12 23:15:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1570', 'EN', 'Point of interest', '2010-09-12 23:16:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1571', 'EN', 'Moving target', '2010-09-12 23:15:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1572', 'EN', 'Webcam ', '2010-09-12 23:15:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1573', 'EN', 'Wihin enclosed rooms (caves, buildings etc.)', '2010-09-12 23:16:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1575', 'EN', 'Without GPS (letterboxes, cistes, compass juggling ...)', '2010-09-12 23:15:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1576', 'EN', 'Access or parking fee', '2010-09-12 23:15:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1577', 'EN', 'Overnight stay necessary', '2010-09-12 23:15:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1578', 'EN', 'Available 24 hours', '2010-09-12 23:15:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1579', 'EN', 'Only available at specified times', '2010-09-12 23:16:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1580', 'EN', 'by day only', '2010-09-12 23:15:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1581', 'EN', 'Tide', '2010-09-12 23:15:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1582', 'EN', 'All seasons', '2010-09-12 23:14:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1583', 'EN', 'Breeding season / protected nature', '2010-09-12 23:15:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1584', 'EN', 'Snow-proof hiding place', '2010-09-12 23:14:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1585', 'EN', 'Special equipment', '2010-09-12 23:14:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'EN', 'Compass', '2010-09-12 23:14:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'EN', 'Flashlight', '2010-09-12 23:14:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'EN', 'Climbing gear', '2010-09-12 23:14:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'EN', 'Cave equipment', '2010-09-12 23:14:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1590', 'EN', 'Diving equipment', '2010-09-12 23:14:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'EN', 'Watercraft', '2010-09-12 23:14:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1592', 'EN', 'Aircraft', '2010-09-12 23:14:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1593', 'EN', 'Investigation', '2010-09-12 23:13:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'EN', 'Puzzle / Mystery', '2010-09-12 23:13:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'EN', 'Arithmetical problem', '2010-09-12 23:13:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1596', 'EN', 'Other cache type', '2010-09-12 23:13:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1597', 'EN', 'Ask owner for start conditions', '2010-09-12 23:13:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'EN', 'suited for children', '2010-09-12 23:13:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'EN', 'There are active railroads nearby. Please be careful, keep a safe distance and cross the rails only at level crossings etc.!', '2010-09-12 23:13:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1600', 'EN', 'There are cliffs or dangerous rocks nearby. Beware of falling rocks at the lower side, and be careful at the upper side of cliffs - especially with children and while mountain biking. It can be very dangerous to take a steep slope towards a cliff, because you may not notice in time where the former ends and the latter starts.', '2010-09-12 23:13:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'EN', 'The geocache is placed within a hunting ground. At twilight and in the dark, a flashlight or headlight should always be used for security reasons. Be considerate when meeting hunters.', '2010-09-12 23:13:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'EN', 'There are thorns near the cache. Wear appropriate clothes.', '2010-09-12 23:12:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'EN', 'There are seasonably many ticks in this area. It is recommended to wear long trousers and to check yourself for ticks after geocaching. There are risk maps for <i>tick-borne encephalitis</i> in the internet, e.g. for Germany at sites like www.meningitis.de (look for FSME there).', '2010-09-12 23:12:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1604', 'EN', 'In the water', '2010-09-12 23:19:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'EN', 'This cache can be done both at daylight and at night.', '2010-09-12 23:30:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1606', 'EN', 'This cache can be done at certain times of day - see the cache description for more details. For example, the cache may be placed in an area with restricted opening hours.', '2010-09-12 23:30:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1607', 'EN', 'This cache shoud be attempted during daylight only. For example, the area may be dangerous and contain cliffs or abysses. Or using flashlights may be unfeasable because it would look suspicious within a residential area.', '2010-09-12 23:30:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1608', 'EN', 'This cache can be done only at low-tide or only at high-tide.', '2010-09-12 23:30:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1609', 'EN', 'This cache can be found the whole year round, while difficulty may depend on seasons. Specify difficulty for <i>good</i> conditions.', '2010-09-12 23:30:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1610', 'EN', 'Don’t seek this cache during animal breeding season! Please indicate in the cache description which time of year must be avoided. Also, pay attention to the local terms and signs regarding nature protection.', '2010-09-12 23:30:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1611', 'EN', 'This cache can be found even after heavy snowing. All stages and the geocache are hidden in a snow-safe way: they will not be covered by fallen snow an not by snow-piles created by snow-clearing vehicles.', '2010-09-12 23:30:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1612', 'EN', 'You will need special equipment which is not specified by other attributes, e.g. a laser pointer, walkie-talkies or a car jack.', '2010-09-12 23:30:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'EN', 'A compass is required.', '2010-09-12 23:29:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'EN', 'A flashlight is required for finding this cache. Don’t forget spare batteries!', '2010-09-12 23:30:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'EN', 'For this cache, you will need climbing equipment and the knowledge how to use it properly. If you are a beginner, don’t do it alone but use the support of a experienced climber or mountaineer.', '2010-09-12 23:29:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'EN', 'This geocache is hidden in a cave, and you should use appropriate equipment to access it. Beware: Even small caves may confront you with unforeseen problems and dangers, like thunder storms (water!) or a sprained ankle. Have advice first from cave-experienced people! Also take care of protected nature; e.g. bat places must not be disturbed.', '2010-09-12 23:29:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1617', 'EN', 'You will need diving equipment to find this geocache. The water depth of the cache location is specified in the description. Please note that secure diving requires special training. Without diving experience, you may search this cache in company of a diving teacher.', '2010-09-12 23:29:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'EN', 'This cache usually can be found only using a watercraft. Swimming is impossible because of the distance or currents. See the cache description for more details.', '2010-09-12 23:29:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1619', 'EN', 'You must investigate additional information before you can seek this cache. This commonly applies to puzzle/mystery caches.', '2010-09-12 23:29:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1620', 'EN', 'Puzzles or mysteries have to be solved before or while seeking this cache.', '2010-09-12 23:29:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'EN', 'Before or while seeking this cache, arithmetical problems must be solved which go beyond very basic calculations.', '2010-09-12 23:29:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1622', 'EN', 'This is none of the standard, pre-defined types of cache. Use this attribute for special, unusual caches.', '2010-09-12 23:28:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1623', 'EN', 'Before doing this cache, you must ask the owner for the starting conditions. E.g. the cache may be linked to certain events at varying dates.', '2010-09-12 23:28:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1624', 'EN', 'This geocache is suitable for children. All challenges can be solved by child in the age of 10 to 12 years and the terrain has no risks (like highways, abysms). There is a large geocache container with trading items inside and the challanges are interesting.', '2010-09-12 23:28:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1625', 'EN', 'This cache leads into a (former) mining area. There may be dangers by collapsing adits, or you may need to enter adits. Be careful and use appropriate equipment, especially in the dark. Old mines may be covered by historic preservation.', '2010-09-12 23:43:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1626', 'EN', 'There are poisonous plants near the cache. Take care and prevent children and dogs from touching or eating them.', '2010-09-12 23:43:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1627', 'EN', 'The area is inhabited by possibly dangerous animals, e.g. rabies areas, venomous snakes, scorpions or bears.', '2010-09-12 23:43:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1628', 'EN', 'A nearby parking area is situated as starting point for doing this cache. If no free parking is available, add the \"access or parking fee\" attribute.', '2010-09-12 23:43:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1629', 'EN', 'This cache is located outside of urban areas and has a public transport station nearby. Don’t set this attribute for geocaches in urban areas that are commonly equipped with public transportation.', '2010-09-12 23:43:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1630', 'EN', 'There is drinking water along the trail or near the cache. This attribute is useful especially for planning event caches, longer hikes or caches at probably dirty locations like caves.', '2010-09-12 23:43:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1631', 'EN', 'There are public restrooms along the way or near the cache. This attribute is useful especially for planning event caches or extensive multicaches.', '2010-09-12 23:43:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1632', 'EN', 'There is a public phone along the way or near the cache. Especially for event caches you should enquire for nearby phones and set this attribute if applicable.', '2010-09-12 23:42:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1633', 'EN', 'There is a first aid station, call box, mountain rescue or similar arrangement near the cache. This attribute is useful especially in demanding areas, like climbing caches, cave caches, high mountains or at the water. Check if you can add emergency phone numbers (like a mountain rescue) to your cache listing.', '2010-09-12 23:42:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1634', 'EN', 'The geocache is located close to a parking area, only a few steps away - it’s a \"cache and dash\".', '2010-09-12 23:42:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1635', 'EN', 'This cache requires a long walk - more than 5 km round trip. In the mountains and other steep areas, the distance for a \"long walk\" may be shorter. Walking shoes and appropriate equipment are recommended.', '2010-09-12 23:42:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1636', 'EN', 'This cache requires passing swampy or marshy ground. Wear appropriate clothes. After rainfall, the terrain may be very demanding or not passable at all.', '2010-09-12 23:42:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1637', 'EN', 'One or more ascents lie between you and the cache.', '2010-09-12 23:42:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1638', 'EN', 'This cache requires some climbing and you may have to use your hands, but you won’t need climbing gear. Be very careful during rainy weather or before thunderstorms!', '2010-09-12 23:41:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1639', 'EN', 'This cache requires crossing a river or a lake. The water is steep ', '2010-09-12 23:42:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1640', 'EN', 'There is a point of interest at the cache, like a nice scenic overlook or a larger castle ruin. This place is worth visiting it even without a geocache nearby.', '2010-09-12 23:42:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1641', 'EN', 'This geocache is moving around. For example, the owner might regularly move the cache from one place to another, or the finders will do this task and post new coordinates in their log entries. The owner must update coordinates in the cache description after each move.', '2010-09-12 23:41:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1642', 'EN', 'There is a webcam at the target location. You must record a webcam picture of your visit and include it in your \"found\" log entry. There may be additional requirements like a geocaching banner on the photo. The webcam’s address is included in the cache description, and it must be publicly accessible, i.e. no user account or similar is required.', '2010-09-12 23:41:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1643', 'EN', 'This geocache is not hidden in the open air, but within a building, a cave or similar.', '2010-09-12 23:41:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1644', 'EN', 'This cache or one of the stages is placed underwater. You will have to enter the water, swim or dive.', '2010-09-12 23:41:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1645', 'EN', 'This cache can be found without a GPS device. No additional coordinates are used besides of the starting coordinates.', '2010-09-12 23:41:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1646', 'EN', 'You must pay an access or parking fee to access this cache, e.g. if the cache is located within a theme park. If there are alternative free parking areas nearby, please include them in the cache description. Please note our current terms of use regarding \"commercial geocaches\".', '2010-09-12 23:41:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1647', 'EN', 'This cache cannot be done within a single day or a single night. You will have to visit the location for more than one time, our you must stay overnight. Preparation time is not included in this calculation, but only the time on site.', '2010-09-12 23:41:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1648', 'EN', 'A newsentry was created on opencaching', '2010-09-13 00:18:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1649', 'EN', 'Runtime: {time} seconds', '2010-09-13 00:18:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1650', 'EN', 'The called page does not exist!', '2010-09-13 00:17:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1651', 'EN', 'Search by cachename', '2010-09-13 00:17:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1652', 'EN', 'Redirect - opencaching', '2010-09-13 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1653', 'EN', 'Do you really want to delete the saved search?', '2010-09-13 00:16:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'EN', 'Status', '2010-09-13 00:16:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1655', 'EN', 'Set status', '2010-09-13 00:16:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'EN', 'Countries', '2010-09-13 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1657', 'EN', 'to', '2010-09-14 01:27:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'EN', 'Route', '2010-09-27 00:21:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'EN', 'Cache size:', '2010-09-27 00:23:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1660', 'EN', 'Link', '2010-09-27 00:23:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1661', 'EN', 'Open', '2010-09-27 00:23:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1662', 'EN', 'Add to favorites...', '2010-09-27 00:23:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1663', 'EN', 'Caches displayed', '2010-09-27 00:23:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1664', 'EN', 'Time to load', '2010-09-27 00:23:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1665', 'EN', 'Sec.', '2010-09-27 00:23:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1666', 'EN', 'Only show Geocaches with the following properties:', '2010-09-27 00:23:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1667', 'EN', 'Cachetype', '2010-09-27 00:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1668', 'EN', 'Cache container', '2010-09-27 00:23:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1669', 'EN', 'Hide', '2010-09-27 00:22:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1670', 'EN', 'My owns', '2010-09-27 00:22:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1671', 'EN', 'Not active', '2010-09-27 00:22:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1672', 'EN', 'Double listings', '2010-09-27 00:22:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1673', 'EN', 'Rating', '2010-09-27 00:22:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1674', 'EN', 'Min. recommendations', '2010-09-27 00:22:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1675', 'EN', 'Drag Zoom', '2010-09-27 00:22:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1676', 'EN', 'Drag a region on the map (click here to reset)', '2010-09-27 00:22:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1677', 'EN', 'Drag Zoom Back', '2010-09-27 00:22:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1678', 'EN', 'Enter a search text, please!', '2010-09-27 00:21:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1680', 'EN', 'Waypoint %1 not found!', '2010-09-27 00:21:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1681', 'EN', 'D/T:', '2010-09-27 00:21:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1682', 'EN', 'Maps \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2010-09-27 00:21:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1683', 'EN', 'Error: Unable to download the search result (HTTP error code %1)', '2010-09-27 00:21:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1684', 'EN', 'Error: Unable to download the search result. The data was not available on the server.', '2010-09-27 00:21:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1685', 'EN', 'There are %1 Geocaches in the selected area, matching the filter options. Please zoom in to display the caches.', '2010-09-27 00:21:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1686', 'EN', 'The filter options have been changed. Click OK to reload the map content.', '2010-09-27 00:20:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1687', 'EN', 'Create a logentry', '2010-10-03 20:32:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1688', 'EN', 'Edit logentry', '2010-10-03 20:32:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1689', 'EN', 'Remove logentry', '2010-10-03 20:32:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1690', 'EN', 'Edit cache', '2010-10-03 20:31:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1691', 'EN', 'Add description', '2010-10-03 20:31:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1692', 'EN', 'Edit description', '2010-10-03 20:31:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1693', 'EN', 'Remove description', '2010-10-03 20:31:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1694', 'EN', 'Select city', '2010-10-03 20:30:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1695', 'EN', 'Show search result', '2010-10-03 20:30:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1696', 'EN', 'Result', '2010-10-03 20:29:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1697', 'EN', 'Description - Create a cache', '2010-10-03 20:29:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1698', 'EN', 'Add picture', '2010-10-03 20:29:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1699', 'EN', 'Message', '2010-10-03 20:29:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1700', 'EN', 'There is no google maps key registered for this domain.', '2010-10-03 22:28:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1701', 'EN', 'Attention! This Geocache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> There is no physical container at the specified (or to be determined) coordinates. In the interest of the place it should not be necessarily to search!', '2010-10-06 22:35:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1702', 'EN', 'Attention! This Geocache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> The geocache itself or parts of it are missing or there are other issues that make a successful search impossible. In the interest of the place it should not be necessarily to search!', '2010-10-06 22:35:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1703', 'EN', 'You have attended this event!', '2010-10-06 22:35:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1704', 'EN', 'You have already found this cache!', '2010-10-06 22:35:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1705', 'EN', '<br /><i>Obsolete: This attribute is cannot be assigned to new caches, because it does not fit our current terms of use.</i><br /> This cache ist listed at Opencaching and at other geocaching sites. This applies to caches which have been linked by their owners to the corresponding listings at other sites. Please note that descriptions and status of multiple-listed caches have to be equally maintained at all sites including Opencaching, according to our terms of use.', '2010-10-21 22:55:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1706', 'EN', 'This OC node', '2010-10-21 22:55:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1707', 'EN', 'Other OC nodes', '2010-10-21 22:55:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1708', 'EN', 'The next events in %1', '2010-10-21 22:55:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1709', 'EN', 'Geocaches with most ratings in the last 30 days in %1.', '2010-10-21 22:54:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'EN', 'Newest caches in %1', '2010-10-21 22:54:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1711', 'EN', 'You need {anzahl} more found log(s) to make another recommendation.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1712', 'EN', 'Add log entry for the cache <a href=\"viewcache.php?cacheid=%1\">%2</a>', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1713', 'EN', 'You have recommended this cache.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1714', 'EN', 'Revoke the recommendation', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1715', 'EN', 'You have given %1 of %2 possible recommendations.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1716', 'EN', 'You need %1 more found log(s) to make another recommandation.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1717', 'EN', 'Please select!', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1718', 'EN', 'Results on this page', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1719', 'EN', 'Result {startatp1} to {endat} (as zip)', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1722', 'EN', 'Do you really want to delete this entry?', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1723', 'EN', 'Do you really want to remove this recommendation?', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1724', 'EN', 'Route', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1725', 'EN', 'Download as...', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1726', 'EN', 'remove log entry for <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1727', 'EN', 'Add new cache description to <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1728', 'EN', 'Send to GPS device', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1729', 'EN', 'Geokrety history', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1730', 'EN', 'New forum topcis (%1)', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1731', 'EN', 'Team blog', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1732', 'EN', 'Forum', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1733', 'EN', 'Geokrety', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1734', 'EN', 'GPX Import', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1735', 'EN', 'For Event Caches: The date of event!', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1736', 'EN', 'User-ID:', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1737', 'EN', 'List', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1738', 'EN', 'Event date', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1739', 'EN', 'Found: %1 Hidden: %2', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1740', 'EN', '<Unknown user>', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1741', 'EN', 'The account is already activated. Please try to <a href=\"login.php\">login</a>.<br /> If you cannot login, please read the following page: <a href=\"{$opt.cms.login}\">Login problems</a>', '2011-04-04 21:35:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1742', 'EN', 'Your browser has rejected our cookie.<br /> For more information on this topic, see <a href=\"{$opt.cms.login}\">Opencaching.de-help</a>.', '2011-04-04 21:31:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1743', 'EN', 'This geocache is probably placed within a nature reserve! Pleas read <a href=\"{$opt.cms.npa}\" target=\"_blank\">this</a> for further information.', '2011-04-04 21:25:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1744', 'EN', 'This geocache is probably placed within the following nature reserves (<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>):', '2011-04-04 21:23:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1745', 'EN', 'Default logo', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1747', 'EN', 'Alternative logo by nybbler', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1752', 'EN', 'Alternative logo', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1753', 'EN', 'Slimline', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1754', 'EN', 'Red logo, slimline', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1755', 'EN', 'Slimline, without statistics', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1756', 'EN', 'Slimline red, without statistics', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1757', 'EN', 'Round corners', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1758', 'EN', 'The account is already activated. Please try to <a href=\"login.php\">login</a>.<br /> If you cannot login, please read the following page: <a href=\"%1\">Login problems</a>', '2011-05-23 22:29:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1759', 'EN', 'Note:', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1760', 'EN', 'Include a coordinate in the note', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1761', 'EN', 'The note is not visible to other users. The note and the optional coordinate will be included in GPX-file downloads and sent to the GPS device.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1762', 'EN', 'Subscribe to feeds from opencaching', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1763', 'EN', 'Your browser has rejected our cookie.<br /> For more information on this topic, see <a href=\"%1\">Opencaching.de-help</a>.', '2011-05-23 22:25:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1764', 'EN', 'Personal cache note', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1765', 'EN', 'This geocache is probably placed within a nature protection area! Please see <a href=\"%1\" target=\"_blank\">here</a> for further information.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1766', 'EN', 'This geocache is probably placed within the following nature reserves (<a href=\"%1\" target=\"_blank\">Info</a>):', '2011-05-23 22:19:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1767', 'EN', 'Quick translation', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1768', 'EN', 'Disable', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1769', 'EN', 'Enable - new', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1770', 'EN', 'Enable - all', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1771', 'EN', 'Text download (new)', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1772', 'EN', 'Text download (all)', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1773', 'EN', 'Text import', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1774', 'EN', 'Text file containing the translations:', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1775', 'EN', 'Child waypoint', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1776', 'EN', 'Waypoint type:', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1777', 'EN', 'Please select type', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1778', 'EN', 'Coordinate:', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1779', 'EN', 'Download GPX file (max. 500)', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1780', 'EN', 'Add waypoint', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1781', 'EN', 'Add new', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1782', 'EN', 'Delete waypoint', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1783', 'EN', 'Edit waypoint', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1788', 'EN', 'Parking', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1789', 'EN', 'Reference point', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1790', 'EN', 'Additional waypoints', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1791', 'EN', 'Add a waypoint', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1792', 'EN', 'Additional waypoints can be entered to make searching easier, for example by pointing to a suitable parking location or start of a path (the waypoint\'s description may contain more information). The waypoints are included in GPX-file downloads and will be sent to the GPS device.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1793', 'EN', 'No waypoints available', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1794', 'EN', 'Additional waypoints can make searching easier, for example by pointing to a suitable parking location or start of a path. The waypoints are included in GPX-file downloads and will be sent to the GPS device.', '2012-08-24 17:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1795', 'EN', 'Maps:', '2012-08-24 17:38:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1796', 'EN', 'Published on', '2012-08-24 17:38:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1797', 'EN', 'Changelog', '2012-08-24 17:38:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1798', 'EN', 'Opencaching e.V.', '2012-07-08 14:50:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1799', 'EN', 'Only available during specified seasons', '2012-10-29 14:28:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1800', 'EN', 'This cache can be done at certain seasons only - see the cache description for more details. For example, the cache may be placed in a corn labyrinth, which only exists from bloom to harvest season.', '2012-10-29 14:28:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1801', 'EN', 'Help', '2012-11-09 19:32:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1802', 'EN', 'Warning: This report is already assigned to another admin. Consult him first before you assume the report!', '2013-02-09 18:29:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1803', 'EN', 'nano', '2012-11-10 15:56:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1804', 'EN', 'Data licsense', '2013-02-09 18:30:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1805', 'EN', 'The www.opencaching.de content is licensed under <br /><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/de/deed.en\" target=\"_blank\">Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Germany</a> License.', '2013-02-09 18:31:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1806', 'EN', 'Please select only one of the delete/disable options!', '2013-02-09 17:34:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1807', 'EN', 'By submitting I accept the <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Opencaching.de Terms of Service</a> and the <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Opencaching.de Data license</a>.', '2013-02-09 19:23:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1808', 'EN', 'I\'ve read and understand the <a target=\"_blank\" href=\"articles.php?page=dsb\">privacy statement</a>, the <a target=\"_blank\" href=\"articles.php?page=impressum#tos\">terms of service</a> and the <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Data license</a> and accept them.', '2013-02-09 19:07:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1809', 'EN', 'You have to accept the privacy statement, the terms of service and the data license to register at opencaching.de.', '2013-02-09 19:23:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1810', 'EN', 'When downloading this file, you accept our <a href=\"articles.php?page=impressum#tos\">terms of use</a> and <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Data license</a>.', '2013-02-09 19:23:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1811', 'EN', 'Disable (and lock all geocaches owned) and remove all foreign licensed content', '2013-02-09 19:30:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1812', 'EN', 'ID', '2013-02-09 19:13:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1813', 'EN', 'Owner', '2013-02-09 19:30:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1814', 'EN', 'Reporter', '2013-02-09 19:30:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1815', 'EN', 'You have to check that you are sure!', '2013-02-09 19:30:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1816', 'EN', 'The cache description was removed, because the owner declined the Opencaching.de data license.', '2013-02-09 19:30:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1817', 'EN', 'User status was successfully changed.', '2013-02-09 19:31:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1818', 'EN', 'Spoiler', '2013-02-11 11:40:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1819', 'EN', 'After saving, you may need to press the reload button in your browser to see the selected picture in your profile.', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1820', 'EN', 'You can now <a href=\"login.php\">login</a> with the new password.', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1821', 'EN', 'OC.de new', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1822', 'EN', 'OC.de new, slimline', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1823', 'EN', 'OC.de new, without statistics', '2013-02-14 00:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1824', 'EN', 'Verify email address', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1825', 'EN', 'One or more e-mails could not be delivered to the address you specified in your user profile', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1826', 'EN', 'Please confirm that this email address is correct, or enter a new one.', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1827', 'EN', 'Enter new email address', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1828', 'EN', 'Confirm this email address', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1829', 'EN', 'Mark e-mail address as invalid', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1830', 'EN', 'data license mail was not delivered', '2013-02-17 18:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1831', 'EN', 'Admins', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1832', 'EN', 'Rights', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1833', 'EN', 'Admin rights can be granted and revoked by a system administrator with database access.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1834', 'EN', 'declined data license', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1835', 'EN', 'The user account has been disabled, because the user declined the <a href=\"articles.php?page=impressum#datalicense\">data license</a>. Cache descriptions, log texts and pictures have been deleted.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1839', 'EN', 'You must select a search to overwrite.', '2013-02-19 05:48:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1', 'ES', 'Reordenar ID', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('2', 'ES', 'La base de datos no se pudo conectar.', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'ES', 'En pruebas - por favor, no entre.', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'ES', 'Usuario', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('5', 'ES', 'vacío', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'ES', 'Conectado como', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'ES', 'Desconectado', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'ES', 'Buscar Waypoint', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('9', 'ES', 'Página generada en', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('10', 'ES', 'sec', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('11', 'ES', 'Página cargando', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'ES', 'Conectándose a la Base de Datos', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('13', 'ES', 'Creada el', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'ES', 'Nota informativa', '2010-12-09 00:17:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'ES', 'Información Legal', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'ES', 'Contactar', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'ES', 'Mapa del Sitio', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'ES', 'Registrarse', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'ES', 'Nuevo usuario registrado', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'ES', 'Nota', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('21', 'ES', 'Vietnamitas', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'ES', 'Usuario', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'ES', 'email', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'ES', 'Nombre', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'ES', 'Apellido', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'ES', 'País', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'ES', 'Registro de Nuevo Usuario', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'ES', 'Uzbekistán', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'ES', 'El Usuario no es valido', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'ES', 'Imprimir últimos Logs', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('31', 'ES', 'El Apellido no es valido', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('32', 'ES', 'El Nombre no es valido', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'ES', 'No especificado', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'ES', 'Mostrar todo', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'ES', 'El email no es valido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'ES', 'Turquía', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'ES', 'Tu Password', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('38', 'ES', 'El Password contiene caracteres no validos.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'ES', 'El Password no coincide', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'ES', 'Por favor repeta', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'ES', 'Se debe introducir los campos marcados con *', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'ES', 'Sueco', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'ES', 'Esloveno', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('44', 'ES', 'por lo menos 6 caracteres de longitud', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'ES', 'por lo menos 4 caracteres diferentes', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('46', 'ES', 'no debe llevar ninguna parte del nombre de usuario', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('47', 'ES', 'no formaR parte de una lista de palabras de uso frecuente en contraseñas', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'ES', 'Eslovaco', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'ES', 'Ruso', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'ES', 'Usted debe estar de acuerdo con la nota informativa sobre Protección de Datos y las condiciones de uso al registrarse en opencacaching.de', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'ES', 'Reset', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('52', 'ES', 'Caches Especiales', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'ES', 'Indice', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'ES', 'Recomendaciones', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'ES', 'Encuentran', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'ES', 'por', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('58', 'ES', 'Vista HTML', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'ES', 'Rumano', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'ES', 'Paso 1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('61', 'ES', 'Intruduzca el texto aquí:', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'ES', 'Siguiente', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'ES', 'Paso 2', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'ES', 'Portugués', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('65', 'ES', 'Volver', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('66', 'ES', 'Vista', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('67', 'ES', 'Paso 3', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('68', 'ES', 'Así es como se ve su código HTML en un navegador:', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('69', 'ES', 'Puede guardar el siguiente código HTML y entrar en la descripción del cache.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'ES', 'Noticias', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'ES', 'Últimos caches', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'ES', 'Últimos caches no en Alemania', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'ES', 'Últimas entradas de Logs', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'ES', 'Polaco', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'ES', 'Noruego', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'ES', 'Letón', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'ES', 'Lituano', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'ES', 'Italiano', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'ES', 'Islandes', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'ES', 'Inicio', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'ES', '¿Que me parece en este sitio?', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'ES', 'En esta página podrás encontrar geocaches en todo el mundo, con especial atención a Alemania, Austria, Suiza, Italia y España. También ofrecemos información sobre temas diversos geocaching, y un foro (tablón de anuncios) y chat para comunicarse con otros cachers.<br /><br />Si desea propagar geocaching en su propio país, puede ejecutar su propio Opencaching sitio en su propio idioma, utilizando la <a href=\"https://github.com/OpencachingDeutschland/oc-server3\" target="\_blank\">software</a> y sabe cómo. Por favor, póngase en contacto con nosotros en nuestro foro internacional para más información.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('83', 'ES', 'El archivo no se ha subido correctamente.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('84', 'ES', 'El archivo era demasiado grande. Se permite un máximo de 150 kB.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('85', 'ES', 'No hay imagen de archivo determinado.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'ES', 'mismo tipo', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'ES', 'Opencaching.de', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'ES', 'Total de %1 caches activos y %2 encontrados por %3 usuarios', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'ES', 'Hungaro', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'ES', 'Croata', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'ES', 'Finlandes', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'ES', 'Sí', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'ES', 'No', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'ES', 'Hola', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('99', 'ES', 'Este e-mail ha sido utilizado por el sitio web opencaching.de, porque se ha creado una cuenta de usuario con su dirección de e-mail. Si no desea recibir más mensajes de email, póngase en contacto con nosotros a través del 1%.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'ES', 'Vasco', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'ES', 'Estonio', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'ES', 'Esperanto', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'ES', 'Griego', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'ES', 'Danés', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('105', 'ES', 'Ocurrió un error imprevisto.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('106', 'ES', 'La plantilla no existe.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('107', 'ES', 'Lo sentimos, pero no se puede ver esta página.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('108', 'ES', 'Lo sentimos, la cache solicitada no existe.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('109', 'ES', 'Lo sentimos, la operación solicitada no pudo ser ejecutada.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('110', 'ES', 'Perdón, la operación solicitada no pudo realizarse debido a que no está registrado.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('111', 'ES', 'Lo sentimos, el usuario solicitado no existe.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('112', 'ES', 'La plantilla de email no existe.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('113', 'ES', 'Tags HTML', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'ES', 'Descripción', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'ES', 'Crear un cache', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'ES', 'Administrador', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'ES', 'Información', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'ES', 'Caches', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'ES', 'Mi Perfil', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'ES', 'Nuevos Logs', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'ES', 'Sin Alemania', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'ES', 'Nuevos Caches', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'ES', 'Acerca de Geocaching', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('124', 'ES', 'Nuevo Registro', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'ES', 'Buscar', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'ES', 'Traducción', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'ES', 'Activación', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'ES', 'Perfil del usuario', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('129', 'ES', 'Al llamar a la página se ha producido un error.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('130', 'ES', 'Se ha producido un error al cargar la página. Si llegó a esta página desde un enlace en nuestra página web y este error se repite desde hace algún tiempo, por favor comuníquese con nosotros a través del correo electrónico.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('131', 'ES', 'Ocurrió el siguiente error', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'ES', 'Sitio', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'ES', 'Mensaje de error', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'ES', '%2 encontrados %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'ES', '%2 no encontrados %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'ES', '%2 escrito una nota por %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'ES', '%2 visitas %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'ES', '%2 quieren visitar %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('139', 'ES', 'Confirmación de registro', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'ES', 'Bienvenido a www.opencaching.de', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('141', 'ES', 'Los siguientes datos han sido almacenados para su dirección de e-mail', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'ES', 'Eslavo', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('143', 'ES', 'A la página de activación se puede acceder desde la siguiente URL:', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('144', 'ES', 'Si no se inscribe dentro de los próximos 14 días, la cuenta de usuario se elimina.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'ES', 'Checo', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'ES', 'Bulgaro', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'ES', 'Perfil de usuario de %1', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'ES', 'Enviar email', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'ES', 'Otros', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('150', 'ES', 'Voy a tener una radio PMR en el canal 2 conmigo', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'ES', 'Registrado&nbsp;desde', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'ES', 'Caches Escondidos', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'ES', 'Caches Encontrados', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'ES', '%1 de %2 posibles', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'ES', 'Holandes', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'ES', 'Japones', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'ES', 'Español', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'ES', 'Francés', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'ES', 'Inglés', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'ES', 'Alemán', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('161', 'ES', 'Precaución: Si utiliza esta opción, no olvides hacer clic en Cerrar sesión cuando se haya registrado desde un PC, que sea accesible a extraños. De lo contrario, podrá leer un extraño los cambio de datos de su cuenta personal.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'ES', 'Zimbabwe', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'ES', 'Zambia', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'ES', 'Sudafrica', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'ES', 'Mayotte', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'ES', 'El código de activación se envían por email.<br> Por favor, siga las instrucciones del email.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'ES', 'Para crear una cuenta en opencaching.de, tiene que introducir una dirección de email valida y un nombre de usuario. Un código de activación será enviado a la dirección de email que proporcionó. Sólo una cuenta se puede crear por dirección de email. Nombre, apellido y país son opcionales.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('168', 'ES', 'Una cuenta con esa dirección de email ya existe. No sera posible crear una segunda cuenta con la misma dirección de email.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('170', 'ES', 'La contraseña que has escrito es demasiado sencilla. Para su propia seguridad, se recomienda una contraseña más fuerte o compleja:', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('171', 'ES', 'El código de activación o dirección de e-mail era incorrecta.<br /> La activación de su cuenta no se ha realizado correctamente.<br /> Por favor, utilice la misma dirección de correo electrónico a la que se envió el correo de registro.<br /> <br /> Por favor, compruebe si había escrito mal. Si no puede resolver el problema, contacte con nosotros a través de <a href=\"mailto:%1\">%1</a>.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'ES', 'Yemen', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'ES', 'Samoa', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('174', 'ES', 'Ir', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('175', 'ES', 'Developer system – testing only', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('177', 'ES', 'Con este asistente, puede hacer que alguna parte de su descripción <b>bold</b> or <i>italic</i>. No requiere conocimientos en HTML', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('178', 'ES', 'Aquí puedes ver el código HTML generado por el texto. Si quieres poner una palabra <b>bold</b> insertar insert \&lt;b\&gt; antes de una palabra y \&lt;/b\&gt; después.', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'ES', 'Islas de Wallis y Futuna', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'ES', 'Insertar una noticia', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'ES', 'Vanuatu', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'ES', 'Vietnam', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'ES', 'Islas Virgenes (U.S.)', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'ES', 'Islas Virgenes (Britanicas)', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'ES', 'Venezuela', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('186', 'ES', 'Selecciona un idioma:', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('187', 'ES', 'Visualiza un nueva traducción', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('188', 'ES', 'Borrar el cache', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('189', 'ES', 'No definido', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('190', 'ES', 'Ver sin necesidad de traducción de referencia', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('191', 'ES', 'Mostrar todas las traducciones', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'ES', 'San Vicente y Granada', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'ES', 'Ciudad del Vaticano', '2010-12-09 00:17:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'ES', 'Uzbekistán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('195', 'ES', 'Utiliza la traducción exacta:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('196', 'ES', 'Todas las traducciones', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('197', 'ES', 'Nuevas traducciones', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('198', 'ES', 'Traducción sin hacer referencia:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'ES', 'Idioma', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'ES', 'Uruguay', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'ES', 'Código de activación', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'ES', 'Estados Unidos de America', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'ES', ' Estados Unidos - Islas Menores', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('206', 'ES', 'Total', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'ES', 'Acceso', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'ES', 'Password', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'ES', 'Uganda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'ES', 'Ucrania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'ES', 'Tanzania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'ES', 'Taiwan, Provincia de China', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'ES', 'Tuvalu', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'ES', 'Trinidad y Tobago', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'ES', 'Turquía', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'ES', '¿No estas registrado?', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'ES', '¿Olvidaste tu password?', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'ES', '¿Olvidaste tu dirección de email?', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'ES', 'Para sugerencias de solución de problemas, consulte', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'ES', 'No imprimir los logs', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'ES', 'Crear un nuevo password', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'ES', 'Recordarme', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'ES', 'Tonga', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'ES', '¡Por favor, introduzca el nombre de usuario y una contraseña!', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'ES', 'Cerrar sesión fue un éxito.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('226', 'ES', 'Autentificación fallida', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('227', 'ES', 'El nombre de usuario introducido / e-mail o la contraseña especificada no coincide.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('228', 'ES', 'Ha intentado %1 veces iniciar sesión en la última hora. El próximo inicio de sesión no se permitirá una hora antes desde el primer intento haya pasado.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'ES', 'Su cuenta no esta activada.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('230', 'ES', '\&gt;<a href=\"activation.php\">Qui</a>\&lt; puedes activar tu cuenta.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'ES', 'Tunez', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'ES', 'Para completar el registro, debera tener en su email el código de activación y confirmarlo.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'ES', 'Turkmenistán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'ES', 'Tokelau', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'ES', 'Tayikistán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'ES', 'Thailandia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'ES', 'Togo', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'ES', 'Francia, Territorios del Sur y Antartida', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'ES', 'Chad', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'ES', 'Turks y Caicos, islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'ES', 'Nombre', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'ES', 'Swasiland', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'ES', 'Siria, República Arabe de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('244', 'ES', 'Recomendación de <a href=\"viewprofile.php?userid=%1\">%2</a>', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('245', 'ES', '<a href=\"viewcache.php?cacheid=%1\">%2</a> por %3', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('246', 'ES', '%1 no ha recomendado ningún geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'ES', 'Mostrar recomendaciones', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'ES', 'El Salvador', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'ES', 'Sao Tome y Principe', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'ES', 'Suriname', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'ES', 'Somalia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('253', 'ES', 'Formato desconocido de waypoint. Los siguientes formatos son válidos: OCxxxx, NCxxxx y GCxxxx, donde xxxx es cualquier número o caracteres.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('254', 'ES', 'Existe más de un caché con el waypoint \&quot;%1\&quot', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('255', 'ES', 'El waypoint \&quot;%1\&quot; no fue encontrado.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'ES', 'Senegal', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'ES', 'San Marino', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'ES', 'Sierra Leona', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'ES', 'Eslovaquia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'ES', 'Svalbard y Jan Mayen (islas)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'ES', 'Eslovenia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'ES', 'Santa Elena', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'ES', 'Singapur', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'ES', 'Suecia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'ES', 'Sudán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'ES', 'Seychelles', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('267', 'ES', 'Salomón, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'ES', 'Arabia Saudí', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'ES', 'Ruanda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'ES', 'Rusia (Federación Rusa)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'ES', 'Rumanía', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'ES', 'Reunion', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'ES', 'Qatar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'ES', 'Paraguay', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'ES', 'Palau', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'ES', 'Portugal', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'ES', 'Puerto Rico', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'ES', 'Pitcairn, Isla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'ES', 'St. Pierre y Miquelon', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'ES', 'Polonia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'ES', 'Pakistán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'ES', 'Filipinas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'ES', 'Papua Nueva Guinea', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'ES', 'Polinesia Francesa', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'ES', 'Perú', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'ES', 'Panamá', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'ES', 'Omán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'ES', 'Nueva Zelanda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'ES', 'Niue', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'ES', 'Nauru', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'ES', 'Nepal', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'ES', 'Noruega', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'ES', 'Holanda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'ES', 'Nicaragua', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'ES', 'Nigeria', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'ES', 'Norfolk, Isla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'ES', 'Niger', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'ES', 'Nueva Caledonia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'ES', 'Namibia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'ES', 'Mozambique', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'ES', 'Malasia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'ES', 'México', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'ES', 'Malawi', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'ES', 'Maldivas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'ES', 'Mauricio', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'ES', 'Malta', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'ES', 'Montserrat, Isla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'ES', 'Mauritania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'ES', 'Martinica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'ES', 'Marinas Septentrional, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'ES', 'Macao', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'ES', 'Mongolia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'ES', 'Myanmar (Birmania)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'ES', 'Mali', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'ES', 'Macedonia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'ES', 'Marshall, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'ES', 'Madagascar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'ES', 'Moldavia, República de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'ES', 'Monaco', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'ES', 'Marruecos', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'ES', 'Libia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'ES', 'Letonia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'ES', 'Luxemburgo', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'ES', 'Lituania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'ES', 'Lesotho', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'ES', 'Liberia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'ES', 'Sri Lanka', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'ES', 'Liechtenstein', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'ES', 'Santa Lucia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'ES', 'Libano', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'ES', 'Laos, República Popular Democrática de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'ES', 'Kazakistan', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'ES', 'Cayman, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'ES', 'Kuwait', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'ES', 'Corea, República de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'ES', 'Corea, República Democrática Popular', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'ES', 'Saint Kitts y Nevis', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'ES', 'Comoros', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'ES', 'Kiribati', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'ES', 'Camboya', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'ES', 'Kirguistán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'ES', 'Kenia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'ES', 'Japón', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'ES', 'Jordania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'ES', 'Jamaica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'ES', 'Italia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'ES', 'Islandia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'ES', 'Irán', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'ES', 'Irak', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'ES', 'Territorio Britanico del oceano Indico', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'ES', 'India', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'ES', 'Israel', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'ES', 'Irlanda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'ES', 'Indonesia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'ES', 'Hungría', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'ES', 'Haití', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'ES', 'Croacia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'ES', 'Honduras', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'ES', 'Heard y Mc Donald, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'ES', 'Hong Kong', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'ES', 'Guyana', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'ES', 'Guinea-Bissau', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'ES', 'Guam', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'ES', 'Guatemala', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'ES', 'Georgia del Sur e Islas Sandwich meridionales', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'ES', 'Grecia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'ES', 'Guadalupe', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'ES', 'Guinea', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'ES', 'Gambia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'ES', 'Groelandia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'ES', 'Gibraltar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'ES', 'Ghana', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'ES', 'Guayana francesa', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'ES', 'Georgia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'ES', 'Granada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'ES', 'Reino Unido (UK)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'ES', 'Gabón', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'ES', 'Francia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'ES', 'Faroe, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'ES', 'Micronesia, Estado Federado de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'ES', 'Falkland, Islas (Malvinas)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'ES', 'Figi', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'ES', 'Finlandia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'ES', 'Etiopia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'ES', 'España', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'ES', 'Eritrea', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'ES', 'Sahara Occidental', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'ES', 'Egipto', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'ES', 'Estonia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'ES', 'Ecuador', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'ES', 'Argelia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'ES', 'Dominicana, República', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'ES', 'Dinamarca', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'ES', 'Djibouti', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'ES', 'Alemania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'ES', 'Checa, República', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'ES', 'Chipre', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'ES', 'Christmas, Isla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'ES', 'Cabo Verde', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'ES', 'Cuba', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('401', 'ES', 'Usuario', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'ES', 'Costa Rica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'ES', 'Colombia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'ES', 'China, Repúbica Popular', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'ES', 'Camerún', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'ES', 'Chile', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'ES', 'Cook, Islas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'ES', 'Costa de Marfil', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'ES', 'Suiza', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'ES', 'Congo', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'ES', 'Centroafrica, República', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'ES', 'Cocos, Islas (Keeling)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'ES', 'Canada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'ES', 'Belize', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'ES', 'Bielorusia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'ES', 'Botswana', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'ES', 'Bouvet, Isla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'ES', 'Bhután', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'ES', 'Bahamas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'ES', 'Brasil', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'ES', 'Bolivia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'ES', 'Brunei', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'ES', 'Bermuda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'ES', 'Benin', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'ES', 'Burundi', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'ES', 'Bahrein', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'ES', 'Bulgaria', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'ES', 'Burkina Faso', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'ES', 'Bélgica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'ES', 'Bangladesh', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'ES', 'Barbados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'ES', 'Bosnia-Herzegowina', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'ES', 'Azerbaijan', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'ES', 'Aruba', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'ES', 'Australia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'ES', 'Austria', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'ES', 'Samoa Americana', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'ES', 'Argentina', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'ES', 'Angola', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'ES', 'Antillas Holandesas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'ES', 'Armenia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'ES', 'Albania', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'ES', 'Anguilla', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'ES', 'Antigua y Barbados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'ES', 'Afghanistan', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'ES', 'Emiratos Arabes Unidos', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'ES', 'Andorra', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('448', 'ES', 'No se puede cambiar la raíz DB', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('449', 'ES', '(antes de una exportación)', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('450', 'ES', 'Estamos actualizando opencaching.de. Para protegerse contra fallos durante el proceso, toda la página está en offline.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('452', 'ES', 'La entrada de noticias esta almacenadas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('453', 'ES', 'Muchas gracias por la entrada de noticias. Vamos a tratar de validar su entrada lo antes posible', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'ES', 'Crear nueva noticia', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'ES', 'Entrada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('456', 'ES', 'El código no coincide', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'ES', '... y ahora insertar el código de protección contra el spam:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'ES', '¿Que muestra la imagen?', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('459', 'ES', 'El email introducido no es valido.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'ES', 'Su email para consultas:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'ES', 'Por favor, use sólo texto etiquetas de formato HTML - por ejemplo, negrita, color, hipervínculos o links. No introducir tablas, divs, etc', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'ES', 'La nueva noticia contiene tags HTML', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'ES', 'Nueva entrada:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'ES', 'Tema:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('465', 'ES', '¿Sabes algunas noticias de interés sobre Geocaching?<br /> Aquí puedes crear una entrada de noticias que se mostrarán en la página principal.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('466', 'ES', 'La activación de su cuenta se ha realizado correctamente. Ahora puedes entrar en la página de inicio de sesión .<br /><br /> <a href=\"login.php\">Ir a la página de inicio de sesión</a>', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('467', 'ES', 'Ayuda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'ES', 'Activar la cuenta', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('469', 'ES', 'Saludos cordiales,<br/>su Equipo de Opencaching.de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('470', 'ES', 'Por favor, sea paciente, estamos haciendo todo lo posible para que el sitio este de nuevo en línea tan pronto como sea posible.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('471', 'ES', 'La cuenta no se pudo crear, la razón no se conoce. Si no puede resolver este problema por sí mismo, por favor contáctenos a través de <a href=\"mailto:%1\">email</a>.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'ES', 'Respetamos su privacidad. Sus datos personales serán almacenados en nuestra base de datos pero no divulgación a terceros. Por favor, tome nota detallada de nuestra <a href=\"articles.php?page=dsb\">privacy statement</a>. Si tiene más preguntas, por favor <a href=\"mailto:%1\">contact us</a> <b>before</b> crear una cuenta.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('473', 'ES', 'Tenemos que aprobar la entrada de noticias antes de que podamos mostrarlo. Vamos a tratar de hacer esto dentro de 24 a 48 horas. La entrada de noticias no se puede modificar después de haberla presentado. Si desea hacer cambios, por favor vuelva a enviar la entrada corregida. Usted puede enviar cualquier noticia sobre Geocaching, pero no podrán presentar publicidad de productos o geocachés. La decisión de aprobar o no aprobar tus noticias son exclusivamente hasta el creador de la página web - no hay demanda para su publicación. En el caso de dudas, por favor esperar si la entrada de noticias serán publicadas, o pedir por correo electrónico a <a href=\"mailto:%1\">%1</a> antes de presentar.\r', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('474', 'ES', 'Si este problema persiste durante un tiempo más largo, por favor contáctenos a través de <a href=\"mailto:%1\">%1</a>.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('475', 'ES', 'Opencaching se encuentra actualmente fuera de servicio', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('476', 'ES', 'Creado en:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('477', 'ES', 'Tiempo de ejecución total:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('478', 'ES', 'Business layer runtime:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('479', 'ES', 'Tiempo de framework:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'ES', 'Tiempo de ejecución del usuario', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('481', 'ES', 'SQL Debugger', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('482', 'ES', '%1 comando', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('483', 'ES', 'Panorámica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'ES', 'Perfil', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('485', 'ES', 'Consultas almacenadas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('486', 'ES', 'Cache observado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'ES', 'Cache ignorado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'ES', 'Configuración', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'ES', 'Editar perfil', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'ES', 'El radio de notificación no debe ser mayor de 150 km. Para desactivar las notificaciones, definir el radio a 0.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'ES', 'Cambiar password', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('492', 'ES', 'Cambiar imagen de estadistica', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'ES', 'Dirección email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('494', 'ES', 'Disponible', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('495', 'ES', 'Temporalmente deshabilitado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('496', 'ES', 'Archivado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'ES', 'No encontrado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('498', 'ES', 'Asistió', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('499', 'ES', 'Asistiré', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('500', 'ES', 'Hola %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('501', 'ES', 'Logs', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'ES', 'Geocaches encontrados: %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'ES', 'Sus últimas entradas de Logs:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'ES', 'No hay encuentros', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'ES', 'Geocaches escondidos: %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'ES', ' Tus últimos geocaches escondidos:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'ES', 'No hay geocaches escondidos', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('508', 'ES', 'Tus geocaches pendientes de publicar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'ES', 'Todos tus caches estan publicados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('510', 'ES', 'email enviado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'ES', 'email enviados: %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('512', 'ES', 'Geocache desconocido', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('513', 'ES', 'Geocache Tradicional', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('514', 'ES', 'Multicache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('515', 'ES', 'Cache Virtual', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('516', 'ES', 'Webcam Geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('517', 'ES', 'Evento Geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('518', 'ES', 'Quiz Geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('519', 'ES', 'Geocache Matemática/Física', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('520', 'ES', 'Geocache en Movimiento', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('521', 'ES', 'Drive-In Geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('522', 'ES', 'Geocache Motocicleta', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('524', 'ES', 'otro tamaño', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('525', 'ES', 'micro', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('526', 'ES', 'pequeño', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('527', 'ES', 'normal', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('528', 'ES', 'grande', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('529', 'ES', 'muy grande', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('530', 'ES', 'sin contenedor', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('531', 'ES', 'Disponible', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('532', 'ES', 'Temporalmente no disponible', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('533', 'ES', 'En prueba de aceptación', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('534', 'ES', 'Pendiente de publicación', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('535', 'ES', 'tipo de cache desconocido', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('536', 'ES', 'Cache Tradicional', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('537', 'ES', 'Cache Virtual', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('538', 'ES', 'Webcam Cache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('539', 'ES', 'Evento Cache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('540', 'ES', 'Cache Matemática/Física', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('541', 'ES', 'Cache en Movimiento', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('542', 'ES', 'Drive-in Cache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'ES', 'Quiero ser notificado sobre nuevos geocachés en un radio de %1 km.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'ES', 'BBCode para web foro:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('546', 'ES', 'Statstics Opencaching.de de %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('547', 'ES', 'Elige el logo', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'ES', 'código HTML:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('549', 'ES', 'Texto visualizado:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('550', 'ES', '¡El texto contiene caracteres no validos!', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('551', 'ES', 'Logos disponibles', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'ES', 'Cancelado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('553', 'ES', 'Guardar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('554', 'ES', 'Las siguientes configuraciones se almacenan para su logo:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('555', 'ES', 'Mostrar log de entrada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('556', 'ES', 'Statistics imagen:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'ES', 'Registrado&nbsp;desde:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('558', 'ES', 'No utilice el editor HTML de forma predeterminada.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('559', 'ES', 'No me registro después de 15 minutos de inactividad.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('560', 'ES', 'Llevaré un  walkie talkie PMR en el canal 2 conmigo.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('561', 'ES', 'Otros:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('562', 'ES', 'Notificación sobre geocaches nuevos con inactividad.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('563', 'ES', 'Notificarme sobre nuevos geocachés en un radio de %1 km.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'ES', 'Aviso:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'ES', 'Coordenadas de casa:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'ES', 'País:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'ES', 'Apellido:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'ES', 'Nombre:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('569', 'ES', 'Recomendación', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'ES', '%1 ha encontrado el geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('571', 'ES', '%1 no han encontrado el geocaching', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('572', 'ES', '%1 han escrito una nota', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('573', 'ES', '%1 han asistido al evento', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('574', 'ES', '%1 quieren asistir al evento', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('575', 'ES', '%1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('576', 'ES', 'Editar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('577', 'ES', 'Cancelar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('578', 'ES', 'Subir imagen', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('579', 'ES', 'Imagen para el log de entrada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('580', 'ES', 'Volver a la lista de geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'ES', 'Dirección de email:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'ES', 'Log de entrada por %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('583', 'ES', 'Seleccionar imagen', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('584', 'ES', 'Seleccione imagen para %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('585', 'ES', 'No hay imagen para este geocache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('586', 'ES', 'Como imagen de vista previa', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'ES', 'Datos de mi perfil', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'ES', 'La siguiente información se almacena en su perfil de usuario:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'ES', 'las entradas grises se ocultan a otros usuarios.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'ES', 'Usuario:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('591', 'ES', 'El país no es valido', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('592', 'ES', 'La entrada del radio no es valido.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('593', 'ES', 'Ocurrió un error desconocido.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('594', 'ES', 'Antes de que usted puede acceder por primera vez, usted tiene que activar su cuenta introduciendo el siguiente código:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'ES', 'Nuevo password', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('596', 'ES', 'Solicitud', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'ES', 'Cambiar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'ES', 'Solicitud de código', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('599', 'ES', 'Código nuevo de password', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('600', 'ES', 'en %1 la solicitud de un código de seguridad para cambiar su contraseña.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('601', 'ES', 'El siguiente código se ha generado: %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('602', 'ES', 'Este código es valido para 3 días.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('603', 'ES', 'Puede introducir su nuevo password en %1newpw.php', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'ES', 'Para cambiar su password, usted tiene que solicitar un código de seguridad que se enviará por e-mail.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('605', 'ES', 'Su dirección de email no esta asociado con un usuario registrado.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('606', 'ES', 'Un correo electrónico ha sido enviado a usted que contiene el código de seguridad.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('607', 'ES', 'Ocurrió un error desconocido. El código de seguridad no se pudo enviar a usted.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'ES', 'Por favor, introduzca su dirección de correo electrónico, el código de seguridad que ha recibido y su nueva contraseña. El código de seguridad es válida durante 3 días solamente. Usted tiene que solicitar uno nuevo si ese período de tiempo ha transcurrido.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('609', 'ES', 'Esta cuenta de usuario no se ha activado todavía.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'ES', 'Código de seguridad:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('611', 'ES', 'El Código de seguridad ha caducado. Por favor solicite uno nuevo.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('612', 'ES', 'El código de seguridad no coincide', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'ES', 'Por favor repitalo:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('614', 'ES', 'La contraseña se ha cambiado.', '2013-02-14 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('615', 'ES', 'Código de seguridad para la nueva dirección de email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('616', 'ES', 'en %1 la solicitud de un código de seguridad para cambiar su dirección de email.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('617', 'ES', 'Verifique su nueva dirección de email en la pagina %1newemail.php', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'ES', 'Modificar la dirección de email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'ES', 'Para cambiar tu dirección de email, usted tiene que solicitar un código de seguridad. Será enviado a su dirección de email nuevo.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'ES', 'Nueva dirección email:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('621', 'ES', 'Esta dirección de email ya está asignado a su cuenta.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'ES', 'Por favor introduce el código de seguridad que ha recibido. El código de seguridad es válida durante 3 días solamente. Usted tiene que solicitar uno nuevo si ese período de tiempo ha transcurrido.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'ES', 'Por favor, solicite un código de seguridad primero.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('624', 'ES', 'La nueva dirección de correo electrónico no ha sido guardada. Por favor, solicite un código de seguridad primero.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('625', 'ES', 'La dirección de email ha sido modificada.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('626', 'ES', 'Descargar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('627', 'ES', 'No hay búsquedas guardadas disponible', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('628', 'ES', 'Con la descarga <a href=\"articles.php?page=impressum#tos\">Nutzungsbedingungen</a> aceptada por Opencaching.de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('629', 'ES', 'Guardar búsqueda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('630', 'ES', 'Opciones de búsqueda guardar como una nueva búsqueda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('631', 'ES', 'Nombre de la búsqueda', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('632', 'ES', 'Usted tiene que introducir un nombre para esta búsqueda.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('633', 'ES', 'Existe una búsqueda con el mismo nombre.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('634', 'ES', 'Guardar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('635', 'ES', 'Opción de sobreescribir búsquedas antiguas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('636', 'ES', '-- Seleccione la búsqueda para sobrescribir --', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('637', 'ES', '-- ninguna opción de búsqueda disponibles --', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'ES', 'Mi recomendación', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('639', 'ES', '¡Su recomendación para la \"<a href=\"viewcache.php?wp=%1\">%2</a>\" ha sido retirada!', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('640', 'ES', 'Recomendación retirada', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('641', 'ES', 'Aún no ha recomendado cachés.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'ES', 'Geocache ignorado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('643', 'ES', 'Quitar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'ES', 'No pasa por alto caches encontrados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('645', 'ES', 'Geocache observado - configuración', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('646', 'ES', 'Envío:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('647', 'ES', 'Inmediato', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('648', 'ES', 'Diario', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('649', 'ES', 'Semanal', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('650', 'ES', 'Enviar a:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('651', 'ES', 'Reloj', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('652', 'ES', 'Enviar a:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('653', 'ES', 'tiempo de envío y de día sólo se utilizará para la entrega diaria o semanal.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('654', 'ES', '¡Error al guardar!', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('655', 'ES', 'Los ajustes se han guardado correctamente.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('656', 'ES', 'Geocache observado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('657', 'ES', 'Últimos encontrados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('658', 'ES', 'Geocaches no observados', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('659', 'ES', 'Recordar dirección email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('660', 'ES', 'Recordarme la direccion de email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('661', 'ES', 'Introduzca su nombre de usuario y le enviaremos un recordatorio por correo electrónico a su dirección de e-mail.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('662', 'ES', 'Introducir un nombre de usuario', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('663', 'ES', 'El usuario no existe', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('664', 'ES', 'El recordatorio de email ha sido enviado', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('665', 'ES', 'Recuperar su dirección de email', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('666', 'ES', 'Su nombre de usuario por e-mail:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('667', 'ES', 'la solicitud de  recordatorio de email en %1', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('668', 'ES', 'Recomendación cache', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('669', 'ES', 'Los usuarios que recomiendan al %1 al %2 también recomendó los geocaches siguientes:', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('670', 'ES', 'Tasa de acierto', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('671', 'ES', 'No puede haber ninguna recomendación porque no hay otras calificaciones.', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('672', 'ES', 'Mantenimiento de la Base de Datos', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('673', 'ES', 'Mantenimiento de la Base de Datos', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('674', 'ES', '%1 ha corregido %2 entradas', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'ES', 'Ejecutar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'ES', 'Enviar', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'ES', 'email de', '2010-12-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('678', 'ES', 'Lo sentimos, pero el usuario está deshabilitado.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('679', 'ES', 'Lo siento, para el usuario especificado no es una dirección de correo electrónico proporcionada.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('680', 'ES', 'Un error desconocido ocurrió y el e-mail no se ha enviado.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('681', 'ES', '\'%1\' en contacto con usted a través de un %2 Del perfil de usuario: %2viewprofile.php?userid=%3 Para responder a este uso el email el enlace de e-mail del perfil de usuario.\r', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'ES', 'Asunto:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('683', 'ES', '¡Todos los datos serán confidenciales y no se revelará a terceros!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('684', 'ES', '\'%1\' dirección email $2 en contacto con usted a través de $3 El perfil de usuario: %3viewprofile.php?userid=%4 Utilice el botón de respuesta de su cliente de email para responder a este correo.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('685', 'ES', 'El E-mail a $1 se ha enviado.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'ES', 'Contenido:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('687', 'ES', 'Enviar email a %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('688', 'ES', '¡Tienes que insertar un tema!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('689', 'ES', '¡Tienes que insertar un contenido!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('690', 'ES', 'Enviar mi dirección email con el mensaje', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('691', 'ES', 'Esto permite que el destinatario responda a su correo electrónico utilizando su cliente de correo electrónico.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('692', 'ES', 'Para protegerlo a usted de los abusos:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('693', 'ES', 'Sólo se admiten mensajes de emails sobre geocaching. ¡El spam esta prohibido!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('694', 'ES', 'Toda la información pertinente se registra (fecha y hora, emisor / receptor y la dirección IP).', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('696', 'ES', 'Lo sentimos, este geocache no se publica.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'ES', 'Mostrar todas las entradas de logs', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'ES', 'Mostrar el geocache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'ES', 'Usted ha iniciado sesión .<br /> Por favor <a href=\"login.php?action=logout\">logout</a> primero debera iniciar sesión.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'ES', 'Al descargar este archivo, usted acepta nuestros <a href=\"articles.php?page=impressum#tos\"> terminos de uso</a>.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'ES', 'Dificultad: %1 de 5', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('702', 'ES', 'Terrno: %1 de 5', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('703', 'ES', 'Lista de participantes', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'ES', 'Log de este cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('705', 'ES', 'No observado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'ES', 'Observado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('707', 'ES', 'No ignorado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'ES', 'Ignorado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'ES', 'Imprimir', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'ES', 'Convertir coordenadas', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'ES', 'Tamaño', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'ES', 'Tiempo requerido', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'ES', 'Distancia', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'ES', 'Ocultos en', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'ES', 'Listado desde', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'ES', 'Última actualización', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'ES', 'Waypoint', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'ES', 'También en la categoría de', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'ES', 'Notas', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'ES', 'Observado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'ES', 'Ignorado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'ES', 'Visitas', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'ES', 'Atributos del cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'ES', 'Ayuda adicional', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'ES', 'Descripción', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'ES', 'Imagenes', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'ES', 'Utilidades', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('729', 'ES', 'Mostrar recomendaciones de los usuarios que recomiendan este geocaché: <a href=\"recommendations.php?cacheid=%1\">all</a>', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'ES', 'Buscar geocaches en las inmediaciones:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'ES', 'todo', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'ES', 'búsqueda', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'ES', 'Descargar como archivo:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'ES', 'Formato .gpx', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('735', 'ES', 'Fichero waypoint .loc', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'ES', 'Google Earth .kml', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('737', 'ES', 'TomTom POI .ov2', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('738', 'ES', 'TOP50 Overlay .ovl', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'ES', 'Fichero de texto .txt', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'ES', 'C O P I A', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('741', 'ES', 'Editar imagen', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('742', 'ES', 'Lo sentimos, la imagen solicitada no existe.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('743', 'ES', 'Lo sentimos, el cachelog solicitada no existe.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('744', 'ES', 'Mostrar statistics', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('745', 'ES', 'Edad', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('746', 'ES', 'Descripción', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('747', 'ES', 'Localización', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('748', 'ES', 'MiniMapa-Zoom', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('749', 'ES', 'Informar sobre este cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('750', 'ES', 'Informó del cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('751', 'ES', 'Nombre del Fichero:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('752', 'ES', '¡Por favor, el nombre de la foto!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('753', 'ES', 'Añadir imagen para el geocache %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('754', 'ES', 'Añadir imagen para el log %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('755', 'ES', 'Editar imagen para el geocache %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('756', 'ES', 'Editar imagen para el log %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'ES', 'Nombre:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('758', 'ES', '¡Nombre de la imagen!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('759', 'ES', 'Cuando pulse <i>carica</i> puede que tarde algo de tiempo antes de que se muestre la página siguiente.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('760', 'ES', 'Esta imagen es un spoiler - No hay vista previa.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('761', 'ES', 'Cargar', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('762', 'ES', 'Los siguientes formatos se permite sólo para imágenes: BMP, GIF, PNG y JPEG. Recomendamos JPEG para las fotos.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('763', 'ES', 'El tamaño de la imagen no debe superar los 150KB. Se recomienda imágenes de 480 píxeles de ancho por 360 de alto.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('764', 'ES', 'El informe sobre %1 ha sido presentado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('765', 'ES', 'Motivo:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('766', 'ES', 'Comentario:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('767', 'ES', 'Informar %1', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('768', 'ES', '¡Tienes que seleccionar una razón de tu denuncia!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('769', 'ES', 'Comentario:', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('770', 'ES', '¡Es necesario introducir un comentario, para informar de una cache!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('771', 'ES', 'Ocurrió un error desconocido. Informe fallido.', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('772', 'ES', 'Informe cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('773', 'ES', 'Nuevo', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('774', 'ES', 'En curso', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('775', 'ES', 'Hecho', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('776', 'ES', 'Cache en una propiedad privada', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('777', 'ES', 'Violación de Copyright', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('778', 'ES', 'Cache desaparecido', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('779', 'ES', 'Otra razón', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('780', 'ES', '¡Este informe ya está asignado a otro administrador!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('781', 'ES', '¡Este informe ya está asignado a usted!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('782', 'ES', '¡No se puede trabajar en este informe, que ya está asignado a otro administrador!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('783', 'ES', '¡Para modificar un informe, debe estar asignado a usted!', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('784', 'ES', 'Ningún comunicado del cache', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('785', 'ES', 'Detalle para el informe de ', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('786', 'ES', 'por', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('787', 'ES', 'no asignado', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('788', 'ES', 'Asignado a mi', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('789', 'ES', 'Contacta con el propietario', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('792', 'ES', 'Marcar como hecho', '2010-12-09 00:17:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('793', 'ES', 'Acción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('794', 'ES', 'Antes de reportar un cache al equipo Opencaching, usted debe tratar de ponerse en contacto con el propietario del cache para aclarar cualquier problema directamente con él. Esto no se aplica a los caches que violen los términos de uso de Opencaching, de tal manera que requieren la atención inmediata del administrador de Opencaching.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('795', 'ES', 'No mostrar esta imagen (que sólo se utiliza en la descripción de HTML, etc)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('796', 'ES', 'No se encontró información en los detalles del usuario.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('797', 'ES', 'Coordenadas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('798', 'ES', 'GeoKrets', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('799', 'ES', 'Mis datos', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('800', 'ES', 'Editar datos', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('801', 'ES', 'Datos del usuario', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('802', 'ES', 'Los datos de mi perfil', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('803', 'ES', 'La siguiente información detallada se almacena en su perfil de usuario:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('804', 'ES', 'Las entradas seleccionadas se mostrarán a otros usuarios.<br />\r\n   Las entradas no marcadas serán utilizadas sólo para usos internos y no seran vistas por los demás usuarios.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('805', 'ES', 'Error al guardar.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('806', 'ES', 'Los caracteres no validos se encuentran en', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('807', 'ES', 'Contenido del campo demasiado largo.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('808', 'ES', 'Los datos originales fueron recuperados.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('809', 'ES', 'visible', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('810', 'ES', 'invisible', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('811', 'ES', 'interno', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('812', 'ES', '(*) Nuevo informe', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('814', 'ES', 'Statistics del usuario', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('815', 'ES', 'mostrar', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('816', 'ES', 'Este usuario todavía no ha encontrado ningún cache.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('817', 'ES', 'El geocache fue bloqueado por un administrador, porque no se ajusta a los términos y condiciones de Opencaching.de. Si desea desbloquear, por favor contacte con nosotros utilizando la función \'informe caché\'. Por favor, seleccione otro como la causa y nos describen lo que ha cambiado para dar cumplimiento a las condiciones de uso. ¡Gracias!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('818', 'ES', 'doc/sql/static-data/data.sql se ha cambiado con la último CVS.<br />Antes de modificar traducciones, actualización de base de datos data.sql!<br /> \&nbsp;', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('819', 'ES', 'Lo sentimos, este geocache está cerrado y no se puede ver.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('821', 'ES', 'Cerrado, visible', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('822', 'ES', 'Cerrado, invisible', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('823', 'ES', 'Última modificación:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('826', 'ES', '=== Por favor selecciona ===', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('827', 'ES', 'Adopciones', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('828', 'ES', 'Data', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('829', 'ES', 'Sí, lo he leído y aprobado las <a href=\"articles.php?page=impressum#tos\">condiciones de uso</a> de Opencaching.de.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('830', 'ES', 'Para completar la adopción, debe enviar este form.<br /> Al enviar este formulario, usted se convierte en el propietario responsable de esta geocache.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('831', 'ES', 'el %2, %1 me dio en adopción este geocache', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('832', 'ES', 'Gracias por haber adoptado %1', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('833', 'ES', 'Confirma la adopción de %1', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('834', 'ES', 'En este momento hay caches que pueden ser adoptados.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('835', 'ES', 'Adoptar ahora', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('836', 'ES', 'Geocache que le han ofrecido en adopción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('837', 'ES', 'Sí, he leído y entendido lo anterior y lo acepto.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('838', 'ES', 'Cuando usted encuentra un usuario que quiere adoptar de su geocache, por favor, ponga el nombre de usuario y confirme la operación. El usuario es entonces este geocache \&gt; mi perfil de adopciones. Para completar la adopción, las condiciones del usuario del servicio de Opencaching.de debera aceptar y confirmar la aprobación. Puedes dejar un geocache a varios usuarios para ofrecer en adopción. El primer usuario de la adopción se confirma, sera el nuevo propietario de la caché. Con la aprobación que le da al usuario un derecho ilimitado para usar este contenido protegido por derechos de autor del cache, modificar y transmitir.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('839', 'ES', 'Oferta %1 para adopción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('840', 'ES', 'No te ha invitado ningún usuario a adoptar este cache.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('841', 'ES', 'Rechazar adopción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('842', 'ES', 'Lista de usuarios que se han ofrecido %1 en adopción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('843', 'ES', 'Usuario desconocido', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('844', 'ES', '¡Usted no puede adoptar su propio cache!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('845', 'ES', '¡Lo sentimos, usted tiene que leer y aceptar la parte superior para continuar!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('846', 'ES', '¡Lo sentimos, usted debe leer y aceptar las condiciones de uso para continuar!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('847', 'ES', 'Esta regla asegura que su contraseña no se puede adivinar por un script automatizado.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('848', 'ES', 'a-z A-Z 0-9 y .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~#', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('849', 'ES', 'No todos los caracteres especiales se permiten. Sólo se puede utilizar:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('850', 'ES', 'No utilice palabras de un diccionario como \"master\"', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('851', 'ES', 'No utilice palabras comunes en geocaching', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('852', 'ES', 'No usar partes de su nombre de usuario, su verdadero nombre o su dirección de correo electrónico.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'ES', 'Longitud entre 6 y 60 caracteres', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('854', 'ES', 'Por favor, asegúrese de que su contraseña cumple con los siguientes criterios:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('855', 'ES', 'Tu contraseña no cumple los criterios de seguridad.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'ES', 'Montenegro', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'ES', 'Serbia', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('858', 'ES', '* Si el usuario explícitamente cierra la sesión después de su última visita o si han pasado<br />  más de 90 días después de la autenticación, no se puede determinar la fecha de la última autenticación.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('859', 'ES', 'Administrar usuario', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('860', 'ES', '¿Seguro?', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('861', 'ES', 'Deshabilitar (y bloquear todos los geocaches del propietario)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('862', 'ES', 'Desconocida', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('863', 'ES', 'Último inicio de sesión conocido:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('864', 'ES', 'Geocaches activos:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('865', 'ES', 'Total escondidos:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('866', 'ES', 'Entradas de registro:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('867', 'ES', 'Usuarios activos:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('868', 'ES', 'Fecha de creación:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('869', 'ES', 'Datos de la cuenta de usuario', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('870', 'ES', 'Datos de la cuenta de usuario', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('871', 'ES', 'email:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('872', 'ES', 'Descarga waypoint', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('873', 'ES', 'Nuevas entradas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('874', 'ES', 'Esconder', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('875', 'ES', 'Terreno', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('876', 'ES', 'Dificultad', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('877', 'ES', 'Envia el waypoint al GPS:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('882', 'ES', 'Top de Recomendaciones', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('884', 'ES', '%1 recomendaciones dentro de los últimos 30 días', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('885', 'ES', '\&gt;<a href=\"tops.php\">Qui</a>\&lt; se pueden encontrar otras recomendaciones.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('886', 'ES', 'Caches no encontrados', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('887', 'ES', 'Últimos&nbsp;inicios&nbsp;de&nbsp;sesión', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('888', 'ES', 'En el último mes', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('889', 'ES', 'Entre el 1 y 6 meses', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('890', 'ES', 'Entre 6 y 12 meses', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('891', 'ES', 'Más de 12 meses', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('892', 'ES', 'La cuenta de usuario ha sido desactivada.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('893', 'ES', 'Un email de una nueva activación ha sido enviado', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('894', 'ES', 'de', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('895', 'ES', 'Mostrar en Google Maps', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('896', 'ES', '(in GM)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('897', 'ES', 'El usuario no tiene geocaches puestos', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('898', 'ES', 'Geocaching.de', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('899', 'ES', 'Google Maps', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'ES', 'Donaciones', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('901', 'ES', 'Tipo de log', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('902', 'ES', 'Texto', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('903', 'ES', '¿Recomienda este cache?', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('904', 'ES', '(solo si tiene puntos inutilizados)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('905', 'ES', 'Waypoint OC', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'ES', 'Términos de Uso', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('907', 'ES', 'Nuestro Equipo', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('914', 'ES', 'Reserva Natural', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('915', 'ES', 'Scan completado', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('916', 'ES', 'Fichero actual:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('921', 'ES', 'Información', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'ES', 'ES', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('923', 'ES', 'La creación del sitio ha fallado. Este error se produce sólo por un corto tiempo, por favor llame a la página de nuevo en unos minutos.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('933', 'ES', 'Scan source codes', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('954', 'ES', 'Standard', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('957', 'ES', 'Chat/IRC', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1059', 'ES', 'Ya existe una cuenta con este nombre de usuario existe.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1060', 'ES', 'Opencaching-Wiki', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1061', 'ES', 'Condiciones de uso e información legal', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1062', 'ES', 'Página de presentación', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1063', 'ES', 'Creación de página', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1097', 'ES', 'D/T', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1100', 'ES', '.gpx', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1123', 'ES', 'Nombre del caches', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1141', 'ES', 'N', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1142', 'ES', 'S', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1143', 'ES', 'E', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1144', 'ES', 'W', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1146', 'ES', 'Kilómetros', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1164', 'ES', 'Otros elementos que se encuentrados ...', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1165', 'ES', 'Buscar por ciudad, cache o waypoint', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1166', 'ES', 'Mostrar enlace en el mapa', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1206', 'ES', 'km', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1208', 'ES', 'h', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1212', 'ES', 'Página:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'ES', 'Mapa', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1272', 'ES', 'Mostrar a pantalla completa', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'ES', 'Menú principal', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1278', 'ES', 'Editor', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1279', 'ES', '\&lt;html\&gt;', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1292', 'ES', 'Smilies no son compatibles', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1296', 'ES', 'Sólo los siguientes formatos de archivo se permite para las imágenes: BMP, GIF, PNG y JPEG.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1297', 'ES', 'a la (hora)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1298', 'ES', 'La lista se actualizará automáticamente basado en las recomendaciones de nuestros usuarios. Más información sobre la división regional se puede en el <a href=\"http://wiki.opencaching.de/index.php/Empfehlungen\" target=\"_blank\">Wiki</a>.<br />\r\n<br />\r\nLos números indican lo siguiente:<br />\r\n<img src=\"images/rating-star.gif\" border=\"0\" alt=\"Empfehlungen\">Número de hallazgos del Geocache<br />\r\n<img src=\"resource2/%1/images/log/16x16-found.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"Que se encuentranquot;>Número de hallazgos del Geocache<br />\r\nEl índice es el número dos en relación a determinar el mejor Geocache<br />\r\n<img src=\"images/tops-formula.png\" border=\"0\" alt=\"Formel\">', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1299', 'ES', '¡Archivo de errores de carga!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1300', 'ES', '¡El fichero XML no se pudo cargar!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1301', 'ES', 'Exportar SQL', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1302', 'ES', 'Descargar XML', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1303', 'ES', 'Importar XML', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1304', 'ES', 'El fichero XML contiene la traducción.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1305', 'ES', 'Comprobar los siguientes idiomas del archivo XML:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1306', 'ES', 'Examinar fichero', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1307', 'ES', 'El código fuente modificado, el texto ya no se utiliza', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1308', 'ES', 'Nueva traducción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1309', 'ES', 'Modificada traducción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1310', 'ES', 'antiguo', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1311', 'ES', 'Seleccionar todos', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1312', 'ES', 'Confirmar', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1315', 'ES', 'Fecha:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1316', 'ES', 'Log:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1317', 'ES', 'Palabra Calve para registro:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1319', 'ES', '¡Palabra Clave incorrecta!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1320', 'ES', '(Sólo para los registros encontrados)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1321', 'ES', '¡Sólo está disponible aquí!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1322', 'ES', 'Nuevo Log', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1323', 'ES', 'Tipo de log:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1326', 'ES', 'Recomendación:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1327', 'ES', '¡Una recomendación sólo puede hacerse dentro de un registro como encontrado!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1328', 'ES', 'Este cache es uno de mis recomendaciones.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1329', 'ES', 'Opcionalmente puedes recuperar uno de las <a href=\"mytop5.php\">recomendaciones</a> existente.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1330', 'ES', 'Usted ha usado {curr} recomendaciones {max} posibles.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1331', 'ES', 'Peligroso', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'ES', 'Infraestructura', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1333', 'ES', 'Waypoints', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1334', 'ES', 'Común', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1335', 'ES', 'Tiempo', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1336', 'ES', 'Estacionales', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1337', 'ES', 'Sistema', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1338', 'ES', 'Requiere de herramientas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1339', 'ES', 'Necesita preparación', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1340', 'ES', 'Personas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1341', 'ES', 'Transporte', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1342', 'ES', 'Propiedades', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1343', 'ES', 'Restricciones / Condiciones previas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1344', 'ES', 'Recomendaciones / Prohibiciones', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1345', 'ES', 'Solo loggeable en Opencaching', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1346', 'ES', 'Tiempo y esfuerzo (opcional):', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1347', 'ES', 'Por supuesto, este esfuerzo sólo puede ser estimado y puede variar en función de las influencias ambientales. Si usted no puede hacer que la información sea lo suficientemente detallada, llene los campos con un O (cero)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1348', 'ES', 'Waypoints (opcional):', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1349', 'ES', 'Este waypoint se utilizará para mostrar los enlaces para mostrar el cache y su página para registrar el encuentro.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1350', 'ES', 'No hay datos, se importarán de forma automática desde los servicios de listado.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1351', 'ES', 'Descripción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1352', 'ES', 'Añadir una descripción adicional', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1353', 'ES', '¡Su descripción contiene al menos un enlace a una imagen alojada en geocaching.com!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1354', 'ES', 'Para evitar cualquier problema con geocaching.com, por favor, carguen todas las imágenes relacionadas en opencaching.de así y vincular las imágenes en el código HTML para éstos en opencaching.de', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1355', 'ES', 'Cargar una imagen', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1356', 'ES', 'Publicado desde:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1357', 'ES', 'Este cache es tuyo', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1358', 'ES', 'Tú encontraste este cache', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1359', 'ES', 'Tú no te has encontrado este cache', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1360', 'ES', 'Este cache almacena una GeoKrety', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1361', 'ES', 'Este cache tiene %1 recomendaciones', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1362', 'ES', 'Editar los registro de entrada del cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1363', 'ES', 'Tipo de log:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1364', 'ES', 'JavaScript está desactivado en su navegador, puede introducir sólo texto. Para utilizar HTML, o el editor, por favor, habilite JavaScript.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1365', 'ES', 'Nuevo cache', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1366', 'ES', 'Propietario:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1367', 'ES', 'Tipo de cache:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'ES', 'Tamaño:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'ES', 'Coordenadas:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1370', 'ES', 'Valoración:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1371', 'ES', 'Dificultad:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1372', 'ES', 'Terreno:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1373', 'ES', 'Tiempo estimado:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1374', 'ES', 'Aviso', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1375', 'ES', 'Crea una nueva descripción', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1376', 'ES', 'Escondido desde:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1377', 'ES', '(Dejar en blanco sin ninguna contraseña)', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1378', 'ES', '¡Por favor, tenga en cuenta la <a href=\"articles.php?page=cacheinfo#logpw\" target=\"_blank\">descripción</a>!', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1379', 'ES', 'Menor', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1380', 'ES', 'Buscar por caches', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1381', 'ES', 'JavaScript no se activa, no puede utilizar las siguientes opciones - búsqueda básica se admite.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1382', 'ES', 'Ordenar los resultados por:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1383', 'ES', 'Último log', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1384', 'ES', 'Mostar primero las recomendaciones de otros usuarios', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1385', 'ES', 'La distancia sólo se puede utilizar si está autentificado e introdujo las coordenadas de su casa.<br />Para realizar una búsqueda basada en la distancia sus coordenadas de casa se usan para calcular la distancia.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1386', 'ES', 'Ocultar los siguientes caches:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1387', 'ES', 'Mís Escondidos', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1388', 'ES', 'Mis Encontrados', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1389', 'ES', 'Ignorados', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1390', 'ES', 'Sólo disponible si se inicia sesión.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1391', 'ES', 'Inactivo', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1392', 'ES', 'Atributos del cache:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1393', 'ES', 'Buscar por distancia', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1394', 'ES', 'de las coordenadas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1395', 'ES', 'Distancia máxima:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1396', 'ES', 'Millas', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1397', 'ES', 'Milla marítima', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1398', 'ES', 'Buscar por ciudad', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1399', 'ES', 'Código Postal:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1400', 'ES', 'Ciudad:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1401', 'ES', 'Buscar por texto', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1402', 'ES', 'Buscar por propietarios', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1403', 'ES', 'Buscar por logs', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1404', 'ES', 'Tipo de log:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1405', 'ES', 'Error al cargar la página', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1406', 'ES', 'En un intento de crear la página, se ha producido un error. Si pasa a través de un hipervínculo a nuestro lado y el problema persiste, no dude en contactar con nosotros por correo electrónico.', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1407', 'ES', 'Ocurrió el siguiente error:', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1408', 'ES', 'Página', '2010-12-09 00:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1409', 'ES', 'Mensaje de error:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1411', 'ES', '¿Estás seguro de que quieres eliminar este log?', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1412', 'ES', '¿Deseas enviar una nota a {log_user_name}?', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1413', 'ES', 'Borrar el long de entrada', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1414', 'ES', 'Fecha es invalida', '2012-08-26 09:10:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1415', 'ES', '(solo para logs de encontrados)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1416', 'ES', 'Entrada de una nuevo cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1417', 'ES', 'Si este es tu primer cache en Opencaching.de , asegúrese de comprobar el tamaño de la <a href=\"articles.php?page=cacheinfo\">descripción</a>', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1418', 'ES', 'Distancia', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1419', 'ES', 'El esfuerzo, por supuesto, sólo puede ser estimado y puede variar dependiendo de las condiciones ambientales. Si usted no puede poner una información suficientemente detallada, escriba 0 (cero) en el campos. (Véase también la <a href=\"articles.php?page=cacheinfo#time\" target=\"_blank\">descripción</a>)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1420', 'ES', 'Idioma:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1421', 'ES', 'Puedes agregar más descripciones en otros idiomas: en la publicación de tu cache.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1422', 'ES', 'Descripción corta:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1423', 'ES', 'Descripción:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1425', 'ES', 'Nota adicional:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1426', 'ES', 'Puedes agregar imágenes adicionales después de crear el cache.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1427', 'ES', 'Publicado:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1428', 'ES', 'Publicado ahora', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1429', 'ES', 'Publicado el', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1430', 'ES', 'No publicar ahora.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1431', 'ES', 'He leído y acepto las <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">la condiciones de uso de Opencaching.de</a>', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1432', 'ES', 'Información: el registro ha sido retirado por el titular del cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1433', 'ES', 'Seleccione una ciudad', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1434', 'ES', 'Total de {resultscount} las ciudades correspondientes', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1435', 'ES', 'Para el criterio de búsqueda no encontró resultado un claro. Por favor, elije una ubicación correcta.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1436', 'ES', 'Añadir un log para el cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1437', 'ES', 'El nombre del cache es invalido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1438', 'ES', 'Las coordenadas usada no son validas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1439', 'ES', 'El tiempo insertado no es válido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1440', 'ES', 'La distancia insertada no es válida. Formato aa.aaa', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1441', 'ES', 'El estado del cache no se corresponde a las opciones para su publicación.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1442', 'ES', '¡Seleccione la revisión de los datos de ambos!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1443', 'ES', 'No hay fotos disponibles', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1444', 'ES', ' {results_count} caches encontrados.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1445', 'ES', 'Resultado {startatp1} a {endat} (como zip):', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1446', 'ES', 'su descripción fue creado en otro Opencaching-servidor web y sólo puede ser eliminado allí.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1447', 'ES', 'La descripción del caché ha sido eliminada.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1448', 'ES', 'Borrar la descripción del cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1450', 'ES', 'El código HTML será cambiado de nuevo por un filtro especial. Esto es necesario para evitar peligrosas etiquetas HTML, como esempio\&lt;script\&gt;. Una lista de etiquetas HTML permitidas se pueden encontrar <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">qui</a>.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1451', 'ES', 'Por favor, no use las imágenes que se alojan en geocaching.com. Sube tus fotos a nuestro servidor.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1452', 'ES', 'nota cifrada:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1453', 'ES', '¿Estás seguro que quieres eliminar la descripción de su cache \&quot;{cachename}\&quot;?', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1454', 'ES', 'Sí, eliminar descripción del cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1455', 'ES', 'Envíe el cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1456', 'ES', 'Formato: DD-MM-AAAA', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1457', 'ES', '¡Han ocurrido algunos errores, por favor, compruebe los campos marcados!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1458', 'ES', 'Las coordenadas insertadas no son válidas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1459', 'ES', 'La distancia insertada no es válida. Formato: aa.aaa', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1460', 'ES', 'Fecha invalida, formato: DD-MM-AAAA', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1461', 'ES', 'Sólo puede ser adoptado el cache si acepta los terminos de uso.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1462', 'ES', 'Este HTML no es válido. Para encontrar la causa exacta del error, puede utilizar <a href=\"htmlprev.php\" target=\"_blank\">HTML preview</a>.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1463', 'ES', 'El tipo de cache no esta seleccionado', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1464', 'ES', '¡El tamaño del cache no esta seleccionado!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1465', 'ES', 'Código HTML es invalido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1466', 'ES', 'Tu cache se ha agregado correctamente a la base de datos. Serás redirigido a la página de cache, ahora.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1467', 'ES', 'Selecciona', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1468', 'ES', '(Error interno) La descripción no esta disponible.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1469', 'ES', '(Error interno) Ya existe una descripción en este idioma.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1471', 'ES', 'Ya existe una descripción en este idioma.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1473', 'ES', '¿Estás seguro de que tu log debe ser eliminado?', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1475', 'ES', 'Un comando de la base de datos no se pudo ejecutar.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1476', 'ES', 'Editar cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1477', 'ES', 'Oferta para adopción', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1478', 'ES', 'Estado:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1479', 'ES', 'Buscar waypoint', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1480', 'ES', 'Country sites', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1482', 'ES', 'Waypoints:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1483', 'ES', 'hora', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1486', 'ES', 'Si su navegador no soporta redirección automática, por favor haga clic aquí.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1489', 'ES', 'DE', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'ES', 'Password', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1491', 'ES', 'Editada descripción del cache por <a href=\"viewcache.php?cacheid={cacheid}\";> cache (name) </a;>', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1494', 'ES', 'Añadir', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1495', 'ES', 'Insertar un nombre, Por favor.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1496', 'ES', '¡Completa el campo de texto, por favor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1497', 'ES', '¡Tienes que comprobar al menos un campo!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1498', 'ES', 'La longitud tiene que ser un número !\\nFormato: hh° mm.mmm', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1499', 'ES', 'La latitud tiene que ser un número !\\nFormato: hh° mm.mmm', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1500', 'ES', '¡La distancia máxima debe ser un número!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1501', 'ES', 'La distancia debe estar comprendida entre 0 y 9999', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1502', 'ES', '¡Insertar el código postal, por favor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1503', 'ES', '¡Insertar una ciudad, por favor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1504', 'ES', '¡Insertar un propietario, por favor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1505', 'ES', '¡Insertar un usuario, por favor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1506', 'ES', 'Registro multiple(waypoint presente en gc.com o nc.com)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1507', 'ES', '¡El formato de salida seleccionado es desconocido!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1508', 'ES', 'La operación de búsqueda no se pudo ejecutar, por favor, vuelva a introducir los datos de búsqueda.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1509', 'ES', 'Encontrar', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1511', 'ES', 'Sin puntuación', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1512', 'ES', 'El código postal no se pudo encontrar', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1513', 'ES', 'No existe ninguna ciudad con ese nombre', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1514', 'ES', 'No hay coordenadas para la ciudad seleccionada', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1515', 'ES', 'La ciudad insertada no es válida', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1516', 'ES', 'El texto introducido no es válido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1517', 'ES', 'El texto introducido contiene más de 50 palabras', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1518', 'ES', 'Todos los paises', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1519', 'ES', 'Todos los tipos de caches', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1520', 'ES', 'Buscar resultados', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1521', 'ES', 'Esta cache se ha creado en otro servidor Web Opencaching y sólo se puede cambiar en ese servidor web Opencaching.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1522', 'ES', 'Salvar opción', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1523', 'ES', 'Editar opción', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1524', 'ES', 'tipo', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1525', 'ES', 'Últimos logs', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1526', 'ES', 'Descargas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1527', 'ES', 'Resultados en la página:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1528', 'ES', 'Descarga de aplicaciones locales', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1529', 'ES', 'Al descargar este archivo está de acuerdo con la <a href=\"articles.php?page=impressum#tos\">condiciones de uso</a> di opencaching.de.\&nbsp;\&nbsp;', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1530', 'ES', 'Este registro fue creado en otro servidor Web Opencaching y sólo se puede cambiar en ese servidor web opencaching.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1531', 'ES', 'Esta descripción fue creado en otro servidor Web Opencaching y sólo se puede cambiar en ese servidor web opencaching.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1532', 'ES', 'El titular del cache escribió este comentario:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1533', 'ES', '¡Para caches virtuales y webcams, el tamaño del recipiente debe ser - sin contenedor!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1537', 'ES', 'El código HTML será cambiado de nuevo por un filtro especial. Esto es necesario para evitar peligrosas las etiquetas HTML, como\&lt;script\&gt;. Una lista de etiquetas HTML permitidas la podra encontrar en <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">qui</a>.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1538', 'ES', 'Idioma:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1539', 'ES', 'No encontrado', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1541', 'ES', 'Sólo por la noche', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1542', 'ES', 'Sólo enlace a otro portal de almacenamiento en caches', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1543', 'ES', 'LETTERBOX (necesita un estampador)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1544', 'ES', 'Zona Peligrosa', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1545', 'ES', 'Esta cache se puede encontrar solamente por la noche - tienes que considerar <i>cache notturna</i>. Puede haber placas reflectantes que brillaran y te llevaran al cache, o otros mecanismo especiales para caches nocturnos.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1546', 'ES', 'Este geocachee esta publicado sólo en Opencaching. Este atributo permite a los usuarios de otras plataformas  encontrar rápidamente caches interesantes de calidad OC geocaching.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1547', 'ES', 'Esta cache se publica en Opencachig y otros sitios de geocaching. Se aplica al cache que se han sido elacionado por sus propietarios  los registros correspondientes de otros sitios. Por favor, tenga en cuenta que la descripción y el estado del cache en varios sitios deben mantenerse idénticos en todos los sitios Opencaching incluidos como condiciones de uso.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1548', 'ES', 'Hay un sello en el cache para estamparlo en su libro de registro personal, y el libro de registro del cache será sellada con su sello personal. ¡Tenga cuidado de no mezclar los sellos! Con frecuencia los letterboxes se pueden encontrar sin GPS, tal vez con una brújula y unos pasos de una ubicación - Añadir el atributo - sin gps, para este clase de caches.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1549', 'ES', 'El cache está situado en una zona peligrosa. Utilice este atributo para señalar los peligros evidentes, tales como carreteras con mucho tráfico, terreno empinado o caída de rocas. Usted debe tomar medidas de seguridad o evitar ir a buscar el caché, sobre todo con niños, con grupos grandes o en condiciones meteorológicas adversas.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1550', 'ES', 'Cerca del ferrocarril activo', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1551', 'ES', 'Acantilado / Rocas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1552', 'ES', 'Zona de Caza', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1553', 'ES', 'Espinas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1554', 'ES', 'Garrapatas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1555', 'ES', 'Mina abandonada', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1556', 'ES', 'Planta venenosa', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1557', 'ES', 'Animales Peligrosos', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1558', 'ES', 'Parking cercano', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1559', 'ES', 'Transporte Público', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1560', 'ES', 'Agua potable en las cercanias', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1561', 'ES', 'Aseos públicos cercanos', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1562', 'ES', 'Teléfono Público en las cercanias', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1563', 'ES', 'Disponible socorro rapido', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1564', 'ES', 'Cerca de un Parking', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1565', 'ES', 'Larga caminata', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1566', 'ES', 'Pantano / terreno fangoso', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1567', 'ES', 'Terreno montañoso', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1568', 'ES', 'fácil de subir (sin equipo)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1569', 'ES', 'Requiere nadar', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1570', 'ES', 'Punto de interes', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1571', 'ES', 'Objetivo en movimiento', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1572', 'ES', 'Webcam', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1573', 'ES', 'en espacios confinados (cuevas, edificios, etc)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1575', 'ES', 'Sin GPS (letterboxes, cistes, compass juggling ...)', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1576', 'ES', 'Acceso o parking pagando', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1577', 'ES', 'Necesario pernoctar', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1578', 'ES', 'Disponible las 24 horas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1579', 'ES', 'Sólo disponible a ciertas horas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1580', 'ES', 'solo por el día', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1581', 'ES', 'Mareas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1582', 'ES', 'Todas las temporadas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1583', 'ES', 'Temporada de reproducción / protección de la naturaleza', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1584', 'ES', 'Nieve en el escondite', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1585', 'ES', 'Equipamiento especial', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'ES', 'Brújula', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'ES', 'Linterna', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'ES', 'Equipo de escalada', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'ES', 'Equipación para cuevas', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1590', 'ES', 'Equipo de buceo', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'ES', 'Barca', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1592', 'ES', 'Aeronave', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1593', 'ES', 'Investigación', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'ES', 'Puzzle / Misterio', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'ES', 'Problema matemático', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1596', 'ES', 'Otro tipo de cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1597', 'ES', 'Pregunte a los propietarios por las condiciones iniciales', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'ES', 'Apto para niños', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'ES', '¡Hay ferrocarriles activos en las proximidades. Por favor, tenga cuidado, manteniendo una distancia segura y cruzar los rieles sólo en los cruces de ferrocarril, etc.!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1600', 'ES', 'Hay acantilados o rocas peligrososas en las cercanas. Tenga cuidado cuando esté bajo las piedras caídas, y tenga cuidado cuando esté sobre el acantilado - especialmente con los niños y el ciclismo. Puede ser muy peligroso tomar un camino empinado para subir el acantilado porque no se puede saber de antemano cuando el primero termina y comienza otra.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'ES', 'El geocache se coloca dentro de un coto de caza. Al caer la tarde y en la oscuridad, una linterna o faro siempre debe utilizarse por razones de seguridad.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'ES', 'Hay espinas cerca de la caché. Use ropa apropiada.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'ES', 'Cada temporada hay un montón de garrapatas en este lubar. Y es recomendable llevar pantalón largo y examinarse en busca de garrapatas después de encontrar el cache.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1604', 'ES', 'En el agua', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'ES', 'Esta cache se puede encontrar tanto de día como de noche.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1606', 'ES', 'Esta cache se puede hacer solamente en ciertos momentos del día - véase la descripción de caché para obtener más detalles. Por ejemplo, la cache puede ser colocado en un área con horarios restringidos.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1607', 'ES', 'Deberas encontrar este cache sólo durante el día. Por ejemplo, el área puede ser peligroso y contienen rocas o abismos. O bien, el uso de linternas puede ser imposible porque sería sospechoso en una zona residencial.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1608', 'ES', 'Esta cache se pueden buscar sólo en marea baja o solo en marea alta', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1609', 'ES', 'Esta cache se encuentrar durante todo el año, mientras que la dificultad puede depender de las estaciones. Especificar las dificultades para <i>buone</i> condiciones.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1610', 'ES', '¡No intente esta cache durante la temporada de cría de los animales! Por favor, indique en la descripción del cache de la época del año debe ser evitado. Preste atención también a las condiciones o signos en cuanto al respeto por la naturaleza.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1611', 'ES', 'Este cache también se puede encontrar después de fuertes nevadas. Todas las fases y geocaches se esconde en lugares seguros para la caída de la nieve, no será cubierto por acumulaciones de nieve.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1612', 'ES', 'Necesitarás un equipo especial no especificado por otros atributos, tales como un puntero láser, walkie-talkie, gato de coche.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'ES', 'Se necesita una brújula', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'ES', 'Es necesario una linterna para encontrar este cache. ¡No se olvide de las baterías de repuesto!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'ES', 'Para este cache, tendrá que utilizar los equipos y saber cómo utilizarlo correctamente. Si usted es un principiante, no lo haga solos, sino que utiliza el apoyo de un experimentado escalador o alpinista.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'ES', 'Este geocache está escondido en una cueva, y se debe utilizar el equipo adecuado para acceder a ella. Tenga en cuenta que incluso las pequeñas cuevas pueden prever los problemas imprevistos y peligros, como durante las tormentas o con un esguince de tobillo. ¡Acceda con personas experimentadas en cuevas! También debe protegerse la naturaleza sobre todo en esos lugares donde los murciélagos no deben  ser molestados.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1617', 'ES', 'Necesitará un equipo de buceo para encontrar este geocache. La profundidad del agua en la ubicación de la cache se especifica en la descripción. Tenga en cuenta que el buceo requiere un entrenamiento especial. Sin experiencia de buceo, puedes buscar por el caché, junto con un buceador experimentado.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'ES', 'Este cache por lo general sólo se puede encontrar con una moto de agua. Nadando es imposible debido a la distancia o la corriente. Véase la descripción del cache para obtener más detalles.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1619', 'ES', 'Necesitas encontrar más información antes de poder buscar este cache. Esto se aplica comúnmente a los cachés de puzzle o misterio.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1620', 'ES', 'Misterio o Puzzle para ser resuelto antes o durante la búsqueda de este cache.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'ES', 'Antes o durante la búsqueda de este cache, resolver problemas matemáticos sencillos más difícil a los cálculos de la base.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1622', 'ES', 'Este es un cache que no pertenece a ninguna de las categorías predefinicas - estándar. Utilice este atributo para caches especial e inusuales.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1623', 'ES', 'Antes de intentar este cache, debe informarse con el propietario de las condiciones iniciales. Por ejemplo, la caché puede estar relacionado con algunos eventos en fechas diferentes.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1624', 'ES', 'Este geocache se creó para los niños. Todas las tareas se puede completar por los niños entre los años 10 y 12 y el terrno no está exenta de riesgo (tales como carreteras, acantilados). Hay un gran contenedor con intercambio final y las tareas son interesantes.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1625', 'ES', 'Esta cache le llevará a un área de la mina (abandonado). Puede haber peligro con el colapso de túneles o galerías que puede ser necesario para cruzar. Tenga cuidado y use de equipo adecuado, especialmente en la oscuridad. Las minas antiguas pueden ser objeto de preservación histórica.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1626', 'ES', 'Hay plantas venenosas en las cercanías. Tenga cuidado y asegúrese de que los niños o los perros no las toquen ni tragarlas.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1627', 'ES', 'Esta zona es frecuentada por los animales potencialmente peligrosos, por ejemplo. zorros rabiosos, serpientes venenosas, escorpiones, osos.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1628', 'ES', 'Una zona de aparcamiento se encuentra cerca del punto de partida de este cache. Si no hay aparcamiento gratuito, agregue el atributo \"de entrada o tarifa de estacionamiento\".', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1629', 'ES', 'Este cache se encuentra también fuera de las zonas urbanas y una estación de transporte público. No utilizar este atributo para geocaches en las zonas urbanas que siempre tienen transporte público.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1630', 'ES', 'Hay agua potable a lo largo de la ruta o cerca de la cache. Este atributo es especialmente útil en la planificación de Eventos, o caches con viajes largos a lugares como las cuevas  o minas probablemente esté sucio.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1631', 'ES', 'Hay baños públicos a lo largo de la carretera o en las proximidades del cache. Este atributo es especialmente útil para la planificación caches lejanos, multicaches o Eventos.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1632', 'ES', 'Hay teléfonos públicos en la carretera o en las proximidades del cache.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1633', 'ES', 'Hay un punto de socorro, un teléfono para pedir ayuda, un centro de rescate de montaña o similar cerca del cache. Este atributo es especialmente útil en zonas difíciles, como en la escalada de cache, caches en cuevas en las montañas o el agua. Verifique si usted puede agregar un número de teléfono de emergencia (rescate en montaña, por ejemplo).', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1634', 'ES', 'El geocache se encuentra cerca de un parking, a poca distancia.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1635', 'ES', 'Esta cache requiere una larga caminata - más de 5 kilometros de ida y vuelta. En las montañas escarpadas o en otras áreas. Recomendados calzado para caminar y equipo adecuado.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1636', 'ES', 'Esta cache requiere la superación de pantanos. Usar ropa apropiada. Después de la lluvia, el suelo puede ser difícil o no factible.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1637', 'ES', 'Una o más pendientes para acceder al cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1638', 'ES', 'Esta cache requiere un poco de escalada y puede ser necesario usar las manos, pero no es necesario material de montaña. ¡Tenga mucho cuidado durante la temporada de lluvias.!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1639', 'ES', 'Esta cache requiere cruzar un río o un lago. El agua es lo suficientemente profundo para nadar. Puede utilizar un barco, pero la distancia es lo suficientemente corto como para ser asequible para un nadador.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1640', 'ES', 'Hay un monumento cerca del cache, como un paisaje hermoso o un castillo en ruinas. Este lugar es digno de visitar, incluso sin un geocache cerca.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1641', 'ES', 'Este geocache está en movimiento. Por ejemplo, el propietario podía mover la caché periódicamente de un lugar a otro, o un geobuscador podría hacer esto y ofrecer nuevos detalles en su registro. El propietario debe actualizar las coordenadas en la descripción del cache después de cada movimiento.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1642', 'ES', 'Hay una webcam en el lugar de destino. necesidad a alguien para registrar con un pantallazo de la imagen de la webcam de su visita e incluirlo en el registro. Puede haber requisitos adicionales como un signo de geocaching en la imagen. La dirección de la webcam está incluido en la descripción de la cache, y debe ser accesible al público, que no debería exigir un registro en el sitio o similares.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1643', 'ES', 'Este geocache no está al aire libre, esta oculto dentro de un edificio, una cueva o similares.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1644', 'ES', 'Esta cache o una de sus etapas se encuentran bajo el agua. Usted debe entrar en el agua, nadar o zambullirse.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1645', 'ES', 'Esta cache se puede encuentra sin un dispositivo GPS. Detalles adicionales no se utilizan, además de las coordenadas iniciales.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1646', 'ES', 'Deberas pagar un acceso o estacionamiento para acceder a esta cache, por ejemplo, si la cache está situado en un parque temático. Si no hay aparcamiento gratuito alternativa cercana, por favor incluya en la descripción. Por favor, tenga en cuenta nuestras condiciones de uso sobre geocaches comerciales.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1647', 'ES', 'No puedrá encontrar este cache en un solo día o durante la noche. Usted tendrá que visitar el lugar más de una vez, o necesitará pasar la noche. El tiempo de preparación no está incluido en este cálculo, sólo el tiempo en el sitio.', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1648', 'ES', 'Una nueva entrada se ha creado en Opencaching', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1649', 'ES', 'Tiempo de ejecutición: {time} segundos', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1650', 'ES', '¡La página llamada no existe!', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1651', 'ES', 'Buscar por nombre de cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1652', 'ES', 'Redireccionar - opencaching', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1653', 'ES', '¿Estás seguro que quieres eliminar la búsqueda guardada?', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'ES', 'Estado', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1655', 'ES', 'Establecer el estado', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'ES', 'Países', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1657', 'ES', 'a', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'ES', 'Ruta', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'ES', 'Tamaño del cache:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1660', 'ES', 'Link', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1661', 'ES', 'Abierto', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1662', 'ES', 'Añadir a favoritos...', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1663', 'ES', 'Visualizador de caches', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1664', 'ES', 'Tiempo de carga', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1665', 'ES', 'seg', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1666', 'ES', 'Mostrar sólo geocaches con las siguientes propiedades:', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1667', 'ES', 'Tipo de cache', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1668', 'ES', 'Contenedor', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1669', 'ES', 'Escondidos', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1670', 'ES', 'Mio', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1671', 'ES', 'No activo', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1672', 'ES', 'listado doble', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1673', 'ES', 'Valoración', '2010-12-09 00:18:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1674', 'ES', 'Recomendaciones min.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1675', 'ES', 'Mover el zoom', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1676', 'ES', 'Se mueve de una región en el mapa (haga clic aquí para restablecerla)', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1677', 'ES', 'Mover el zoom', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1678', 'ES', '¡Insertar una busqueda de texto, por favor!', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1680', 'ES', 'Waypoint %1 no encontrado!', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1681', 'ES', 'D/T', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1682', 'ES', 'Maps \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1683', 'ES', 'Error: No se puede descargar los resultados de búsqueda (código de erro HTTP %1)', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1684', 'ES', 'Error: No se puede descargar los resultados de búsqueda. Los datos no están disponibles en el servidor.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1685', 'ES', 'Hemos encontrado %1 geocache en la región seleccionada que cumplen las condiciones de filtro. Zoom para ver la cache.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1686', 'ES', 'Las opciones de filtrado han sido cambiados. Haga clic en Aceptar para volver a cargar el contenido del mapa.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1687', 'ES', 'Crea un log', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1688', 'ES', 'Editar el log', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1689', 'ES', 'Borrar el log', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1690', 'ES', 'Editar el cache', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1691', 'ES', 'Añadir una descripción', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1692', 'ES', 'Editar una descripción', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1693', 'ES', 'Borrar una descripción', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1694', 'ES', 'Seleccionar una ciudad', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1695', 'ES', 'Mostrar el resultado de la búsqueda', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1696', 'ES', 'Resultado', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1697', 'ES', 'Descripción - Crea un cache', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1698', 'ES', 'Añade una imagen', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1699', 'ES', 'Mensaje', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1700', 'ES', 'No hay claves de google maps registrado para este dominio.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1701', 'ES', '¡Atención! Este geocache es \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> No es un contenedor físico a las coordenadas especificadas (o los que tienen que determinar). ¡El interés del lugar no es necesariamente la búsqueda!', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1702', 'ES', '¡Atención! Este geocache es \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> El geocaché en sí misma o alguns de sus partes que faltan o hay otros problemas que hacen imposible encontrar su ubicación. ¡El interés del lugar no es necesariamente la búsqueda!', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1703', 'ES', '¡Has participado en este evento!', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1704', 'ES', 'Ya has encontrado esta cache', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1705', 'ES', '<br /><i>Obsoleto: El atributo no puede concederse a una nuevo cache, porque no está de acuerdo con las condiciones actuales de uso.</i><br /> Este caché está disponible no sólo en Opencaching, sino también en otros sitios de geocaching. Esto se aplica al cache que se han relacionado por sus propietarios a los anuncios correspondientes en otros sitios. Tenga en cuenta que las descripciones y el estado de un cache que figuran en más de un sitio deberá de ser igual en todos los sitios incluidos Opencaching, de acuerdo con nuestros términos de uso.', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1706', 'ES', 'Esto es un nodo OC', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1707', 'ES', 'Otros nodos OC', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1708', 'ES', 'El próximo evento en %1', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1709', 'ES', 'Geocaches con mayor valoración en los últimos 30 días en %1', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'ES', 'Últimos caches en %1', '2010-12-09 00:18:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1711', 'ES', 'Necesitas {anzahl} encuentros adicionales, para realizar otra recomendación.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1712', 'ES', 'Añadir un log de entrada para el cache <a href=\"viewcache.php?cacheid=%1\">%2</a>', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1713', 'ES', 'Has recomendado este cache.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1714', 'ES', 'Revocar la recomendación', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1715', 'ES', 'Has dado %1 de %2 recomendaciones posibles.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1716', 'ES', 'Necesitas %1 encuentro adicional, para hacer otra recomendación.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1717', 'ES', '¡Por favor selelecciona!', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1718', 'ES', 'Resultados de esta página', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1719', 'ES', 'Resultado {startatp1} a {endat} (como zip)', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1722', 'ES', '¿Estás seguro que quieres eliminar esta entrada?', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1723', 'ES', '¿Estás seguro que quieres eliminar esta recomendación?', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1724', 'ES', 'Distancia del camino', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1725', 'ES', 'Descargar como...', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1726', 'ES', 'Eliminar log de entrada para <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1727', 'ES', 'Agregar una nueva descripción al cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1728', 'ES', 'Enviar a dispositivo GPS', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1729', 'ES', 'Historia Geokrety', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1730', 'ES', 'Nuevo topcis en el foro(%1)', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1731', 'ES', 'Teamblog', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1732', 'ES', 'Foro', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1733', 'ES', 'Geokrety', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1734', 'ES', 'Importar GPX', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1735', 'ES', 'Para Eventos: ¡Fecha del evento!', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1736', 'ES', 'ID de Usuario', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1737', 'ES', 'Lista', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1738', 'ES', 'Fecha del Evento', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1739', 'ES', 'Encontrados: %1  Puestos: %2', '2011-04-04 22:05:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1740', 'ES', '<Usuario no conocido>', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1741', 'ES', 'La cuenta ya está activada. Por favor trate de <a href=\"login.php\">login</a>.<br /> Si no puede acceder, por favor lea la página siguiente: <a href=\"{$opt.cms.login}\">Login problems</a>', '2011-04-04 21:34:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1742', 'ES', 'Su navegador ha rechazado nuestra cookie.<br /> Para obtener más información sobre este tema, véase <a href=\"{$opt.cms.login}\">Opencaching.de-help</a>.', '2011-04-04 21:32:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1743', 'ES', 'Este geocache está probablemente en una reserva natural. ¡Por favor, en consecuencia compórtate con cuidado!<font size=\"1\">(<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>)</font>', '2011-04-04 21:24:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1744', 'ES', 'Este geocache está probablemente en las siguientes áreas protegidas (<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>):', '2011-04-04 21:24:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1745', 'ES', 'Logo standard', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1747', 'ES', 'Alternativa para nybbler', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1752', 'ES', 'Alternativa de logo', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1753', 'ES', 'Slimline', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1754', 'ES', 'Logo rojo, Linea delgada', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1755', 'ES', 'Linea delgada, con estadistica', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1756', 'ES', 'Linea delgada roja, con estadistica', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1757', 'ES', 'Esquinas redondeadas', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1758', 'ES', 'La cuenta ya está activada. Por favor trate de <a href=\"login.php\">login</a>.<br /> Si no puede acceder, por favor lea la página siguiente: <a href=\"%1\">Login problems</a>', '2011-05-23 22:30:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1759', 'ES', 'Nota:', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1760', 'ES', 'Incluir coordenadas en la nota', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1761', 'ES', 'La nota no es visible para otros usuarios. La nota y la coordenada opcional se incluye en la descarga de archivos GPX y se envía al dispositivo GPS.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1762', 'ES', 'Suscribirse a los feeds de opencaching', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1763', 'ES', 'Su navegador ha rechazado nuestra cookie.<br /> Para obtener más información sobre este tema, véase <a href=\"%1\">Opencaching.de-help</a>.', '2011-05-23 22:26:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1764', 'ES', 'Nota persona del cache', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1765', 'ES', '¡Este geocache está probablemente situado dentro de una zona de protección de la naturaleza! Mira <a href=\"%1\" target=\"_blank\">aqui</a> para obtener más información, por favor.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1766', 'ES', 'Este geocache está probablemente en las siguientes áreas protegidas (<a href=\"%1\" target=\"_blank\">Info</a>):', '2011-05-23 22:20:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1767', 'ES', 'Traducción rápida', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1768', 'ES', 'Inhabilitar', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1769', 'ES', 'Habilitar - nuevo', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1770', 'ES', 'Habilitar - todo', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1771', 'ES', 'Descargar (nuevo) texto', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1772', 'ES', 'Descargar (todo) el texto', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1773', 'ES', 'Importar texto', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1774', 'ES', 'Archivo de texto que contiene las traducciones:', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1775', 'ES', 'Waypoit Adicionales', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1776', 'ES', 'Tipo de Waypoint:', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1777', 'ES', 'Por favor seleccione un tipo', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1778', 'ES', 'Coordenadas:', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1779', 'ES', 'Descargar fichero GPX (max. 500)', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1780', 'ES', 'Añadir waypoint', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1781', 'ES', 'Añadir nuevo', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1782', 'ES', 'Borrar waypoint', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1783', 'ES', 'Editar waypoint', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1788', 'ES', 'Parking', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1789', 'ES', 'Punto de Referencia', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1790', 'ES', 'Waypoints Adicionales', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1791', 'ES', 'Añadir un waypoint', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1792', 'ES', 'Los waypoints adicionales se pueden introducir para hacer la búsqueda más fácil, por ejemplo, que apunta a un lugar de estacionamiento adecuado o inicio de un camino (la descripción \ waypoints puede contener más información). Los puntos de referencia se incluyen en las descargas de archivos GPX y se enviarán al dispositivo GPS.', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1793', 'ES', 'No hay waypoints disponibles', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1794', 'ES', 'Waypoints adicionales pueden hacer la búsqueda más fácil, por ejemplo, que apunta a un lugar de estacionamiento adecuado o inicio de un camino. Los puntos de referencia se incluyen en las descargas de archivos GPX y se enviarán al dispositivo GPS.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1795', 'ES', 'Mapas:', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1796', 'ES', 'Publicado en', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1797', 'ES', 'Cambios', '2012-08-24 17:43:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1798', 'ES', 'Opencaching e.V.', '2012-07-08 14:50:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1799', 'ES', 'Sólo disponible durante las estaciones especificadas', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1800', 'ES', 'Esta cache se puede hacer en ciertas épocas del año solamente - vea la descripción de cache para obtener más detalles. Por ejemplo, el cache puede ser colocado en un laberinto de maíz, que sólo existe desde la floración hasta la temporada de cosecha.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1801', 'ES', 'Ayuda', '2012-11-09 19:32:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1802', 'ES', 'Advertencia: Este informe ya está asignado a otro administrador. ¡Consulte a él primero antes de asumir el informe!', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1803', 'ES', 'nano', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1804', 'ES', 'Licencia de datos', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1806', 'ES', '¡Por favor, seleccione sólo una de las opciones de eliminar / desactivar!', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1807', 'ES', 'Al enviar Acepto los  <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">los terminos de servicio de Opencaching.de</a> y la <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">licencia de datos de Opencaching.de</a>', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1808', 'ES', 'He leído y entendido la <a target=\"_blank\" href=\"articles.php?page=dsb\">declaración de privacidad</a>, los <a target=\"_blank\" href=\"articles.php?page=impressum#tos\">terminos de servicio</a> y la <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Licencia de Datos</a> y aceptarlos.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1809', 'ES', 'Tienes que aceptar la declaración de privacidad, términos de servicio y la licencia de datos para registrarse en opencaching.de', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1810', 'ES', 'Al descargar este archivo, aceptas nuestros <a href=\"articles.php?page=impressum#tos\">terminos de uso</a> y <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Licencia de Datos</a>.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1811', 'ES', 'Desactivar (y bloquear todos los geocaches propiedad) y quitar todo el contenido con licencia extranjera', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1812', 'ES', 'ID', '2013-02-09 19:31:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1813', 'ES', 'Propietario', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1814', 'ES', 'Reportar', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1815', 'ES', '¡Tienes que comprobar que es seguro!', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1816', 'ES', 'Descripción de cache fue eliminado por el propietario se negó licencia de contenido', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1817', 'ES', 'Estado de usuario se ha cambiado correctamente.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1818', 'ES', 'Spoiler', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1819', 'ES', 'Después de guardar, es posible que tengas que pulsar el botón de recarga en tu navegador para ver la imagen seleccionada en tu perfil.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1820', 'ES', 'Ahora puede <a href=\"login.php\">login</a> con el nuevo password.', '2013-02-09 00:17:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1821', 'ES', 'Nuevo OC.de', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1822', 'ES', 'OC.de new, slimline', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1823', 'ES', 'Nuevo OC.de, sin estadisticas', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1824', 'ES', 'Verificar email', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1825', 'ES', 'Uno o varios correos electrónicos no pudo ser entregado a la dirección especificada en tu perfil de usuario', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1826', 'ES', 'Por favor, confirma que esta dirección de correo electrónico es correcta, o introducir uno nuevo.', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1827', 'ES', 'Introduce una nuevo email', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1828', 'ES', 'Confirma el email', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1829', 'ES', 'Marca el email no válido', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1830', 'ES', 'el email de los datos licencia no se entregó', '2013-02-21 00:32:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'FR', 'Pseudo', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'FR', 'Quite', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'FR', 'Prénom', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'FR', 'Nom de famille', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'FR', 'Pays', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'FR', 'Ouzbek', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'FR', 'Turc', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'FR', 'Votre mot de passe', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'FR', 'Suédois', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'FR', 'Slovène', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'FR', 'Slovaque', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'FR', 'Russe', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'FR', 'Index', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'FR', 'Recommandations', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'FR', 'Trouvé', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'FR', 'par', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'FR', 'Roumain', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'FR', 'Prochain', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'FR', 'Portugais', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'FR', 'Polonais', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'FR', 'Norvégien', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'FR', 'Letton', '2010-10-04 00:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'FR', 'Litaunien', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'FR', 'Italien', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'FR', 'Islandais', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'FR', 'Page d\'accueil', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'FR', 'Opencaching.de', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'FR', 'Hongrois', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'FR', 'Croate', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'FR', 'Finnois', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'FR', 'Oui', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'FR', 'Non', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'FR', 'Salut', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'FR', 'Basque', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'FR', 'Espéranto', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'FR', 'Grec', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'FR', 'Danois', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'FR', 'Description', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'FR', 'Admin', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'FR', 'Information', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'FR', 'Caches', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'FR', 'Sans Allemagne', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'FR', 'Chercher', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'FR', 'Traduction', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'FR', 'Activation', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'FR', 'Page', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'FR', 'Indication d\'erreur', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'FR', '%2 a trouvé %1', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'FR', '%2 ne pas trouvé %1', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'FR', 'Bienvenue à www.opencaching.de!', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'FR', 'Slave', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'FR', 'Tchèque', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'FR', 'Bulgare', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'FR', 'Divers', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'FR', 'Néerlandais', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'FR', 'Japonais', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'FR', 'Espagnol', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'FR', 'Anglais', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'FR', 'Allemand', '2010-10-04 00:17:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'FR', 'le entre de news est pose de html', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'FR', 'Exécuter', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'FR', 'Envoyer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'FR', 'E-Mail de', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'FR', 'Objet:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'FR', 'Contenu:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'FR', 'Afficher cette Geocache', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'FR', 'Difficulté: %1 of 5.0', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'FR', 'Observer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'FR', 'Ignorer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'FR', 'Imprimer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'FR', 'Convertir les coordonnées', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'FR', 'Distance', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'FR', 'Waypoint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'FR', 'Ignoré', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'FR', 'Déchiffrer', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'FR', 'Images', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'FR', 'Utilités', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'FR', 'Chercher des Geocaches prés:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'FR', 'tous', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'FR', 'trouvable', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'FR', 'Télécharger en fichier vers l\'aval:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'FR', 'GPS Exchange Format .gpx', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'FR', 'Google Earth .kml', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'FR', 'C O P I E', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'FR', 'FR', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'FR', 'Statut', '2010-09-13 00:16:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1', 'IT', 'Riordina gli ID', '2010-10-27 18:49:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('2', 'IT', 'Impossibile riconnettersi al database', '2010-08-28 20:28:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'IT', 'Test - per favore non connettersi', '2010-08-28 20:36:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'IT', 'Utente', '2010-08-28 20:29:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('5', 'IT', '(vuoto)', '2010-08-28 20:29:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'IT', 'Connesso come', '2010-08-28 20:31:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'IT', 'Disconnessione', '2010-08-28 20:31:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'IT', 'Ricerca waypoint', '2010-08-28 20:32:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('9', 'IT', 'Pagina generata in', '2010-08-28 20:44:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('10', 'IT', 'sec', '2010-08-28 20:44:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('11', 'IT', 'Pagina pregenerata', '2010-08-28 20:45:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'IT', 'Connessione al DB', '2010-08-28 20:46:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('13', 'IT', 'Creata il', '2010-08-28 20:47:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'IT', 'Nota informativa', '2010-08-28 20:50:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'IT', 'Informazioni legali', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'IT', 'Contatti', '2010-08-28 20:52:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'IT', 'Mappa del sito', '2010-08-28 20:52:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'IT', 'Registrazione', '2010-08-28 20:52:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'IT', 'Nuovo utente registrato', '2010-08-28 20:53:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'IT', 'Nota', '2010-08-28 20:53:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('21', 'IT', 'Vietnamita', '2010-08-28 20:53:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'IT', 'Nome utente', '2010-08-28 20:53:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'IT', 'email', '2010-08-28 20:54:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'IT', 'Nome', '2010-08-28 20:54:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'IT', 'Cognome', '2010-08-28 20:54:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'IT', 'Nazione', '2010-08-28 20:55:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'IT', 'Registra nuovo utente', '2010-08-28 20:55:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'IT', 'Uzbeco', '2010-08-28 20:56:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'IT', 'Il nome utente non è valido', '2010-08-28 20:56:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'IT', 'Stampa gli ultimi log', '2010-08-28 20:56:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('31', 'IT', 'Il Cognome non è valido', '2010-08-28 20:57:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('32', 'IT', 'Il Nome non è valido', '2010-08-28 20:58:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'IT', 'Non specificato', '2010-08-28 20:58:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'IT', 'Mostra tutto', '2010-08-28 20:58:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'IT', 'La email non è valida.', '2010-08-28 21:00:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'IT', 'Turco', '2010-08-28 20:59:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'IT', 'La tua password', '2010-08-28 20:59:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('38', 'IT', 'La passoword contiene caratteri non validi.', '2010-08-28 21:00:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'IT', 'Le password non coincidono.', '2010-08-28 21:00:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'IT', 'Per favore ripetere', '2010-08-28 21:01:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'IT', '* sono campi obbligatori', '2010-08-28 21:01:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'IT', 'Svedese', '2010-08-28 21:02:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'IT', 'Sloveno', '2010-08-28 21:02:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('44', 'IT', 'lunghezza minima 6 caratteri', '2010-08-28 21:02:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'IT', 'almeno 4 caratteri differenti', '2010-08-28 21:02:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('46', 'IT', 'non parte del nome utente', '2010-08-28 21:03:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('47', 'IT', 'non nella lista delle password frequentemente usate', '2010-08-28 21:04:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'IT', 'Slovacco', '2010-08-28 21:04:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'IT', 'Russo', '2010-08-28 21:05:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'IT', 'E\' necessario accettare la nota informativa e le condizioni d\'uso per registrarsi a opencaching.de', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'IT', 'Ripristino', '2010-08-28 21:06:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('52', 'IT', 'Cache speciali', '2010-08-28 21:07:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'IT', 'Indice', '2010-08-28 21:07:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'IT', 'Raccomandazioni', '2010-08-28 21:07:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'IT', 'Trovata', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'IT', 'di', '2010-08-28 21:07:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('58', 'IT', 'anteprima HTML', '2010-08-28 21:07:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'IT', 'Rumeno', '2010-08-28 21:11:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'IT', 'Passo 1', '2010-08-28 21:11:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('61', 'IT', 'Inserire il testo nel seguente campo:', '2010-08-28 21:12:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'IT', 'Prossimo', '2010-08-28 21:12:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'IT', 'Passo 2', '2010-08-28 21:12:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'IT', 'Portoghese', '2010-08-28 21:12:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('65', 'IT', 'Indietro', '2010-08-28 21:12:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('66', 'IT', 'Anteprima', '2010-08-28 21:26:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('67', 'IT', 'Passo 3', '2010-08-28 21:12:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('68', 'IT', 'Il Browser visualizzerà il tuo codice HTML in questo modo:', '2010-08-28 21:13:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('69', 'IT', 'Puoi salvare questo codice HTML ed inserirlo nella descrizione della cache.', '2010-08-28 21:14:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'IT', 'Novità', '2010-08-28 21:14:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'IT', 'Ultime cache', '2010-08-28 21:14:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'IT', 'Ultime cache non in Germania', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'IT', 'Ultimi log inseriti', '2010-08-28 21:15:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'IT', 'Polacco', '2010-08-28 21:18:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'IT', 'Norvegese', '2010-08-28 21:26:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'IT', 'Lettone', '2010-08-28 21:18:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'IT', 'Lituano', '2010-08-28 21:36:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'IT', 'Italiano', '2010-08-28 21:19:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'IT', 'Islandese', '2010-08-28 21:27:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'IT', 'Inizio', '2010-08-28 21:19:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'IT', 'Che cosa trovo in questo sito?', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'IT', 'In questa pagina trovi le Geocache di tutto il mondo, con particolare riguardo a Germania, Austria, Italia e Spagna. Offriamo anche informazioni su svariati argomenti, e un forum (scambio messaggi) con chat per comunicare con altrio cachers.<br /><br />Se vuoi propagare il geocaching nella tua nazione, puoi creare un sito Opencaching nella tua lingua, usando il nostro <a href=\"https://github.com/OpencachingDeutschland/oc-server3\" target=\"_blank\">software</a> e le nostre conoscenze. Per favore contattaci sul forum internazionale per maggiori informazioni.', '2010-12-19 00:27:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('83', 'IT', 'Il file non è stato caricato correttamente.', '2010-08-28 21:20:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('84', 'IT', 'Il file è troppo grande. La dimensione massima è 150 KB.', '2010-08-28 21:21:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('85', 'IT', 'File per l\'immagine non definito.', '2010-08-28 21:22:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'IT', 'stesso tipo', '2010-08-28 21:27:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'IT', 'Opencaching.de', '2010-08-28 21:22:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'IT', 'Totale di %1 cache attive e %2 trovate da %3 utenti', '2010-08-28 21:23:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'IT', 'Ungherese', '2010-08-28 21:23:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'IT', 'Croato', '2010-08-28 21:23:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'IT', 'Finlandese', '2010-08-28 21:23:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'IT', 'Si', '2010-08-28 21:23:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'IT', 'No', '2010-08-28 21:23:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'IT', 'Ciao', '2010-08-28 21:27:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('99', 'IT', 'Questa email è stata generata dal sito opencaching.de, perché è stata creato una registrazione con questo indirizzo di email. Se non desideri più ricevere email, ti preghiamo di contattarci via email %1', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'IT', 'Basco', '2010-08-28 21:29:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'IT', 'Estone', '2010-08-28 21:29:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'IT', 'Esperanto', '2010-08-28 21:29:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'IT', 'Greco', '2010-08-28 21:29:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'IT', 'Danese', '2010-08-28 21:30:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('105', 'IT', 'Si è verificato un errore imprevisto.', '2010-08-28 21:30:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('106', 'IT', 'Il Template non esiste.', '2010-08-28 21:31:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('107', 'IT', 'Spiacente, non hai i diritti per vedere questa pagina.', '2010-08-28 21:32:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('108', 'IT', 'Spiacente, la cache richiesta non esiste.', '2010-08-28 21:32:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('109', 'IT', 'Spiacente, l\'operazione richiesta non può essere eseguita.', '2010-08-28 21:33:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('110', 'IT', 'Spiacente, l\'operazione richiesta non può essere eseguita perché non sei connesso come utente registrato.', '2010-08-28 21:34:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('111', 'IT', 'Spiacente, l\'utente richiesto non esiste.', '2010-08-28 21:34:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('112', 'IT', 'Il Template per la email non esiste.', '2010-08-28 21:35:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('113', 'IT', 'Tags HTML', '2010-08-28 21:35:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'IT', 'Descrizione', '2010-08-28 21:35:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'IT', 'Crea una cache', '2010-08-28 21:35:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'IT', 'Amministratore', '2010-08-28 21:35:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'IT', 'Informazioni', '2010-08-28 21:35:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'IT', 'Cache', '2010-08-28 21:36:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'IT', 'Il mio profilo', '2010-08-28 21:46:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'IT', 'Nuovi log', '2010-08-28 21:46:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'IT', 'Non in Germania', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'IT', 'Nuove cache', '2010-08-28 21:46:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'IT', 'A proposito di Geocaching', '2010-08-28 21:38:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('124', 'IT', 'Nuovo elemento', '2010-08-28 21:38:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'IT', 'Cerca', '2010-08-28 21:38:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'IT', 'Traduzione', '2010-08-28 21:38:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'IT', 'Attivazione', '2010-08-28 21:38:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'IT', 'Profilo utente', '2010-08-28 21:38:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('129', 'IT', 'Si è verificato un errore elaborando la pagina.', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('130', 'IT', 'Si è verificato un errore elaborando la pagina. Se sei arrivato a questa pagina da un collegamento sul nostro sito e questo errore si ripete per un certo tempo, per favore contattaci via email.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('131', 'IT', 'Si è verificato l\'errore seguente', '2010-08-28 21:40:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'IT', 'Sito', '2010-08-28 21:41:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'IT', 'Messaggio di errore', '2010-08-28 21:41:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'IT', '%2 ha trovato %1', '2010-08-28 21:42:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'IT', '%2 non ha trovato %1', '2010-08-28 21:43:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'IT', '%2 ha scritto una nota per %1', '2010-08-28 21:43:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'IT', '%2 ha visitato %1', '2010-08-28 21:43:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'IT', '%2 vuole visitare %1', '2010-08-28 21:43:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('139', 'IT', 'Conferma registrazione', '2010-08-28 21:43:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'IT', 'Benvenuto a www.opencaching.de!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('141', 'IT', 'I dati seguenti sono stati registrati per il tuo indirizzo di email %1', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'IT', 'Slave', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('143', 'IT', 'L\'attivazione può essere eseguita al seguente indirizzo (URL):', '2010-08-28 21:53:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('144', 'IT', 'Se non esegui un accesso entro i prossimi 14 giorni, la tua registrazione può essere cancellata.', '2010-08-28 21:48:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'IT', 'Ceco', '2010-08-28 21:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'IT', 'Bulgaro', '2010-08-28 21:49:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'IT', 'Profilo utente di %1', '2010-08-28 21:49:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'IT', 'Invia email', '2010-08-28 21:49:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'IT', 'Altri', '2010-08-28 21:49:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('150', 'IT', 'Ho con me una radio PMR sul canale 2.', '2010-08-28 21:51:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'IT', 'Registrato&nbsp;dal ', '2010-08-28 21:51:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'IT', 'Cache nascoste', '2010-08-28 21:51:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'IT', 'Cache trovate', '2010-08-28 21:52:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'IT', '%1 di %2 possibili', '2010-08-28 21:52:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'IT', 'Olandese', '2010-08-28 21:52:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'IT', 'Giapponese', '2010-08-28 21:52:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'IT', 'Spagnolo', '2010-08-28 21:52:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'IT', 'Francese', '2010-08-28 21:52:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'IT', 'Inglese', '2010-08-28 21:53:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'IT', 'Tedesco', '2010-08-28 21:53:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('161', 'IT', 'Attenzione: se usi queta opzione, non dimenticare di disconnetterti prima che altre persone possano usare il tuo computer. Altrimenti potrebbero usare e modificare i tuoi dati personali.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'IT', 'Zimbabwe', '2010-08-28 22:00:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'IT', 'Zambia', '2010-08-28 22:00:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'IT', 'Sudafrica', '2010-08-28 22:00:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'IT', 'Mayotte', '2010-08-28 22:00:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'IT', 'Ti è stato spedito via email il codice di attivazione.<br>Per favore segui le istruzioni contenute nella email.', '2010-08-28 22:01:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'IT', 'Per creare un utente registrato su opencaching.de devi inserire un indirizzo di email valido e un nome utente. Verrà spedita una email contenete un codice di attivazione all\'indirizzo da te indicato. Un solo utente registrato può essere creato per ciascun indirizzo email. Nome, Cognome e Nazione sono campi opzionali.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('168', 'IT', 'Esiste già un utente registrato con questo indirizzo email. Non è possibile registrare un secondo utente con lo stesso indirizzo email.', '2010-08-28 22:05:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('170', 'IT', 'La password che hai scelto è troppo semplice. Per la tua sicurezza, raccomandiamo una password più robusta:', '2010-08-28 22:08:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('171', 'IT', 'Il codice di attivazione o la email sono sbagliati.<br/>L\'attivazione della tua registrazione utente non è andata a buon fine.<br/>Per favore utilizza l\'indirizzo email a cui la email è stata inviata.<br/><br/>Per favore controlla di aver digitato correttamente - se non riesci a risolvere il problema da solo, contattaci alla email <a href=\"mailto:%1\">%1</a>', '2010-08-28 22:12:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'IT', 'Yemen', '2010-08-28 22:11:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'IT', 'Samoa', '2010-08-28 22:11:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('174', 'IT', 'Vai', '2010-08-28 22:13:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('175', 'IT', 'Sistema di sviluppo - solo test', '2010-08-28 22:13:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('177', 'IT', 'Utilizzando questa procedura, puoi rendere parte della tua descizione in <b>grassetto</> o in <i>corsivo</>. Non è necessario conoscere l\'HTML.', '2010-08-28 22:16:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('178', 'IT', 'Qui puoi vedere il codice HTML generato a partire dal tuo testo. Se desideri rendere una parola in <b>grassetto</b>, inserisci \&lt;b\&gt; prima della parola e \&lt;/b\&gt; dopo.', '2010-08-28 22:18:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'IT', 'Isole Wallis e Futuna', '2010-08-28 22:18:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'IT', 'Inserisci notizie', '2010-08-28 22:18:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'IT', 'Vanuatu', '2010-08-28 22:19:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'IT', 'Vietnam', '2010-08-28 22:19:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'IT', 'Isole Vergini (US)', '2010-08-28 22:19:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'IT', 'Isole Vergini (GB)', '2010-08-28 22:20:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'IT', 'Venezuela', '2010-08-28 22:20:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('186', 'IT', 'Seleziona una lingua:', '2010-08-28 22:20:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('187', 'IT', 'Visualizza nuove traduzioni', '2010-08-28 22:20:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('188', 'IT', 'Pulisci la cache', '2010-08-28 22:20:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('189', 'IT', 'Non definito', '2010-08-28 22:20:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('190', 'IT', 'Visualizza traduzioni non più referenziate', '2010-08-28 22:21:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('191', 'IT', 'Visualizza tutte le traduzioni', '2010-08-28 22:21:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'IT', 'Saint Vincent e Grenadine', '2010-08-28 22:22:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'IT', 'Città del Vaticano', '2010-08-28 22:22:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'IT', 'Uzbekistan', '2010-08-28 22:22:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('195', 'IT', 'Utilizza traduzioni esistenti:', '2010-08-28 22:22:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('196', 'IT', 'Tutte le traduzioni:', '2010-08-28 22:23:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('197', 'IT', 'Nuova traduzione:', '2010-08-28 22:23:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('198', 'IT', 'Traduzioni non più referenziate:', '2010-08-28 22:23:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'IT', 'Linguaggi', '2010-08-28 22:24:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'IT', 'Uruguay', '2010-08-30 09:26:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'IT', 'Codice di attivazione:', '2010-08-30 09:26:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'IT', 'Stati Uniti', '2010-08-30 09:26:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'IT', 'Stati Uniti - Isole Minori', '2010-08-30 09:27:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('206', 'IT', 'Totali', '2010-08-30 09:28:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'IT', 'Accesso', '2010-08-30 09:29:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'IT', 'Password', '2010-08-30 09:29:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'IT', 'Uganda', '2010-08-30 09:29:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'IT', 'Ucraina', '2010-08-30 09:29:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'IT', 'Tanzania, Repubblica Unita di', '2010-08-30 09:29:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'IT', 'Taiwan, Repubblica Cinese di', '2010-08-30 09:31:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'IT', 'Tuvalu', '2010-08-30 09:31:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'IT', 'Trinitad e Tobago', '2010-08-30 09:33:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'IT', 'Turchia', '2010-08-30 09:34:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'IT', 'Non sei registrato?', '2010-08-30 09:34:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'IT', 'Hai dimenticato la tua password?', '2010-08-30 09:34:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'IT', 'Hai dimenticato il tuo indirizzo email?', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'IT', 'Qui puoi trovare ulteriore aiuto per la risoluzione:', '2010-08-30 09:35:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'IT', 'Non stampare i log', '2010-08-30 09:35:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'IT', 'Crea una nuova password', '2010-08-30 09:36:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'IT', 'Ricordami', '2010-08-30 09:36:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'IT', 'Tonga', '2010-08-30 09:36:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'IT', 'Per favore riempi i campi Nome Utente e Password', '2010-08-30 09:36:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'IT', 'Autenticazione riuscita.', '2010-08-30 09:37:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('226', 'IT', 'L\'autenticazione non ha avuto successo.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('227', 'IT', 'Il Nome Utente o la email o la password specificata non coincidono.', '2010-08-30 09:38:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('228', 'IT', 'Hai tentato di autenticarti più di %1 volte nell\'ultima ora. La prossima autenticazione sarà permessa solamente quando sarà trascorsa un\'ora dall\'ultimo tentativo.', '2010-08-30 09:40:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'IT', 'Il tuo utente non è attivato.', '2010-08-30 11:29:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('230', 'IT', '\&gt;<a href=\"activation.php\">Qui</a>\&lt; puoi attivare il tuo utente.', '2010-08-30 09:41:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'IT', 'Tunisia', '2010-08-30 09:41:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'IT', 'Per completare la registrazione, devi introdurre la tua email e il codice di attivazione.', '2010-08-30 09:47:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'IT', 'Turkmenistan', '2010-08-30 09:43:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'IT', 'Tokelau', '2010-08-30 09:43:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'IT', 'Tagikistan', '2010-08-30 09:44:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'IT', 'Tailandia', '2010-08-30 09:44:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'IT', 'Togo', '2010-08-30 09:44:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'IT', 'Francesi, Terre australi e antartiche', '2010-08-30 09:46:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'IT', 'Ciad', '2010-08-30 09:47:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'IT', 'Turks e Caicos, isole', '2010-08-30 09:47:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'IT', 'Nome', '2010-08-30 09:48:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'IT', 'Swaziland', '2010-08-30 09:48:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'IT', 'Siria, Repubblica Araba di', '2010-08-30 09:49:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('244', 'IT', 'Raccomandazioni di <a href=\"viewprofile.php?userid=%1\">%2</a>', '2010-08-30 09:49:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('245', 'IT', '<a href=\"viewcache.php?cacheid=%1\">%2</a> di %3', '2010-08-30 09:49:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('246', 'IT', '%1 non ha raccomandato nessuna geocache.', '2010-08-30 09:50:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'IT', 'Visualizza raccomandazioni', '2010-08-30 09:50:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'IT', 'El Salvador', '2010-08-30 09:50:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'IT', 'Sao Tome e Principe', '2010-08-30 09:51:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'IT', 'Suriname', '2010-08-30 09:51:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'IT', 'Somalia', '2010-08-30 09:51:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('253', 'IT', 'Formato sconosciuto per il waypoint. I seguenti sono formati noti: OCxxxx, NCxxxx e GCxxxx dove xxx può essere un qualsiasi numero di lettere o cifre', '2010-08-30 11:38:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('254', 'IT', 'Esiste più di una cache con il waypoint \&quot;%1\&quot', '2010-08-30 11:29:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('255', 'IT', 'Il waypoint \&quot;%1\&quot; non è stato trovato.', '2010-08-30 11:30:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'IT', 'Senegal', '2010-08-30 11:30:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'IT', 'San Marino', '2010-08-30 11:30:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'IT', 'Sierra Leone', '2010-08-30 11:30:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'IT', 'Slovacchia (Repubblica Slovacca)', '2010-08-30 11:30:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'IT', 'Svalbard e Jan Mayen (isole)', '2010-08-30 11:31:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'IT', 'Slovenia', '2010-08-30 11:31:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'IT', 'Sant\'Elena', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'IT', 'Singapore', '2010-08-30 11:31:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'IT', 'Svezia', '2010-08-30 11:31:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'IT', 'Sudan', '2010-08-30 11:31:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'IT', 'Seicelle (Repubblica delle Seychelles)', '2010-08-30 11:32:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('267', 'IT', 'Salomone, Isole', '2010-08-30 11:32:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'IT', 'Arabia Saudita', '2010-08-30 11:32:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'IT', 'Ruanda', '2010-08-30 11:32:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'IT', 'Russia (Federazione Russa)', '2010-08-30 11:32:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'IT', 'Romania', '2010-08-30 11:33:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'IT', 'Reunion', '2010-08-30 11:38:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'IT', 'Qatar', '2010-08-30 11:33:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'IT', 'Paraguay', '2010-08-30 11:28:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'IT', 'Palau', '2010-08-30 11:38:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'IT', 'Portogallo', '2010-08-30 11:39:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'IT', 'Porto Rico', '2010-08-30 12:07:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'IT', 'Pitcairn, Isole', '2010-08-30 11:39:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'IT', 'St. Pierre e Miquelon', '2010-08-30 11:40:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'IT', 'Polonia', '2010-08-30 11:39:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'IT', 'Pakistan', '2010-08-30 11:40:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'IT', 'Filippine', '2010-08-30 11:40:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'IT', 'Papua Nuova Guinea', '2010-08-30 11:40:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'IT', 'Polinesia Francese', '2010-08-30 11:40:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'IT', 'Perù', '2010-08-30 11:40:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'IT', 'Panama', '2010-08-30 11:40:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'IT', 'Oman', '2010-08-30 11:42:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'IT', 'Nuova Zelanda', '2010-08-30 11:42:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'IT', 'Niue', '2010-08-30 11:42:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'IT', 'Nauru', '2010-08-30 11:43:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'IT', 'Nepal', '2010-08-30 11:43:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'IT', 'Norvegia', '2010-08-30 11:43:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'IT', 'Paesi Bassi', '2010-08-30 11:43:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'IT', 'Nicaragua', '2010-08-30 11:43:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'IT', 'Nigeria', '2010-08-30 11:44:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'IT', 'Norfolk, Isola', '2010-08-30 11:44:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'IT', 'Niger', '2010-08-30 11:44:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'IT', 'Nuova Caledonia', '2010-08-30 11:45:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'IT', 'Namibia', '2010-08-30 11:45:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'IT', 'Mozambico', '2010-08-30 11:45:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'IT', 'Malesia', '2010-08-30 11:45:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'IT', 'Messico', '2010-08-30 11:45:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'IT', 'Malawi', '2010-08-30 11:46:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'IT', 'Maldive', '2010-08-30 12:07:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'IT', 'Mauritius', '2010-08-30 11:57:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'IT', 'Malta', '2010-08-30 11:57:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'IT', 'Montserrat, Isola', '2010-08-30 11:57:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'IT', 'Mauritania', '2010-08-30 11:55:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'IT', 'Martinica', '2010-08-30 11:55:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'IT', 'Marianne Settentrionali, Isole', '2010-08-30 11:55:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'IT', 'Macau', '2010-08-30 11:55:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'IT', 'Mongolia', '2010-08-30 11:54:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'IT', 'Myanmar (Birmania)', '2010-08-30 11:54:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'IT', 'Mali', '2010-08-30 11:53:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'IT', 'Macedonia', '2010-08-30 11:53:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'IT', 'Marshall, Isole', '2010-08-30 11:52:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'IT', 'Madagascar', '2010-08-30 11:52:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'IT', 'Moldova', '2010-08-30 12:07:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'IT', 'Monaco', '2010-08-30 11:50:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'IT', 'Marocco', '2010-08-30 11:50:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'IT', 'Libia, Grande Repubblica (Jamāhīriyya) Araba di', '2010-08-30 11:52:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'IT', 'Latvia', '2010-08-30 11:49:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'IT', 'Lussemburgo', '2010-08-30 11:49:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'IT', 'Lituania', '2010-08-30 11:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'IT', 'Lesotho', '2010-08-30 11:49:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'IT', 'Liberia', '2010-08-30 11:48:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'IT', 'Sri Lanka', '2010-08-30 11:48:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'IT', 'Liechtenstein', '2010-08-30 11:48:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'IT', 'Santa Lucia', '2010-08-30 11:58:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'IT', 'Libano', '2010-08-30 11:58:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'IT', 'Laos, Repubblica Popolare Democratica del', '2010-08-30 11:59:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'IT', 'Kazakistan', '2010-08-30 11:59:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'IT', 'Cayman, Isole', '2010-08-30 11:59:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'IT', 'Kuwait', '2010-08-30 11:59:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'IT', 'Corea, Repubblica di', '2010-08-30 11:59:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'IT', 'Corea, Repubblica Democratica Popolare', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'IT', 'Saint Kitts e Nevis', '2010-08-30 12:00:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'IT', 'Comoros', '2010-08-30 12:01:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'IT', 'Kiribati', '2010-08-30 12:01:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'IT', 'Cambogia', '2010-08-30 12:01:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'IT', 'Kyrgyzstan', '2010-08-30 12:07:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'IT', 'Kenya', '2010-08-30 12:02:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'IT', 'Giappone', '2010-08-30 12:02:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'IT', 'Giordania', '2010-08-30 12:08:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'IT', 'Giamaica', '2010-08-30 12:03:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'IT', 'Italia', '2010-08-30 12:03:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'IT', 'Islanda', '2010-08-30 12:03:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'IT', 'Iran, Repubblica Islamica di', '2010-08-30 12:03:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'IT', 'Iraq', '2010-08-30 12:03:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'IT', 'Territorio britannico dell\'oceano Indiano', '2010-08-30 12:04:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'IT', 'India', '2010-08-30 12:04:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'IT', 'Israele', '2010-08-30 12:04:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'IT', 'Irlanda', '2010-08-30 12:04:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'IT', 'Indonesia', '2010-08-30 12:04:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'IT', 'Ungheria', '2010-08-30 12:05:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'IT', 'Haiti', '2010-08-30 12:05:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'IT', 'Croazia (nome locale: Hrvatska)', '2010-08-30 12:05:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'IT', 'Honduras', '2010-08-30 12:05:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'IT', 'Heard e Mc Donald (Isole)', '2010-08-30 12:06:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'IT', 'Hong Kong', '2010-08-30 12:06:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'IT', 'Guyana', '2010-08-30 12:08:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'IT', 'Guinea-Bissau', '2010-08-30 12:08:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'IT', 'Guam', '2010-08-30 12:08:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'IT', 'Guatemala', '2010-08-30 12:08:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'IT', 'Georgia del Sud e isole Sandwich meridionali', '2010-08-30 12:08:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'IT', 'Grecia', '2010-08-30 12:10:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'IT', 'Guadalupa', '2010-08-30 12:10:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'IT', 'Guinea', '2010-08-30 12:10:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'IT', 'Gambia', '2010-08-30 12:10:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'IT', 'Groenlandia', '2010-08-30 12:11:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'IT', 'Gibilterra', '2010-08-30 12:11:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'IT', 'Ghana', '2010-08-30 12:11:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'IT', 'Guiana francese', '2010-08-30 12:12:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'IT', 'Georgia', '2010-08-30 12:10:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'IT', 'Grenada', '2010-08-30 12:12:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'IT', 'Regno Unito (UK)', '2010-08-30 12:12:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'IT', 'Gabon', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'IT', 'Francia', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'IT', 'Faroe, Isole', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'IT', 'Micronesia, Stati Federati di', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'IT', 'Falkland, Isole (Malvine)', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'IT', 'Figi', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'IT', 'Finlandia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'IT', 'Etiopia', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'IT', 'Spagna', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'IT', 'Eritrea', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'IT', 'Sahara Occidentale', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'IT', 'Egitto', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'IT', 'Estonia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'IT', 'Ecuador', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'IT', 'Algeria', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'IT', 'Dominicana, Repubblica', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'IT', 'Danimarca', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'IT', 'Gibbuti', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'IT', 'Germania', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'IT', 'Ceca, Repubblica', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'IT', 'Cipro', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'IT', 'Christmas, Isola (Kiritimati)', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'IT', 'Capo Verde', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'IT', 'Cuba', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('401', 'IT', 'Attendere', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'IT', 'Costa Rica', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'IT', 'Colombia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'IT', 'Cina, Repubblica Popolare', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'IT', 'Camerun', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'IT', 'Cile', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'IT', 'Cook, Isole', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'IT', 'Costa d\'Avorio', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'IT', 'Svizzera', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'IT', 'Congo', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'IT', 'Centraficana, Repubblica', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'IT', 'Cocos, Isole (Keeling)', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'IT', 'Canada', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'IT', 'Belize', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'IT', 'Bielorussia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'IT', 'Botswana', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'IT', 'Bouvet, Isola', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'IT', 'Bhutan', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'IT', 'Bahamas', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'IT', 'Brasile', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'IT', 'Bolivia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'IT', 'Brunei', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'IT', 'Bermuda', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'IT', 'Benin', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'IT', 'Burundi', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'IT', 'Bahrain', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'IT', 'Bulgaria', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'IT', 'Burkina Faso', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'IT', 'Belgio', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'IT', 'Bangladesh', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'IT', 'Barbados', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'IT', 'Bosnia-Herzegowina', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'IT', 'Azerbaijan', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'IT', 'Aruba', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'IT', 'Australia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'IT', 'Austria', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'IT', 'Samoa americane', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'IT', 'Argentina', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'IT', 'Angola', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'IT', 'Antille olandesi', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'IT', 'Armenia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'IT', 'Albania', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'IT', 'Anguilla', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'IT', 'Antigua e Barbuda', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'IT', 'Afghanistan', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'IT', 'Emirati Arabi Uniti', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'IT', 'Andorra', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('448', 'IT', 'Impossibile cambiare a DB root', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('449', 'IT', '(prima di una esportazione)', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('450', 'IT', 'Stiamo aggiornando opencaching.de. Per protezione, durante l\'elaborazione l\'intera pagina è fuori linea.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('452', 'IT', 'Il nuovo inserimento è stato salvato', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('453', 'IT', 'Grazie per il tuo nuovo inserimento. Cercheremo di convalidarlo appena possibile.<br /> <br /> Ritorna all\' <a href=\"index.php\">Inizio</a>', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'IT', 'Invia un nuovo inserimento', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'IT', 'Invia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('456', 'IT', 'Il codice non coincide.', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'IT', '... ed ora inserisci il codice di protezione contro lo spam:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'IT', 'Che cosa mostra l\'immagine?', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('459', 'IT', 'Indirizzo email non valido.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'IT', 'Il tuo indirizzo email per domande:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'IT', 'Per favore usa solamante testo formattato con HTML - cioè grassetto, colore e hiperlinks. Non inserire tabelle, divs ecc.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'IT', 'La nuova entrata contiene tags HTML', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'IT', 'Nuova entrata:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'IT', 'Argomento:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('465', 'IT', 'Hai interessanti notizie riguadanti il Geocaching?<br /> Qui puoi creare nuove notizie che verrano visualizzate in homepage.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('466', 'IT', 'L\'attivazione del tuo utente ha avuto successo. Puoi ora autenticarti alla pagina di autenticazoine.<br /><br /> <a href=\"login.php\">Vai alla pagina di autenticazione</a>', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('467', 'IT', 'Suggerimento', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'IT', 'Attivazione utente', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('469', 'IT', 'I migliori saluti,<br/>il tuo team Opencaching.de', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('470', 'IT', 'Per favore abbi pazienza, faremo del nostro meglio per riportare nuovamente il sito in linea appena possibile.', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('471', 'IT', 'L\'utente non può essere creato, la ragione non è nota. Se non riesci a risolvere da solo il problema, per favore contattaci tramie <a href=\"mailto:%1\">email</a>.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'IT', 'Noi rispettiamo la tua privacy. I tuoi dati personali verranno registrati nel nostro database e non saranno rivelati a terzi. Puoi prendere visione dei dettagli alla pagina <a href=\"articles.php?page=dsb\">privacy statement</a>. Se ha altre domande, per favore <a href=\"mailto:%1\">contattaci</a> <b>prima</b> di creare un utente.', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('473', 'IT', 'Dobbiamo approvare il tuo nuovo inserimento prima di visualizzarlo. Cercheremo di farlo tra 24 e 48 ore. Le notizie non possono essere modificate una volta che le hai inviate. Se vuoi eseguire delle modifiche, per favore inviale nuovamente. Puoi introdurre notizie riguardanti il Geocaching, ma non puoi fare pubblicità per prodotti o per geocaches. La decisione se approvare o meno una notizia è di esclusiva pertinenza dell\'operatore di questa pagina web - non sono possibili rivendicazioni per la pubblicazione. In caso di dubbio, per favore attendi se la tua notizia sarà pubblicata, o chiedi via email a <a href=\"mailto:%1\">%1</a> prima di inviarla.\r', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('474', 'IT', 'Se questo problema persiste per un tempo più lungo, per favore contattaci via email a <a href=\"mailto:%1\">%1</a>. ', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('475', 'IT', 'Opencaching è attualmente fuori servizio', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('476', 'IT', 'Creato il:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('477', 'IT', 'Tempo totale:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('478', 'IT', 'Tempo business layer:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('479', 'IT', 'Tempo framework:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'IT', 'Tempo utente:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('481', 'IT', 'SQL Debugger', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('482', 'IT', '%1 comandi', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('483', 'IT', 'Panoramica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'IT', 'Profilo', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('485', 'IT', 'Ricerche salvate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('486', 'IT', 'Cache osservate', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'IT', 'Cache ignorate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'IT', 'Impostazioni', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'IT', 'Modifica profilo', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'IT', 'Il raggio di notifica non deve essere maggiore di 150 km. Per disattivare le notifiche, impostare il raggio a 0.', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'IT', 'Cambia password', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('492', 'IT', 'Cambia immagine statistica', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'IT', 'Indirizzo email', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('494', 'IT', 'Disponibile', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('495', 'IT', 'Temporaneamente disabilitata', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('496', 'IT', 'Archiviata', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'IT', 'Non trovata', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('498', 'IT', 'Partecipato', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('499', 'IT', 'Parteciperò', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('500', 'IT', 'Ciao %1', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('501', 'IT', 'Log', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'IT', 'Geocaches trovate: %1', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'IT', 'I tuoi ultimi log:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'IT', 'Nessuna trovata', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'IT', 'Geocaches nascoste: %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'IT', 'Le tue ultime geocaches nascoste:', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'IT', 'Nessuna geocache nascosta', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('508', 'IT', 'Le tue geocache in attesa di pubblicazione', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'IT', 'Tutte le tue geocache sono pubblicate.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('510', 'IT', 'email inviata', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'IT', 'email inivate: %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('512', 'IT', 'Geocache Sconosciuta', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('513', 'IT', 'Geocache Tradizionale', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('514', 'IT', 'Multicache', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('515', 'IT', 'Geocache Virtuale', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('516', 'IT', 'Webcam Geocache', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('517', 'IT', 'Evento Geocache', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('518', 'IT', 'Quiz Geocache', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('519', 'IT', 'Geocache Matematica/Fisica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('520', 'IT', 'Geocache in Movimento', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('521', 'IT', 'Drive-In Geocache', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('522', 'IT', 'Geocache Motociclistica', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('524', 'IT', 'altra dimensione', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('525', 'IT', 'micro', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('526', 'IT', 'piccola', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('527', 'IT', 'normale', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('528', 'IT', 'grande', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('529', 'IT', 'molto grande', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('530', 'IT', 'nessun contenitore', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('531', 'IT', 'Disponibile', '2010-09-01 23:48:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('532', 'IT', 'Temporaneamente non disponibile', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('533', 'IT', 'Al test di approvazione', '2010-09-01 23:48:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('534', 'IT', 'Non ancora pubblicata', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('535', 'IT', 'tipo di cache sconosciuto', '2010-09-01 23:48:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('536', 'IT', 'Cache Tradizionale', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('537', 'IT', 'Cache Virtuale', '2010-09-01 23:48:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('538', 'IT', 'Webcam Cache', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('539', 'IT', 'Evento Cache', '2010-09-01 23:48:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('540', 'IT', 'Cache Matematica/Fisica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('541', 'IT', 'Cache in Movimento', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('542', 'IT', 'Drive-in Cache', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'IT', 'Voglio essere avvisato su nuove geocache nel raggio di %1 km.', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'IT', 'BBCode per il forum web:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('546', 'IT', 'Statistiche Opencaching.de di %1', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('547', 'IT', 'Scelta logo', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'IT', 'codice HTML:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('549', 'IT', 'Testo visualizzato:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('550', 'IT', 'Il testo contiene caratteri non validi!', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('551', 'IT', 'Loghi disponibili:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'IT', 'Cancella', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('553', 'IT', 'Salva', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('554', 'IT', 'Le seguenti impostazioni sono state salvate per il tuo logo:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('555', 'IT', 'Visualizza i log', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('556', 'IT', 'Statistiche:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'IT', 'Registrato&nbsp;dal:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('558', 'IT', 'Non usare l\'editor HTML di default.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('559', 'IT', 'Non disconnettermi dopo 15 minuti di inattività.', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('560', 'IT', 'Ho con me una radio PMR sul canale 2.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('561', 'IT', 'Altro:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('562', 'IT', 'La notifica di nuove geocache è disabilitata.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('563', 'IT', 'Avvisami di nuove geocache all\'interno di un raggio di %1 km.', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'IT', 'Avvisi:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'IT', 'Coordinate home:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'IT', 'Nazione:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'IT', 'Cognome:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'IT', 'Nome:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('569', 'IT', 'Raccomandata', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'IT', '%1 ha trovato la geocache', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('571', 'IT', '%1 non ha trovato la geocache', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('572', 'IT', '%1 ha scritto una nota', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('573', 'IT', '%1 ha visitato l\'evento', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('574', 'IT', '%1 vuole visitare l\'evento', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('575', 'IT', '%1', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('576', 'IT', 'Modifica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('577', 'IT', 'Cancella', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('578', 'IT', 'Carica immagine', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('579', 'IT', 'Immagini per questo log:', '2010-09-01 23:49:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('580', 'IT', 'Ritorna al listing della geocache', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'IT', 'Indirizzo email:', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'IT', 'Log per %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('583', 'IT', 'Selezione immagine', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('584', 'IT', 'Selezione immagine per %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('585', 'IT', 'Non ci sono immagini per questa geocache', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('586', 'IT', 'Anteprima immagine', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'IT', 'Dati del mio profilo', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'IT', 'Nel tuo profilo sono registrate le seguenti informazioni:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'IT', 'Le righe in grigio non sono visibili ad altri utenti.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'IT', 'Nome utente:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('591', 'IT', 'La nazione non è valida.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('592', 'IT', 'Il raggio introdotto non è valido.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('593', 'IT', 'Si è verificato un errore imprevisto.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('594', 'IT', 'Prima di poterti autenticare per la prima volta è necessario attivare l\'utente inserendo il seguente codice:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'IT', 'Nuova password', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('596', 'IT', 'Richiesta', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'IT', 'Cambio', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'IT', 'Richiesta codice', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('599', 'IT', 'Codice nuova password', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('600', 'IT', 'il %1 hai richiesto un codice di sicurezza per cambiare la tua password.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('601', 'IT', 'E\' stato generato il codice seguente: %1', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('602', 'IT', 'Questo codice è valido per 3 giorni.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('603', 'IT', 'Puoi inserire la nuova password in %1newpw.php', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'IT', 'Per cambiare la tua password, devi richiedere un codice di sicurezza che ti verrà inviato via email.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('605', 'IT', 'Questo indirizzo email non è associato ad un nome utente valido.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('606', 'IT', 'Ti è stata inviata una email contenente il codice di sicurezza.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('607', 'IT', 'Si è verificato un errore imprevisto. Il codice di sicurezza non ti può essere inviato.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'IT', 'Per favore inserisci il tuo indirizzo email, il codice di sicurezza che hai ricevuto e la tua password. Il codice di sicurezza è valido solo per 3 giorni. Devi richiedere un nuovo codice se questo periodo di tempo è trascorso.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('609', 'IT', 'L\'utente non è ancora stato attivato.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'IT', 'Codice di sicurezza:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('611', 'IT', 'Il codice di sicurezza è scaduto. Per favore richiedine uno nuovo.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('612', 'IT', 'Il codice di sicurezza non coincide.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'IT', 'Per favore ripeti:', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('614', 'IT', 'La password è stata cambiata.', '2013-02-14 00:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('615', 'IT', 'Codice di sicurezza per nuovo indirizzo email', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('616', 'IT', 'il %1 hai richiesto un codice di sicurezza per modificare il tuo indirizzo email.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('617', 'IT', 'Puoi verificare il tuo nuovo indirizzo email alla pagina %1newemail.php', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'IT', 'Modifica indirizzo email', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'IT', 'Per modificare il tuo indirizzo email devi richiedere un codice di sicurezza. Ti verrà inviato al tuo nuovo indirizzo email.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'IT', 'Nuovo indirizzo email:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('621', 'IT', 'Questo indirizzo email è già assegnato al tuo utente.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'IT', 'Per favore inserisci il codice di sicurezza che hai ricevuto. Il codice di sicurezza è valodo solo per 3 giorni. Devi richiedere un nuovo codice se questo periodo di tempo è trascorso.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'IT', 'Per favore richiedi prima un codice di controllo.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('624', 'IT', 'Non è stato registrato un nuovo indirizzo email. Per favore richiedi prima un codice di controllo.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('625', 'IT', 'L\'indirizzo email è stato modificato.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('626', 'IT', 'Scarica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('627', 'IT', 'Non ci sono ricerche salvate disponibili', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('628', 'IT', 'Scaricando accetti le <a href=\"articles.php?page=impressum#tos\">condizioni d\'uso</a> di opencaching.de.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('629', 'IT', 'Salva ricerca', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('630', 'IT', 'Salva le opzioni di ricerca in una nuova ricerca', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('631', 'IT', 'Nome della ricerca', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('632', 'IT', 'Devi inserire un nome per questa ricerca.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('633', 'IT', 'Esiste già una ricerca con questo nome.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('634', 'IT', 'Salva', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('635', 'IT', 'Sovrascrivi le vecchie opzioni di ricerca', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('636', 'IT', '-- Seleziona una ricerca da sovrascrivere --', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('637', 'IT', '-- non sono state trovate ricerche salvate --', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'IT', 'Mie raccomandazioni', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('639', 'IT', 'La tua raccomandazione per \"<a href=\"viewcache.php?wp=%1\">%2</a>\" è stata rimossa!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('640', 'IT', 'Rimuovi raccomandazione', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('641', 'IT', 'Non hai raccomandato geocache.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'IT', 'Geocache ignorate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('643', 'IT', 'rimuovi', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'IT', 'Non ci sono geocache ignorate.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('645', 'IT', 'Geocache osservate - impostazioni', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('646', 'IT', 'Spedizione:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('647', 'IT', 'Immediata', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('648', 'IT', 'Giornaliera', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('649', 'IT', 'Settimanale', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('650', 'IT', 'Inviata a:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('651', 'IT', 'ore', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('652', 'IT', 'Inviata il:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('653', 'IT', 'Ora e giorno di spedizione possono essere specificati solo per invii giornalieri o settimanali.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('654', 'IT', 'Errore nel salvataggio delle impostazioni!', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('655', 'IT', 'Impostazioni salvate con successo.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('656', 'IT', 'Geocache osservate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('657', 'IT', 'Ultima trovata', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('658', 'IT', 'Nessuna geocache osservata.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('659', 'IT', 'Ricorda indirizzo email', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('660', 'IT', 'Ricordami l\'indirizzo email', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('661', 'IT', 'Inserisci il tuo nome utente e invieremo una email di recupero al tuo indirizzo email.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('662', 'IT', 'Inserisci un nome utente.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('663', 'IT', 'Il nome utente non esiste.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('664', 'IT', 'La email di recupero è stata inviata.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('665', 'IT', 'Recupero al tuo indirizzo email', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('666', 'IT', 'Indirizzo email con cui ti autentichi:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('667', 'IT', 'hai richiesto una email di recupero il %1', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('668', 'IT', 'Raccomandazioni cache', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('669', 'IT', 'L\'utente che ha raccomandato %1 di %2 ha raccomandato anche le seguenti geocache:', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('670', 'IT', 'Occorrenze', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('671', 'IT', 'Nessuna raccomandazione trovata.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('672', 'IT', 'Manutenzione database', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('673', 'IT', 'Manutenzione DB', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('674', 'IT', '%1 ha corretto %2 entrate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'IT', 'Esegui', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'IT', 'Invia', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'IT', 'Email da', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('678', 'IT', 'Spiacente, l\'utente richiesto è disattivato.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('679', 'IT', 'Spiacente, non esiste un indirizzo email per questo utente.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('680', 'IT', 'Si è verificato un errore sconosciuto e la email non è stata inviata.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('681', 'IT', '\'%1\' ti ha contattato via %2\r Profilo dell\'utente %2viewprofile.php?userid=%3\r Per rispondere a questa email utilizza il link alla email che trovi nel profilo dell\'utente.\r', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'IT', 'Soggetto:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('683', 'IT', 'Tutte le informazioni verranno mantenute confidenziali e non saranno rivelate a terzi!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('684', 'IT', '\'%1\' con indirizzo email %2 ti ha contattato via %3 Profilo utente: %3viewprofile.php?userid=%4 Utilizza il pulsante rispondi (reply) del tuo cliente email per rispondere a questa email.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('685', 'IT', 'Inviata email a %1.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'IT', 'Contenuto:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('687', 'IT', 'Invia email a %1', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('688', 'IT', 'Devi inserire un soggetto!', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('689', 'IT', 'Devi inserire un messaggio!', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('690', 'IT', 'Invia il mio indirizzo email con questo messaggio', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('691', 'IT', 'Questo permette al destinatario di rispondere alla tua email usando il suo client di email.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('692', 'IT', 'Per proteggere te e noi dagli abusi:', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('693', 'IT', 'Sono ammesse solo email riguardanti il geocaching. Lo spam è proibito!', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('694', 'IT', 'Verranno registrate tutte le informazioni rilevanti (data/ora, mittente/destinatario e indirizzo IP).', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('696', 'IT', 'Spiacente, questa geocache non è pubblicata.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'IT', 'Visualizza tutti i log', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'IT', 'Visualizza geocache', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'IT', 'Se già autenticato.<br /> Per favore <a href=\"login.php?action=logout\">esci</a> per autenticarti di nuovo.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'IT', 'Scaricando questo file, accetti le nostre <a href=\"articles.php?page=impressum#tos\">condizioni d\'uso</a>.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'IT', 'Difficultà: %1 su 5', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('702', 'IT', 'Terreno: %1 su 5', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('703', 'IT', 'Lista dei partecipanti', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'IT', 'Logga questa cache', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('705', 'IT', 'Non osservare', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'IT', 'Osserva', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('707', 'IT', 'Non ignorare', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'IT', 'Ignora', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'IT', 'Stampa', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'IT', 'Conversione coordinate', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'IT', 'Dimensione', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'IT', 'Tempo necessario', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'IT', 'Distanza', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'IT', 'Nascosta il', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'IT', 'Pubblicata dal', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'IT', 'Ultimo aggiornamento', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'IT', 'Waypoint', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'IT', 'Pubblicata anche su', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'IT', 'Note', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'IT', 'Osservata', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'IT', 'Ignorata', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'IT', 'Pagina visite', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'IT', 'Attributi cache', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'IT', 'Suggerimenti addizionali', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'IT', 'Decripta', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'IT', 'Immagini', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'IT', 'Utilità', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('729', 'IT', 'Visualizza le raccomandazioni degli utenti che hanno raccomandato questa geocache: <a href=\"recommendations.php?cacheid=%1\">all</a>', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'IT', 'Cerca geocache vicine:', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'IT', 'tutte', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'IT', 'ricercabile', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'IT', 'Scarica come file:', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'IT', 'Formato di scambio GPS (.gpx)', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('735', 'IT', 'File waypoint (.loc)', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'IT', 'Google Earth (.kml)', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('737', 'IT', 'TomTom POI (.ov2)', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('738', 'IT', 'TOP50 Overlay (.ovl)', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'IT', 'File di testo (.txt)', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'IT', 'C O P I A', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('741', 'IT', 'Modifica immagine', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('742', 'IT', 'Spiacente, l\'immagine richiesta non esiste.', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('743', 'IT', 'Spiacente, il log richiesto non esiste.', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('744', 'IT', 'Visualizza statistiche', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('745', 'IT', 'Età', '2010-09-01 23:49:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('746', 'IT', 'Descrizione', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('747', 'IT', 'Località', '2010-09-01 23:49:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('748', 'IT', 'MiniMap-Zoom', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('749', 'IT', 'Segnala questa cache', '2010-09-01 23:49:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('750', 'IT', 'Cache segnalate', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('751', 'IT', 'Nome file:', '2010-09-01 23:49:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('752', 'IT', 'Per favore dai un titolo all\'immagine!', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('753', 'IT', 'Aggiungi immagine per la geocache %1', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('754', 'IT', 'Aggiungi immagine per il log %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('755', 'IT', 'Modifica immagine per la geocache %1', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('756', 'IT', 'Modifica immagine per il log %1', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'IT', 'Titolo:', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('758', 'IT', 'Dai un titolo all\'immagine!', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('759', 'IT', 'Quando premi <i>carica</i> può essere necessario un certo tempo prima che venga visualizzata la pagina successiva.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('760', 'IT', 'Questa immagine è uno spoiler - non visualizzare l\'anteprima.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('761', 'IT', 'Carica', '2010-08-31 20:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('762', 'IT', 'Sono ammessi solo i seguenti formati per le immagini: BMP, GIF, PNG and JPEG. Raccomandiamo JPEG per le foto.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('763', 'IT', 'La dimensione dell\'immagine non deve essere superiore a 150kB. Raccomandiamo immagini di 480 pixel di larghezza per 360 di altezza.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('764', 'IT', 'Segnalazione per %1 inviata.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('765', 'IT', 'Motivo:', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('766', 'IT', 'Commento:', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('767', 'IT', 'Segnalazione %1', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('768', 'IT', 'Devi avere un motivo per la tua segnalazione!', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('769', 'IT', 'Commento: (richiesto)', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('770', 'IT', 'E\' richiesto un tuo commento per segnalare una cache!', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('771', 'IT', 'Si è verificato un errore sconosciuto. Segnalazione fallita.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('772', 'IT', 'Segnala cache', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('773', 'IT', 'Nuova', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('774', 'IT', 'In corso', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('775', 'IT', 'Fatto', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('776', 'IT', 'Cache su proprietà privata', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('777', 'IT', 'Violazione del diritto d\'autore', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('778', 'IT', 'Cache sparita', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('779', 'IT', 'Altro motivo', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('780', 'IT', 'Questa segnalazione è già assegnata ad un altro Amministratore!', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('781', 'IT', 'Questa segnalazione è già assegnata a te!', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('782', 'IT', 'Non puoi lavorare su questa segnalazione, è già assegnata ad un altro Amministratore!', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('783', 'IT', 'Per lavorare su una segnalazione devi assegnartela!', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('784', 'IT', 'Nessuna cache segnalata', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('785', 'IT', 'Dettagli segnalazione di ', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('786', 'IT', 'di', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('787', 'IT', 'non assegnata', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('788', 'IT', 'Assegnala a me', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('789', 'IT', 'Contatta il proprietario', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('792', 'IT', 'Marca come sparita', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('793', 'IT', 'Azione', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('794', 'IT', 'Prima di segnalare una cache al team Opencaching, dovresti cercare di contattare il proprietario e provare a risolvere il presunto problema da solo. Questo non si applica per cache che violino le condizioni d\'uso dell\'Opencaching in modo tale da richiedere l\'immediato intervento di un amministratore Opencaching.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('795', 'IT', 'Non visualizzare questa immagine (che è utilizzata solo nella descrizione HTML ecc.)', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('796', 'IT', 'Nessuna informazione trovata nei dettagli dell\'utente.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('797', 'IT', 'Coordinate', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('798', 'IT', 'Geokrets', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('799', 'IT', 'Miei dettagli', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('800', 'IT', 'Modifica dettagli', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('801', 'IT', 'Dettagli utente', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('802', 'IT', 'Dettagli mio profilo', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('803', 'IT', 'Le seguenti informazioni dettagliate sono registrate nel tuo profilo utente:', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('804', 'IT', 'Le righe non spuntate non sono visibili agli altri utenti.<br /> Le righe non spuntabili sono usate solo per scopi interni e non verrano mai visualizzate nel tuo profilo pubblico.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('805', 'IT', 'Errore di registrazione.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('806', 'IT', 'Trovati caratteri non ammessi in', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('807', 'IT', 'Campo troppo lungo in', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('808', 'IT', 'Ripristinati i dati originali.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('809', 'IT', 'visibile', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('810', 'IT', 'invisibile', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('811', 'IT', 'interno', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('812', 'IT', '(*) nuove segnalazioni', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('814', 'IT', 'Statistiche utente', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('815', 'IT', 'visualizza', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('816', 'IT', 'Questo utente non ha ancora trovato nessuna cache.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('817', 'IT', 'Questa cache è stata chiusa dall\'amministratore perchè violava le condizioni d\'uso di Opencaching. Se vuoi riaprirla, contattaci utilizzando il link \"segnala cache\"', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('818', 'IT', 'doc/sql/static-data/data.sql è cambiato dall\'ultimo checkout CVS.<br /> Prima di modificare le traduzioni, aggiorna il database dai dati sql!<br /> \&nbsp;', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('819', 'IT', 'Spiacente, la geocache è chiusa e non può essere vista.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('821', 'IT', 'Chiusa, visibile', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('822', 'IT', 'Chiusa, invisibile', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('823', 'IT', 'Ultima modifica:', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('826', 'IT', '=== Per favore seleziona ===', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('827', 'IT', 'Adozioni', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('828', 'IT', 'Data', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('829', 'IT', 'Si, ho letto e approvato le <a href=\"articles.php?page=impressum#tos\">condizioni d\'uso</a> di Opencaching.de.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('830', 'IT', 'Per completare l\'adozione, devi inviare questa form.<br /> Inviando questa form, diventi il proprietario responsabile per questa geocache.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('831', 'IT', 'il %2, %1 ti ha offerto questa geocache in adozione', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('832', 'IT', 'Grazie per avere adottato %1', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('833', 'IT', 'Conferma l\'adozione di %1', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('834', 'IT', 'Non ci sono al momento attuale cache che possano essere adottate.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('835', 'IT', 'Adotta adesso', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('836', 'IT', 'Geocache che ti sono state offerte in adozione', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('837', 'IT', 'Si, ho letto e compreso quanto sopra e lo approvo.', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('838', 'IT', 'Quando hai trovato un utente che voglia adottare la tua geocache, inserisci il nome utente e invia. L\'utente vedrà questa geocache in \"il mio Profilo \&gt; Adozioni\". Per completare l\'adozioni, l\'utente deve accettare le condizioni d\'uso e confermare l\'adozione. Puoi offrire questa geocache a più di un utente. Il primo utente che conferma l\'adozione diventa il nuovo proprietario di questa cache. Con l\'adozione, concedi all\'utente diritti illimitati di utilizzo, modifica, pubblicazione e licenza sulla geocache.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('839', 'IT', 'Offri %1 in adozione', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('840', 'IT', 'Non hai invitato nessun utente ad adottare questa cache.', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('841', 'IT', 'Rifiuta l\'adozione', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('842', 'IT', 'Lista di utenti a cui hai offerto %1 in adozione', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('843', 'IT', 'Nome utente sconosciuto', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('844', 'IT', 'Non puoi adottare le tue cache!', '2010-08-31 20:06:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('845', 'IT', 'Spiacente, devi leggere e accettare quanto sopra per continuare!', '2010-09-01 23:49:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('846', 'IT', 'Spiacente, devi leggere e accettare le condizioni d\'uso per continuare!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('847', 'IT', 'Questa regola assicura che la tua password non possa essere indovinata da uno script automatico.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('848', 'IT', 'a-z A-Z 0-9 e .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~#', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('849', 'IT', 'Non tutti i caratteri speciali sono ammessi. Puoi usare solamente:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('850', 'IT', 'Non usare parole contenute in un dizionario come ad esempio \'master\'', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('851', 'IT', 'Non usare parole comuni nel geocaching', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('852', 'IT', 'Non usare parti del tuo nome utente, del tuo nome vero o del tuo indirizzo di email.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'IT', 'Lunghezza tra 6 e 60 caratteri', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('854', 'IT', 'Per favore verifica che la tua password soddisfi i seguenti criteri:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('855', 'IT', 'La tua password non soddisfa i criteri di sicurezza.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'IT', 'Montenegro', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'IT', 'Serbia', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('858', 'IT', '* Se l\'utente si disconnette esplicitamente dopo la sua ultima visita o se sono passati<br /> più di 90 giorni dall\'ultima autenticazione, non è possibile determinare la data di ultima autenticazione.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('859', 'IT', 'Gestione utente', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('860', 'IT', 'Sicuro?', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('861', 'IT', 'Disabilita (e chiudi tutte le cache possedute)', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('862', 'IT', 'Sconosciuto', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('863', 'IT', 'Ultima autenticazione nota:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('864', 'IT', 'Geocache attive:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('865', 'IT', 'Totale nascoste:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('866', 'IT', 'Numero di log:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('867', 'IT', 'Utenti attivi:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('868', 'IT', 'Data di creazione:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('869', 'IT', 'Visualizza i dettagli dell\'utente', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('870', 'IT', 'Dettagli utente', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('871', 'IT', 'email:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('872', 'IT', 'Scarica waypoint', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('873', 'IT', 'Nuovi ingressi', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('874', 'IT', 'Nascondi', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('875', 'IT', 'Terreno', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('876', 'IT', 'Difficoltà', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('877', 'IT', 'Invia questo waypoint al GPS:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('882', 'IT', 'Raccomandazioni al top', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('884', 'IT', '%1 raccomandazini negli ultimi 30 giorni', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('885', 'IT', '\&gt;<a href=\"tops.php\">Qui</a>\&lt; puoi trovare altre raccomandazioni.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('886', 'IT', 'Cache non trovate', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('887', 'IT', 'Ultima&nbsp;autenticazione', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('888', 'IT', 'Entro l\'ultimo mese', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('889', 'IT', 'Tra 1 e 6 mesi', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('890', 'IT', 'Tra 6 e 12 mesi', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('891', 'IT', 'Più di 12 mesi fa.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('892', 'IT', 'L\'utente è stato disabilitato.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('893', 'IT', 'E\' stata inviata una nuova email di attivazione.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('894', 'IT', 'di', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('895', 'IT', 'Visualizza in Google Maps', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('896', 'IT', '(in GM)', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('897', 'IT', 'Questo utente non ha ancora nascosto cache.', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('898', 'IT', 'Geocaching.de', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('899', 'IT', 'Google Maps', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'IT', 'Donazioni', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('901', 'IT', 'Tipo di log', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('902', 'IT', 'Testo', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('903', 'IT', 'Raccomandi questa cache?', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('904', 'IT', '(solo se possiedi punti inutilizzati)', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('905', 'IT', 'waypoint OC', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'IT', 'Condizioni d\'uso', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('907', 'IT', 'Il nostro team', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('914', 'IT', 'Riserva naturale', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('915', 'IT', 'Scan completato', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('916', 'IT', 'File attuale:', '2010-09-10 23:15:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('921', 'IT', 'Informazioni', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'IT', 'IT', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('923', 'IT', 'Fallimento nella compilazione del template. Potrebbe trattarsi di un problema temporaneo. Per favore riprova tra qualche minuto.', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('933', 'IT', 'Scan codice sorgente', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('954', 'IT', 'Standard', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('957', 'IT', 'Chat/IRC', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1059', 'IT', 'Esiste già un utente con questo nome.', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1060', 'IT', 'Opencaching-Wiki', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1061', 'IT', 'Condizioni d\'uso e informazioni legali', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1062', 'IT', 'Pagina sulle prestazioni', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1063', 'IT', 'Creazione della pagina', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1097', 'IT', 'D/T', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1100', 'IT', '.gpx', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1123', 'IT', 'Nome cache', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1141', 'IT', 'N', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1142', 'IT', 'S', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1143', 'IT', 'E', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1144', 'IT', 'O', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1146', 'IT', 'Chilometri', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1164', 'IT', 'Altri oggetti trovati...', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1165', 'IT', 'Ricerca per città, cache o waypoint', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1166', 'IT', 'Visualizza link a questa mappa', '2010-09-10 23:15:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1206', 'IT', 'km', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1208', 'IT', 'h', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1212', 'IT', 'Pagina:', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'IT', 'Mappa', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1272', 'IT', 'Visualizza a pieno schermo', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'IT', 'Menu principale', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1278', 'IT', 'Editor', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1279', 'IT', '\&lt;html\&gt;', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1292', 'IT', 'L\'utilizzo degli smilies non è supportato', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1296', 'IT', 'Sono ammesse solo le immagini nei seguenti formati: BMP, GIF, PNG e JPEG.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1297', 'IT', 'alle (ora)', '2010-08-28 22:26:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1298', 'IT', 'Questa lista è generata automaticamente sulla base delle raccomandazioni degli utenti. Puoi trovare maggiori informazioni sulla classificazione regionale nell <a href=\"http://wiki.opencaching.de/index.php/Empfehlungen\" target=\"_blank\">Wiki</a>.<br /> <br /> I numeri nella lista qui sotto significano:<br /> <img src=\"images/rating-star.gif\" border=\"0\" alt=\"Recommendations\"> Numbero di utenti che raccomandano questa cache<br /> <img src=\"resource2/%1/images/log/16x16-found.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"Found\"> Checks = Numero di volte in cui la cache è stata trovata<br /> L\' indice cerca di ordinare il numero di raccomandazioni e i ritrovamenti in modo da visualizzare per prime \'le migliori\' geocache.<br /> <img src=\"images/tops-formula.png\" border=\"0\" alt=\"Formula\"> \r\n', '2010-08-28 22:26:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1299', 'IT', 'Errore caricamento file!', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1300', 'IT', 'Il file XML non può essere caricato!', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1301', 'IT', 'Esportazione SQL', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1302', 'IT', 'Scarica XML', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1303', 'IT', 'Importa XML', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1304', 'IT', 'Il file XML contenete le traduzioni:', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1305', 'IT', 'Controlla le seguenti lingue nel file XML:', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1306', 'IT', 'Scan file', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1307', 'IT', 'Codice sorgente modificato, testo non più utilizzato', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1308', 'IT', 'Nuova traduzione', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1309', 'IT', 'Traduzione modificata', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1310', 'IT', 'vecchio', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1311', 'IT', 'Seleziona tutto', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1312', 'IT', 'Conferma', '2010-09-10 23:15:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1315', 'IT', 'Data:', '2010-09-10 23:33:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1316', 'IT', 'Log:', '2010-09-10 23:56:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1317', 'IT', 'Parole chiave per il log:', '2010-09-10 23:57:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1319', 'IT', 'La parola chiave non è corretta!', '2010-09-11 00:06:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1320', 'IT', '(solo per i log \"trovata\")', '2010-09-11 00:07:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1321', 'IT', 'Pubblicata solo qui!', '2010-09-11 00:07:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1322', 'IT', 'Nuovo log', '2010-09-11 00:07:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1323', 'IT', 'Tipo di log:', '2010-09-11 00:06:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1326', 'IT', 'Raccomandazioni:', '2010-09-11 00:06:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1327', 'IT', 'Puoi raccomandare questa cache solo dopo che la hai loggata come trovata!', '2010-09-11 00:05:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1328', 'IT', 'Questa cache è una delle mie raccomandazioni.', '2010-09-11 00:05:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1329', 'IT', 'Opzionalmente puoi recuperare una delle <a href=\"mytop5.php\">raccomandazioni</a> esistenti.', '2010-09-11 00:05:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1330', 'IT', 'Hai usato {curr} raccomandazioni su {max} disponibili.', '2010-09-11 00:05:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1331', 'IT', 'Pericoli', '2010-09-10 23:58:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'IT', 'Infrastrutture', '2010-09-11 00:05:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1333', 'IT', 'Waypoints', '2010-09-11 00:05:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1334', 'IT', 'Comune', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1335', 'IT', 'Tempo', '2010-09-11 00:04:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1336', 'IT', 'Stagionale', '2010-09-11 00:04:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1337', 'IT', 'Sistema', '2010-09-11 00:03:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1338', 'IT', 'Necessari attrezzi', '2010-09-11 00:03:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1339', 'IT', 'Necessaria preparazione', '2010-09-11 00:03:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1340', 'IT', 'Persone', '2010-09-11 00:03:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1341', 'IT', 'Trasporti', '2010-09-11 00:03:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1342', 'IT', 'Proprietà', '2010-09-11 00:02:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1343', 'IT', 'Limitazioni / Prerequisiti', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1344', 'IT', 'Raccomandazioni / Divieti', '2010-09-11 00:02:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1345', 'IT', 'Loggabile solo su Opencaching', '2010-09-11 00:02:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1346', 'IT', 'Tempo e sforzo (opzionali):', '2010-09-11 00:02:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1347', 'IT', 'Lo sforzo naturalmente può essere solo stimato e può variare anche a seconda delle condizioni ambientali. Se non è possibile inserire informazioni sufficientemente dettagliate, scrivere in entrambi i campi 0 (zero)', '2010-09-11 00:02:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1348', 'IT', 'Waypoints (opzionali):', '2010-09-11 00:02:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1349', 'IT', 'Questi waypoint saranno usati per visualizzare collegamenti nella visualizzazione della cache e nella pagina dei log.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1350', 'IT', 'Nessun dato verrà importato automaticamente da questi servizi di registrazione.', '2010-09-11 00:00:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1351', 'IT', 'Descrizioni', '2010-09-11 00:00:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1352', 'IT', 'Aggiungi una descrizione addizionale', '2010-09-11 00:00:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1353', 'IT', 'La tua descrizione contiene almeno un collegamento ad una immagine ospitata su geocaching.com!', '2010-09-11 00:00:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1354', 'IT', 'Per prevenire ogni problema con geocaching.com ti invitiamo a caricare tutte le immagini collegate anche su opencaching.de e collegare le immagini nel codice HTML a quelle presenti su opencaching.de', '2010-09-11 00:00:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1355', 'IT', 'Carica una immagine', '2010-09-10 23:59:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1356', 'IT', 'Pubblicata dal:', '2010-09-10 23:59:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1357', 'IT', 'Questa cache è tua', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1358', 'IT', 'Hai già trovato questa cache', '2010-09-10 23:59:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1359', 'IT', 'Non hai ancora trovato questa cache', '2010-09-10 23:58:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1360', 'IT', 'In questa cache c\'è un GeoKrety', '2010-09-10 23:58:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1361', 'IT', 'Questa cache ha %1 raccomandazioni', '2010-09-10 23:58:30');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1362', 'IT', 'Modificare il log per la cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-10 23:58:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1363', 'IT', 'Tipo di log:', '2010-09-10 23:57:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1364', 'IT', 'JavaScript è disabilitato, è possibile inserire solo testo semplice. Per inserire HTML o usare l\'editor attivare JavaScript, per favore.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1365', 'IT', 'Nuova cache', '2010-09-10 23:57:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1366', 'IT', 'Proprietario:', '2010-09-10 23:56:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1367', 'IT', 'Tipo cache:', '2010-09-10 23:55:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'IT', 'Dimensioni:', '2010-09-10 23:55:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'IT', 'Coordinate:', '2010-09-10 23:55:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1370', 'IT', 'Valutazione:', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1371', 'IT', 'Difficoltà:', '2010-09-10 23:54:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1372', 'IT', 'Terreno:', '2010-09-10 23:54:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1373', 'IT', 'Tempo stimato:', '2010-09-10 23:54:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1374', 'IT', 'Riferimento', '2010-09-10 23:54:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1375', 'IT', 'Crea una nuova descrizione', '2010-09-10 23:54:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1376', 'IT', 'Nascosta il:', '2010-09-10 23:53:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1377', 'IT', '(Lascia in bianco per nessuna password)', '2010-09-10 23:53:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1378', 'IT', 'Si prega di prendere visione della <a href=\"articles.php?page=cacheinfo#logpw\" target=\"_blank\">Descrizione</a>!', '2010-09-10 23:53:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1379', 'IT', 'Meno', '2010-09-10 23:52:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1380', 'IT', 'Ricerca cache', '2010-09-10 23:52:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1381', 'IT', 'JavaScript non è attivo, non puoi usare le seguenti opzioni - tuttavia la ricerca di base è ugualmente possibile.', '2010-09-10 23:52:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1382', 'IT', 'Risultati ordinati per:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1383', 'IT', 'Ultimo log', '2010-09-10 23:52:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1384', 'IT', 'Visualizza prima le raccomandazioni di altri utenti', '2010-09-10 23:51:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1385', 'IT', 'La distanza può essere utilizzata solo se sei autenticato ed hai inserito le tue coordinate.<br />Per la ricerca in base alla distanza vengono utilizzate le tue coordinate per calcolare la distanza.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1386', 'IT', 'Nascondi le seguenti cache:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1387', 'IT', 'Possedute da me', '2010-09-10 23:51:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1388', 'IT', 'Miei ritrovamenti', '2010-09-10 23:51:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1389', 'IT', 'Ignorate', '2010-09-10 23:51:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1390', 'IT', 'Utilizzabile solo se autenticati.', '2010-09-10 23:51:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1391', 'IT', 'Inattive', '2010-09-10 23:50:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1392', 'IT', 'Attributi cache:', '2010-09-10 23:50:44');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1393', 'IT', 'Ricerca per distanza', '2010-09-10 23:50:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1394', 'IT', 'Dalle coordinate:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1395', 'IT', 'Distanza massima:', '2010-09-10 23:50:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1396', 'IT', 'Miglia', '2010-09-10 23:50:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1397', 'IT', 'Miglia marine', '2010-09-10 23:49:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1398', 'IT', 'Ricerca per città', '2010-09-10 23:49:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1399', 'IT', 'Codice postale:', '2010-09-10 23:49:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1400', 'IT', 'Città:', '2010-09-10 23:47:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1401', 'IT', 'Ricerca per testo', '2010-09-10 23:49:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1402', 'IT', 'Ricerca per proprietario', '2010-09-10 23:49:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1403', 'IT', 'Ricerca per log', '2010-09-10 23:49:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1404', 'IT', 'Tipo di log:', '2010-09-10 23:48:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1405', 'IT', 'Si è verificato un errore nel sito', '2010-09-10 23:48:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1406', 'IT', 'Nel tentativo di creare la pagina, si è verificato un errore. Se il problema si ripresenta, segnalalo con una email tramite il link qui a fianco.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1407', 'IT', 'Si è verificato il seguente errore:', '2010-09-10 23:48:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1408', 'IT', 'Pagina:', '2010-09-10 23:48:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1409', 'IT', 'Rapporto errore:', '2010-09-10 23:47:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1411', 'IT', 'Vuoi veramente cancellare questo log?', '2010-09-10 23:47:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1412', 'IT', 'Vuoi inviare un commento a {log_user_name}?', '2010-09-10 23:46:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1413', 'IT', 'Cancella il log', '2010-09-10 23:46:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1414', 'IT', 'La data non è valida.', '2012-08-26 09:10:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1415', 'IT', '(solo per i log \"trovata\")', '2010-09-10 23:44:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1416', 'IT', 'Proponi una nuova cache', '2010-09-10 23:44:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1417', 'IT', 'Se questa è la tua prima cache su Opencaching.de, assicurati di controllare le dimensioni nella <a href=\"articles.php?page=cacheinfo\">descrizione</a>', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1418', 'IT', 'Tragitto', '2010-09-10 23:32:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1419', 'IT', 'Lo sforzo naturalmente può solo essere stimato e può variare anche a seconda delle condizioni ambientali. Se non è possibile rendere disponibili informazioni sufficientemente dettagliate, scrivere in entrambi i campi 0 (zero). (Vedi anche la <a href=\"articles.php?page=cacheinfo#time\" target=\"_blank\">descrizione</a>)', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1420', 'IT', 'Lingua:', '2010-09-10 23:45:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1421', 'IT', 'Descrizioni in altre lingue possono essere aggiunte dopo la pubblicazione della cache.', '2010-09-10 23:44:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1422', 'IT', 'Descrizione breve:', '2010-09-10 23:44:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1423', 'IT', 'Descrizione:', '2010-09-10 23:43:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1425', 'IT', 'Suggerimento aggiuntivo:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1426', 'IT', 'Le immagini per questa cache possono essere aggiunte dopo la sua creazione.', '2010-09-10 23:42:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1427', 'IT', 'Pubblicata:', '2010-09-10 23:40:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1428', 'IT', 'Già pubblicata', '2010-09-10 23:40:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1429', 'IT', 'Pubblicata su', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1430', 'IT', 'Non ancora pubblicata.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1431', 'IT', 'Ho letto e accetto le <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">condizioni d\'uso di Opencaching.de</a> e la <a href=\"http://www.opencaching.de/articles.php?page=impressum#datalicense\">Lecenza dati Opencaching.de</a>.', '2010-09-10 23:39:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1432', 'IT', 'Informazione: il tuo log è stato cancellato dal proprietario della cache', '2010-09-10 23:39:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1433', 'IT', 'Seleziona città', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1434', 'IT', 'Totale di {resultscount} città corrispondenti', '2010-09-10 23:38:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1435', 'IT', 'Esiste più di un risultato che soddisfa i tuoi criteri di scelta. Per favore seleziona la città corretta.', '2010-09-10 23:38:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1436', 'IT', 'Aggiungi log per la cache <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-10 23:38:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1437', 'IT', 'Nome cache non valido', '2010-09-10 23:34:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1438', 'IT', 'Le coordinate usate non sono valide.', '2010-09-10 23:38:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1439', 'IT', 'Il tempo inserito non è valido.', '2010-09-10 23:37:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1440', 'IT', 'La distanza inserita non è valida. Formato aa.aaa', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1441', 'IT', 'Lo stato della cache non corrisponde alle opzioni di pubblicazione.', '2010-09-10 23:34:16');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1442', 'IT', 'Seleziona la revisione dei dati di entrambi!', '2010-09-10 23:33:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1443', 'IT', 'Nessuna foto disponibile', '2010-09-10 23:32:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1444', 'IT', '{results_count} cache trovate.', '2010-09-10 23:33:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1445', 'IT', 'Risultati {startatp1} a {endat} (come zip):', '2010-09-10 23:33:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1446', 'IT', 'Questa descrizione è stata creata su un server Web Opencaching diverso e può essere cancellata solo su quello.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1447', 'IT', 'La descrizione della cache è stata eliminata.', '2010-09-10 23:31:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1448', 'IT', 'Cancella descrizione cache', '2010-09-10 23:30:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1450', 'IT', 'Il tuo codice HTML verrà modificato di nuovo da uno speciale filtro. Questo è necessario per evitare tag HTML pericolosi, come ad esempio\&lt;script\&gt;. Una lista dei tag HTML permessi la puoi trovare <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">qui</a>. ', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1451', 'IT', 'Si prega di non utilizzare immagini ospitate su geocaching.com. Scaricale sul nostro server.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1452', 'IT', 'Suggerimenti crittografati:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1453', 'IT', 'Vuoi veramente cancellare la descrizione della tua cache \&quot;{cachename}\&quot;', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1454', 'IT', 'Si, cancella la descrizione della cache', '2010-09-10 23:26:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1455', 'IT', 'Proponi la cache', '2010-09-10 23:26:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1456', 'IT', 'Formato: GG-MM-AAAA', '2010-09-10 23:26:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1457', 'IT', 'Si sono verificati degli errori, si prega di correggere gli errori evidenziati qui sotto!', '2010-09-10 23:27:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1458', 'IT', 'Le coordinate inserite non sono valide.', '2010-09-10 23:19:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1459', 'IT', 'La distanza inserita non è valida. Formato: aa.aaa', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1460', 'IT', 'La data non è valida. Formato: GG-MM-AAAA', '2010-09-10 23:20:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1461', 'IT', 'La cache può essere adottata soltanto se si approvano le nostri condizioni d\'utilizzo.', '2010-09-10 23:19:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1462', 'IT', 'Questo codice HTML non è valido. Per trovare la causa esatta dell\'errore, puoi usare l\'<a href=\"htmlprev.php\" target=\"_blank\">anteprima HTML</a>.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1463', 'IT', 'Tipo della cache non selezionato!', '2010-09-10 23:18:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1464', 'IT', 'Dimensione della cache non selezionata!', '2010-09-10 23:17:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1465', 'IT', 'Il codice HTML non è valido.', '2010-09-10 23:17:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1466', 'IT', 'La cache è registrata nel database. Ora verrai reindirizzato alla pagina della cache.', '2010-09-10 23:17:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1467', 'IT', 'Seleziona', '2010-09-10 23:17:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1468', 'IT', '(Errore interno) La descrizione non è disponibile.', '2010-09-10 23:17:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1469', 'IT', '(Errore interno) Esiste già una descrizione con questa lingua.', '2010-09-10 23:16:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1471', 'IT', 'Esiste già una descrizione in questa lingua', '2010-09-10 23:16:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1473', 'IT', 'Vuoi veramente cancellare questo log?', '2010-09-10 23:15:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1475', 'IT', 'Un comando di database non può essere completato.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1476', 'IT', 'Modifica cache <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2010-09-11 02:36:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1477', 'IT', 'offerta in adozione', '2010-09-11 02:34:42');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1478', 'IT', 'Stato:', '2010-09-11 02:33:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1479', 'IT', 'Ricerca waypoint', '2010-09-11 02:35:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1480', 'IT', 'Siti locali', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1482', 'IT', 'Waypoint:', '2010-09-11 02:33:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1483', 'IT', 'ora', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1486', 'IT', 'Se il tuo browser non supporta il reindirizzamento automatico, clicca qui.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1489', 'IT', 'DE', '2010-09-11 02:33:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'IT', 'Password', '2010-09-11 02:33:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1491', 'IT', 'Modifica descrizione della cache per <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2010-09-11 02:32:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1494', 'IT', 'Aggiungere', '2010-09-11 02:33:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1495', 'IT', 'Inserisci un nome, per favore!', '2010-09-11 02:32:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1496', 'IT', 'Completa il campo testo, per favore!', '2010-09-11 02:32:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1497', 'IT', 'Devi selezionare almeno un campo!', '2010-09-11 02:32:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1498', 'IT', 'La longitudine deve essere un numero!\\nFormato: hh° mm.mmm', '2010-09-11 02:32:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1499', 'IT', 'La latitudine deve essere un numero!\\nFormato: hh° mm.mmm', '2010-09-11 02:32:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1500', 'IT', 'La distanza massima deve essere un numero!', '2010-09-11 02:32:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1501', 'IT', 'La distanza deve essere compresa tra 0 e 9999', '2010-09-11 02:32:12');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1502', 'IT', 'Inserisci un codice postale, per favore!', '2010-09-11 02:32:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1503', 'IT', 'Inserisci la città, per favore!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1504', 'IT', 'Inserisci il proprietario, per favore!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1505', 'IT', 'Inserisci l\'utente, per favore!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1506', 'IT', 'Registrate su più siti (waypoint presente in gc.com o nc.com)', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1507', 'IT', 'Il formato di uscita selezionato è sconosciuto!', '2010-09-11 02:31:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1508', 'IT', 'La ricerca non può essere eseguita, per favore reinserisci i dati di ricerca.', '2010-09-11 02:31:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1509', 'IT', 'Trovata', '2010-09-11 02:31:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1511', 'IT', 'Nessun punteggio', '2010-09-11 02:30:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1512', 'IT', 'Il codice postale non è stato trovato', '2010-09-11 02:30:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1513', 'IT', 'Non esistono città con questo nome', '2010-09-11 02:30:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1514', 'IT', 'Non ci sono coordinate disponibili per la città selezionata', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1515', 'IT', 'La città inserita non è valida.', '2010-09-11 02:31:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1516', 'IT', 'Il testo inserito non è valido.', '2010-09-11 02:30:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1517', 'IT', 'Il testo inserito contiene più di 50 parole', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1518', 'IT', 'Tutte le nazioni', '2010-09-11 02:30:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1519', 'IT', 'Tutti i tipi di cache', '2010-09-11 02:29:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1520', 'IT', 'Risultati ricerca', '2010-09-11 02:29:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1521', 'IT', 'Questa cache è stata creata su un altro Web server Opencaching e può essere modificata solo su quello.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1522', 'IT', 'Salva opzioni', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1523', 'IT', 'Modifica opzioni', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1524', 'IT', 'Tipo', '2010-09-11 02:28:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1525', 'IT', 'Ultimo log', '2010-09-11 02:29:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1526', 'IT', 'Scarichi', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1527', 'IT', 'Risultati su questa pagina:', '2010-09-11 02:27:59');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1528', 'IT', 'Scarica per applicazioni locali', '2010-09-11 02:27:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1529', 'IT', 'Scaricando il file accetti le <a href=\"articles.php?page=impressum#tos\">condizioni d\'uso</a> di opencaching.de.\&nbsp;\&nbsp;', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1530', 'IT', 'Questo log è stato creato su un altro Web server Opencaching e può essere modificato solo su quello.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1531', 'IT', 'Questa descrizione è stato creata su un altro Web server Opencaching e può essere modificata solo su quello.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1532', 'IT', 'Il proprietario della cache ha scritto questo commento:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1533', 'IT', 'Per cache virtuali e webcam, la dimensione del contenitore deve essere -nessun contenitore-!', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1537', 'IT', 'Il tuo codice HTML verrà modificato di nuovo da uno speciale filtro. Questo è necessario per evitare tag HTML pericolosi, come ad esempio\&lt;script\&gt;. Una lista dei tag HTML permessi la puoi trovare <a href=\"http://www.opencaching.de/articles.php?page=htmltags\">qui</a>.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1538', 'IT', 'Lingua:', '2010-09-11 02:57:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1539', 'IT', 'Non trovata', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1541', 'IT', 'Solo di notte', '2010-09-12 22:54:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1542', 'IT', 'Solo collegamento ad un altro portale di caching', '2010-09-12 22:54:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1543', 'IT', 'Letterbox (richiede un timbro)', '2010-09-12 22:55:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1544', 'IT', 'Area pericolosa', '2010-09-12 22:55:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1545', 'IT', 'Questa cache può essere trovata solo di notte - è una cosiddetta <i>cache notturna</i>. Ci possono essere targhette riflettenti che devono essere illuminate e ti conducono al nascondiglio, o altri speciali meccanismi di caching notturno.', '2010-09-12 22:54:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1546', 'IT', 'Questa geocache è pubblicata solo su Opencaching. Questo attributo permette agli utenti di altre piattaforme di geocaching di trovare velocemente interessanti cache OC di qualità.', '2010-09-12 22:54:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1547', 'IT', 'Questa cache è pubblicata su Opencachig e su altri siti di geocaching. Si applica alle cache che sono state collegate dai rispettivi proprietari alle corrispondenti registrazioni su altri siti. Per favore fate attenzione che la descrizione e lo stato di cache registrate su più siti deve essere mantenuta identica su tutti i siti incluso Opencaching, come dalle condizioni d\'uso.', '2010-09-12 22:54:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1548', 'IT', 'C\'è un timbro nella cache per timbrare il tuo quaderno personale, e il log della cache verrà timbrato con il tuo timbro personale. Fate attenzione a non confondere i timbri e a lasciare il timbro della cache nella cache! Spesso le letterbox possono essere trovate senza GPS, magari con una bussola e contando i passi - in questo caso aggiungici l\'attributo \"senza GPS\".', '2010-09-13 15:08:37');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1549', 'IT', 'La cache è situata in un\'area pericolosa. Usa questo attributo per segnalare pericoli non ovvi, come strade ad alto traffico, terreno ripido o caduta sassi. Si dovrebbero adottare misure di sicurezza o evitare di andare a cercare la cache, in particolare nel geocaching con bambini, con gruppi numerosi o in condizioni climatiche sfavorevoli.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1550', 'IT', 'Ferrovia attiva nei pressi', '2010-09-12 23:13:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1551', 'IT', 'Scogliera / Rocce', '2010-09-12 23:17:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1552', 'IT', 'Caccia', '2010-09-12 23:17:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1553', 'IT', 'Spine', '2010-09-12 23:17:39');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1554', 'IT', 'Zecche', '2010-09-12 23:17:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1555', 'IT', 'Miniere abbandonate', '2010-09-12 23:17:25');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1556', 'IT', 'Piante velenose', '2010-09-12 23:17:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1557', 'IT', 'Animali pericolosi', '2010-09-12 23:16:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1558', 'IT', 'Parcheggio nei pressi', '2010-09-12 23:17:11');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1559', 'IT', 'Trasporto pubblico', '2010-09-12 23:17:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1560', 'IT', 'Acqua potabile nei pressi', '2010-09-12 23:16:49');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1561', 'IT', 'Bagni pubblici nei pressi', '2010-09-12 23:16:54');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1562', 'IT', 'Telefono pubblico nei pressi', '2010-09-12 23:16:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1563', 'IT', 'Disponibile pronto soccorso', '2010-09-12 23:16:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1564', 'IT', 'Vicino all\'area di parcheggio', '2010-09-12 23:16:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1565', 'IT', 'Lunga camminata', '2010-09-12 23:16:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1566', 'IT', 'Palude o marcita', '2010-09-12 23:16:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1567', 'IT', 'Area collinare', '2010-09-12 23:16:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1568', 'IT', 'Arrampicata (attrezzatura non necessaria)', '2010-09-12 23:15:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1569', 'IT', 'Nuoto necessario', '2010-09-12 23:15:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1570', 'IT', 'Punto di interesse', '2010-09-12 23:16:15');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1571', 'IT', 'Oggetto in movimento', '2010-09-12 23:15:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1572', 'IT', 'Webcam', '2010-09-12 23:15:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1573', 'IT', 'All\'interno di stanze chiuse (caverne, edifici, ecc.)', '2010-09-12 23:16:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1575', 'IT', 'Senza GPS (letterboxes, cistes, compass juggling ...)', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1576', 'IT', 'Tassa di ingresso o di parcheggio', '2010-09-12 23:15:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1577', 'IT', 'Necessario pernottamento', '2010-09-12 23:15:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1578', 'IT', 'Disponibile 24 ore', '2010-09-12 23:15:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1579', 'IT', 'Disponibile solo in certi orari', '2010-09-12 23:16:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1580', 'IT', 'solo di giorno', '2010-09-12 23:15:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1581', 'IT', 'Maree', '2010-09-12 23:15:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1582', 'IT', 'Tutte le stagioni', '2010-09-12 23:14:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1583', 'IT', 'Stagione di riproduzione / natura protetta', '2010-09-12 23:15:14');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1584', 'IT', 'Luogo a prova di neve', '2010-09-12 23:14:55');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1585', 'IT', 'Equipaggiamento speciale', '2010-09-12 23:14:50');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'IT', 'Bussola', '2010-09-12 23:14:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'IT', 'Lampada tascabile', '2010-09-12 23:14:46');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'IT', 'Attrezzatura per arrampicata', '2010-09-12 23:14:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'IT', 'Attrezzatura per grotta', '2010-09-12 23:14:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1590', 'IT', 'Attrezzatura per immersione', '2010-09-12 23:14:17');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'IT', 'Barca', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1592', 'IT', 'Elicottero', '2010-09-12 23:14:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1593', 'IT', 'Ricerca', '2010-09-12 23:13:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'IT', 'Puzzle / Mystery', '2010-09-12 23:13:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'IT', 'Problema matematico', '2010-09-12 23:13:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1596', 'IT', 'Altro tipo di cache', '2010-09-12 23:13:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1597', 'IT', 'Chiedere al proprietario per le condizioni di partenza', '2010-09-12 23:13:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'IT', 'Adatta ai bambini', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'IT', 'Ci sono ferrovie attive nelle vicinanze. Per favore usate cautela, tenendo una distanza di sicurezza e attraversando le rotaie solo ai passaggi a livello ecc.!', '2010-09-12 23:13:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1600', 'IT', 'Ci sono scogliere o rocce pericolose nelle vicinanze. Fate attenzione alla caduta pietre quando siete sotto, e siate cauti quando siete sopra la scogliera - specialmente con bambini e in bicicletta. Può essere molto pericoloso prendere un sentiero ripido per salire la scogliera, poiché non potete sapere in anticipo quando la prima termina e inizia l\'altra.', '2010-09-12 23:13:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'IT', 'La geocache è situata nei pressi di una area di caccia. Al crepuscolo e al buio, dovrebbe sempre essere usata una torcia portatile o frontale per ragioni di sicurezza. Incontrando i cacciatori è opportuna una reciproca gentilezza.', '2010-09-12 23:13:03');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'IT', 'Ci sono spine nei pressi della cache. Indossare indumenti appropriati.', '2010-09-12 23:12:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'IT', 'Stagionalmente ci sono molte zecche in questa area. E\' raccomandabile indossare pantaloni lunghi e ispezionarsi alla ricerca di zecche dopo il geocaching. In internet ci sono mappe di rischio per <i>encefalite e borelliosi da morso di zecca</i>, ad es. per la Germania si veda www.meningitis.de e si cerchi \"FSME\".', '2010-09-12 23:12:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1604', 'IT', 'Nell\'acqua', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'IT', 'Questa cache può essere trovata sia di giorno che di notte.', '2010-09-12 23:30:34');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1606', 'IT', 'Questa cache può essere cercata solo a certe ore del giorno - vedi la descrizione per ulteriori informazioni. Per esempio, la cache può essere in un\'area soggetta ad un orario di apertura.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1607', 'IT', 'Si dovrebbe cercare questa cache solamente durante il giorno. Ad esempio, l\'area può essere pericolosa e contenere scogliere o abissi. Oppure, l\'utilizzo di torce elettriche potrebbe essere impossibile perché risulterebbe sospetto all\'interno di una zona residenziale.', '2010-09-12 23:30:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1608', 'IT', 'Questa cache può essere cercata solo con bassa marea o solo con alta marea.', '2010-09-12 23:30:43');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1609', 'IT', 'Questa cache si trova tutto l\'anno, mentre la difficoltà può dipendere dalle stagioni. Specificare difficoltà per le <i>buone</i> condizioni.', '2010-09-12 23:30:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1610', 'IT', 'Non cercare questa cache durante il periodo riproduttivo degli animali! Per favore indicate nella descrizione della cache quale periodo dell\'anno debba essere evitato. Prestate anche attenzione alle condizioni o ai cartelli riguardo il rispetto della natura.', '2010-09-13 15:09:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1611', 'IT', 'Questa cache può essere trovata anche dopo forti nevicate. Tutte le fasi e la geocache sono nascosti in luoghi sicuri per la neve: non saranno coperti da neve caduta né da cumuli di neve creati ad esempio da veicoli spalaneve.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1612', 'IT', 'Avrete bisogno di attrezzature speciali non specificate da altri attributi, come ad esempio un puntatore laser, walkie-talkie o un cric.', '2010-09-12 23:30:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'IT', 'E\' necessaria una bussola.', '2010-09-12 23:29:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'IT', 'E\' necessaria una torcia portatile per trovare questa cache. Non dimenticate le batterie di riserva!', '2010-09-13 15:09:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'IT', 'Per questa cache, avrete bisogno di materiale da arrampicata e di saperlo usare correttamente. Se sei un principiante, non farlo da solo, ma utilizza il sostegno di uno scalatore esperto o un alpinista.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'IT', 'Questa geocache è nascosta in una grotta, e si dovrebbe utilizzare attrezzature adeguate per accedervi. Attenzione: anche piccole grotte possono prevedere problemi imprevisti e pericoli, come in caso di temporali (acqua!) o una caviglia slogata. Consigliatevi prima con persone che abbiano esperienza di grotte! Abbiate anche cura della natura protetta, ad esempio dei luoghi dove i pipistrelli non devono essere disturbati.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1617', 'IT', 'Avrete bisogno di attrezzatura subacquea per trovare questa geocache. La profondità d\'acqua nella posizione della cache viene specificata nella descrizione. Si prega di notare che l\'immersione in tutta sicurezza richiede una formazione specifica. Senza esperienza di immersioni, è possibile cercare questa cache in compagnia di un insegnante di sub.', '2010-09-12 23:29:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'IT', 'Questa cache di solito può essere trovata solo con una moto d\'acqua. Il nuoto è impossibile a causa della distanza o delle correnti. Vedi la descrizione della cache per maggiori dettagli.', '2010-09-12 23:29:27');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1619', 'IT', 'È necessario trovare ulteriori informazioni prima di poter cercare questa cache. Ciò si applica comunemente a puzzle o mystery cache.', '2010-09-12 23:29:18');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1620', 'IT', 'Puzzle o Mystery devono essere risolti prima o durante la ricerca di questa cache.', '2010-09-12 23:29:13');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'IT', 'Prima o durante la ricerca di questa cache, devono essere risolti problemi matematici più difficili di semplici calcoli base.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1622', 'IT', 'Questa è una cache che non appartiene a nessuna delle categorie standard perdefinite. Usa questo attributo per cache speciali e inusuali.', '2010-09-12 23:28:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1623', 'IT', 'Prima di cercare questa cache, è necessario chiedere al proprietario le condizioni di partenza. Ad esempio la cache può essere collegata ad alcuni eventi in date diverse.', '2010-09-12 23:28:53');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1624', 'IT', 'Questa geocache è stata creata per i bambini. Tutte i compiti possono essere portati a termine da bambini tra 10 e 12 anni e il terreno non presenta rischi (come autostrade, abissi). C\'e un grande contenitore finale con oggetti di scambio e i compiti sono interessanti.', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1625', 'IT', 'Questa cache vi porta in una area di miniera (abbandonata). Ci possono essere pericoli per crollo di gallerie, o potrebbe essere necessario attraversare gallerie. Fare attenzione e utilizzate attrezzature adeguate, soprattutto al buio. Le vecchie miniere possono essere oggetto di conservazione storica.', '2010-09-12 23:43:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1626', 'IT', 'Ci sono piante velenose nelle vicinanze. Fate attenzione e controllate che bambini o cani non le tocchino o le ingoino.', '2010-09-12 23:43:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1627', 'IT', 'Quest area è frequentata da animali potenzialmente pericolosi, ad es. volpi rabide, serpenti velenosi, scorpioni, orsi.', '2010-09-12 23:43:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1628', 'IT', 'Una area di parcheggio è situata nei pressi del punto di partenza di questa cache. Se non è disponibile un parcheggio gratuito, aggiungi l\'attributo \"Tassa di ingresso o di parcheggio\"', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1629', 'IT', 'Questa cache è situata al difuori di aree urbane e ha una stazione di trasporto pubblico nelle vicinanze. Non usate questo attributo per geocache in aree urbane che sono comunemente fornite di mezzi di trasporto pubblico.', '2010-09-13 15:07:05');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1630', 'IT', 'C\'è acqua potabile lungo il percorso o nelle vicinanze della cache. Questo attributo è utile soprattutto nella pianificazione di cache evento, di lunghe escursioni o di cache in luoghi probabilmente sporchi come le grotte o le miniere.', '2010-09-12 23:43:10');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1631', 'IT', 'Ci sono WC pubblici lungo la strada o nelle vicinanze della cache. Questo attributo è utile soprattutto per pianificare cache evento o lunghe multicache.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1632', 'IT', 'Ci sono telefoni pubblici lungo la strada o nelle vicinanze della cache. Specialmente per cache evento dovreste cercare telefoni nelle vicinanze e settare questo attributo se ce ne sono.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1633', 'IT', 'C\'è un pronto soccorso, un telefono per chiamate di soccorso, un centro di soccorso alpino o simili nelle vicinanze della cache. Questo attributo è utile soprattutto in aree difficili, come nel caso di cache con arrampicata, cache in grotte, in alta montagna o nell\'acqua. Controlla se puoi aggiungere un numero di telefono di soccorso (ad esempio del soccorso alpino) nella registrazione della tua cache.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1634', 'IT', 'La geocache è posta vicino ad un\'area di parcheggio, solo poco distante.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1635', 'IT', 'Questa cache richiede una lunga camminata - più di 5 km tra andata e ritorno. In montagna o in altre aree ripide, la distanza per una cache del genere può essere minore. Sono raccomandati scarpe da escursione ed equipaggiamento adeguato.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1636', 'IT', 'Questa cache richiede il superamento di terreno paludoso o acquitrinoso. Indossare un abbigliamento adeguato. Dopo la pioggia, il terreno può essere molto impegnativo o non praticabile a tutti.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1637', 'IT', 'Una o più salite si trovano tra voi e la cache.', '2010-09-12 23:42:33');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1638', 'IT', 'Questa cache richiede un po\' di arrampicata e potrebbe essere necessario usare le mani, ma non c\'è bisogno di attrezzatura da arrampicata. Prestare molta attenzione durante la stagione delle piogge o prima dei temporali!', '2010-09-13 15:06:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1639', 'IT', 'Questa cache richiede l\'attraversamento di un fiume o un lago. L\'acqua è abbastanza profonda per nuotare. È possibile utilizzare una barca, ma la distanza è abbastanza breve per essere alla portata di un nuotatore medio.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1640', 'IT', 'C\'è un punto di interesse alla cache, come un bel panorama o di un castello in rovina. Questo luogo merita una visita anche senza una geocache vicina.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1641', 'IT', 'Questa geocache è in muovimento. Per esempio, il proprietario potrebbe spostare regolarmente la cache da un luogo ad un altro, o i cacher potrebbero eseguire questa operazione e indicare nuove coordinate nel loro log. Il proprietario deve aggiornare le coordinate nella descrizione della cache dopo ogni mossa.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1642', 'IT', 'C\'è una webcam nella posizione di destinazione. E\' necessario registrare una foto con la webcam della vostra visita e includerla nel log. Ci possono essere requisiti addizionali come un segnale di geocaching sulla foto. L\'indirizzo della webcam è incluso nella descrizione della cache, e deve essere accessibile al pubblico, cioè non deve essere necessaria una registrazione al sito o simili.', '2010-09-13 15:06:09');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1643', 'IT', 'Questa geocache non è nascosta all\'aria aperta ma all\'interno di un edificio, di una grotta o simili.', '2010-09-12 23:41:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1644', 'IT', 'Questa cache o uno dei suoi stadi sono posizionati sott\'acqua. Devi entrare in acqua, nuotare o fare una immersione.', '2010-09-12 23:41:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1645', 'IT', 'Questa cache può essere trovata senza un dispositivo GPS. Non sono utilizzate coordinate addizionali oltre alle coordinate iniziali.', '2010-09-12 23:41:26');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1646', 'IT', 'Devi pagare un accesso o parcheggio a pagamento per accedere a questa cache, ad esempio se la cache si trova all\'interno di un parco a tema. Se ci sono alternative di parcheggio gratuiti nelle vicinanze, si prega di includerli nella descrizione. Per favore tieni presenti le nostre condizioni d\'uso a proposito di geocache commerciali.', '2010-09-13 15:05:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1647', 'IT', 'Non è possibile trovare questa cache in un solo giorno o una sola notte. Dovrete visitare il percorso per più di una volta, oppure è necessario il pernottamento. Il tempo di preparazione non è incluso in questo calcolo, ma solo il tempo sul sito.', '2010-09-12 23:41:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1648', 'IT', 'Una nuova notizia è stata creata su opencaching', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1649', 'IT', 'Runtime: {time} secondi', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1650', 'IT', 'La pagina invocata non esiste!', '2010-09-13 00:17:45');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1651', 'IT', 'Ricerca per nome cache', '2010-09-13 00:17:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1652', 'IT', 'Redirezione - opencaching', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1653', 'IT', 'Vuoi veramente cancellare la ricerca salvata?', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'IT', 'Stato', '2010-09-13 00:16:38');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1655', 'IT', 'Setta stato', '2010-09-13 00:16:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'IT', 'Paesi', '2010-09-13 22:10:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1657', 'IT', 'a', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'IT', 'Percorso', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'IT', 'Dimensioni cache:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1660', 'IT', 'Link', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1661', 'IT', 'Aperto', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1662', 'IT', 'Aggiungi ai favoriti...', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1663', 'IT', 'Cache visualizzate', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1664', 'IT', 'Tempo di caricamento', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1665', 'IT', 'sec', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1666', 'IT', 'Visualizza solo le geocache con le seguenti proprietà:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1667', 'IT', 'Tipo di cache', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1668', 'IT', 'Contenitore', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1669', 'IT', 'Nascosta', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1670', 'IT', 'Mie', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1671', 'IT', 'Non attiva', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1672', 'IT', 'Doppio listing', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1673', 'IT', 'Valutazione', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1674', 'IT', 'Raccomandazioni min.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1675', 'IT', 'Sposta zoom', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1676', 'IT', 'Sposta una regione sulla mappa (clicca qui per ripristinare)', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1677', 'IT', 'Sposta zoom indietro', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1678', 'IT', 'Inserire un testo da cercare!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1680', 'IT', 'Waypoint %1 non trovato!', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1681', 'IT', 'D/T:', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1682', 'IT', 'Maps \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1683', 'IT', 'Errore: Impossibile scaricare i risultati della ricerca (codice di errore HTTP %1)', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1684', 'IT', 'Errore: Impossibile scaricare i risultati della ricerca. I dati non sono disponibili sul server.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1685', 'IT', 'Sono state trovate %1 geocache nella regione selezionata che soddisfano le condizioni di filtro. Zoomare per visualizzare le cache.', '2010-10-27 18:49:19');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1686', 'IT', 'Le opzioni di filtro sono state modificate. Cliccare OK per ricaricare il contenuto della mappa.', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1687', 'IT', 'Crea un log', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1688', 'IT', 'Edita il log', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1689', 'IT', 'Rimuovi il log', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1690', 'IT', 'Edita la cache', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1691', 'IT', 'Aggiungi descrizione', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1692', 'IT', 'Edita descrizione', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1693', 'IT', 'Rimuovi descrizione', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1694', 'IT', 'Seleziona città', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1695', 'IT', 'Visualizza risultati ricerca', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1696', 'IT', 'Risultati', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1697', 'IT', 'Descrizione - Creare una cache', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1698', 'IT', 'Aggiungi immagine', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1699', 'IT', 'Messaggio', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1700', 'IT', 'Non ci sono chiavi google maps registrate per questo dominio.', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1701', 'IT', 'Attenzione! Questa geocache è \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> Non c\'è un contenitore fisico alle coordinate specificate (o a quelle che devono essere determinate). L\'interesse del luogo non è necessariamente la ricercare!', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1702', 'IT', 'Attenzione! Questa geocache è \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> La geocache stessa o sue parti sono mancanti o ci sono altri problemi che rendono impossibile cercarla con successo. L\'interesse del luogo non è necessariamente la ricercare!', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1703', 'IT', 'Hai partecipato a questo evento!', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1704', 'IT', 'Hai già trovato questa cache', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1705', 'IT', '<br /><i>Obsoleto: Questo attributo non può essere assegnato a nuove cache, perché non è conforme nelle attuali condizioni d\'uso.</i><br /> Questa cache è disponibile non solo su Opencaching, ma anche in altri siti di geocaching. Questo vale per le cache che sono state collegate dai loro proprietari a corrispondenti annunci in altri siti. Si prega di notare che le descrizioni e lo stato di una cache elencata in più di un sito devono essere mantenute uguali in tutti i siti compreso Opencaching, secondo le nostre condizioni d\'uso. ', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1706', 'IT', 'Questo nodo OC', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1707', 'IT', 'Altri nodi OC', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1708', 'IT', 'I prossimi eventi in %1', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1709', 'IT', 'Geocache con più valutazioni negli ultimi 30 giorni in %1', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'IT', 'Ultime cache in %1', '2010-10-27 18:49:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1711', 'IT', 'Devi trovare ancora {anzahl} cache per fare un\' altra raccomandazione', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1712', 'IT', 'Aggiungi un log per la cache <a href=\"viewcache.php?cacheid=%1\">%2</a>', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1713', 'IT', 'Hai raccomandato questa cache.', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1714', 'IT', 'Ritira la raccomandazione', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1715', 'IT', 'Hai assegnato %1 delle %2 possibili raccomandazioni.', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1716', 'IT', 'Devi avere ancora %1 finds per fare un\'altra raccomandazione.', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1717', 'IT', 'Per favore seleziona!', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1718', 'IT', 'Risultati su questa pagina', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1719', 'IT', 'Risultati {startatp1} in {endat} (come zip)', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1722', 'IT', 'Vuoi veramente cancellare?', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1723', 'IT', 'Vuoi veramente rimuovere questa raccomandazione?', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1724', 'IT', 'Lunghezza percorso', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1725', 'IT', 'Scarica come...', '2010-12-05 00:03:28');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1726', 'IT', 'cancella il log per <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a>', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1727', 'IT', 'Aggiungi una nuova descrizione della cache a <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a>', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1728', 'IT', 'Invia al dispositivo GPS', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1729', 'IT', 'Storia Geoketry', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1730', 'IT', 'Nuovo argomento per il forum (%1)', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1731', 'IT', 'Teamblog', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1732', 'IT', 'Forum', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1733', 'IT', 'Geoketry', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1734', 'IT', 'Importa GPX', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1735', 'IT', 'Per gli eventi: La data dell\'evento!', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1736', 'IT', 'Identificativo utente:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1737', 'IT', 'List', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1738', 'IT', 'Data evento', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1739', 'IT', 'Trovate: %1 Nascoste: %2', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1740', 'IT', '<Utente sconosciuto>', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1741', 'IT', 'Questo utente è già stato attivato. Per favore prova a  <a href=\"login.php\">connetterti</a>.<br />Se non è possibile connetterti, per favore leggi la pagina sui <a href=\"{$opt.cms.login}\">problemi con la connessione</a>', '2011-04-04 21:34:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1742', 'IT', 'Il tuo browser ha rifiutato il nostro cookie.<br/> Puoi trovare ulteriori informazioni su questo argomento in <a href=\"{$opt.cms.login}\">Opencaching.de-help</a>.', '2011-04-04 21:32:29');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1743', 'IT', 'Questa geocache probabilmente è situata in una riserva naturale! Per favore leggi <a href=\"{$opt.cms.npa} target=\"_blank\">questo</a> per ulteriori informazioni.', '2011-04-04 21:25:24');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1744', 'IT', 'Questa geocache probabilmente è situata in una riserva naturale (<a href=\"{$opt.cms.npa}\" target=\"_blank\">Info</a>):', '2011-04-04 21:24:22');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1745', 'IT', 'logo standard', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1747', 'IT', 'Alternativa per nybbler', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1752', 'IT', 'Logo alternativo', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1753', 'IT', 'line sottile', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1754', 'IT', 'Logo rosso, line sottile', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1755', 'IT', 'Linea sottile, senza statistiche', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1756', 'IT', 'Linea rossa sottile, senza statistiche', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1757', 'IT', 'Angoli arrotondati', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1758', 'IT', 'Questo utente è già stato attivato. Per favore prova a <a href=\"login.php\">connetterti</a>.<br />Se non è possibile connetterti, per favore leggi la pagina sui <a href=\"%1\">problemi con la connessione</a>', '2011-05-23 22:30:04');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1759', 'IT', 'Nota:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1760', 'IT', 'Includi una coordinata nella nota', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1761', 'IT', 'La nota non è visibile ad altri utenti. La nota e le coordinate opzionali vengono incluse nei file GPX ed inviate al tuo dispositivo GPS.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1762', 'IT', 'Sottoscrivi i feeds di opencaching', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1763', 'IT', 'Il tuo browser ha rifiutato il nostro cookie.<br/> Puoi trovare ulteriori informazioni su questo argomento in <a href=\"%1\">Opencaching.de-help</a>.', '2011-05-23 22:26:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1764', 'IT', 'Nota personale per la cache', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1765', 'IT', 'Questa geocache è probabilmente situata all\'interno di un\'area naturale protetta! Per favore, vedi <a href=\"%1\" target=\"_blank\">qui</a> per ulteriori informazioni.', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1766', 'IT', 'Questa geocache probabilmente è situata in una riserva naturale (<a href=\"%1\" target=\"_blank\">Info</a>):', '2011-05-23 22:19:58');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1767', 'IT', 'Traduzione rapida', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1768', 'IT', 'Disabilita', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1769', 'IT', 'Abilita - nuova', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1770', 'IT', 'Abilita - tutto', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1771', 'IT', 'Scarica testo (nuova)', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1772', 'IT', 'Scarica testo (tutto)', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1773', 'IT', 'Importa testo', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1774', 'IT', 'File di testo contenete la traduzione:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1775', 'IT', 'Punto intermedio', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1776', 'IT', 'Tipo di punto:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1777', 'IT', 'Per favore seleziona il tipo', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1778', 'IT', 'Coordinata:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1779', 'IT', 'Scasica file GPX (max. 500)', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1780', 'IT', 'Aggiungi punto', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1781', 'IT', 'Aggiungi nuovo', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1782', 'IT', 'Cancella punto', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1783', 'IT', 'Modifica punto', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1788', 'IT', 'Parcheggio', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1789', 'IT', 'Punto di riferimento', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1790', 'IT', 'Punti addizionali', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1791', 'IT', 'Aggiungi un punto', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1792', 'IT', 'Possono essere impostati altri waypoints per rendere la ricerca più semplice, per esempio con le indicazioni di un parcheggio o del punto di partenza di un sentiero (la descrizione del waypoint può contenere ulteriori informazioni). I waypoints sono inclusi nei file GPX e inviati al dispositivo GPS.', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1793', 'IT', 'Nessun punto disponibile', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1794', 'IT', 'Waypoints addizionali possono rendere la ricerca più semplice, per esempio con le indicazioni di un parcheggio o del punto di partenza di un sentiero. I waypoints sono inclusi nei file GPX e inviati al dispositivo GPS.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1795', 'IT', 'Mappe:', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1796', 'IT', 'Pubblicata il', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1797', 'IT', 'Elenco modifiche', '2012-08-26 02:39:48');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1798', 'IT', 'Opencaching e.V.', '2012-07-08 14:50:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1799', 'IT', 'Disponibile solo in certe stagioni', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1800', 'IT', 'Questa cache può essere cercata solo in certe stagioni - vedi la descrizione per ulteriori informazioni. Per esempio, la cache può essere in un labirinto di mais, che esiste solo dalla crescita alla stagione del raccolto.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1801', 'IT', 'Assistenza', '2012-11-09 19:32:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1802', 'IT', 'Avvertenza: Questa segnalazione è già assegnata a un altro admin. Consultarlo/la prima di assegnarsi la segnalazione!', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1803', 'IT', 'nano', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1804', 'IT', 'Licenza dati', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1805', 'IT', 'Il contenuto di www.opencaching.de è rilasciato sotto <br />Licenza <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/de/deed.it\" target=\"_blank\">Attribuzione - Non commerciale - Non opere derivate 3.0 Germania</a>.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1806', 'IT', 'Per favore seleziona una sola opzione cancella/disabilita!', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1807', 'IT', 'Inviando accetto i <a href=\"articles.php?page=impressum#tos\" target=\"_blank\">Termini del Servizio Opencaching.de</a> e la <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Lecenza dati Opencaching.de</a>', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1808', 'IT', 'Ho letto e compreso la <a target=\"_blank\" href=\"articles.php?page=dsb\">dichiarazione di privacy</a>, i <a target=\"_blank\" href=\"articles.php?page=impressum#tos\">termini del servizio</a> e la <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">licnza Dati</a> e di accerrali.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1809', 'IT', 'Devi accettare la dichiarazione di privacy, i termini del servizio e la licenza dati per registrarti su opencaching.de', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1810', 'IT', 'Scaricando questo file accetti i nostri <a href=\"articles.php?page=impressum#tos\">termini di utilizzo</a> e la <a href=\"articles.php?page=impressum#datalicense\" target=\"_blank\">Licenza dati</a>.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1811', 'IT', 'Disabilita (e blocca tutte le geocache possedute) e rimuovi tutti i contenuti con licenza straniera', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1812', 'IT', 'ID', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1813', 'IT', 'Proprietario', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1814', 'IT', 'Segnalatore', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1815', 'IT', 'Devi spuntare che sei sicuro!', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1816', 'IT', 'la descrizione della cache è stata rimossa perchè il proprietario ha declinato la licenza', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1817', 'IT', 'Lo stato dell\\\'utente è stato cambiato.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1818', 'IT', 'Spoiler', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1819', 'IT', 'Dopo il salvataggio può essere necessario premere il pulsante di ricarica sul browser per vedere l\\\'immagine selezionata sul tuo profilo', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1820', 'IT', 'Ora puoi <a href=\"login.php\">autenticarti</a> con la nuova password.', '2013-02-14 00:06:23');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1821', 'IT', 'OC.de nuova', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1822', 'IT', 'OC.de nuova, slimline', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1823', 'IT', 'OC.de nuova, senza statistiche', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1824', 'IT', 'Verifica l\\\'indirizzo email', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1825', 'IT', 'Una o più email non possono essere consegnate all\\\'indirizzo specificato nel tuo profilo utente', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1826', 'IT', 'Per favore conferma che questa email è corretta, o inseriscine una nuova.', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1827', 'IT', 'Inserisci il nuovo indirizzo email', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1828', 'IT', 'Conferma questo indirizzo email', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1829', 'IT', 'Segna l\\\'indirizzo email come non valido', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1830', 'IT', 'mail di licenza dati non consegnata', '2013-02-20 01:27:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'JA', 'JA', '2011-05-15 16:04:51');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1', 'NL', 'ID\'s opnieuw sorteren', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('2', 'NL', 'De verbinding met de database kon niet hersteld worden.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'NL', 'Test - niet inloggen alstublieft', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'NL', 'Gebruiker', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('5', 'NL', '(leeg)', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'NL', 'Ingelogt als', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'NL', 'Uitloggen', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'NL', 'Waypoint-zoeken', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('9', 'NL', 'Pagina gegenereerd in', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('10', 'NL', 'sec', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('11', 'NL', 'Cachegeheugen', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'NL', 'Database verbonden', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('13', 'NL', 'Gemaakt op', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'NL', 'Privacy verklaring', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'NL', 'Juridische informatie', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'NL', 'Contact', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'NL', 'Sitemap', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'NL', 'Registreren', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'NL', 'Nieuwe gebruiker geregistreerd', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'NL', 'Opmerking', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('21', 'NL', 'Vietnamees', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'NL', 'Gebruikersnaam', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'NL', 'E-mail', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'NL', 'Voornaam', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'NL', 'Achternaam', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'NL', 'Land', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'NL', 'Nieuwe gebruiker registreren', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('28', 'NL', 'Oezbeeks', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'NL', 'De gebruikersnaam is niet geldig.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'NL', 'Laatste 5 logs afdrukken', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('31', 'NL', 'De achternaam bevat ongeldige tekens.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('32', 'NL', 'De voornaam bevat ongeldige tekens.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'NL', 'Niet gespecificeerd', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'NL', 'Toon alle', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'NL', 'Het e-mail adres is niet geldig.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'NL', 'Turks', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'NL', 'Jouw wachtwoord', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('38', 'NL', 'Het wachtwoord bevat ongeldige tekens of is te kort.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'NL', 'Beide wachtwoorden zijn niet gelijk.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'NL', 'Herhalen', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'NL', 'Met * aangegeven velden moeten ingevuld worden.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'NL', 'Zweeds', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'NL', 'Sloveens', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('44', 'NL', 'minstens 6 tekens', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'NL', 'minstens 4 verschillende tekens', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('46', 'NL', 'geen deel van de gebruikersnaam', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('47', 'NL', 'niet in de woordenlijst met veelgebruikte wachtwoorden', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('48', 'NL', 'Slovaaks', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'NL', 'Russisch', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'NL', 'Je dient de privacy statement en gebruiksvoorwaarden te accepteren, om op opencaching.nl te registreren', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'NL', 'Herstellen', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('52', 'NL', 'Bijzondere Caches', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('54', 'NL', 'Index', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'NL', 'Aanbevelingen', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'NL', 'Gevonden', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'NL', 'door', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('58', 'NL', 'HTML voorbeeld', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'NL', 'Roemeens', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'NL', 'Stap 1', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('61', 'NL', 'Als eerste een tekst ingeven in het tekstveld en dan op Volgende drukken.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('62', 'NL', 'Volgende', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'NL', 'Stap 2', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'NL', 'Portugees', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('65', 'NL', 'Terug', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('66', 'NL', 'Voorbeeld', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('67', 'NL', 'Stap 3', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('68', 'NL', 'Zo zal de HTML-code in een browser te zien zijn:', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('69', 'NL', 'Bewaar de HTML-code of plaats deze in de cache beschijving.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'NL', 'Nieuws', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'NL', 'Nieuwste Caches', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'NL', 'Nieuwste caches buiten Nederland', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'NL', 'Nieuwste logjes', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'NL', 'Pools', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'NL', 'Noors', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'NL', 'Lets', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'NL', 'Litouws', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'NL', 'Italiaans', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'NL', 'Ijslands', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'NL', 'Startpagina', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'NL', 'Welkom op opencaching.nl', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'NL', 'Hier kan alles gevonden worden wat met Geocaching te maken heeft, als beginner of iemand die veel ervaring heeft. van een eenvoudige wiki tot forum waar met andere cachers gediscussieerd  kan worden.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('83', 'NL', 'Bij de dataoverdracht is een fout opgetreden.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('84', 'NL', 'Het bestand is te groot, de maximale grootte is 150 KB.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('85', 'NL', 'Geen afbeelding opgegeven.', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'NL', 'zelfde cache soort', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'NL', 'Opencaching.nl', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'NL', 'Totaal %1 actieve Caches en %2 gevonden door %3 gebruikers', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('91', 'NL', 'Hongaars', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'NL', 'Kroatisch', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'NL', 'Fins', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'NL', 'Ja', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'NL', 'Nee', '2011-02-04 19:49:56');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'NL', 'Hallo', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('99', 'NL', 'Deze E-Mail werd gegenereerd door de opencaching.nl website, omdat een gebruikersaccount met dit E-Mail adres aangemaakt is. Indien er geen E-Mails meer ontvangen mogen worden, neem dan contact op met %1', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('100', 'NL', 'Baskisch', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'NL', 'Estlands', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'NL', 'Esperanto', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'NL', 'Grieks', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'NL', 'Deens', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('105', 'NL', 'Een onbekende fout is opgetreden.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('106', 'NL', 'De Template bestaat niet.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('107', 'NL', 'Sorry, Je bent niet gemachtigd om deze pagina te bekijken.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('108', 'NL', 'Sorry, de gevraagde cache bestaat niet.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('109', 'NL', 'Sorry, de gevraagde handeling kan niet uitgevoerd worden.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('110', 'NL', 'Sorry, de gevraagde handeling kan niet uitgevoerd worden omdat er niet is ingelogt.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('111', 'NL', 'Sorry, de gevraagde gebruiker bestaat niet.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('112', 'NL', 'E-mail adres bestaat niet.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('113', 'NL', 'Toegestane HTML Tags', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'NL', 'Beschrijving', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'NL', 'Maak een cache', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'NL', 'Admin', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('117', 'NL', 'Informatie', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'NL', 'Caches', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'NL', 'Mijn profiel', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'NL', 'Nieuwste logs', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('121', 'NL', 'Zonder Nederland', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'NL', 'Nieuwste caches', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'NL', 'Over Opencaching', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('124', 'NL', 'Nieuwe toevoeging', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'NL', 'Zoeken', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('126', 'NL', 'Vertaling', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'NL', 'Activatie', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'NL', 'Gebruikersprofiel', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('129', 'NL', 'Er is een fout opgetreden bij het laden van de pagina.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('130', 'NL', 'Er is een fout opgetreden bij het laden van de pagina. Indien deze pagina via een link bereikt is en de fout blijft zich voordoen gelieve ons een e-mail te sturen.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('131', 'NL', 'De volgende fout is opgetreden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('132', 'NL', 'Pagina', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('133', 'NL', 'Foutmelding', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'NL', '%2 heeft %1 gevonden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'NL', '%2 heeft %1 niet gevonden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'NL', '%2 kreeg een opmerking van %2', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'NL', '%2 heeft %1 bezocht', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'NL', '%2 wil %1 bezoeken', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('139', 'NL', 'Registratie bevestiging', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('140', 'NL', 'Hartelijk welkom op www.opencaching.nl!', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('141', 'NL', 'Voor het volgende E-Mail adres %1 werden de volgende gegevens ingevoerd:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('142', 'NL', 'Slavisch', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('143', 'NL', 'De activering kan worden uitgevoerd op het volgende webadres:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('144', 'NL', 'Als je niet inlogt binnen de komende 14 dagen zal jouw account worden verwijderd', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'NL', 'Tsjechisch', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'NL', 'Bulgaars', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'NL', 'Gebruikersprofiel van %1', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'NL', 'E-Mail sturen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'NL', 'Overige', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('150', 'NL', 'Ik neem een PMR zender mee op kanaal 2 met het cachen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'NL', 'Geregistreerd&nbsp;sinds', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'NL', 'Gemaakte caches', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'NL', 'Gevonden caches', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'NL', '%1 van %2 mogelijkheden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('155', 'NL', 'Nederlands', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'NL', 'Japans', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'NL', 'Spaans', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'NL', 'Frans', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'NL', 'Engels', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'NL', 'Duits', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('161', 'NL', 'Atentie: Indien je deze optie gebruikt, vergeet dan niet uit te loggen om te voorkomen dat anderen gegevens zouden kunnen veranderen van jouw account.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'NL', 'Zimbabwe', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'NL', 'Zambia', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'NL', 'Zuid Afrika', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'NL', 'Mayotte', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'NL', 'De activeringscode werd per E-Mail verzonden.<br />Volg de aanwijzigingen in deze E=mal om de activering te voltooien.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'NL', 'Om een gebruikersaccount aan te maken op opencaching.nl, dient je een geldig E-Mail adres en een gebruikersnaam \"nickname\' op te geven. Een E-Mail zal naar het opgegeven E-Mail adres verzonden worden, waarmee het account geactiveerd kan worden. Per E-Mailadres kan één account aangemaakt worden. Voornaam, achternaam en land zijn niet verplicht.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('170', 'NL', 'Het gekozen wachtwoord is te kort. voor jouw veiligheid dient je een langer wachtwoord te kiezen:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('171', 'NL', 'De activatiecode of E-Mailadres in niet correct.<br /> De activatie van het account is mislukt.<br /> Gebruik hetzelfde E-Mail adres die ook bij de registratie is opgegeven.<br /> <br /> Controleer op type fouten. Als de fout zich blijft voordoen. neem contact op via <a href=\"mailto:%1\">%1</a>.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'NL', 'Jemen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'NL', 'Samoa', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('174', 'NL', 'Ga', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('175', 'NL', 'Ontwikkeling - alleen testen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('177', 'NL', 'Wil je in je cachebeschrijving delen of woorden in <b>vet</b> of <i>cursief</i> maken, en geen ervaring met HTML?<br /\n  Geen probleem, met deze instructies wordt het kinderspel.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('178', 'NL', 'Hier zie je een HTML code van jouw tekst. Als je een woord <b>vet</b> hebben wilt, voeg dan voor het eerste woord \&lt;b\&gt; toe en achter het laatste woord \&lt;/b\&gt;.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'NL', 'Wallis en Futuna', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'NL', 'Nieuws toevoegen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'NL', 'Vanuatu', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'NL', 'Vietnam', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'NL', 'Amerikaanse Maagdeneilanden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'NL', 'Britse Maagdeneilanden', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'NL', 'Venezuela', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('186', 'NL', 'Selecteer gewenste taal:', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('187', 'NL', 'Laat nieuwe vertalingen zien', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('188', 'NL', 'Smarty-Cache wissen', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('189', 'NL', 'Niet aangegeven', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('190', 'NL', 'Bekijk zonder verwijzende vertaling', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('191', 'NL', 'Laat alle vertalingen zien', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'NL', 'Saint Vincent en de Grenadines', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'NL', 'Vaticaanstad', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'NL', 'Oezbekistan', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('195', 'NL', 'Gebruik bestaande vertalingen:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('196', 'NL', 'Alle vertalingen:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('197', 'NL', 'Nieuwe vertalingen:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('198', 'NL', 'Vertalingen zonder referentie:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'NL', 'Talen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'NL', 'Uruguay', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'NL', 'Activatiecode:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'NL', 'Verenigde staten', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'NL', 'Kleine afgelegen eilanden van de Verenigde Staten', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('206', 'NL', 'Toaal', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'NL', 'Inloggen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'NL', 'Wachtwoord', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'NL', 'Oeganda', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'NL', 'Oekraïne', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'NL', 'Tanzania', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'NL', 'Taiwan', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'NL', 'Tuvalu', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'NL', 'Trinidad en Tobago', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'NL', 'Turkije', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'NL', 'Nog niet geregistreerd?', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'NL', 'Wachtwoord vergeten?', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'NL', 'E-Mail adres vergeten?', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'NL', 'Andere oplossingen zijn te hier te vinden:', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'NL', 'Zonder logs afdrukken', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'NL', 'Nieuw wachtwoord opgeven', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'NL', 'Herinnering sturen', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'NL', 'Tonga', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'NL', 'Altublieft Gebruikersnaam en Wachtwoord invullen!', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'NL', 'Succesvol uitgelogt.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('226', 'NL', 'Inloggen mislukt.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('227', 'NL', 'De opgegeven gebruikersnaam/E-Mailadres of het wachtwoord komen niet overeen.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('228', 'NL', 'In het laatste uur is er meer dan %1 keer proberen in te loggen. De volgende poging kan pas na een uur vanaf de eerste poging gedaan worden.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'NL', 'Jouw account is niet geactiveerd.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('230', 'NL', 'Je kunt jouw account \&gt;<a href=\"activation.php\">hier</a>\&lt; activeren.', '2011-02-04 19:49:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'NL', 'Tunesië', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'NL', 'Om het account te voltooien, dient je nog het E-Mailadres en de verkregen activeringscode in te voeren en te bevestigen', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'NL', 'Turkmenistan', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'NL', 'Tokelau-eilanden', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'NL', 'Tadzjikistan', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'NL', 'Thailand', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'NL', 'Togo', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'NL', 'Franse Zuidelijke en Antarctische gebieden', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'NL', 'Tsjaad', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'NL', 'Turks- en Caicoseilanden', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'NL', 'Naam', '2011-02-04 19:50:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'NL', 'Swaziland', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'NL', 'Syrië', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('244', 'NL', 'Aanbevelingen van <a href=\"viewprofile.php?userid=%1\">%2</a>', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('245', 'NL', '<a href=\"viewcache.php?cacheid=%1\">%2</a> van %3', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('246', 'NL', '%1 heeft nog geen cache aanbevolen.', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'NL', 'Aanbevelingen tonen', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'NL', 'El Salvador', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'NL', 'Sao Tomé en Principe', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'NL', 'Suriname', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'NL', 'Somalië', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('253', 'NL', 'Onbekend waypointformaat. Toegestane formaten zijn: OCxxxx, NCxxxx en GC, waarbij de xxxx elk cijfer en letter kan zijn.', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('254', 'NL', 'Meerdere caches met waypoint \&quot;%1\&quot; gevonden.', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('255', 'NL', 'Geen cache met waipoint \&quot;%1\&quot; gevonden.', '2011-02-04 19:50:02');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'NL', 'Senegal', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'NL', 'San Marino', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'NL', 'Sierra Leone', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'NL', 'Slowakije', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'NL', 'Spitsbergen en Jan Mayen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'NL', 'Slovenië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'NL', 'Sint-Helena (eiland)', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'NL', 'Singapore', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'NL', 'Zweden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'NL', 'Soedan', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'NL', 'Seychellen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'NL', 'Saoedi-Arabië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'NL', 'Rwanda', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'NL', 'Russische Federatie', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'NL', 'Roemenië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'NL', 'Réunion', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'NL', 'Qatar', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'NL', 'Paraguay', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'NL', 'Palau', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'NL', 'Portugal', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'NL', 'Puerto Rico', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'NL', 'Pitcairneilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'NL', 'St. Pierre en Miquelon', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'NL', 'Polen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'NL', 'Pakistan', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'NL', 'Filipijnen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'NL', 'Papoea-Nieuw-Guinea', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'NL', 'Frans-Polynesië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'NL', 'Peru', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'NL', 'Panama', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'NL', 'Oman', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'NL', 'Nieuw Zeeland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'NL', 'Niue', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'NL', 'Nauru', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'NL', 'Nepal', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'NL', 'Noorwegen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'NL', 'Nederland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'NL', 'Nicaragua', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'NL', 'Nigeria', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'NL', 'Norfolk (eiland)', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'NL', 'Niger', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'NL', 'Nieuw-Caledonië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'NL', 'Namibië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'NL', 'Mozambique', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'NL', 'Maleisië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'NL', 'Mexico', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'NL', 'Malawi', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'NL', 'Maldiven', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'NL', 'Mauritius', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'NL', 'Malte', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'NL', 'Montserrat', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'NL', 'Mauritanië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'NL', 'Martinique', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'NL', 'Noordelijke Marianen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'NL', 'Macau', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'NL', 'Mongolië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'NL', 'Myanmar', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'NL', 'Mali', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'NL', 'Macedonië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'NL', 'Marshalleilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'NL', 'Madagaskar', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'NL', 'Moldavië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'NL', 'Monaco', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'NL', 'Marokko', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'NL', 'Libië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'NL', 'Letland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'NL', 'Luxemburg', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'NL', 'Litouwen', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'NL', 'Lesotho', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'NL', 'Liberia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'NL', 'Sri Lanka', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'NL', 'Liechtenstein', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'NL', 'Saint Lucia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'NL', 'Libanon', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'NL', 'Laos', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'NL', 'Kazachstan', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'NL', 'Kaaimaneilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'NL', 'Koeweit', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'NL', 'Zuid-Korea', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'NL', 'Noord-Korea', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'NL', 'Saint Kitts en Nevis', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'NL', 'Comoren', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'NL', 'Kiribati', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'NL', 'Cambodja', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'NL', 'Kirgizië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'NL', 'Kenia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'NL', 'Japan', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'NL', 'Jordanië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'NL', 'Jamaica', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'NL', 'Italië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'NL', 'Ijsland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'NL', 'Iran', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'NL', 'Irak', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'NL', 'Brits Indische Oceaanterritorium', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'NL', 'India', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'NL', 'Israël', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'NL', 'Ierland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'NL', 'Indonesië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'NL', 'Hongarije', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'NL', 'Haiti', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'NL', 'Kroatië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'NL', 'Honduras', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'NL', 'Heardeiland en McDonaldeilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'NL', 'Hong Kong', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'NL', 'Guyana', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'NL', 'Guinee-Bissau', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'NL', 'Guam', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'NL', 'Guatemala', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'NL', 'Zuid-Georgia en de Zuidelijke Sandwicheilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'NL', 'Griekenland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'NL', 'Guadeloupe', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'NL', 'Guinea', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'NL', 'Gambia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'NL', 'Groenland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'NL', 'Gibraltar', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'NL', 'Ghana', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'NL', 'Frans-Guyana', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'NL', 'Georgia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'NL', 'Grenada', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'NL', 'Verenigd Koninkrijk', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'NL', 'Gabon', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'NL', 'Frankrijk', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'NL', 'Faeröer', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'NL', 'Micronesia', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'NL', 'Falklandeilanden', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'NL', 'Fiji', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'NL', 'Finland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'NL', 'Ethiopië', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'NL', 'Spanje', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'NL', 'Eritrea', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'NL', 'Westelijke Sahara', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'NL', 'Egypte', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'NL', 'Estland', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'NL', 'Ecuador', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'NL', 'Algerije', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'NL', 'Dominicaanse Republiek', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'NL', 'Denemarken', '2011-02-04 19:50:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'NL', 'Djibouti', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'NL', 'Duitsland', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'NL', 'Tsjechische Republiek', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'NL', 'Cyprus', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'NL', 'Kersteiland ', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'NL', 'Kaapverdië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'NL', 'Cuba', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('401', 'NL', 'Deelnemer', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'NL', 'Costa Rica', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'NL', 'Colombia', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'NL', 'China', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'NL', 'Kameroen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'NL', 'Chili', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'NL', 'Cookeilanden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'NL', 'Ivoorkust', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'NL', 'Zwitserland', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'NL', 'Kongo', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'NL', 'Centraal-Afrikaanse Republiek', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'NL', 'Cocoseilanden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'NL', 'Canada', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'NL', 'Belize', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'NL', 'Wit-Rusland', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'NL', 'Botswana', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'NL', 'Bouvet', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'NL', 'Bhutan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'NL', 'Bahama\'s', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'NL', 'Brazilië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'NL', 'Bolivia', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'NL', 'Brunei', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'NL', 'Bermuda', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'NL', 'Menin', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'NL', 'Burundi', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'NL', 'Bahrain', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'NL', 'Bulgarije', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'NL', 'Burkina Faso', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'NL', 'België', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'NL', 'Bangladesh', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'NL', 'Barbados', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'NL', 'Bosnië en Herzegovina', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'NL', 'Azerbeidzjan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'NL', 'Aruba', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'NL', 'Australië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'NL', 'Oostenrijk', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'NL', 'Amerikaans-Samoa', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'NL', 'Argentinië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'NL', 'Angola', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'NL', 'Nederlandse Antillen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'NL', 'Armenië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'NL', 'Albanië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'NL', 'Anguilla', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'NL', 'Antigua en Barbuda', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'NL', 'Afghanistan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'NL', 'Verenigde Arabische Emiraten', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'NL', 'Andorra', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('448', 'NL', 'De aanmelding aan de database als root is mislukt.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('449', 'NL', '(voor een export)', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('450', 'NL', 'Op dit ogenblik wordt opencaching.nl geupdated. Om problemen met de data te voorkomen is de site geheel buiten bedrijf.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('452', 'NL', 'Nieuwsbericht niet opgeslagen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('453', 'NL', 'Bedankt voor het nieuwsbericht, Wij proberen het zo snel mogelijk te controleren en door te voeren.<br />\r\n<br />\r', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'NL', 'Een nieuwsbericht opstellen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'NL', 'Versturen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('456', 'NL', 'De code komt niet overeen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'NL', '... en nu de code invullen om te beschermen tegen spammers:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'NL', 'Wat laat het plaatje zien?', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('459', 'NL', 'E-Mailadres niet geldig.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'NL', 'Jouw E-Mailadres voor eventuele vragen:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'NL', 'Gelieve enkel HTML-tags te gebruiken voor de tekst - bijvoorbeeld vet, kleur of hyperlinks. Liever geen tabellen etc.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'NL', 'Het nieuwsbericht is in HTML-code geschreven', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'NL', 'Nieuwsbericht', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'NL', 'Thema', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('465', 'NL', 'Is er wat nieuws over het cachen?<br />\r\nMeldt het nieuwsbericht dan hier en het zal op de startpagina verschijnen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('466', 'NL', 'De activatie van jouw account is gelukt. Je kunt nu inloggen op de inlogpagina.<br /><br /> <a href=\"login.php\">Naar inlog paginalt;/a>', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('467', 'NL', 'Hint', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'NL', 'Account activeren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('469', 'NL', 'Hartelijk bedankt, het Opencaching.nl-team', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('470', 'NL', 'Wij vragen om wat geduld, wij doen ons best om de site zo snel mogelijk weer online te hebben.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('471', 'NL', 'Het account kon niet gemaakt worden, de reden is onbekend. Indien je het probleem niet zelf op kunt lossen, neem dan contact op via <a href=\"mailto:%1\">E-Mail</a>.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'NL', 'Wij respecteren jouw privacy. Jouw persoonlijke gegevens worden opgeslagen in onze database en niet doorgegeven aan derden. Let op onze gedetailleerde <a href=\"articles.php?page=dsb\">Privacy verklaring</a>.Mochten er nog vragen zijn, kun je contact met ons opnemen via <a href=\"mailto:%1\">contact us</a> <b>voordat</b> je een account aanmaakt.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('473', 'NL', 'Wij moeten jouw nieuwsbericht eerst keuren alvorens wij het plaatsen. Wij proberen dit binnen 24 tot 48 uren te doen.\r\nHet nieuwsbericht kun je niet meer veranderen nadat het geplaatst is. Mocht het noodzakelijk zijn om iets gewijzigd te hebben\r\nkun je het gecorrigeerde bericht nogmaals verzenden.Je mag elk soort nieuws plaatsen als het maar met cachen te maken heeft,\r\nmaar het is niet toegestaan advertenties te plaatsen over pruducten en/of caches. Het is aan de keuringscommissie te bepalen welke\r\nnieuwsberichten er geplaatst worden. In geval van twijfel kan het nieuwsbericht verzonden worden en en te wachten tot het gepubliceerd\r\nword of je kunt een mail sturen naar <a href=\"mailto:%1\">%1</a> voordat je het nieuwsbericht gaat plaatsen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('474', 'NL', 'Mocht het probleem langer aanhouden, neem dan contact met ons op via <a href=\"mailto:%1\">%1</a>.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('475', 'NL', 'Opencaching.nl is momenteel buiten bedrijf', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('476', 'NL', 'Gemaakt op:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('477', 'NL', 'Totale runtime:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('478', 'NL', 'Business layer runtime:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('479', 'NL', 'Framework runtime:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'NL', 'Gebruiker runtime:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('481', 'NL', 'SQL Debugger', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('482', 'NL', '%1 commando\'s', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('483', 'NL', 'Overzicht', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'NL', 'profiel', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('485', 'NL', 'Opgeslagen zoekopdrachten', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('486', 'NL', 'Gevolgde caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'NL', 'Genegeerd caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'NL', 'Instellingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'NL', 'Profiel bewerken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'NL', 'De radius mag maximaal 150 km. Om de notificaties uit te zetten, zet de radius op 0.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'NL', 'Wachtwoord veranderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('492', 'NL', 'Verander statistiekenplaatje', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'NL', 'E-Mail adres veranderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('494', 'NL', 'Beschikbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('495', 'NL', 'Niet beschikbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('496', 'NL', 'Gearchiveerd', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'NL', 'Niet gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('498', 'NL', 'Deelgenomen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('499', 'NL', 'Wil deelnemen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('500', 'NL', 'Welkom %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('501', 'NL', 'Logs', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'NL', 'Gevonden caches: %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'NL', 'Je laatste logjes:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'NL', 'Geen items gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'NL', 'Geplaatste caches: %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'NL', 'Jouw laatste geplaatste caches:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'NL', 'Geen geplaatste caches gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('508', 'NL', 'Jouw nog niet gepubliceerde caches:', '2012-07-23 15:54:00');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'NL', 'Geen ongepubliceerde caches.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('510', 'NL', 'Verzonden E-Mails', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'NL', 'Verzonden E-Mails: %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('512', 'NL', 'Onbekende cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('513', 'NL', 'Traditionele cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('514', 'NL', 'Multi cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('515', 'NL', 'Virtuele cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('516', 'NL', 'Webcam cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('517', 'NL', 'Event cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('518', 'NL', 'Puzzel cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('519', 'NL', 'Wiskunde/natuurkunde cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('520', 'NL', 'Bewegende cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('521', 'NL', 'Drive-In cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('522', 'NL', 'Motorfiets cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('524', 'NL', 'andere grootte', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('525', 'NL', 'micro', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('526', 'NL', 'klein', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('527', 'NL', 'normaal', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('528', 'NL', 'groot', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('529', 'NL', 'extra groot', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('530', 'NL', 'geen behuizing', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('531', 'NL', 'Beschikbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('532', 'NL', 'Tijdelijk niet beschikbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('533', 'NL', 'Verborgen door approvers, om gecontroleerd te worden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('534', 'NL', 'Nog niet beschikbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('535', 'NL', 'onbekende cache soort', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('536', 'NL', 'Traditionele Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('537', 'NL', 'Virtuele Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('538', 'NL', 'Webcam Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('539', 'NL', 'Event Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('540', 'NL', 'Wiskunde/natuurkunde Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('541', 'NL', 'Bewegende Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('542', 'NL', 'Drive-in Cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'NL', 'Ik wil op de hoogte gehouden worden over nieuwe caches in een omtrek van %1 km.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'NL', 'BBCode voor forums:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('546', 'NL', 'Opencaching.nl statistieken van %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('547', 'NL', 'Kies logo', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'NL', 'HTML code:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('549', 'NL', 'Getoonde tekst', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('550', 'NL', 'Ongeldige tekens in de tekst!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('551', 'NL', 'Beschikbare logo\'s', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'NL', 'Annuleren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('553', 'NL', 'Opslaan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('554', 'NL', 'De volgende instellingen voor uw statistiekenweergave zijn opgeslagen:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('555', 'NL', 'Laat logs zien', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('556', 'NL', 'Statistieklogo:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'NL', 'Geregistreerd&nbsp;sinds:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('558', 'NL', 'Als standaard geen HTML gebruiken.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('559', 'NL', 'Het automatisch uitloggen na 15 minuten na het verlaten van de website is uitgeschakeld.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('560', 'NL', 'Ik neem een PMR zender mee op kanaal 2 met het cachen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('561', 'NL', 'Anders:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('562', 'NL', 'Notificaties over nieuwe caches is uitgeschakeld.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('563', 'NL', 'Notificatie over nieuwe caches binnen een straal van %1.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'NL', 'Notificaties:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'NL', 'Thuis coördinaten:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'NL', 'Land:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'NL', 'Achternaam:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'NL', 'Voornaam', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('569', 'NL', 'Aanbevolen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'NL', '%1 heeft de cache gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('571', 'NL', '%1 heeft de cache niet gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('572', 'NL', '%1 heeft een notitie geschreven', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('573', 'NL', '%1 heeft het event bezocht', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('574', 'NL', '%1 wil het event bezoeken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('575', 'NL', '%1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('576', 'NL', 'Bewerken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('577', 'NL', 'Verwijderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('578', 'NL', 'Afbeelding toevoegen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('579', 'NL', 'Afbeeldingen voor deze log:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('580', 'NL', 'Terug naar de cachebeschrijving', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'NL', 'E-Mail adres', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'NL', 'Logs van %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('583', 'NL', 'Afbeelding selectie', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('584', 'NL', 'Afbeeldingselectie voor %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('585', 'NL', 'Voor deze cache zijn nog geen afbeeldingen verzonden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('586', 'NL', 'Voorbeeld afbeelding toevoegen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'NL', 'Mijn profiel', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'NL', 'De volgende informatie is opgeslagen in jouw gebruikersprofiel:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'NL', 'Grijze velden zijn niet zichtbaar voor andere gebruikers.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'NL', 'Gebruikersnaam:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('591', 'NL', 'Het land is niet geldig.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('592', 'NL', 'De opgegeven radius is niet geldig.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('593', 'NL', 'En onbekende fout is opgetreden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('594', 'NL', 'Om de eerste keer in te loggen dien je jouw account te actieveren met de volgende code:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'NL', 'Nieuw wachtwoord', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('596', 'NL', 'Vragen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'NL', 'Veranderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'NL', 'Code opvragen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('599', 'NL', 'Veiligheidscode voor een nieuw wachtwoord', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('600', 'NL', 'je hebt op %1 een nieuwe veiligheidscode gevraagt om je wachtwoord te veranderen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('601', 'NL', 'De volgende veiligheidscode werd gegenereerd: %1', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('602', 'NL', 'De veiligheidscode blijft 3 dagen geldig.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('603', 'NL', 'Je nieuwe wachtwoord kun je op %1newpw.php invoeren.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'NL', 'Om een nieuw wachtwoord krijgen moet je een veilighiedscode aanvragen, deze wordt per E-Mail verstuurd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('605', 'NL', 'Dit E-Mailadres hoort niet bij een geregistreede gebruiker.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('606', 'NL', 'Er is een E-Mail verzonden met je veiligheidscode.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('607', 'NL', 'De veiligheidscode kon door een fout niet verzonden worden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'NL', 'Vul je E-Mailadres in, je ontvangen veiligheidscode en je nieuwe wachtwoord. De veiligheidscode is 3 dagen geldig, daarna moet je een nieuwe aanvragen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('609', 'NL', 'De opgegeven gebruiker is nog niet geactieveerd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'NL', 'Veiligheidscode', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('611', 'NL', 'De veiligheidscode is verlopen. Vraag een nieuwe aan.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('612', 'NL', 'De wachtwoorden komen niet overeen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'NL', 'Wachtwoord herhalen:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('614', 'NL', 'Het wachtwoord is veranderd.', '2013-02-14 00:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('615', 'NL', 'Veiligheidscode voor een nieuw E-Mail adres', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('616', 'NL', 'je hebt op %1 een veiligheidscode opgevraagt om je E-Mail adres te veranderen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('617', 'NL', 'Je E-Mail adres kun je op %1newemail.php activeren.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'NL', 'E-Mail adres veranderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'NL', 'Om het E-Mail adres te veranderen, moet je eerst een veiligheidscode opvragen die naar je nieuwe E-Mail adres verstuurd wordt.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'NL', 'Nieuwe E-Mail adres:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('621', 'NL', 'Je account is al op dit E-Mail adres geregistreerd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'NL', 'Vul nu de veiligheidscode in die je per E-Mail ontvangen hebt. De veiligheidscode is 3 dagen geldig, daarna moet je een nieuwe aanvragen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'NL', 'Eerst de veiligheidscode opvragen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('624', 'NL', 'Er werd nog geen nieuw E-Mail adres aangemaakt. Vraag eerst een veiligheidscode aan.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('625', 'NL', 'Het E-Mail adres is veranderd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('626', 'NL', 'Download', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('627', 'NL', 'Er zijn geen opgeslagen zoekopdrachten gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('628', 'NL', 'Met het downloaden worden de <a href=\"articles.php?page=impressum#tos\">gebruikers voorwaarden</a> van Opencaching.nl geaccepteerd', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('629', 'NL', 'Zoekopdracht opslaan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('630', 'NL', 'Bewaar zoekopties voor zoekopdracht', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('631', 'NL', 'Naam van zoekopdracht', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('632', 'NL', 'Er moet een naam voor de zoekopdracht opgegeven worden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('633', 'NL', 'Er bestaat al een zoekopdracht met deze naam.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('634', 'NL', 'Opslaan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('635', 'NL', 'Oude zoekopties overschrijven', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('636', 'NL', 'Het over te schrijven zoekopdracht kiezen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('637', 'NL', '-- Nog geen zoekopties gevonden --', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'NL', 'Mijn aanbevelingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('639', 'NL', 'Jouw aanbeveling voor \"<a href=\"viewcache.php?wp=%1\">%2</a>\" is teruggetrokken!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('640', 'NL', 'Aanbeveling terugtrekken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('641', 'NL', 'Je hebt nog geen caches aanbevolen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'NL', 'Genegeerde caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('643', 'NL', 'Verwijderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'NL', 'Geen genegeerde caches gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('645', 'NL', 'Gevolgde caches - Instellingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('646', 'NL', 'Verzending:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('647', 'NL', 'Direct', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('648', 'NL', 'Dagelijks', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('649', 'NL', 'Wekelijks', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('650', 'NL', 'Verzenden om:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('651', 'NL', 'uur', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('652', 'NL', 'Verzenden op:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('653', 'NL', 'Verzendtijd en dag worden alleen bij dagelijks/wekenlijks gebruikt', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('654', 'NL', 'Fout bij opslaan!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('655', 'NL', 'De instellingen zijn opgeslagen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('656', 'NL', 'Gevolgde caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('657', 'NL', 'Laatst gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('658', 'NL', 'Geen gevolgde caches.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('659', 'NL', 'E-Mail adres herinneren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('660', 'NL', 'E-Mail adres herinnering', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('661', 'NL', 'Vul je gebruikersnaam in en wij zenden een E-Mail naar het E-Mail adres die bij de registratie opgegeven is.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('662', 'NL', 'Vul je gebruikersnaam in.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('663', 'NL', 'Gebruikersnaam bestaat niet.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('664', 'NL', 'De herinneringsmail is verzonden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('665', 'NL', 'Herinnering naar jouw E-Mail adres', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('666', 'NL', 'Het E-Mail adres waarmee je in kunt loggen:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('667', 'NL', 'je had op %date% een herinnering op jouw E-Mail adres opgevraagt.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('668', 'NL', 'Cache aanbevelingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('669', 'NL', 'Gebruikers die %1 van %2 aanbevelen hebben ook de volgende caches aanbevolen:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('671', 'NL', 'Geen aanbevelingen gevonden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('672', 'NL', 'Database onderhoud', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('673', 'NL', 'DB onderhoud', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('674', 'NL', '%1 heeft %2 logs bewerkt', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('675', 'NL', 'Uitvoeren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('676', 'NL', 'Verzenden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('677', 'NL', 'E-Mail van', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('678', 'NL', 'Sorry, maar de gebruiker is gedeactiveerd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('679', 'NL', 'Sorry, er is geen E-Mail adres voor de gebruiker gevraagd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('680', 'NL', 'De E-Mail kon door een fout niet verzonden worden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('681', 'NL', '%1 bericht je via %2\r\nHet gebruikersprofiel: %2viewprofile.php?userid=%3\r\nOm deze mail te beantwoorden moet je functie \"Email sturen\" in het gebruikersprofiel.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('682', 'NL', 'Onderwerp:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('683', 'NL', 'Alle informatie zal vertrouwelijk behandeld worden en zal niet voor derden toegankelijk zijn!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('684', 'NL', '\'%1\' met E-Mail adres %2 schrijft jou over %3\r\nHet gebruikersprofiel: %3viewprofile.php?userid=%4\r\nOm deze E-Mail te beantworden kan de antwoordfunctie gebruikt worden van je E-Mail programma.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('685', 'NL', 'E-Mail aan %1 is verzonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('686', 'NL', 'Inhoud:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('687', 'NL', 'E-Mail aan %1 sturen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('688', 'NL', 'Je moet een onderwerp opgeven:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('689', 'NL', 'Je moet een inhoud ingeven:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('690', 'NL', 'Mijn E-Mail adres met deze E-Mail meezenden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('691', 'NL', 'Hiermee weet de ontvanger jouw E-Mail adres en heeft de mogelijkheid om direct op jouw E-Mail te antwoorden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('692', 'NL', 'Om misbruik te voorkomen moeten we voor jullie en onze veiligheid de volgende regels naleven:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('693', 'NL', 'Er mogen alleen E-Mails over cachen en dergelijke verzonden worden, elke vorm van spam is verboden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('694', 'NL', 'Alle relevante informatie wordt geregistreerd (datum/tijd, zender/ontvanger en IP adressen)', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('696', 'NL', 'Sorry, deze cache is niet gepubliceerd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'NL', 'Alle logs laten zien', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('698', 'NL', 'Laat cache zien', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'NL', 'Je bent al inglogt.<br />\r\nJe moet eerst <a href=\"login.php?action=logout\">uitloggen</a>, om je opnieuw in te loggen.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'NL', 'Met het downloaden, word de <a href=\"articles.php?page=impressum#tos\">gebruikers overeenkomst</a> van Opencaching.nl geaccepteerd.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('701', 'NL', 'Moeilijkheid: %1 van 5', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('702', 'NL', 'Terrein: %1 van 5', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('703', 'NL', 'Deelnemerslijst', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'NL', 'Log deze cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('705', 'NL', 'Niet volgen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'NL', 'Volgen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('707', 'NL', 'Niet negeren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'NL', 'Negeren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'NL', 'Afdruk voorbeeld', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('710', 'NL', 'andere coördinaatstelsel', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'NL', 'Grootte', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'NL', 'Benodigde tijd', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('713', 'NL', 'Afstand', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'NL', 'Verborgen op', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'NL', 'Gepubliceerd sinds', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'NL', 'Laatste verandering', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('718', 'NL', 'Waypoint', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'NL', 'Ook gepubliceerd op', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'NL', 'Opmerkingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'NL', 'Volgers', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'NL', 'Negeerders', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'NL', 'Bekeken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'NL', 'Cache attributen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'NL', 'Gecodeerde hint', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'NL', 'Decoderen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'NL', 'Afbeeldingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'NL', 'Hulpmiddelen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('729', 'NL', 'Cache aanbevelingen van gebruikers die deze cache aanbevolen hebben: <a href=\"recommendations.php?cacheid=%1\">alle</a>', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('730', 'NL', 'Zoek caches in de omgeving:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'NL', 'alle', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('732', 'NL', 'zoekbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'NL', 'Download als bestand:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('734', 'NL', 'GPS Exchange Format .gpx', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('735', 'NL', 'Waipont bestand .loc', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('736', 'NL', 'Google Earth .kml', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('737', 'NL', 'TomTom POI .ov2', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('738', 'NL', 'TOP50-Overlay .ovl', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'NL', 'Tekstbestand .txt', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('740', 'NL', 'K O P I E', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('741', 'NL', 'Afbeelding bewerken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('742', 'NL', 'De aangegeven afbeelding bestaat niet.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('743', 'NL', 'De aangegeven log bestaat niet.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('744', 'NL', 'Statistieken laten zien', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('745', 'NL', 'Leeftijd', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('746', 'NL', 'Beschrijving', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('747', 'NL', 'Locatie', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('748', 'NL', 'MiniMap-Zoom', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('749', 'NL', 'Cache melden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('750', 'NL', 'Gemelde caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('751', 'NL', 'Bestandsnaam:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('752', 'NL', 'Geen titel opgegeven!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('753', 'NL', 'Afbeelding voor cache %1 toevoegen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('754', 'NL', 'Afbeelding voor log %1 toevoegen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('755', 'NL', 'Afbeelding voor cache %1 bewerken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('756', 'NL', 'Afbeelding voor log %1 bewerken', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'NL', 'Naam:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('758', 'NL', 'Geen titel opgegeven!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('765', 'NL', 'Reden:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('766', 'NL', 'Commentaar:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('767', 'NL', '%1 melden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('768', 'NL', 'Er moet een reden opgegeven worden!', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('773', 'NL', 'Nieuw', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('776', 'NL', 'Cache op privégrond', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('778', 'NL', 'Cache is weg', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('779', 'NL', 'Andere reden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('784', 'NL', 'Geen gerapporteerde caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('786', 'NL', 'van', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('793', 'NL', 'Actie', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('798', 'NL', 'Geokrets', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('805', 'NL', 'Fout bij opslaan', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('806', 'NL', 'Ongeldige tekens gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('807', 'NL', 'Veldinhoud te lang.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('809', 'NL', 'Zichtbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('810', 'NL', 'Niet zichtbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('811', 'NL', 'Intern', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('812', 'NL', '(*) Nieuwe meldingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('816', 'NL', 'Dze gebruiker heeft nog geen caches gevonden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('819', 'NL', 'Sorry, da cache is geblokkerd en kan niet bekeken worden.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('821', 'NL', 'Geblokkeerd, zichtbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('822', 'NL', 'Geblokkerd, nietzichtbaar', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('823', 'NL', 'Laatste verandering:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('827', 'NL', 'Adopteren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('828', 'NL', 'Datum', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('829', 'NL', 'Ja, ik heb de <a href=\"articles.php?page=impressum#tos\">gebruikersovereenkomst</a> van Opencaching.nl gelezen en accepteren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('835', 'NL', 'Adopteren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('839', 'NL', '%1 ter adoptie aanbieden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('841', 'NL', 'Adoptie afwijzen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('843', 'NL', 'Gebruikersnaam onbekend', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('848', 'NL', 'a-z A-Z 0-9 en .-_ @\&auml;\&uuml;\&ouml;\&Auml;\&Uuml;\&Ouml;=)(/\\\&amp;*+~# \r\n', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'NL', 'Tussen 6 en 60 tekens lang', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'NL', 'Montenegro', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'NL', 'Serbië', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('860', 'NL', 'Zeker?', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('862', 'NL', 'Onbekend', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('864', 'NL', 'Actieve caches:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('871', 'NL', 'E-Mail:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('872', 'NL', 'Waypoint download', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('875', 'NL', 'Terrein', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('876', 'NL', 'Moeilijkheid', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('889', 'NL', 'Tussen 1 en 6 maandden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('890', 'NL', 'Tussen 6 en 12 maanden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('891', 'NL', 'Meer dan 12 maanden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('894', 'NL', 'van', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('896', 'NL', '(in GM)', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('898', 'NL', 'Geocaching.nl', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('899', 'NL', 'Google Maps', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'NL', 'Doneren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('902', 'NL', 'Tekst', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('903', 'NL', 'Deze cache aanbevelen?', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('905', 'NL', 'OC-Waypoint', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'NL', 'Gebruikers overeenkomst', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('907', 'NL', 'Ons Team', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('914', 'NL', 'Beschermd gebied', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('921', 'NL', 'Info', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'NL', 'NL', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('957', 'NL', 'Chat/IRC', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1097', 'NL', 'D/T', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1100', 'NL', 'gpx', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1123', 'NL', 'Cachenaam', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1141', 'NL', 'N', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1142', 'NL', 'Z', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1143', 'NL', 'O', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1144', 'NL', 'W', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1146', 'NL', 'Kilometer', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1206', 'NL', 'km', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1208', 'NL', 'h', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1212', 'NL', 'Pagina:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'NL', 'Kaart', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'NL', 'Hoofdmenu', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1297', 'NL', 'op', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1301', 'NL', 'SQL Export', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1302', 'NL', 'XML Download', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1303', 'NL', 'XML Import', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1308', 'NL', 'Nieuwe vertaling', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1309', 'NL', 'Veranderde vertaling', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1310', 'NL', 'oud', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1315', 'NL', 'Datum:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1316', 'NL', 'log:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1326', 'NL', 'Aanbeveling:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1330', 'NL', 'Je hebt {curr} van de {max} mogelijke aanbevelingen gegeven.', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1331', 'NL', 'Gevaren', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'NL', 'Infrastructuur', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1333', 'NL', 'Waypoints', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1334', 'NL', 'Algemeen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1340', 'NL', 'Personen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1345', 'NL', 'Alleen bij Opencaching te loggen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1348', 'NL', 'Waypoints (optioneel):', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1351', 'NL', 'Beschrijvingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1357', 'NL', 'Dit is jouw cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1358', 'NL', 'Je hebt deze cache gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1359', 'NL', 'Je hebt deze cache niet gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1360', 'NL', 'In deze cache zit een GeoKrety', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1361', 'NL', 'Deze cache heeft %1 aanbevelingen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1363', 'NL', 'Soort log', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1365', 'NL', 'Nieuwe cache', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1366', 'NL', 'Eigenaar:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1367', 'NL', 'Cachesoort:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'NL', 'Grootte:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'NL', 'Coördinaten', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1370', 'NL', 'Anbeveling', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1371', 'NL', 'Moeilijkheid:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1372', 'NL', 'Terrein:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1379', 'NL', 'Minder', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1383', 'NL', 'Laatste log', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1387', 'NL', 'Mijn caches', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1388', 'NL', 'Mijn gevonden', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1389', 'NL', 'Mijn genegeerde', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1393', 'NL', 'Zoek op afstand', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1396', 'NL', 'Mijlen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1397', 'NL', 'Zeemijlen', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1398', 'NL', 'Zoek op plaats', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1399', 'NL', 'Postcode:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1400', 'NL', 'Plaats:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1401', 'NL', 'Zoek op tekst', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1404', 'NL', 'Logsoort:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1409', 'NL', 'Foutmelding:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1420', 'NL', 'Taal:', '2011-02-04 19:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'NL', 'Kompas', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'NL', 'Zaklamp', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'NL', 'Klimuitrusting', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'NL', 'Grotuitrusting', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1590', 'NL', 'Duikuitrusting', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'NL', 'Boot', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1592', 'NL', 'Vliegtuig', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1593', 'NL', 'Onderzoek', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'NL', 'Puzzel / raadsel', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'NL', 'Rekenopgave', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1596', 'NL', 'andere cache', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1597', 'NL', 'Start aanwijzingen aan plaatser vragen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'NL', 'Kindvriendelijk', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'NL', 'Er zijn spoorlijnen dichtbij. Wees voorzichtig, blijf op veilige afstand van het spoor en steek over op de daarvoor bestemde plaatsen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1600', 'NL', 'Er zijn rotsen of gevaarlijke rotsen in de buurt. Pas op voor vallende stenen aan de onderkant, en wees voorzichtig aan de bovenzijde van de kliffen (speciaal met kinderen of mountainbikes). ', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'NL', 'De cache is geplaatst in jachtgebied. In schemering of nacht is een zaklamp of hoofdlamp noodzakelijk voor de veiligheid. Wees er van bewust dan men jagers tegen kan komen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'NL', 'In de nabijheid van de cache bevinden zich doornen. Draag beschermende kleding en eventueel handschoenen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'NL', 'In bepaald seizoenen komen teken voor in dit gebied. Het wordt aanbevolen lange kleding te dragen en na het cachen de lichamen te controlen op teken.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1604', 'NL', 'In het water', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'NL', 'Deze cache is de doen bij dag en nacht.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'NL', 'een kompas is noodzakelijk', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'NL', 'Een zaklamp is noodzakelijk om deze cache te vinden. Denk ook aan reserve batterijen!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'NL', 'Voor deze cache is een klim uitrusting nodig en de benodigde kennis om te klimmen. Indien men geen ervaring heeft is het raadzaam om niet alleen te gaan, maar hulp te vtagen aan iemand met klimervaring.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'NL', 'Deze cache is geplaatst in een grot, en het is raadzaam om de benodigde zaken mee te nemen. Pas op: Zelfs de klein grotten kunnen gevaren met zich meebrengen zoals bij hevige regenval buiten zou het water de grot in kunnen stromen of men kan gewond raken. Vraag eventueel aan een deskundige om advies. Denk ook aan de natuur, zoals beschermde dieren (vleermuizen) en mogen dan ook niet verstoord worden. ', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1617', 'NL', 'Om deze cache te vinden heeft men een duikuitrusting nodig. Op welke diepte de cache ligt staat beschreven in de beschrijving. Denk er wel aan dat duiken niet zonder ervaring gedaan kan worden, of ga als groep of met een instructeur zoeken.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'NL', 'Deze cache kan alleen (normaal gesproken)gevonden worden met behulp van een boot. Door de afstand is het niet mogelijk om de cache swemmend te benaderen. Zie de cachebeschrijving voor meer gegevens.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1619', 'NL', 'Voor deze cache moet er informatie opgezocht worden voor het zoeken van de cache. Dit komt vaak voor bij puzzel/mystery caches.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1620', 'NL', 'Bij deze cache moet voor of onderweg een puzzel opgelost worden om de cache te zoeken.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'NL', 'Er moeten voor of tijdens het cachen rekenopgaven gedaan worden die verder gaan dan het simpele rekenwerk. Bijvoorbeeld middelpuntberekeningen of peilingen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1642', 'NL', 'Aan het einde is een webcam en om te loggen dient een opname uit die webcam waar men dan op staat te krijgen om te bewijzen dat men daar daadwerkelijk was. Sommige webcam-caches vragen wat extra\'s zoals een banner te tonen. Het webadres dient aangegeven te worden in de beschrijving, en dient vrij toegankelijk te zijn, zonder een account te hoeven maken en vrij van kosten.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1643', 'NL', 'Deze cache in niet geplaatst in open gebied, maar in een gebouw, een grot of iets dergelijks.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1644', 'NL', 'Deze cache of één van de punten is geplaatst onder water. Men dient in het water te gaan, zwemmen of duiken.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1645', 'NL', 'Deze cache kan gevonden worden zonder GPS. Behalve de startcoördinaten heeft men geen andere coördinaten nodig om de cache te zoeken.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1646', 'NL', 'Er dient parkeergeld en/of entree betaald te worden om deze cache te doen, bijvoorbeeld in een themapark. Als er een alternative gratis parkeerplaats in de buurt is dient dat ook in de cachebeschrijving vermeld te worden. Let op onze huidige voorwaarden voor het gebruik met betrekking tot \"commerciële caches\".', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1647', 'NL', 'Deze cache kan niet in één dag of nacht gedaan worden. De locatie zal verschillende keren bezocht moeten worden of moeten overnachten. Voorbereidingstijd is niet berekend, alleen de tijd tijdens het cachen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1648', 'NL', 'Een nieuwsbericht is gemaakt op opencaching', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1649', 'NL', 'Looptijd: {time} Seconden', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1650', 'NL', 'De opgeroepen site bestaat niet!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1651', 'NL', 'Zoek op cachenaam', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1652', 'NL', 'Redirect - opencaching', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1653', 'NL', 'Moet de opgeslagen zoek resultaten verwijdert worden?', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1654', 'NL', 'Status', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1655', 'NL', 'Status veranderen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'NL', 'Landen (nodes)', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1657', 'NL', 'tot', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'NL', 'Route', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'NL', 'Cachegrootte:', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1660', 'NL', 'Link', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1661', 'NL', 'Openen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1662', 'NL', 'Aan favorieten toevoegen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1663', 'NL', 'Getoonde caches', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1664', 'NL', 'Laadtijd', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1665', 'NL', 'sec.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1666', 'NL', 'Alleen caches met de volgende eigenschappen tonen:', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1667', 'NL', 'Cache soort', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1668', 'NL', 'Cache behuizing', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1669', 'NL', 'Verbergen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1670', 'NL', 'Mijn eigen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1671', 'NL', 'Niet actief', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1672', 'NL', 'Meerdere lijsten', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1673', 'NL', 'Waardering', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1674', 'NL', 'Min. aanbevelingen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1675', 'NL', 'Drag Zoom', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1676', 'NL', 'Gebied op de kaart met de muis markeren (hier klikken om af te breken)', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1677', 'NL', 'Drag Zoom Back', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1678', 'NL', 'Voer een zoektekst in, alstublieft!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1680', 'NL', 'Waypoint %1 niet gevonden!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1681', 'NL', 'D/T:', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1682', 'NL', 'Kaartgegevens \&copy; 2009 <a href=\"http://www.openstreetmap.org/\">OpenStreetMap</a> Contributors', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1683', 'NL', 'Fout: Het zoek resultaat kan niet weergegeven worden (HTTP fout code %1)', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1684', 'NL', 'Fout: Het zoek resultaat kan niet weergegeven worden. De gegevens zijn niet beschikbaar op de server.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1685', 'NL', 'Er zijn %1 caches gevonden. Vergroot de kaart om de caches te zien.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1686', 'NL', 'De zoekfilters zijn veranderd. Klik op OK om te herladen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1687', 'NL', 'Nieuwe log', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1688', 'NL', 'Log bewerken', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1689', 'NL', 'Log verwijderen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1690', 'NL', 'Cache bewerken', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1691', 'NL', 'Beschrijving toevoegen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1692', 'NL', 'Beschrijving bewerken', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1693', 'NL', 'Beschrijving verwijderen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1694', 'NL', 'Kies plaats', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1695', 'NL', 'Bekijk zoek resultaat', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1696', 'NL', 'Resultaat', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1697', 'NL', 'Beschrijving - Nieuwe cache aanmaken', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1698', 'NL', 'Afbeelding toevoegen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1699', 'NL', 'Melding', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1700', 'NL', 'Er is geen Google Maps Key geregistreerd voor dit domein.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1701', 'NL', 'Attentie! Deze cache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> Er bevind zich geen behuizing op de aangegeven (of uitgerekende) coördinaten. Het is dan ook raadzaam om deze cache niet te gaan zoeken!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1702', 'NL', 'Attentie! Deze cache is \&quot;<span class=\"errormsg\">%1</span>\&quot;!</strong> De cache zelf of delen ervan zijn niet beschikbaar of er zijn andere problemen, die het vinden niet mogelijk kunnen maken. Het is dan ook raadzaam om deze cache niet te gaan zoeken!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1703', 'NL', 'U heeft dit evenement bezocht!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1704', 'NL', 'U heeft deze cache al gevonden!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1705', 'NL', '<br /><i>Veroudert: Deze attribuut kan bij nieuwe caches niet meer gebruikt worden, omdat het attribuut niet meer aan de actuele  gebruikersvoorwaarden voldoet</i>\r\n<br />Deze cache is niet alleen op opencaching.nl geplaatst, maar ook op andere cachesites. Dit geldt voor caches die door hun eigenaars gekoppeld aan de overeenkomstige vermeldingen op andere sites. Wij wijzen er op, dat ook op opencaching.nl de veranderingen die de cache ondergaat vermeld dienen te worden zoals ook omschreven wordt in de gebruikersverklaring.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1706', 'NL', 'Deze OC-site', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1707', 'NL', 'Andere OC-sites', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1708', 'NL', 'De volgende evenementen in %1', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1709', 'NL', 'Caches met de meeste aanbevelingen van de laatste 30 dagen in %1.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'NL', 'Nieuwste caches in %1', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1711', 'NL', 'U dient nog {anzahl} cache(s) te vinden om een aanbeveling te geven.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1712', 'NL', 'Log voor de Cache <a href=\"viewcache.php?cacheid=%1\">%2</a> toevoegen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1713', 'NL', 'U heeft deze Cache aanbevolen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1714', 'NL', 'Aanbeveling terug halen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1715', 'NL', 'U heeft %1 van %2 mogelijke aanbevelingen vergeven.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1716', 'NL', 'U dient nog %1 cache(s) te loggen, om een aanbeveling te doen.', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1717', 'NL', 'Alstublieft kiezen!', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1718', 'NL', 'Resultaat op deze pagina', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1719', 'NL', 'Resultaat {startatp1} tot {endat} (als zip)', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1722', 'NL', 'Wilt u de log werkelijk verwijderen?', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1723', 'NL', 'Wilt u werkelijk de aanbeveling verwijderen?', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1724', 'NL', 'Lengte', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1725', 'NL', 'Download als ...', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1726', 'NL', 'Log voor <a href=\"viewcache.php?cacheid={cacheid}\">{cachename}</a> verwijderen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1727', 'NL', 'Nieuwe beschrijving voor <a href=\"viewcache.php?cacheid={cacheid}\">{name}</a> toevoegen', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1728', 'NL', 'Verstuur naar GPS', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1729', 'NL', 'Geokrety verleden', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1730', 'NL', 'Nieuw forum topic(s) (%1)', '2011-02-04 19:50:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1741', 'NL', 'Het account is al geactiveerd. Probeer <a href=\"login.php\">inloggen</a>.<br /> Indien je niet in kunt loggen. lees dan de volgende pagina: <a href=\"{$opt.cms.login}\">problemen met inloggen</a>', '2011-04-04 21:34:57');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1742', 'NL', 'Jouw browser heeft onze cookie van opencaching.nl afgewezen.<br />\r', '2011-04-04 21:30:40');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1758', 'NL', 'Het account is al geactiveerd. Probeer <a href=\"login.php\">inloggen</a>.<br /> Indien je niet in kunt loggen. lees dan de volgende pagina: <a href=\"%1\">problemen met inloggen</a>', '2011-05-23 22:28:31');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1820', 'NL', 'Je kunt nu met je nieuwe wachtwoord <a href=\"login.php\">inloggen</a>.', '2013-02-14 00:50:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'NO', 'NO', '2011-05-15 11:46:21');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('3', 'PL', 'Test - proszę nie logować się', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('4', 'PL', 'Użytkownik', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'PL', 'Zalogowany jako', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'PL', 'Wyloguj', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('8', 'PL', 'Szukaj-Waypoint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('12', 'PL', 'Połącznie z Bazą', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'PL', 'Ochrona danych osobowych', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'PL', 'Imprint', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'PL', 'Kontakt', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'PL', 'Sitemap', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'PL', 'Rejestracja', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('20', 'PL', 'Komentarz', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'PL', 'Użytkownik', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'PL', 'Imie', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'PL', 'Nazwisko', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'PL', 'Kraj', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'PL', 'Rejestracja nowego użytkownika', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'PL', 'pokaż wszystkie', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'PL', 'Twoje hasło', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'PL', 'Proszę powtórzyć', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'PL', 'pola zaznaczone * są wymagane', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'PL', 'Tak. Zapoznałem się z zasadmi o Ochronie danych osobowych i Zasadami Używania serwisu OpenCaching PL i zgadzam się z nimi', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'PL', 'Wyczyść', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'PL', 'Rekomendacje', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'PL', 'Znaleziona', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('57', 'PL', 'założona przez', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'PL', 'Nowości', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'PL', 'Najnowsze skrzynki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('72', 'PL', 'Najnowsze skrzynki poza Niemacami', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'PL', 'Najnowsze logi', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'PL', 'Polski', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('81', 'PL', 'Co znajdziesz na tej stronie?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'PL', 'Na tej stronie znajdziesz wszystko co dotyczy Geocachingu w Niemczech.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('87', 'PL', 'Opencaching.de', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('90', 'PL', 'Liczba aktywnych skrzynek: %1 | Liczba odkryć skrzynek: %2 | Liczba aktywnych użytkowników: %3', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'PL', 'Tak', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'PL', 'Nie', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('96', 'PL', 'Witaj', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'PL', 'Nowa skrzynka', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'PL', 'Caches', '2010-10-04 00:22:41');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'PL', 'Moje konto', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'PL', 'Najnowsze logi', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'PL', 'Najnowsze skrzynki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'PL', 'Co to jest Geocaching?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'PL', 'Aktywacja', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('128', 'PL', 'Dane użytkownika', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('134', 'PL', '%2 znaleziona przez %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('135', 'PL', '%2 nie znaleziona przez %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('136', 'PL', '%2 komentarz %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('137', 'PL', '%2 uczestniczył %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('138', 'PL', '%2 zamierza uczesticzyć %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('147', 'PL', 'Profil użytkownika %1', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('148', 'PL', 'Wyślij E-mail', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('149', 'PL', 'Inne', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'PL', 'Zarejstrowany&nbsp;od', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('152', 'PL', 'Ukryte skrzynki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('153', 'PL', 'Znalezione skrzynki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('154', 'PL', '%1 z możliwych %2', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'PL', 'W celu rejestracji na OpenCaching musisz posiadać rzeczywisty adres E-mail na który zostanie wysłany kod aktywacyjny. Możesz tylko jednego użytkownika zarejestrować na jeden adres E-mail.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'PL', 'Języki', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'PL', 'Login', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'PL', 'Hasło', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'PL', 'Chcesz się zarejestrować?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'PL', 'Zapomniałeś swoje hasło?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'PL', 'Zapomniałeś swój E-mail?', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('219', 'PL', 'Czy masz:', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('221', 'PL', 'Nowe hasło', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('222', 'PL', 'Przypomnij mi', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('225', 'PL', 'Wylogowanie z sukcesem.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('229', 'PL', 'Twoje konto nie jest aktywowane', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'PL', 'Nazwa', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('248', 'PL', 'Pokaż rekomendacje', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'PL', 'Twoje dane osobowe będą zgromadzone w naszej bazie danych, i nie będą przekazane trzecim osobom. Proszę zapoznaj się dokładne z treścią naszej instrukcji o <a href=\"articles.php?page=dsb\">ochronie danych osobowych</a>. Jeżeli masz jakieś pytania ponadto, proszę skontaktować <a href=\"mailto:contact@opencaching.de\">się z nami</a>, <b>zanim zarejestrujesz się</b>.\r\n', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('699', 'PL', 'Jesteś zalogowany.<br /><a href=\"login.php?action=logut\">Wyloguj się</a> aby ponownie zalogować się.', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'PL', 'PL', '2010-08-28 11:48:08');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1479', 'PL', 'Szukaj-Waypoint', '2010-09-11 02:35:20');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'PL', 'Hasło', '2010-09-11 02:33:52');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'PT', 'PT', '2011-05-15 11:46:47');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('6', 'RU', 'Вы вошли как', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('7', 'RU', 'Выход', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('14', 'RU', 'О конфиденциальности', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('15', 'RU', 'О конфиденциальности', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('16', 'RU', 'Контакты', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('17', 'RU', 'Карта сайта', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('18', 'RU', 'Регистрация', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('19', 'RU', 'Новый пользователь зарегистрирован', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('22', 'RU', 'Пользователь', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('23', 'RU', 'Электронный адрес', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('24', 'RU', 'Имя', '2010-10-06 22:23:01');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('25', 'RU', 'Фамилия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('26', 'RU', 'Страна', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('27', 'RU', 'Регистрация', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('29', 'RU', 'Недопустимое имя пользователя.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('30', 'RU', 'Печатать последние отчёты', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('33', 'RU', 'Не указана', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('34', 'RU', 'Показать все', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('35', 'RU', 'Недопустимый адрес электронной почты.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('36', 'RU', 'Турецкий', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('37', 'RU', 'Пароль', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('39', 'RU', 'Пароли не совпадают.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('40', 'RU', 'Повторите пароль', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('41', 'RU', 'Звёздочкой (*) отмечены поля, обязательные для заполнения.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('42', 'RU', 'Шведский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('43', 'RU', 'Словенский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('45', 'RU', 'Использованы, как минимум, 4 разные символа', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('49', 'RU', 'Русский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('50', 'RU', 'Вы должны принять <a href=\"articles.php?page=dsb\">Положение о конфиденциальности</a> \n  и <a href=\"articles.php?page=tos\">Условия использования</a> для регистрации.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('51', 'RU', 'Очистить форму', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('55', 'RU', 'Золотые ярлыки', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('56', 'RU', 'Найден', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('59', 'RU', 'Румынский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('60', 'RU', 'Шаг 1', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('63', 'RU', 'Шаг 2', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('64', 'RU', 'Португальский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('70', 'RU', 'Новости', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('71', 'RU', 'Новые тайники', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('73', 'RU', 'Новые отчёты', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('74', 'RU', 'Польский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('75', 'RU', 'Норвежский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('76', 'RU', 'Латвийский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('77', 'RU', 'Литовский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('78', 'RU', 'Итальянский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('79', 'RU', 'Исландский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('80', 'RU', 'Начало', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('82', 'RU', 'Всё, что нужно для геокешинга…', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('86', 'RU', 'того же типа', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('92', 'RU', 'Хорватский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('93', 'RU', 'Финский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('94', 'RU', 'Да', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('95', 'RU', 'Нет', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('101', 'RU', 'Эстонский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('102', 'RU', 'Эсперанто', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('103', 'RU', 'Греческий', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('104', 'RU', 'Датский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('114', 'RU', 'Описание', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('115', 'RU', 'Создать тайник', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('116', 'RU', 'Admin', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('118', 'RU', 'Тайники', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('119', 'RU', 'Профиль', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('120', 'RU', 'Новые отчёты', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('122', 'RU', 'Новые тайники', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('123', 'RU', 'Об игре', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('125', 'RU', 'Выбор', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('127', 'RU', 'Активация', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('145', 'RU', 'Чешский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('146', 'RU', 'Болгарский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('151', 'RU', 'Дата&nbsp;регистрации', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('156', 'RU', 'Японский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('157', 'RU', 'Испанский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('158', 'RU', 'Французский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('159', 'RU', 'Английский', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('160', 'RU', 'Немецкий', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('162', 'RU', 'Зимбабве', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('163', 'RU', 'Замбия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('164', 'RU', 'ЮАР', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('165', 'RU', 'Майотта', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('166', 'RU', 'На ваш адрес выслано письмо с кодом активации. Пожалуйста, следуйте инструкциям в письме.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('167', 'RU', 'Для регистрации вы должны выбрать имя пользователя (псевдоним, под которым вы будете известны на сайте) \n  и указать действующий адрес электронной почты. \n  На этот адрес будет выслано письмо с кодом активации.\n  Вы можете указать также ваши настоящие имя и фамилию, \n  но это не является обязательным.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('172', 'RU', 'Йемен', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('173', 'RU', 'Самоа', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('179', 'RU', 'Уоллис и Футуна', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('180', 'RU', 'Опубликовать новость', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('181', 'RU', 'Вануату', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('182', 'RU', 'Вьетнам', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('183', 'RU', 'Американские Виргинские острова', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('184', 'RU', 'Британские Виргинские острова', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('185', 'RU', 'Венесуэла', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('192', 'RU', 'Сент-Винсент и Гренадины', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('193', 'RU', 'Ватикан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('194', 'RU', 'Узбекистан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('199', 'RU', 'Языки', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('201', 'RU', 'Уругвай', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('202', 'RU', 'Код активации:', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('203', 'RU', 'США', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('204', 'RU', 'Внешние малые острова США', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('207', 'RU', 'Вход', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('208', 'RU', 'Пароль', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('209', 'RU', 'Уганда', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('210', 'RU', 'Украина', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('211', 'RU', 'Танзания', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('212', 'RU', 'Тайвань', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('213', 'RU', 'Тувалу', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('214', 'RU', 'Тринидад и Тобаго', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('215', 'RU', 'Турция', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('216', 'RU', 'Не зарегистрированы?', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('217', 'RU', 'Забыли пароль?', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('218', 'RU', 'Забыли адрес электронной почты?', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('220', 'RU', 'Печатать без журнала', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('223', 'RU', 'Тонга', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('224', 'RU', 'Укажите ваши имя пользователя и пароль.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('231', 'RU', 'Тунис', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('232', 'RU', 'Для завершения регистрации введите код активации, который вы получили по электронной почте.', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('233', 'RU', 'Туркмения', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('234', 'RU', 'Токелау', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('235', 'RU', 'Таджикистан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('236', 'RU', 'Таиланд', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('237', 'RU', 'Того', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('238', 'RU', 'Французские Южные и Антарктические территории', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('239', 'RU', 'Чад', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('240', 'RU', 'Тёркс и Кайкос', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('241', 'RU', 'Название', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('242', 'RU', 'Свазиленд', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('243', 'RU', 'Сирия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('249', 'RU', 'Сальвадор', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('250', 'RU', 'Сан-Томе и Принсипи', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('251', 'RU', 'Суринам', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('252', 'RU', 'Сомали', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('256', 'RU', 'Сенегал', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('257', 'RU', 'Сан-Марино', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('258', 'RU', 'Сьерра-Леоне', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('259', 'RU', 'Словакия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('260', 'RU', 'Шпицберген и Ян-Майен', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('261', 'RU', 'Словения', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('262', 'RU', 'Остров Святой Елены', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('263', 'RU', 'Сингапур', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('264', 'RU', 'Швеция', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('265', 'RU', 'Судан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('266', 'RU', 'Сейшелы', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('267', 'RU', 'Соломоновы Острова', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('268', 'RU', 'Саудовская Аравия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('269', 'RU', 'Руанда', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('270', 'RU', 'Россия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('271', 'RU', 'Румыния', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('272', 'RU', 'Реюньон', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('273', 'RU', 'Катар', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('274', 'RU', 'Парагвай', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('275', 'RU', 'Палау', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('276', 'RU', 'Португалия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('277', 'RU', 'Пуэрто-Рико', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('278', 'RU', 'Питкерн', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('279', 'RU', 'Сен-Пьер и Микелон', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('280', 'RU', 'Польша', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('281', 'RU', 'Пакистан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('282', 'RU', 'Филиппины', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('283', 'RU', 'Папуа — Новая Гвинея', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('284', 'RU', 'Французская Полинезия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('285', 'RU', 'Перу', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('286', 'RU', 'Панама', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('287', 'RU', 'Оман', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('288', 'RU', 'Новая Зеландия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('289', 'RU', 'Ниуэ', '2010-12-06 22:17:35');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('290', 'RU', 'Науру', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('291', 'RU', 'Непал', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('292', 'RU', 'Норвегия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('293', 'RU', 'Нидерланды', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('294', 'RU', 'Никарагуа', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('295', 'RU', 'Нигерия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('296', 'RU', 'Норфолк', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('297', 'RU', 'Нигер', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('298', 'RU', 'Новая Каледония', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('299', 'RU', 'Намибия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('300', 'RU', 'Мозамбик', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('301', 'RU', 'Малайзия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('302', 'RU', 'Мексика', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('303', 'RU', 'Малави', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('304', 'RU', 'Мальдивы', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('305', 'RU', 'Маврикий', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('306', 'RU', 'Мальта', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('307', 'RU', 'Монтсеррат', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('308', 'RU', 'Мавритания', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('309', 'RU', 'Мартиника', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('310', 'RU', 'Северные Марианские острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('311', 'RU', 'Макао', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('312', 'RU', 'Монголия', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('313', 'RU', 'Мьянма', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('314', 'RU', 'Мали', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('315', 'RU', 'Македония', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('316', 'RU', 'Маршалловы Острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('317', 'RU', 'Мадагаскар', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('318', 'RU', 'Молдавия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('319', 'RU', 'Монако', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('320', 'RU', 'Марокко', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('321', 'RU', 'Ливия', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('322', 'RU', 'Латвия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('323', 'RU', 'Люксембург', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('324', 'RU', 'Литва', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('325', 'RU', 'Лесото', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('326', 'RU', 'Либерия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('327', 'RU', 'Шри-Ланка', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('328', 'RU', 'Лихтенштейн', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('329', 'RU', 'Сент-Люсия', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('330', 'RU', 'Ливан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('331', 'RU', 'Лаос', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('332', 'RU', 'Казахстан', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('333', 'RU', 'Каймановы острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('334', 'RU', 'Кувейт', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('335', 'RU', 'Южная Корея', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('336', 'RU', 'Северная Корея', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('337', 'RU', 'Сент-Китс и Невис', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('338', 'RU', 'Коморы', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('339', 'RU', 'Кирибати', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('340', 'RU', 'Камбоджа', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('341', 'RU', 'Киргизия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('342', 'RU', 'Кения', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('343', 'RU', 'Япония', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('344', 'RU', 'Иордания', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('345', 'RU', 'Ямайка', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('346', 'RU', 'Италия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('347', 'RU', 'Исландия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('348', 'RU', 'Иран', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('349', 'RU', 'Ирак', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('350', 'RU', 'Британская территория в Индийском океане', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('351', 'RU', 'Индия', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('352', 'RU', 'Израиль', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('353', 'RU', 'Ирландия', '2010-10-06 22:23:06');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('354', 'RU', 'Индонезия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('355', 'RU', 'Венгрия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('356', 'RU', 'Гаити', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('357', 'RU', 'Хорватия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('358', 'RU', 'Гондурас', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('359', 'RU', 'Херд и Макдоналд', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('360', 'RU', 'Гонконг', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('361', 'RU', 'Гайана', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('362', 'RU', 'Гвинея-Бисау', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('363', 'RU', 'Гуам', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('364', 'RU', 'Гватемала', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('365', 'RU', 'Южная Георгия и Южные Сандвичевы острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('366', 'RU', 'Греция', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('367', 'RU', 'Гваделупа', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('368', 'RU', 'Гвинея', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('369', 'RU', 'Гамбия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('370', 'RU', 'Гренландия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('371', 'RU', 'Гибралтар', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('372', 'RU', 'Гана', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('373', 'RU', 'Французская Гвиана', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('374', 'RU', 'Грузия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('375', 'RU', 'Гренада', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('376', 'RU', 'Великобритания', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('377', 'RU', 'Габон', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('378', 'RU', 'Франция', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('379', 'RU', 'Фареры', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('380', 'RU', 'Микронезия', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('381', 'RU', 'Фолклендские острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('382', 'RU', 'Фиджи', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('383', 'RU', 'Финляндия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('384', 'RU', 'Эфиопия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('385', 'RU', 'Испания', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('386', 'RU', 'Эритрея', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('387', 'RU', 'Западная Сахара', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('388', 'RU', 'Египет', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('389', 'RU', 'Эстония', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('390', 'RU', 'Эквадор', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('391', 'RU', 'Алжир', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('392', 'RU', 'Доминиканская Республика', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('393', 'RU', 'Дания', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('394', 'RU', 'Джибути', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('395', 'RU', 'Германия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('396', 'RU', 'Чехия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('397', 'RU', 'Кипр', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('398', 'RU', 'Остров Рождества', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('399', 'RU', 'Кабо-Верде', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('400', 'RU', 'Куба', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('402', 'RU', 'Коста-Рика', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('403', 'RU', 'Колумбия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('404', 'RU', 'Китай', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('405', 'RU', 'Камерун', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('406', 'RU', 'Чили', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('407', 'RU', 'Острова Кука', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('408', 'RU', 'Кот-д’Ивуар', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('409', 'RU', 'Швейцария', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('410', 'RU', 'Конго', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('411', 'RU', 'Центрально-Африканская Республика', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('412', 'RU', 'Кокосовые острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('413', 'RU', 'Канада', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('414', 'RU', 'Белиз', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('415', 'RU', 'Белоруссия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('416', 'RU', 'Ботсвана', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('417', 'RU', 'Буве', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('418', 'RU', 'Бутан', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('419', 'RU', 'Багамы', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('420', 'RU', 'Бразилия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('421', 'RU', 'Боливия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('422', 'RU', 'Бруней', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('423', 'RU', 'Бермуды', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('424', 'RU', 'Бенин', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('425', 'RU', 'Бурунди', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('426', 'RU', 'Бахрейн', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('427', 'RU', 'Болгария', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('428', 'RU', 'Буркина Фасо', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('429', 'RU', 'Бельгия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('430', 'RU', 'Бангладеш', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('431', 'RU', 'Барбадос', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('432', 'RU', 'Босния и Герцеговина', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('433', 'RU', 'Азербайджан', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('434', 'RU', 'Аруба', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('435', 'RU', 'Австралия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('436', 'RU', 'Австрия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('437', 'RU', 'Американское Самоа', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('438', 'RU', 'Аргентина', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('439', 'RU', 'Ангола', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('440', 'RU', 'Нидерландские Антильские острова', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('441', 'RU', 'Армения', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('442', 'RU', 'Албания', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('443', 'RU', 'Ангилья', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('444', 'RU', 'Антигуа и Барбуда', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('445', 'RU', 'Афганистан', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('446', 'RU', 'ОАЭ', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('447', 'RU', 'Андорра', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('454', 'RU', 'Опубликовать новость', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('455', 'RU', 'Сохранить', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('457', 'RU', 'Антиспамерский код:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('458', 'RU', 'Что изображено на рисунке?', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('460', 'RU', 'Электронный адрес:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('461', 'RU', 'Используете HTML-разметку только для шрифтового оформления текста \n  (<b>, <u>, <i>) и ссылок (<a>). Пожалуйста, не используйте таблицы (<table>), разделы (<div>) и т. д.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('462', 'RU', 'В тексте присутствует HTML-разметка.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('463', 'RU', 'Текст:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('464', 'RU', 'Тема:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('468', 'RU', 'Активация', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('472', 'RU', 'Мы уважаем ваше право на неприкосновенность частной жизни. \n  Ваши персональные данные сохраняются в нашей базе данных, \n  но мы не передаём их другим лицам и организациям. \n  Пожалуйста, ознакомьтесь с <a href=\"articles.php?page=dsb\">Положением о конфиденциальности</a>. \n  Если у вас есть вопросы, <a href=\"mailto:%1\">свяжитесь с нами</a> до регистрации.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('480', 'RU', 'Пользователь:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('484', 'RU', 'Профиль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('487', 'RU', 'Чёрные метки', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('488', 'RU', 'Настройки', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('489', 'RU', 'Править профиль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('490', 'RU', 'Радиус не может превышать 150 км. Чтобы отменить уведомления, задайте 0.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('491', 'RU', 'Сменить пароль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('493', 'RU', 'Сменить адрес', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('497', 'RU', 'Не найден', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('502', 'RU', 'Найдено тайников: %1', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('503', 'RU', 'Ваши последние отчёты:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('504', 'RU', 'Нет отчётов', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('505', 'RU', 'Спрятано тайников: %1', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('506', 'RU', 'Ваши последние тайники:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('507', 'RU', 'Нет спрятанных тайников', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('509', 'RU', 'Все ваши тайники опубликованы', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('511', 'RU', 'Отправлено писем: %1', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('544', 'RU', 'Присылать уведомления о новых тайниках в радиусе %1 км.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('545', 'RU', 'BBCode для форумов:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('548', 'RU', 'HTML:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('552', 'RU', 'Отменить', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('557', 'RU', 'Дата&nbsp;регистрации:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('564', 'RU', 'Уведомления:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('565', 'RU', 'Координаты:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('566', 'RU', 'Страна:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('567', 'RU', 'Фамилия:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('568', 'RU', 'Имя:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('570', 'RU', '%1 нашёл тайник', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('581', 'RU', 'Электронный адрес:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('582', 'RU', 'Журнал', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('587', 'RU', 'Профиль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('588', 'RU', 'Эта информация сохранена в вашем профиле:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('589', 'RU', 'Серым цветом помечена информация, недоступная для других пользователей.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('590', 'RU', 'Пользователь:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('595', 'RU', 'Новый пароль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('597', 'RU', 'Сохранить', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('598', 'RU', 'Получить код', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('604', 'RU', 'Для смены пароля вы должны получить защитный код. Код высылается вам по электронной почте, он действителен \n  в течении трёх суток.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('608', 'RU', 'Введите ваш электронный адрес, защитный код (который вы получили по электронной почте)\n  и ваш новый пароль.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('610', 'RU', 'Защитный код:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('613', 'RU', 'Повторите пароль:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('618', 'RU', 'Сменить адрес электронной почты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('619', 'RU', 'Для смены пароля вы должны получить защитный код. Код высылается вам по электронной почте и действителен в течении трёх суток.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('620', 'RU', 'Новый электронный адрес:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('622', 'RU', 'Введите защитный код, который вы получили по почте.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('623', 'RU', 'Сначала получите защитный код.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('638', 'RU', 'Золотые ярлыки', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('642', 'RU', 'Чёрные метки', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('644', 'RU', 'Cписок пуст', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('697', 'RU', 'Показать все отчёты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('700', 'RU', 'Загружая файл, вы соглашаетесь с <a href=\"articles.php?page=impressum#tos\">Условиями использования</a>.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('704', 'RU', 'Отчитаться', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('706', 'RU', 'Наблюдать', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('708', 'RU', 'Чёрная метка', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('709', 'RU', 'Печать', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('711', 'RU', 'Размер', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('712', 'RU', 'Время на поиск', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('715', 'RU', 'Спрятан', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('716', 'RU', 'Опубликован', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('717', 'RU', 'Обновлён', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('719', 'RU', 'Также опубликован', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('720', 'RU', 'Заметок', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('721', 'RU', 'Наблюдают', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('722', 'RU', 'Чёрных меток', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('723', 'RU', 'Просмотров', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('724', 'RU', 'Атрибуты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('725', 'RU', 'Подсказка', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('726', 'RU', 'Показать', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('727', 'RU', 'Фотографии', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('728', 'RU', 'Полезности', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('731', 'RU', 'все', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('733', 'RU', 'Загрузить как:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('739', 'RU', 'Текстовый файл (.txt)', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('757', 'RU', 'Название:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('797', 'RU', 'Координаты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('847', 'RU', 'Выполнение этих требований повышает стойкость вашего пароля.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('849', 'RU', 'Допустимые символы:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('850', 'RU', 'Не используйте распространёные слова.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('851', 'RU', 'Не используйте распространённые геокешерские слова.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('852', 'RU', 'Не используйте части вашего имени пользователя, настоящего имени или электронного адреса.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('853', 'RU', 'Длина от 6 до 60 символов.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('854', 'RU', 'Введите пароль, который удовлетворяет следующим критериям:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('855', 'RU', 'Ваш пароль не прошёл проверку.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('856', 'RU', 'Черногория', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('857', 'RU', 'Сербия', '2010-10-06 22:23:07');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('900', 'RU', 'Помощь сайту', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('906', 'RU', 'Условия использования', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'RU', 'RU', '2011-01-05 20:58:32');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1061', 'RU', 'Условия использования', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1269', 'RU', 'Карта', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1275', 'RU', 'Меню', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1332', 'RU', 'Инфраструктура', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1335', 'RU', 'Время', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1336', 'RU', 'Сезонность', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1338', 'RU', 'Снаряжение', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1339', 'RU', 'Подготовка', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1368', 'RU', 'Размер контейнера:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1369', 'RU', 'Координаты:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1380', 'RU', 'Выбор тайников', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1392', 'RU', 'Атрибуты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1416', 'RU', 'Новый тайник', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1417', 'RU', 'Если это ваш первый тайник, прочитайте <a href=\"articles.php?page=cacheinfo\">описание</a> отдельных полей.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1423', 'RU', 'Описание:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1490', 'RU', 'Пароль', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1524', 'RU', 'Тип', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1538', 'RU', 'Язык:', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1541', 'RU', 'Ночной', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1544', 'RU', 'Опасная зона', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1550', 'RU', 'Железная дорога', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1552', 'RU', 'Охота', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1553', 'RU', 'Колючки', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1554', 'RU', 'Клещи', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1555', 'RU', 'Заброшенные шахты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1556', 'RU', 'Ядовитые растения', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1557', 'RU', 'Опасные животные', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1558', 'RU', 'Парковка', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1559', 'RU', 'Общественный транспорт', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1560', 'RU', 'Питьевая вода', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1561', 'RU', 'Туалет', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1562', 'RU', 'Телефон', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1563', 'RU', 'Первая помощь', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1566', 'RU', 'Болото', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1567', 'RU', 'Холмистая местность', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1576', 'RU', 'Плата за вход или парковку', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1578', 'RU', 'Круглосуточный', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1580', 'RU', 'Дневной', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1582', 'RU', 'Всесезонный', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1586', 'RU', 'Компас', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1587', 'RU', 'Фонарь', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1588', 'RU', 'Альпинистское снаряжение', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1589', 'RU', 'Пещерное снаряжение', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1591', 'RU', 'Плавсредство', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1594', 'RU', 'Головоломка', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1595', 'RU', 'Математическая задача', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1598', 'RU', 'Детский', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1599', 'RU', 'Действующая железная дорога неподалёку. Будьте осторожны, держитесь на безопасной дистанции, будьте внимательны при переходе.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1601', 'RU', 'Тайник спрятан в охотничьих угодьях. Опасайтесь попасть под выстрел. В сумерках или темноте держите фонарь вклёченным в целях безопасности. ', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1602', 'RU', 'Опасайтесь колючек. Носите подходящую одежду.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1603', 'RU', 'В летнее время опасайтесь клещей. Носите брюки, одежду с длинными рукавами, периодически осматривайте друг друга. Заранее позаботьтесь о прививках против клещевого энцефалита.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1605', 'RU', 'Этот тайник можно искать хоть днём, хоть ночью.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1607', 'RU', 'Этот тайник можно искать только в светлое время суток. Например, скалистая местность с утёсами и обрывами опасна для посещения ночью, а в жилой местности использование фонарей может выглядеть подозрительно.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1609', 'RU', 'Тайник можно искать круглый год, но сложность может зависетьот сезона. Указывайте сложность для хороших условий.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1613', 'RU', 'Для поисков нужен компас.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1614', 'RU', 'Для поисков необходим фонарь. Не забудьте запасной комплект батарей!', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1615', 'RU', 'Для поисков этого тайника вам потребуется альпинистское снаряжения и навыки его правильного использования. Если вы новичок, не ходите на поиски в одиночку, возьмите с собой опытного альпиниста.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1616', 'RU', 'Этот тайник спрятан в пещере, и вам потребуется соответствующее снаряжение. Будьте осторожны, даже маленькие пещеры могут быть таить непредвиденные опасности, такие, как внезапная гроза (берегитесь воды) или вывихнутая лодыжка. Посоветуйтесь с опытными людьми прежде чем лезть в пещеру. Также берегите природу, например, не тревожьте летучих мышей.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1618', 'RU', 'Тайник может быть найден только с использованием плавредства: лодки, катера, яхты… Добраться до тайника вплавь (без лодки) не представляется возможным из-за расстояния, течения или иных препятствий. Подробности должны быть указаны в описании.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1621', 'RU', 'Перед или во время поисков тайника нужно рещить математическую задачу, выходящую за рамки тривиальных арифметических операций.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1624', 'RU', 'Тайник сделан специально для детей. TODO. ', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1626', 'RU', 'Опасайтесь ядовитых растений. Смотрите за детьми и собаками, не давайте им трогать или есть отраву.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1627', 'RU', 'Эта местность населена потенциально опасными животными, например, медведями, ядовитыми змеями, скорпионами, или является природным очагом бешенства.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1628', 'RU', 'Ближняя парковка является хорошей начальной точкой для поисков тайника. Если поблизости нет бесплатных парковок, должен быть установлен атрибут «Плата за вход или парковку».', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1629', 'RU', 'Тайник расположен за городом, но до него можно добраться общественным транспортом. Не устанавливайте этот атрибут для тайников в населённых пунктах.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1630', 'RU', 'По пути к тайнику или поблизости от тайника есть источник питьевой воды. Этот атрибут полезен для планирования встреч, длительных пеших прогулок или посещения тайников в потенциально грязных местах, таких, как пещеры.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1636', 'RU', 'При поисках этого тайника придётся ходить по болоту или преодолевать залитые водой участки местности. Носите подходящую одежду и обувь. После ливня местность может стать непроходимой.', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1656', 'RU', 'Другие сайты', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1658', 'RU', 'Путь', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1659', 'RU', 'Размер контейнера', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('1710', 'RU', 'Новые тайники в %1', '2010-12-06 22:17:36');
INSERT INTO `sys_trans_text` (`trans_id`, `lang`, `text`, `last_modified`) VALUES ('922', 'SV', 'SV', '2011-05-15 11:46:05');

-- Table watches_waitingtypes
SET NAMES 'utf8';
TRUNCATE TABLE `watches_waitingtypes`;
INSERT INTO `watches_waitingtypes` (`id`, `watchtype`) VALUES ('1', 'ownerlog');
INSERT INTO `watches_waitingtypes` (`id`, `watchtype`) VALUES ('2', 'cache_watches');

INSERT INTO `sysconfig` (`name`, `value`) VALUES ('datasql_checksum', 'beb14bc26fb2614baec346de4a974067') ON DUPLICATE KEY UPDATE `value`='beb14bc26fb2614baec346de4a974067';